import { __decorate, __param, __awaiter, __generator, __values, __assign, __rest, __spread, __read } from 'tslib';
import { NgModule, ɵɵdefineInjectable, Injectable, Inject, Component, ViewEncapsulation, ɵɵinject, EventEmitter, ChangeDetectorRef, Input, Output, ViewChild, Pipe, ViewChildren, ChangeDetectionStrategy, Directive, TemplateRef, ViewContainerRef } from '@angular/core';
import { DatePipe, CommonModule } from '@angular/common';
import { HttpHeaders, HttpClient, HttpClientModule } from '@angular/common/http';
import { NG_VALIDATORS, NG_ASYNC_VALIDATORS, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DeviceDetectorService, DeviceDetectorModule } from 'ngx-device-detector';
import { CKEditorModule } from 'ckeditor4-angular';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatInputModule } from '@angular/material/input';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSelectModule } from '@angular/material/select';
import { MatRadioModule } from '@angular/material/radio';
import { MatAutocompleteModule, MatAutocompleteTrigger } from '@angular/material/autocomplete';
import { MatIconModule } from '@angular/material/icon';
import { MatMenuModule } from '@angular/material/menu';
import { MatChipsModule } from '@angular/material/chips';
import { MatButtonModule } from '@angular/material/button';
import { MatDialogModule, MatDialogRef, MAT_DIALOG_DATA, MatDialog } from '@angular/material/dialog';
import { MatBottomSheetModule, MatBottomSheet } from '@angular/material/bottom-sheet';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatTabsModule } from '@angular/material/tabs';
import { DragDropModule, moveItemInArray } from '@angular/cdk/drag-drop';
import { timeout, startWith, map } from 'rxjs/operators';
import { v4 } from 'uuid';
import $$1 from 'jquery';
import swal from 'sweetalert2';
import md5 from 'md5';
import XLSX from 'xlsx';
import { saveAs } from 'file-saver';
import 'bootstrap';
import 'jquery-datetimepicker';
import * as hash from 'object-hash';
import hash__default from 'object-hash';
import { DomSanitizer } from '@angular/platform-browser';
import { Subscription } from 'rxjs';
import * as Chart from 'chart.js';
import { ENTER, COMMA } from '@angular/cdk/keycodes';
import moment from 'moment';
import 'daterangepicker';

var MaterialModule = /** @class */ (function () {
    function MaterialModule() {
    }
    MaterialModule = __decorate([
        NgModule({
            imports: [
                MatTooltipModule,
                MatFormFieldModule,
                MatInputModule,
                MatSelectModule,
                MatAutocompleteModule,
                MatCheckboxModule,
                MatSlideToggleModule,
                MatRadioModule,
                MatIconModule,
                MatMenuModule,
                MatChipsModule,
                MatButtonModule,
                MatDialogModule,
                MatBottomSheetModule,
                MatProgressSpinnerModule,
                DragDropModule,
                MatExpansionModule,
                MatTabsModule
            ],
            exports: [
                MatTooltipModule,
                MatFormFieldModule,
                MatInputModule,
                MatSelectModule,
                MatAutocompleteModule,
                MatCheckboxModule,
                MatSlideToggleModule,
                MatRadioModule,
                MatIconModule,
                MatMenuModule,
                MatChipsModule,
                MatButtonModule,
                MatDialogModule,
                MatBottomSheetModule,
                MatProgressSpinnerModule,
                DragDropModule,
                MatExpansionModule,
                MatTabsModule
            ]
        })
    ], MaterialModule);
    return MaterialModule;
}());

var ConfigurationService = /** @class */ (function () {
    function ConfigurationService() {
    }
    ConfigurationService.prototype.setConfig = function (configurationOption) {
        this.option = configurationOption;
    };
    ConfigurationService.prototype.getApiConfiguration = function () {
        this.option = this.option || {};
        this.option.api = this.option.api || {};
        this.option.api.host = this.option.api.host || location.origin;
        this.option.api.localStorageKey = this.option.api.localStorageKey || 'a9b9b57f-cfea-49d8-988b-9e96f486b7c4';
        this.option.api.tokenHeaderKey = this.option.api.tokenHeaderKey || 'Token';
        return this.option.api;
    };
    ConfigurationService.prototype.getExcelConfiguration = function () {
        if (this.option && this.option.excel) {
            return this.option.excel;
        }
        return null;
    };
    ConfigurationService.prototype.getSettingConfiguration = function () {
        if (this.option && this.option.setting) {
            return this.option.setting;
        }
        return null;
    };
    ConfigurationService.prototype.getGridConfiguration = function () {
        if (this.option && this.option.grid) {
            return this.option.grid;
        }
        return null;
    };
    ConfigurationService.prototype.getTranslateConfiguration = function () {
        var _a;
        return (_a = this.option) === null || _a === void 0 ? void 0 : _a.translate;
    };
    ConfigurationService.ɵprov = ɵɵdefineInjectable({ factory: function ConfigurationService_Factory() { return new ConfigurationService(); }, token: ConfigurationService, providedIn: "root" });
    ConfigurationService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ConfigurationService);
    return ConfigurationService;
}());

var TranslateService = /** @class */ (function () {
    function TranslateService(configurationService) {
        var _this = this;
        var _a, _b;
        this.configurationService = configurationService;
        this.undeclaredLanguage = {};
        this.dictionary = {};
        this.translate = function (keyWord, language) {
            var _a;
            if (!keyWord) {
                return '';
            }
            keyWord = keyWord.toString().trim();
            language = language || _this.currentLanguage;
            if (!keyWord || !language) {
                return keyWord;
            }
            if (!((_a = _this.dictionary[language]) === null || _a === void 0 ? void 0 : _a[keyWord])) {
                if (!_this.undeclaredLanguage[keyWord]) {
                    _this.undeclaredLanguage[keyWord] = true;
                }
                return keyWord;
            }
            return _this.dictionary[language][keyWord];
        };
        this.setDictionary = function (language, keyWord, value) {
            var _a;
            if (!_this.dictionary[language]) {
                _this.dictionary[language] = (_a = {},
                    _a[keyWord] = value,
                    _a);
            }
            else {
                _this.dictionary[language][keyWord] = value;
            }
        };
        this.setDictionaries = function (language, dictionary) {
            _this.dictionary[language] = dictionary;
        };
        this.setDefaultLanguage = function (language) {
            _this.currentLanguage = language;
        };
        this.getUndeclaredLanguage = function () { return _this.undeclaredLanguage; };
        var translateConfiguration = this.configurationService.getTranslateConfiguration();
        if (translateConfiguration) {
            this.currentLanguage = translateConfiguration.defaultLanguage;
            this.dictionary = ((_b = (_a = translateConfiguration).initializeDictionary) === null || _b === void 0 ? void 0 : _b.call(_a)) || {};
        }
    }
    TranslateService.ctorParameters = function () { return [
        { type: ConfigurationService }
    ]; };
    TranslateService = __decorate([
        Injectable()
    ], TranslateService);
    return TranslateService;
}());

var DialogConfirmComponent = /** @class */ (function () {
    function DialogConfirmComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    DialogConfirmComponent.prototype.onNoClick = function () {
        this.dialogRef.close();
    };
    DialogConfirmComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    DialogConfirmComponent = __decorate([
        Component({
            selector: 'sd-dialog-confirm',
            template: "<h1 mat-dialog-title class=\"\">\r\n  <mat-icon *ngIf=\"data?.icon\" [ngClass]=\"data?.icon\">\r\n    {{data?.icon}}\r\n  </mat-icon>{{data?.title || 'Confirm'}}\r\n</h1>\r\n<div mat-dialog-content>\r\n  <div [innerHtml]=\"data?.message\">\r\n  </div>\r\n  <div *ngIf=\"data?.input\">\r\n    <sd-textarea-control [(model)]=\"value\" [maxlength]=\"data.input?.maxlength\" [placeholder]=\"data.input?.placeholder\">\r\n    </sd-textarea-control>\r\n  </div>\r\n</div>\r\n<div mat-dialog-actions align=\"end\">\r\n  <button *ngIf=\"data?.noTitle\" mat-button (click)=\"onNoClick()\">{{data?.noTitle}}</button>\r\n  <button *ngIf=\"data?.yesTitle\" mat-raised-button [mat-dialog-close]=\"value || 'ACCEPT'\" color=\"primary\"\r\n    cdkFocusInitial>{{data?.yesTitle}}</button>\r\n</div>",
            encapsulation: ViewEncapsulation.None,
            styles: ["sd-dialog-confirm{padding:12px 16px;display:block}sd-dialog-confirm .mat-dialog-title{display:flex;align-items:center}sd-dialog-confirm .mat-dialog-title .mat-icon{margin-right:5px}sd-dialog-confirm .mat-dialog-content{margin:0 -16px 16px!important}sd-dialog-confirm .mat-button{background-color:#f5f5f5}"]
        }),
        __param(1, Inject(MAT_DIALOG_DATA))
    ], DialogConfirmComponent);
    return DialogConfirmComponent;
}());

var NotifyService = /** @class */ (function () {
    function NotifyService(dialog, translateService) {
        var _this = this;
        this.dialog = dialog;
        this.translateService = translateService;
        this.notifyId = 'N' + v4();
        this.alert = {
            success: function (message) {
                _this.dialog.open(DialogConfirmComponent, {
                    width: '400px',
                    data: {
                        icon: 'done',
                        title: _this.translateService.translate('Success'),
                        message: message || 'Done!',
                        yesTitle: _this.translateService.translate('Ok'),
                    }
                });
            },
            warning: function (message) {
                _this.dialog.open(DialogConfirmComponent, {
                    width: '400px',
                    data: {
                        icon: 'warning',
                        title: _this.translateService.translate('Warning'),
                        message: message || 'Something went wrong!',
                        yesTitle: _this.translateService.translate('Ok'),
                    }
                });
            },
            error: function (message) {
                _this.dialog.open(DialogConfirmComponent, {
                    width: '400px',
                    data: {
                        icon: 'error',
                        title: _this.translateService.translate('Error'),
                        message: message || 'Something went wrong!',
                        yesTitle: _this.translateService.translate('Ok'),
                    }
                });
            },
            image: function (imageUrl, imageWidth, imageHeight, option) {
                if (option === void 0) { option = {}; }
                swal.fire({
                    title: option.title,
                    html: option.message,
                    imageUrl: imageUrl,
                    imageWidth: imageWidth,
                    imageHeight: imageHeight,
                });
            }
        };
        this.notify = {
            success: function (message, delay) {
                // tslint:disable-next-line: max-line-length
                var style = "border-radius: 5px; margin: 0; padding: 12px; z-index: 99999; top: 5px; right: 5px; display: none; position: fixed;color: #4F8A10; background-color: #DFF2BF";
                // tslint:disable-next-line: max-line-length
                var html = "<div id=\"" + _this.notifyId + "\" style=\"" + style + "\"><i class=\"fa fa-check\"></i> " + (message || _this.translateService.translate('Success')) + "</div>";
                _this.showNotify(html, delay);
            },
            warning: function (message, delay) {
                // tslint:disable-next-line: max-line-length
                var style = "border-radius: 5px; margin: 0; padding: 12px; z-index: 99999; top: 5px; right: 5px; display: none; position: fixed;color: #9F6000; background-color: #FEEFB3";
                // tslint:disable-next-line: max-line-length
                var html = "<div id=\"" + _this.notifyId + "\" style=\"" + style + "\"><i class=\"fa fa-exclamation-triangle\"></i> " + (message || _this.translateService.translate('Warning')) + "</div>";
                _this.showNotify(html, delay);
            },
            error: function (message, delay) {
                // tslint:disable-next-line: max-line-length
                var style = "border-radius: 5px; margin: 0; padding: 12px; z-index: 99999; top: 5px; right: 5px; display: none; position: fixed;color: #D8000C; background-color: #FFD2D2";
                // tslint:disable-next-line: max-line-length
                var html = "<div id=\"" + _this.notifyId + "\" style=\"" + style + "\"><i class=\"fa fa-times\"></i> " + (message || _this.translateService.translate('Error')) + "</div>";
                _this.showNotify(html, delay);
            }
        };
        this.confirmDelete = function () { return _this.confirm(_this.translateService.translate('Delete record(s)')); };
        this.confirmApprove = function () { return _this.confirm(_this.translateService.translate('Approve record(s)')); };
        this.confirmWithInput = function (title, option) {
            if (option === void 0) { option = {}; }
            var _a, _b;
            var dialogRef = _this.dialog.open(DialogConfirmComponent, {
                width: '400px',
                data: {
                    title: title || _this.translateService.translate('Confirm'),
                    yesTitle: ((_a = option) === null || _a === void 0 ? void 0 : _a.yesTitle) || _this.translateService.translate('Yes'),
                    noTitle: ((_b = option) === null || _b === void 0 ? void 0 : _b.noTitle) || _this.translateService.translate('No'),
                    input: {
                        maxlength: 255
                    }
                }
            });
            return new Promise(function (resolve) {
                dialogRef.afterClosed().subscribe(function (result) {
                    if (result) {
                        if (result === 'ACCEPT') {
                            resolve('');
                        }
                        else {
                            resolve(result);
                        }
                    }
                });
            });
            // return new Promise(resolve => {
            //   swal.fire({
            //     title,
            //     input: 'textarea',
            //     inputPlaceholder: 'Tối đa 225 ký tự...',
            //     inputAttributes: {
            //       'aria-label': 'Tối đa 225 ký tự'
            //     },
            //     showCancelButton: true,
            //     confirmButtonColor: '#3085d6',
            //     cancelButtonColor: '#adadad',
            //     confirmButtonText: option.yesTitle || this.translateService.translate('Yes'),
            //     cancelButtonText: option.noTitle || this.translateService.translate('No'),
            //     reverseButtons: true,
            //     inputValidator: (value) => {
            //       if (!value || value?.length > 255) {
            //         return 'Vui lòng nhập lý do tối đa 255 ký tự!';
            //       }
            //     },
            //     allowOutsideClick: () => false
            //   }).then((result) => {
            //     if (result.value) {
            //       resolve(result.value);
            //     }
            //   });
            // });
        };
    }
    NotifyService.prototype.confirm = function (message, option) {
        if (option === void 0) { option = {}; }
        var _a, _b, _c;
        var dialogRef = this.dialog.open(DialogConfirmComponent, {
            width: '400px',
            data: {
                title: ((_a = option) === null || _a === void 0 ? void 0 : _a.title) || this.translateService.translate('Confirm'),
                message: message,
                yesTitle: ((_b = option) === null || _b === void 0 ? void 0 : _b.yesTitle) || this.translateService.translate('Yes'),
                noTitle: ((_c = option) === null || _c === void 0 ? void 0 : _c.noTitle) || this.translateService.translate('No'),
            }
        });
        return new Promise(function (resolve) {
            dialogRef.afterClosed().subscribe(function (result) {
                if (result) {
                    resolve();
                }
            });
        });
    };
    NotifyService.prototype.showNotify = function (html, delay) {
        var _this = this;
        if ($$1("#" + this.notifyId).length === 0) {
            $$1('body').append(html);
            var element = $$1("#" + this.notifyId);
            element.slideDown(200);
            setTimeout(function () {
                $$1('body').children("#" + _this.notifyId).remove();
            }, delay || 5000);
        }
    };
    NotifyService.ctorParameters = function () { return [
        { type: MatDialog },
        { type: TranslateService }
    ]; };
    NotifyService.ɵprov = ɵɵdefineInjectable({ factory: function NotifyService_Factory() { return new NotifyService(ɵɵinject(MatDialog), ɵɵinject(TranslateService)); }, token: NotifyService, providedIn: "root" });
    NotifyService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NotifyService);
    return NotifyService;
}());

var ApiService = /** @class */ (function () {
    function ApiService(httpClient, notifyService, configurationService, translateService) {
        var _this = this;
        this.httpClient = httpClient;
        this.notifyService = notifyService;
        this.configurationService = configurationService;
        this.translateService = translateService;
        this.uploadId = 'U' + v4();
        this.init = function () {
            var apiConfiguration = _this.configurationService.getApiConfiguration();
            _this.host = apiConfiguration.host;
            _this.tokenHeaderKey = apiConfiguration.tokenHeaderKey;
            _this.setCustomHeader = apiConfiguration.setCustomHeader;
            _this.beforeRemote = apiConfiguration.beforeRemote;
            _this.afterRemote = apiConfiguration.afterRemote;
        };
        this.uploadSingle = function (url, option) {
            return new Promise(function (resolve, reject) {
                if ($$1("#" + _this.uploadId).length) {
                    $$1('body').children("#" + _this.uploadId).remove();
                }
                $$1('body').append("<input id=\"" + _this.uploadId + "\" style=\"display: none\" type=\"file\" />");
                $$1("#" + _this.uploadId).on('change', function (evt) {
                    try {
                        var target = evt.target;
                        var fileToUpload = target.files.item(0);
                        _this.upload(url, fileToUpload, option).then(resolve).catch(reject);
                    }
                    catch (error) {
                        reject(error);
                    }
                });
                $$1("#" + _this.uploadId).trigger('click');
            });
        };
        this.upload = function (url, file, option) { return __awaiter(_this, void 0, void 0, function () {
            var translate, lastDot, message, extension, message, message, message, formData;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        translate = this.translateService.translate;
                        lastDot = file.name.lastIndexOf('.');
                        if (lastDot === -1) {
                            message = this.translateService.translate("Invalid file extension");
                            this.notifyService.notify.warning(message);
                            throw new Error(message);
                        }
                        extension = file.name.substring(lastDot + 1);
                        if (option) {
                            if (((_a = option.extensions) === null || _a === void 0 ? void 0 : _a.length) && !option.extensions.some(function (e) { return e.toUpperCase() === extension.toUpperCase(); })) {
                                message = "[" + file.name + "] " + translate('Uploaded file is not match extension') + " " + option.extensions.join(', ');
                                this.notifyService.notify.warning(message);
                                throw new Error(message);
                            }
                            if (option.maxSizeInMb > 0 && option.maxSizeInMb * 1024 * 1024 < file.size) {
                                message = "[" + file.name + "] " + translate('Max file size') + " " + option.maxSizeInMb + " Mbs";
                                this.notifyService.notify.warning(message);
                                throw new Error(message);
                            }
                            if (option.validator && option.validator(file.name)) {
                                message = option.validator(file.name);
                                this.notifyService.notify.warning(message);
                                throw new Error(message);
                            }
                        }
                        formData = new FormData();
                        formData.append('file', file, file.name);
                        return [4 /*yield*/, this.post(url, formData, this.defaultHeader)];
                    case 1: return [2 /*return*/, _b.sent()];
                }
            });
        }); };
        this.setTokenHeaderValue = function (tokenHeaderValue) {
            localStorage.setItem(_this.key, JSON.stringify({ tokenHeaderValue: tokenHeaderValue }));
        };
        this.getTokenHeaderValue = function () {
            return _this.token;
        };
    }
    Object.defineProperty(ApiService.prototype, "key", {
        get: function () {
            var _a;
            var apiConfiguration = this.configurationService.getApiConfiguration();
            return ((_a = apiConfiguration) === null || _a === void 0 ? void 0 : _a.localStorageKey) || 'a9b9b57f-cfea-49d8-988b-9e96f486b7c4';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ApiService.prototype, "token", {
        get: function () {
            try {
                var tokenHeaderValue = JSON.parse(localStorage.getItem(this.key)).tokenHeaderValue;
                return tokenHeaderValue;
            }
            catch (err) {
                return '';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ApiService.prototype, "defaultHeader", {
        get: function () {
            var httpHeaders = new HttpHeaders();
            if (this.tokenHeaderKey) {
                httpHeaders = httpHeaders.set(this.tokenHeaderKey, this.token);
            }
            return httpHeaders;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ApiService.prototype, "headers", {
        get: function () {
            if (this.setCustomHeader) {
                return this.setCustomHeader(this.defaultHeader);
            }
            return this.defaultHeader;
        },
        enumerable: true,
        configurable: true
    });
    ApiService.prototype.post = function (url, body, headers) {
        var _this = this;
        this.init();
        if (!url.startsWith('http')) {
            url = this.host + url;
        }
        headers = headers || this.headers;
        if (this.beforeRemote) {
            this.beforeRemote({
                url: url,
                method: 'POST',
                headers: headers,
                body: body
            });
        }
        return new Promise(function (resolve, reject) {
            _this.httpClient.post(encodeURI(url), body, {
                observe: 'response',
                headers: headers
            }).pipe(timeout(600000)).toPromise().then(function (result) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'POST',
                        headers: headers,
                        body: body,
                        statusCode: result.status,
                        result: result.body
                    });
                }
                if (result.ok) {
                    resolve(result.body);
                }
                else {
                    reject(result.body);
                }
            }).catch(function (httpErrorResponse) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'POST',
                        headers: headers,
                        body: body,
                        statusCode: httpErrorResponse.status,
                        result: httpErrorResponse.error
                    });
                }
                reject(httpErrorResponse);
            });
        });
    };
    ApiService.prototype.put = function (url, body, headers) {
        var _this = this;
        this.init();
        if (!url.startsWith('http')) {
            url = this.host + url;
        }
        headers = headers || this.headers;
        if (this.beforeRemote) {
            this.beforeRemote({
                url: url,
                method: 'PUT',
                headers: headers,
                body: body
            });
        }
        return new Promise(function (resolve, reject) {
            _this.httpClient.put(encodeURI(url), body, {
                observe: 'response',
                headers: headers
            }).pipe(timeout(600000)).toPromise().then(function (result) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'PUT',
                        headers: headers,
                        body: body,
                        statusCode: result.status,
                        result: result.body
                    });
                }
                if (result.ok) {
                    resolve(result.body);
                }
                else {
                    reject(result.body);
                }
            }).catch(function (httpErrorResponse) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'PUT',
                        headers: headers,
                        body: body,
                        statusCode: httpErrorResponse.status,
                        result: httpErrorResponse.error
                    });
                }
                reject(httpErrorResponse);
            });
        });
    };
    ApiService.prototype.get = function (url, headers, options) {
        var _this = this;
        this.init();
        headers = headers || this.headers;
        if (!url.startsWith('http')) {
            url = this.host + url;
        }
        if (this.beforeRemote) {
            this.beforeRemote({
                url: url,
                method: 'GET',
                headers: headers
            });
        }
        return new Promise(function (resolve, reject) {
            var _a, _b;
            if (((_a = options) === null || _a === void 0 ? void 0 : _a.responseType) && options.responseType !== 'json') {
                _this.httpClient.get(encodeURI(url), { observe: 'body', headers: headers, responseType: (_b = options) === null || _b === void 0 ? void 0 : _b.responseType })
                    .toPromise().then(function (result) {
                    if (_this.afterRemote) {
                        _this.afterRemote({
                            url: url,
                            method: 'GET',
                            headers: headers,
                            statusCode: null,
                            result: result
                        });
                    }
                    resolve(result);
                }).catch(function (httpErrorResponse) {
                    if (_this.afterRemote) {
                        _this.afterRemote({
                            url: url,
                            method: 'GET',
                            headers: headers,
                            statusCode: httpErrorResponse.status,
                            result: httpErrorResponse.error
                        });
                    }
                    reject(httpErrorResponse.error);
                });
            }
            else {
                _this.httpClient.get(encodeURI(url), { observe: 'response', headers: headers }).toPromise().then(function (result) {
                    if (_this.afterRemote) {
                        _this.afterRemote({
                            url: url,
                            method: 'GET',
                            headers: headers,
                            statusCode: result.status,
                            result: result.body
                        });
                    }
                    if (result.ok) {
                        resolve(result.body);
                    }
                    else {
                        reject(result.body);
                    }
                }).catch(function (httpErrorResponse) {
                    if (_this.afterRemote) {
                        _this.afterRemote({
                            url: url,
                            method: 'GET',
                            headers: headers,
                            statusCode: httpErrorResponse.status,
                            result: httpErrorResponse.error
                        });
                    }
                    reject(httpErrorResponse.error);
                });
            }
        });
    };
    ApiService.prototype.delete = function (url, headers) {
        var _this = this;
        this.init();
        headers = headers || this.headers;
        if (!url.startsWith('http')) {
            url = this.host + url;
        }
        if (this.beforeRemote) {
            this.beforeRemote({
                url: url,
                method: 'DELETE',
                headers: headers
            });
        }
        return new Promise(function (resolve, reject) {
            _this.httpClient.delete(encodeURI(url), { observe: 'response', headers: headers }).toPromise().then(function (result) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'DELETE',
                        headers: headers,
                        statusCode: result.status,
                        result: result.body
                    });
                }
                if (result.ok) {
                    resolve(result.body);
                }
                else {
                    reject(result.body);
                }
            }).catch(function (httpErrorResponse) {
                if (_this.afterRemote) {
                    _this.afterRemote({
                        url: url,
                        method: 'DELETE',
                        headers: headers,
                        statusCode: httpErrorResponse.status,
                        result: httpErrorResponse.error
                    });
                }
                reject(httpErrorResponse.error);
            });
        });
    };
    Object.defineProperty(ApiService.prototype, "hasTokenHeaderValue", {
        get: function () {
            return !!this.token;
        },
        enumerable: true,
        configurable: true
    });
    ApiService.prototype.clearToken = function () {
        localStorage.removeItem(this.key);
    };
    ApiService.prototype.getHost = function () {
        return this.host;
    };
    ApiService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: NotifyService },
        { type: ConfigurationService },
        { type: TranslateService }
    ]; };
    ApiService.ɵprov = ɵɵdefineInjectable({ factory: function ApiService_Factory() { return new ApiService(ɵɵinject(HttpClient), ɵɵinject(NotifyService), ɵɵinject(ConfigurationService), ɵɵinject(TranslateService)); }, token: ApiService, providedIn: "root" });
    ApiService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ApiService);
    return ApiService;
}());

var UtilityService = /** @class */ (function () {
    function UtilityService(notifyService) {
        var _this = this;
        this.notifyService = notifyService;
        this.handle = {
            error: function (err) {
                if (typeof (err) === 'string') {
                    _this.notifyService.notify.warning(err);
                }
                else if (typeof (err) === 'object') {
                    var message = err.error || err.message || err.ExceptionMessage || err.Message || 'UNKNOWN ERROR';
                    if (typeof (err.json) === 'function') {
                        err = err.json();
                        if (err) {
                            message = err.error || err.message || err.ExceptionMessage || err.Message || 'UNKNOWN ERROR';
                        }
                    }
                    _this.notifyService.notify.warning(message);
                }
                else {
                    console.error(err);
                    _this.notifyService.notify.warning('UNKNOWN ERROR');
                }
            }
        };
        this.hashMD5 = function (key) { return md5(key); };
        this.arrayToObject = function (items, key) {
            return items.reduce(function (obj, item) { obj[item[key]] = item; return obj; }, {});
        };
        this.isUuid = function (key) {
            key = key || '';
            return key.length === 36;
            // const regex = new Regex('[0-9a-fA-F]{8}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{12}');
            // return regex.test(key);
        };
    }
    UtilityService.prototype.changeAliasLowerCase = function (alias) {
        var str = alias || '';
        str = str.toString().toLowerCase();
        str = str.replace(/à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ/g, 'a');
        str = str.replace(/è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ/g, 'e');
        str = str.replace(/ì|í|ị|ỉ|ĩ/g, 'i');
        str = str.replace(/ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ/g, 'o');
        str = str.replace(/ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ/g, 'u');
        str = str.replace(/ỳ|ý|ỵ|ỷ|ỹ/g, 'y');
        str = str.replace(/đ/g, 'd');
        str = str.replace(/!|@|%|\^|\*|\(|\)|\+|\=|\<|\>|\?|\/|,|\.|\:|\;|\'|\"|\&|\#|\[|\]|~|\$|_|`|-|{|}|\||\\/g, ' ');
        str = str.replace(/ + /g, ' ');
        str = str.trim();
        return str;
    };
    UtilityService.ctorParameters = function () { return [
        { type: NotifyService }
    ]; };
    UtilityService.ɵprov = ɵɵdefineInjectable({ factory: function UtilityService_Factory() { return new UtilityService(ɵɵinject(NotifyService)); }, token: UtilityService, providedIn: "root" });
    UtilityService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], UtilityService);
    return UtilityService;
}());

var ExcelService = /** @class */ (function () {
    function ExcelService(configurationService, notifyService) {
        var _this = this;
        this.configurationService = configurationService;
        this.notifyService = notifyService;
        this.importId = 'I' + v4();
        this.import = function () {
            return new Promise(function (resolve, reject) {
                if ($$1("#" + _this.importId).length) {
                    $$1('body').children("#" + _this.importId).remove();
                }
                $$1('body').append("<input id=\"" + _this.importId + "\" style=\"display: none\" type=\"file\" />");
                $$1("#" + _this.importId).on('change', function (evt) {
                    try {
                        var target_1 = evt.target;
                        if (target_1.files.length !== 1) {
                            throw new Error('Cannot use multiple files');
                        }
                        var reader = new FileReader();
                        reader.onload = function (e) {
                            var bstr = e.target.result;
                            var wb = XLSX.read(bstr, { type: 'binary' });
                            var wsname = wb.SheetNames[0];
                            var ws = wb.Sheets[wsname];
                            var lines = (XLSX.utils.sheet_to_json(ws, { header: 1 }));
                            var records = [];
                            var headers = lines[0];
                            lines.splice(0, 1);
                            lines.forEach(function (line) {
                                var record = {};
                                var hasValue = false;
                                headers.forEach(function (header, index) {
                                    record[header] = line[index];
                                    if (line[index] !== undefined && line[index] !== null && line[index].toString()) {
                                        hasValue = true;
                                    }
                                    if (typeof (record[header]) === 'string') {
                                        record[header] = record[header].trim();
                                    }
                                    if (record[header] === '') {
                                        record[header] = null;
                                    }
                                });
                                if (hasValue) {
                                    records.push(record);
                                }
                            });
                            resolve({
                                items: records,
                                file: target_1.files[0]
                            });
                        };
                        reader.readAsBinaryString(target_1.files[0]);
                    }
                    catch (error) {
                        reject(error);
                    }
                });
                $$1("#" + _this.importId).trigger('click');
            });
        };
        this.export = function (exportInfo) {
            /* Worksheet */
            var worksheet = XLSX.utils.json_to_sheet(exportInfo.data, { cellDates: true });
            /* Workbook */
            var workbook = XLSX.utils.book_new();
            /* Add worksheet to workbook */
            XLSX.utils.book_append_sheet(workbook, worksheet, exportInfo.sheetName || 'Default');
            var wbout = XLSX.write(workbook, { bookType: 'xlsx', type: 'binary' });
            var fileName = exportInfo.fileName ? exportInfo.fileName + _this.current() : v4() + '.xlsx';
            saveAs(new Blob([_this.s2ab(wbout)], { type: 'application/octet-stream' }), fileName);
        };
        this.current = function () {
            var now = new Date();
            var year = now.getFullYear();
            var month = (now.getMonth() + 1).toString().padStart(2, '0');
            var day = now.getDate().toString().padStart(2, '0');
            var hour = now.getHours().toString().padStart(2, '0');
            var minute = now.getMinutes().toString().padStart(2, '0');
            var second = now.getSeconds().toString().padStart(2, '0');
            return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
        };
        this.s2ab = function (s) {
            var buffer = new ArrayBuffer(s.length);
            var view = new Uint8Array(buffer);
            for (var i = 0; i < s.length; ++i) {
                // tslint:disable-next-line: no-bitwise
                view[i] = s.charCodeAt(i) & 0xFF;
            }
            return buffer;
        };
        this.generateExcelTemplate = function (excelTemplate) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.generateTemplate(excelTemplate).catch(function (err) {
                                _this.notifyService.notify.error(err);
                                return {
                                    fileName: '',
                                    filePath: ''
                                };
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.generateAndUploadExcelTemplate = function (key, excelTemplate) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.generateAndUploadTemplate(key, excelTemplate).catch(function (err) {
                                _this.notifyService.notify.error(err);
                                return {
                                    fileName: '',
                                    filePath: ''
                                };
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.uploadTemplate = function (key, validator) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.uploadTemplate(key, validator)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.downloadTemplate = function (filePath, fileName) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.downloadTemplate(filePath, fileName)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.generateExcelDataByTemplate = function (filePath, columns, items, fileName) { return __awaiter(_this, void 0, void 0, function () {
            var result;
            var _this = this;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.generateExcelDataByTemplate(filePath, columns, items).catch(function (err) {
                                _this.notifyService.notify.error(err);
                                return {
                                    filePath: ''
                                };
                            })];
                    case 1:
                        result = _b.sent();
                        if (!((_a = result) === null || _a === void 0 ? void 0 : _a.filePath)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.configuration.downloadTemplate(result.filePath, fileName || v4() + ".xlsx")];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        this.getFiles = function (key) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.getFiles(key)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.remove = function (key, name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.configuration) {
                            this.notifyService.notify.warning('Please init excel configuration');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.configuration.remove(key, name)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
    }
    Object.defineProperty(ExcelService.prototype, "configuration", {
        get: function () {
            return this.configurationService.getExcelConfiguration();
        },
        enumerable: true,
        configurable: true
    });
    ExcelService.ctorParameters = function () { return [
        { type: ConfigurationService },
        { type: NotifyService }
    ]; };
    ExcelService.ɵprov = ɵɵdefineInjectable({ factory: function ExcelService_Factory() { return new ExcelService(ɵɵinject(ConfigurationService), ɵɵinject(NotifyService)); }, token: ExcelService, providedIn: "root" });
    ExcelService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ExcelService);
    return ExcelService;
}());

var LoadingService = /** @class */ (function () {
    function LoadingService() {
        var _this = this;
        this.loadingId = 'L' + v4();
        this.progressId = 'P' + v4();
        this.start = function (element) {
            if (element === void 0) { element = 'body'; }
            $$1(element).append(_this.loadingNormal);
        };
        this.isLoading = function () {
            return $$1("#" + _this.loadingId).length > 0;
        };
        this.stop = function () {
            $$1('body').children("#" + _this.loadingId).remove();
        };
    }
    Object.defineProperty(LoadingService.prototype, "loadingNormal", {
        // Loading
        get: function () {
            // tslint:disable-next-line: max-line-length
            return "<div id=\"" + this.loadingId + "\" style=\"top:0;left:0;height:100vh;width:100vw;position:absolute;opacity:0.6;background:#FFFFFF;z-index: 99999;\"><i class=\"fa fa-5x fa-spinner fa-pulse\" style=\"margin-top:calc(50vh - 2.5rem);margin-left:calc(50vw - 2.5rem)\"></i></div>";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoadingService.prototype, "loadingSearching", {
        get: function () {
            // tslint:disable-next-line: max-line-length
            return "<div id=\"" + this.loadingId + "\" style=\"top:0;left:0;height:100%;width:100%;position:absolute;opacity:0.6;background:#FFFFFF;z-index: 99999;background-image:url(../assets/images/loading/searching.gif);background-position:center;background-repeat:no-repeat;\"></div>";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoadingService.prototype, "loadingRalph", {
        get: function () {
            // tslint:disable-next-line: max-line-length
            return "<div id=\"" + this.loadingId + "\" style=\"top:0;left:0;height:100%;width:100%;position:absolute;opacity:0.6;background:#FFFFFF;z-index: 99999;background-image:url(../assets/images/loading/ralph.gif);background-position:center;background-repeat:no-repeat;\"></div>";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoadingService.prototype, "loadingFiveBalls", {
        get: function () {
            // tslint:disable-next-line: max-line-length
            return "<div id=\"" + this.loadingId + "\" style=\"top:0;left:0;height:100%;width:100%;position:absolute;opacity:0.6;background:#FFFFFF;z-index: 99999;background-image:url(../assets/images/loading/five-balls.gif);background-position:center;background-repeat:no-repeat;\"></div>";
        },
        enumerable: true,
        configurable: true
    });
    LoadingService.prototype.startProgress = function (title, current, max) {
        this.max = max;
        var html = "<div id=\"" + this.progressId + "\" class=\"modal fade\" data-backdrop=\"static\" data-keyboard=\"false\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" style=\"padding-top:15%; overflow-y:visible;\">\n                        <div class=\"modal-dialog modal-m\">\n                            <div class=\"modal-content\">\n                                <div class=\"modal-header\"><h3 style=\"margin:0;\">" + title + " (<span id=\"abcd\">" + current + "</span>/" + max + ")</h3></div>\n                            <div class=\"modal-body\">\n                                <div class=\"progress\">\n                                    <div id=\"cde\" class=\"progress-bar progress-bar-striped progress-bar-animated\" role=\"progressbar\" style=\"width: " + current / 100 + "%\"></div>\n                                </div>\n                            </div>\n                        </div>\n                    </div>";
        $$1('body').append(html);
        $$1("#" + this.progressId).modal('show');
    };
    LoadingService.prototype.updateProgress = function (current) {
        $$1("#" + this.progressId).find('#abcd').html(current.toString());
        $$1("#" + this.progressId).find('#cde').css('width', current * 100 / this.max + "%");
    };
    LoadingService.prototype.stopProgress = function () {
        var _this = this;
        $$1("#" + this.progressId).modal('hide');
        setTimeout(function () {
            $$1("#" + _this.progressId).remove();
        }, 1000);
    };
    LoadingService = __decorate([
        Injectable()
    ], LoadingService);
    return LoadingService;
}());

var InputControlComponent = /** @class */ (function () {
    function InputControlComponent(ref) {
        var _this = this;
        this.ref = ref;
        this.name = v4();
        this.appearance = 'legacy ';
        this.type = 'text';
        this.step = 0.01;
        this.modelChange = new EventEmitter();
        this.icon = 'fa fa-search';
        // tslint:disable-next-line: no-output-native
        this.click = new EventEmitter();
        this.sdClick = new EventEmitter();
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.sdFocus = new EventEmitter();
        this.sdFocusForceBlur = new EventEmitter();
        this.keyupEnter = new EventEmitter();
        this.reValidate = function () {
            var _a;
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
        this.onChange = function (value) {
            if (_this.type === 'currency') {
                _this.cModel = (value || '').replace(/,/g, '');
                if (!Number.isNaN(+_this.cModel)) {
                    _this.cModel = +_this.cModel;
                }
                else {
                    _this.cModel = null;
                }
            }
            else {
                _this.cModel = value;
            }
            _this.modelChange.emit(_this.cModel);
            _this.change.emit(_this.cModel);
            _this.sdChange.emit(_this.cModel);
        };
        this.onKeyupEnter = function () {
            _this.keyupEnter.emit(_this.cModel);
        };
        this.onClick = function () {
            _this.click.emit(_this.cModel);
            _this.sdClick.emit(_this.cModel);
        };
        this.onFocus = function () {
            var _a;
            _this.sdFocus.emit();
            if (((_a = _this.sdFocusForceBlur.observers) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                _this.blur();
                _this.sdFocusForceBlur.emit();
            }
        };
        this.blur = function () {
            $(_this.control.nativeElement).trigger('blur');
        };
    }
    Object.defineProperty(InputControlComponent.prototype, "model", {
        set: function (value) {
            this.cModel = value;
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    InputControlComponent.prototype.ngAfterViewInit = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        this.ref.detectChanges();
    };
    InputControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    InputControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], InputControlComponent.prototype, "appearance", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "placeholder", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "type", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "step", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "maxlength", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "pattern", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "icon", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "validator", void 0);
    __decorate([
        Input()
    ], InputControlComponent.prototype, "tooltip", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "click", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "sdClick", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "sdFocus", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "sdFocusForceBlur", void 0);
    __decorate([
        Output()
    ], InputControlComponent.prototype, "keyupEnter", void 0);
    __decorate([
        ViewChild('control')
    ], InputControlComponent.prototype, "control", void 0);
    __decorate([
        ViewChild('formModel')
    ], InputControlComponent.prototype, "formModel", void 0);
    InputControlComponent = __decorate([
        Component({
            selector: 'sd-input-control',
            template: "<mat-form-field class=\"sd-form\" [ngClass]=\"{'sd-form-with-information':tooltip}\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <input *ngIf=\"type !== 'currency'\" class=\"sd-input\" #formModel=\"ngModel\" [type]=\"type\" [name]=\"name\" #control matInput\r\n    placeholder=\"{{placeholder || label}}\" [ngModel]=\"cModel\" (ngModelChange)=\"onChange($event)\"\r\n    (keyup.enter)=\"onKeyupEnter()\" (focus)=\"onFocus()\" [required]=\"required\" [maxlength]=\"maxlength\" [pattern]=\"pattern\"\r\n    [disabled]=\"disabled\" [sdCustomValidator]=\"validator\" autocomplete=\"off\">\r\n  <input *ngIf=\"type === 'currency'\" class=\"sd-input\" #formModel=\"ngModel\" [type]=\"type\" [name]=\"name\" #control matInput\r\n    placeholder=\"{{placeholder || label}}\" [ngModel]=\"cModel | sdCurrency\" (ngModelChange)=\"onChange($event)\"\r\n    (keyup.enter)=\"onKeyupEnter()\" (focus)=\"onFocus()\" [required]=\"required\" [maxlength]=\"maxlength\" [pattern]=\"pattern\"\r\n    [disabled]=\"disabled\" [sdCustomValidator]=\"validator\" autocomplete=\"off\">\r\n  <span class=\"mr-1\" *ngIf=\"maxlength\" matSuffix>{{cModel?.length || 0}}/{{maxlength}}</span>\r\n  <i *ngIf=\"click?.observers?.length || sdClick?.observers?.length\" [className]=\"icon\" (click)=\"onClick()\"\r\n    style=\"cursor:pointer\" matSuffix></i>\r\n  <mat-error *ngIf=\"formModel?.errors?.required\">\r\n    {{'This field is required' | sdTranslate}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.maxlength\">\r\n    {{'Max length' | sdTranslate}} <strong>{{maxlength}}</strong>\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.pattern\">\r\n    {{'Pattern error' | sdTranslate}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.customValidator\">\r\n    <strong>{{formModel?.errors?.customValidator}}</strong>\r\n  </mat-error>\r\n</mat-form-field>\r\n<div *ngIf=\"tooltip\" class=\"sd-information\">\r\n  <i class=\"fa fa-info-circle fa-fw\" [matTooltip]=\"cModel | inputTooltipPipe:tooltip\" (click)=\"sdTooltip.toggle()\"\r\n    #sdTooltip=\"matTooltip\"></i>\r\n</div>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}"]
        })
    ], InputControlComponent);
    return InputControlComponent;
}());

var defaultGridOption = {
    type: undefined,
    items: [],
    filter: {
        type: 'inline',
        disabled: false
    },
    sortable: true,
    paginate: {
        pageSize: 50,
        pageCount: 5
    },
    exportable: true,
    commands: [],
    columns: []
};

var HandlerLocal = /** @class */ (function () {
    function HandlerLocal(datePipe) {
        var _this = this;
        this.datePipe = datePipe;
        this.filter = function (localItems, filterInfo) {
            var items = localItems.filter(function (item) {
                var e_1, _a;
                try {
                    for (var _b = __values(filterInfo.columns), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var column = _c.value;
                        var filterValue = (filterInfo.rawFilter[column.field] || '').toString().trim().toLowerCase();
                        var columnValue = (item[column.field] || '').toString().trim().toLowerCase();
                        if (filterValue) {
                            if (!columnValue) {
                                return false;
                            }
                            if (column.type === 'string') {
                                if (columnValue.indexOf(filterValue) === -1) {
                                    return false;
                                }
                            }
                            else if (column.type === 'values' || column.type === 'radio') {
                                if (columnValue !== filterValue) {
                                    return false;
                                }
                            }
                            else if (column.type === 'number') {
                                var fValue = +filterValue.replace('>=', '').replace('<=', '').replace('>', '').replace('<', '');
                                var cValue = +columnValue;
                                if (fValue || fValue === 0) {
                                    if (!cValue && cValue !== 0) {
                                        return false;
                                    }
                                    if (filterValue.indexOf('>=') > -1 && cValue < fValue) {
                                        return false;
                                    }
                                    else if (filterValue.indexOf('<=') > -1 && cValue > fValue) {
                                        return false;
                                    }
                                    else if (filterValue.indexOf('<') > -1 && cValue >= fValue) {
                                        return false;
                                    }
                                    else if (filterValue.indexOf('>') > -1 && cValue <= fValue) {
                                        return false;
                                    }
                                    else if (cValue !== fValue) {
                                        return false;
                                    }
                                }
                            }
                            else if (column.type === 'bool') {
                                if (filterValue === '1' && columnValue !== '1' && columnValue !== 'true') {
                                    return false;
                                }
                                else if (filterValue === '0' && columnValue !== '0' && columnValue !== 'false') {
                                    return false;
                                }
                            }
                            else if (column.type === 'date' || column.type === 'datetime') {
                                var date = _this.datePipe.transform(filterValue, 'yyyy/MM/dd');
                                var fromDate = new Date(date);
                                var toDate = new Date(date);
                                toDate.setDate(toDate.getDate() + 1);
                                if (new Date(columnValue).getTime() < fromDate.getTime() || new Date(columnValue).getTime() >= toDate.getTime()) {
                                    return false;
                                }
                            }
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return true;
            });
            // Sort
            if (filterInfo.orderBy && filterInfo.orderDirection) {
                var column = filterInfo.columns.find(function (e) { return e.field === filterInfo.orderBy; });
                if (column) {
                    var type_1 = column.type, field_1 = column.field;
                    items.sort(function (current, next) {
                        if (type_1 === 'number') {
                            return (current[field_1] || 0) - (next[field_1] || 0);
                        }
                        if (type_1 === 'date' || type_1 === 'datetime' || type_1 === 'time') {
                            var d1 = new Date(current[field_1] || '').getTime();
                            var d2 = new Date(current[field_1] || '').getTime();
                            return d1 - d2;
                        }
                        var s1 = (current[field_1] || '').toString();
                        var s2 = (next[field_1] || '').toString();
                        if (s1 > s2) {
                            return 1;
                        }
                        if (s1 < s2) {
                            return -1;
                        }
                        return 0;
                    });
                    if (filterInfo.orderDirection === 'DESC') {
                        items.reverse();
                    }
                }
            }
            return {
                items: items,
                total: items.length
            };
        };
    }
    HandlerLocal.ctorParameters = function () { return [
        { type: DatePipe }
    ]; };
    HandlerLocal.ɵprov = ɵɵdefineInjectable({ factory: function HandlerLocal_Factory() { return new HandlerLocal(ɵɵinject(DatePipe)); }, token: HandlerLocal, providedIn: "root" });
    HandlerLocal = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], HandlerLocal);
    return HandlerLocal;
}());

var HandlerDotnet = /** @class */ (function () {
    function HandlerDotnet() {
        var _this = this;
        this.mapRequest = function (filterInfo) {
            var result = {
                whereClause: '1>0',
                pageSize: filterInfo.pageSize,
                pageNumber: filterInfo.pageNumber,
                orderBy: filterInfo.orderBy,
                orderDirection: filterInfo.orderDirection,
                filter: {}
            };
            if (filterInfo.customFilter) {
                // Nếu custom filter là string
                if (typeof (filterInfo.customFilter) === 'string') {
                    result.whereClause += " AND " + filterInfo.customFilter;
                }
                else if (typeof (filterInfo.customFilter) === 'function') {
                    result.whereClause += " AND " + filterInfo.customFilter();
                }
            }
            var executeColumnNoChildren = function (column) {
                if (!filterInfo.rawFilter[column.field]) {
                    return;
                }
                result.filter[column.field] = filterInfo.rawFilter[column.field];
                if (column.type === 'string') {
                    var filterValue = filterInfo.rawFilter[column.field].toString();
                    // Kiểm tra có phải Guid ko?
                    if (column.isGuid && !_this.isGuid(filterInfo.rawFilter[column.field])) {
                        return;
                    }
                    if (_this.isGuid(filterInfo.rawFilter[column.field])) {
                        result.whereClause += " AND " + column.field + " = GUID(\"" + filterInfo.rawFilter[column.field] + "\")";
                    }
                    else if (filterValue.startsWith('!=')) {
                        result.whereClause += " AND " + column.field + " != \"" + filterValue.substring(2, filterValue.length) + "\"";
                    }
                    else if (filterValue.startsWith('=')) {
                        result.whereClause += " AND " + column.field + " = \"" + filterValue.substring(1, filterValue.length) + "\"";
                    }
                    else if (filterValue.startsWith('%')) {
                        result.whereClause += " AND " + column.field + ".EndsWith(\"" + filterValue.substring(1, filterValue.length) + "\")";
                    }
                    else if (filterValue.endsWith('%')) {
                        result.whereClause += " AND " + column.field + ".StartsWith(\"" + filterValue.substring(0, filterValue.length - 1) + "\")";
                    }
                    else {
                        result.whereClause += " AND " + column.field + ".Contains(\"" + filterValue + "\")";
                    }
                }
                else if (column.type === 'number') {
                    var value = +(filterInfo.rawFilter[column.field].replace('>=', '').replace('<=', '').replace('>', '').replace('<', '').trim());
                    if (filterInfo.rawFilter[column.field].indexOf('>=') > -1) {
                        result.whereClause += " AND " + column.field + " >= " + value;
                    }
                    else if (filterInfo.rawFilter[column.field].indexOf('<=') > -1) {
                        result.whereClause += " AND " + column.field + " <= " + value;
                    }
                    else if (filterInfo.rawFilter[column.field].indexOf('>') > -1) {
                        result.whereClause += " AND " + column.field + " > " + value;
                    }
                    else if (filterInfo.rawFilter[column.field].indexOf('<') > -1) {
                        result.whereClause += " AND " + column.field + " < " + value;
                    }
                    else {
                        result.whereClause += " AND " + column.field + " = " + value;
                    }
                }
                else if (column.type === 'bool') {
                    if (filterInfo.rawFilter[column.field] === '0' || filterInfo.rawFilter[column.field] === '1') {
                        result.whereClause += " AND " + column.field + " = " + (filterInfo.rawFilter[column.field] === '1' ? 'true' : 'false');
                    }
                }
                else if (column.type === 'values') {
                    if (filterInfo.rawFilter[column.field]) {
                        // Kiểm tra có phải Guid ko?
                        if (column.isGuid && !_this.isGuid(filterInfo.rawFilter[column.field])) {
                            return;
                        }
                        if (_this.isGuid(filterInfo.rawFilter[column.field])) {
                            result.whereClause += " AND " + column.field + " = GUID(\"" + filterInfo.rawFilter[column.field] + "\")";
                        }
                        else {
                            result.whereClause += " AND " + column.field + " = \"" + filterInfo.rawFilter[column.field] + "\"";
                        }
                    }
                }
                else if (column.type === 'radio') {
                    if (filterInfo.rawFilter[column.field]) {
                        result.whereClause += " AND " + column.field + " = \"" + filterInfo.rawFilter[column.field] + "\"";
                    }
                }
                else if (column.type === 'date' || column.type === 'datetime') {
                    // "DateTime(yyyy,mm,dd,HH,mm,ss)"
                    // generate fromDate, toDate
                    var date = new Date(filterInfo.rawFilter[column.field]);
                    // From Date
                    date = new Date(date.getFullYear(), date.getMonth(), date.getDate(), 0, 0, 0);
                    result.whereClause += " AND " + column.field + " >= DateTime(" + date.getFullYear() + "," + (date.getMonth() + 1) + "," + date.getDate() + ")";
                    // To Date
                    date.setDate(date.getDate() + 1);
                    result.whereClause += " AND " + column.field + " < DateTime(" + date.getFullYear() + "," + (date.getMonth() + 1) + "," + date.getDate() + ")";
                }
            };
            var executeColumnChildren = function (columnChildren) {
                var e_1, _a, e_2, _b;
                var flag = false;
                try {
                    for (var _c = __values(columnChildren.children), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var column = _d.value;
                        if (filterInfo.rawFilter[column.field]) {
                            executeColumnNoChildren(column);
                            flag = true;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                if (flag) {
                    return;
                }
                if (!filterInfo.rawFilter[columnChildren.field]) {
                    return;
                }
                result.filter[columnChildren.field] = filterInfo.rawFilter[columnChildren.field];
                var whereClause = '';
                try {
                    for (var _e = __values(columnChildren.children), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var column = _f.value;
                        if (column.type === 'string') {
                            var filterValue = filterInfo.rawFilter[column.field].toString();
                            // Kiểm tra có phải Guid ko?
                            if (column.isGuid && !_this.isGuid(filterInfo.rawFilter[column.field])) {
                                return;
                            }
                            if (_this.isGuid(filterInfo.rawFilter[column.field])) {
                                whereClause += " OR " + column.field + " = GUID(\"" + filterInfo.rawFilter[column.field] + "\")";
                            }
                            else if (filterValue.startsWith('!=')) {
                                whereClause += " OR " + column.field + " != \"" + filterValue.substring(2, filterValue.length) + "\"";
                            }
                            else if (filterValue.startsWith('=')) {
                                whereClause += " OR " + column.field + " = \"" + filterValue.substring(1, filterValue.length) + "\"";
                            }
                            else if (filterValue.startsWith('%')) {
                                whereClause += " OR " + column.field + ".EndsWith(\"" + filterValue.substring(1, filterValue.length) + "\")";
                            }
                            else if (filterValue.endsWith('%')) {
                                whereClause += " OR " + column.field + ".StartsWith(\"" + filterValue.substring(0, filterValue.length - 1) + "\")";
                            }
                            else {
                                whereClause += " OR " + column.field + ".Contains(\"" + filterValue + "\")";
                            }
                        }
                        else if (column.type === 'number') {
                            var value = +(filterInfo.rawFilter[column.field].replace('>=', '').replace('<=', '').replace('>', '').replace('<', '').trim());
                            if (!Number.isNaN(value)) {
                                if (filterInfo.rawFilter[column.field].indexOf('>=') > -1) {
                                    whereClause += " OR " + column.field + " >= " + value;
                                }
                                else if (filterInfo.rawFilter[column.field].indexOf('<=') > -1) {
                                    whereClause += " OR " + column.field + " <= " + value;
                                }
                                else if (filterInfo.rawFilter[column.field].indexOf('>') > -1) {
                                    whereClause += " OR " + column.field + " > " + value;
                                }
                                else if (filterInfo.rawFilter[column.field].indexOf('<') > -1) {
                                    whereClause += " OR " + column.field + " < " + value;
                                }
                                else {
                                    whereClause += " OR " + column.field + " = " + value;
                                }
                            }
                        }
                        else if (column.type === 'bool') {
                            if (filterInfo.rawFilter[column.field] === '0' || filterInfo.rawFilter[column.field] === '1') {
                                whereClause += " OR " + column.field + " = " + (filterInfo.rawFilter[column.field] === '1' ? 'true' : 'false');
                            }
                        }
                        else if (column.type === 'values') {
                            if (filterInfo.rawFilter[column.field]) {
                                // Kiểm tra có phải Guid ko?
                                if (column.isGuid && !_this.isGuid(filterInfo.rawFilter[column.field])) {
                                    return;
                                }
                                if (_this.isGuid(filterInfo.rawFilter[column.field])) {
                                    whereClause += " OR " + column.field + " = GUID(\"" + filterInfo.rawFilter[column.field] + "\")";
                                }
                                else {
                                    whereClause += " OR " + column.field + " = \"" + filterInfo.rawFilter[column.field] + "\"";
                                }
                            }
                        }
                        else if (column.type === 'radio') {
                            if (filterInfo.rawFilter[column.field]) {
                                whereClause += " OR " + column.field + " = \"" + filterInfo.rawFilter[column.field] + "\"";
                            }
                        }
                        else if (column.type === 'date' || column.type === 'datetime') {
                            // "DateTime(yyyy,mm,dd,HH,mm,ss)"
                            // generate fromDate, toDate
                            var date = new Date(filterInfo.rawFilter[column.field]);
                            // From Date
                            date = new Date(date.getFullYear(), date.getMonth(), date.getDate(), 0, 0, 0);
                            whereClause += " OR " + column.field + " >= DateTime(" + date.getFullYear() + "," + (date.getMonth() + 1) + "," + date.getDate() + ")";
                            // To Date
                            date.setDate(date.getDate() + 1);
                            whereClause += " OR " + column.field + " < DateTime(" + date.getFullYear() + "," + (date.getMonth() + 1) + "," + date.getDate() + ")";
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                if (whereClause.trim().startsWith('OR')) {
                    whereClause = whereClause.trim().substr(2);
                    result.whereClause += " AND(" + whereClause + ")";
                }
            };
            filterInfo.columns.forEach(function (column) {
                if (column.type !== 'children') {
                    executeColumnNoChildren(column);
                }
                else {
                    executeColumnChildren(column);
                }
            });
            return result;
        };
        this.mapResponse = function (res) {
            var items = res.items, total = res.total;
            return {
                items: items,
                total: total
            };
        };
        this.isGuid = function (key) {
            return key.length === 36;
            // const regex = new Regex('[0-9a-fA-F]{8}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{4}\-[0-9a-fA-F]{12}');
            // return regex.test(key);
        };
    }
    HandlerDotnet.ɵprov = ɵɵdefineInjectable({ factory: function HandlerDotnet_Factory() { return new HandlerDotnet(); }, token: HandlerDotnet, providedIn: "root" });
    HandlerDotnet = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], HandlerDotnet);
    return HandlerDotnet;
}());

var EditorHandlerPipe = /** @class */ (function () {
    function EditorHandlerPipe() {
    }
    EditorHandlerPipe.prototype.transform = function (value, item, gridOption) {
        var e_1, _a;
        var visible = function (column) {
            var _a, _b, _c, _d;
            if (column.type === 'children') {
                return false;
            }
            var isDisabled = false;
            // Kiểm tra xem có bị disabled hay không?
            if (column.editor) {
                isDisabled = typeof (column.editor.disabled) === 'function' ? column.editor.disabled(item) : column.editor.disabled;
            }
            // Nếu bị disabled return false
            if (isDisabled) {
                return false;
            }
            if (typeof ((_a = gridOption.editor) === null || _a === void 0 ? void 0 : _a.disabled) === 'function') {
                isDisabled = gridOption.editor.disabled(item);
            }
            else {
                isDisabled = (_b = gridOption.editor) === null || _b === void 0 ? void 0 : _b.disabled;
            }
            // Nếu bị disabled return false
            if (isDisabled) {
                return false;
            }
            // Hiển thị editor nếu dòng đó:
            // Đang được edit: editingStatus
            return item.editingStatus
                // Được thiết lập alwayDisplay
                || ((_c = column.editor) === null || _c === void 0 ? void 0 : _c.alwayDisplay)
                // Editable có thuộc tính type inline
                || ((_d = gridOption.editor) === null || _d === void 0 ? void 0 : _d.type) === 'inline';
        };
        item.editorHandler = item.editorHandler || {};
        try {
            for (var _b = __values(gridOption.columns), _c = _b.next(); !_c.done; _c = _b.next()) {
                var column = _c.value;
                item.editorHandler.disabled = false;
                item.editorHandler[column.field] = {};
                if (typeof (gridOption.editor) === 'object') {
                    if (typeof (gridOption.editor.disabled) === 'function') {
                        item.editorHandler.disabled = gridOption.editor.disabled(item);
                    }
                    else {
                        item.editorHandler.disabled = gridOption.editor.disabled;
                    }
                }
                else {
                    item.editorHandler.disabled = false;
                }
                if (item.editorHandler.disabled) {
                    item.editorHandler[column.field].visible = false;
                }
                else {
                    item.editorHandler[column.field].visible = visible(column);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    EditorHandlerPipe = __decorate([
        Pipe({
            name: 'editorHandler'
        })
    ], EditorHandlerPipe);
    return EditorHandlerPipe;
}());

var GridControlComponent = /** @class */ (function () {
    function GridControlComponent(ref, deviceService, handlerLocal, handlerDotnet, utilityService, translateService, configurationService, datePipe, loadingService, apiService, excelService, notifyService, editorVisiblePipe) {
        var _this = this;
        var _a;
        this.ref = ref;
        this.handlerLocal = handlerLocal;
        this.handlerDotnet = handlerDotnet;
        this.utilityService = utilityService;
        this.translateService = translateService;
        this.configurationService = configurationService;
        this.datePipe = datePipe;
        this.loadingService = loadingService;
        this.apiService = apiService;
        this.excelService = excelService;
        this.notifyService = notifyService;
        this.editorVisiblePipe = editorVisiblePipe;
        this.isMobileOrTablet = false;
        this.displayKey = 'SDCUSTOM';
        this.localItems = [];
        this.items = [];
        this.filter = {};
        this.externalFilter = {};
        this.currentPage = 1;
        this.hiddenPaginate = false;
        this.inlineExternal = {};
        this.inlineColumn = {};
        this.quickFilters = [];
        // Paginate
        this.pages = [1];
        this.pageCount = 5;
        this.totalPage = 1;
        // Loading
        this.isLoading = false;
        this.viewItems = [];
        this.fixedColumns = [];
        this.normalColumns = [];
        this.columns = [];
        this.isCheckedAll = false;
        this.selectedItems = [];
        this.selectedItem = null;
        this.rowHandler = {
            click: function (item) {
                _this.selectedItem = item;
                if (_this.gridOption.onClickRow) {
                    _this.gridOption.onClickRow(item);
                }
            },
            dblClick: function (item) {
                _this.selectedItem = item;
                if (_this.gridOption.onDblClickRow) {
                    _this.gridOption.onDblClickRow(item);
                }
            }
        };
        this.setOption = function (option) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
            delete _this.gridOption;
            var gridConfiguration = _this.configurationService.getGridConfiguration();
            if (!((_a = option.filter) === null || _a === void 0 ? void 0 : _a.type) && ((_c = (_b = gridConfiguration) === null || _b === void 0 ? void 0 : _b.filter) === null || _c === void 0 ? void 0 : _c.type)) {
                if (!option.filter) {
                    option.filter = {
                        type: gridConfiguration.filter.type
                    };
                }
                else {
                    option.filter.type = gridConfiguration.filter.type;
                }
            }
            if (!((_d = option.filter) === null || _d === void 0 ? void 0 : _d.columnInline) && ((_f = (_e = gridConfiguration) === null || _e === void 0 ? void 0 : _e.filter) === null || _f === void 0 ? void 0 : _f.columnInline)) {
                if (!option.filter) {
                    option.filter = {
                        columnInline: gridConfiguration.filter.columnInline
                    };
                }
                else {
                    option.filter.columnInline = gridConfiguration.filter.columnInline;
                }
            }
            if (!((_g = option.filter) === null || _g === void 0 ? void 0 : _g.quickFilterVisibility) && ((_j = (_h = gridConfiguration) === null || _h === void 0 ? void 0 : _h.filter) === null || _j === void 0 ? void 0 : _j.quickFilterVisibility)) {
                if (!option.filter) {
                    option.filter = {
                        quickFilterVisibility: gridConfiguration.filter.quickFilterVisibility
                    };
                }
                else {
                    option.filter.quickFilterVisibility = gridConfiguration.filter.quickFilterVisibility;
                }
            }
            _this.gridOption = __assign(__assign({}, defaultGridOption), option);
            switch (_this.gridOption.type) {
                case 'local':
                    _this.handler = _this.handlerLocal;
                    break;
                case 'dotnet':
                    _this.handler = _this.handlerDotnet;
                    break;
                case 'custom':
                    _this.handler = _this.gridOption.handlerCustom || ((_k = gridConfiguration) === null || _k === void 0 ? void 0 : _k.handlerCustom);
                    if (!_this.handler) {
                        _this.notifyService.notify.warning("Handler custom was not found");
                        return;
                    }
                    break;
            }
            // Loại bỏ những command bị ẩn
            _this.gridOption.commands = _this.gridOption.commands.filter(function (command) {
                var hidden = command.hidden;
                if (hidden !== undefined) {
                    if (typeof (hidden) === 'boolean') {
                        return !hidden;
                    }
                    else if (typeof (hidden) === 'function') {
                        return !hidden();
                    }
                }
                else {
                    return true;
                }
            });
            _this.sdGridConfig.setOption({
                key: option.key,
                pageSize: _this.gridOption.paginate.pageSize,
                columns: _this.gridOption.columns
            });
            _this.initExternalFilter();
            _this.resize();
            _this.detectChanges();
        };
        this.reload = function (gridItems) { return __awaiter(_this, void 0, void 0, function () {
            var handler, filter_1, queryString, url, response, _a, items, total, response, _b, items, total, handler, results, _c, response, error_1;
            var _d, _e, _f, _g, _h, _j;
            return __generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        if (this.isLoading) {
                            return [2 /*return*/];
                        }
                        this.isLoading = true;
                        _k.label = 1;
                    case 1:
                        _k.trys.push([1, 15, , 16]);
                        if (!(this.gridOption.type !== 'local')) return [3 /*break*/, 6];
                        handler = this.handler;
                        filter_1 = handler.mapRequest(this.getFilterInfo(this.currentPage, this.gridOption.paginate.pageSize));
                        if (!(this.gridOption.method === 'GET')) return [3 /*break*/, 3];
                        queryString = Object.keys(filter_1).filter(function (key) { return filter_1[key] !== null && filter_1[key] !== undefined; })
                            .map(function (key) { return key + '=' + filter_1[key]; }).join('&');
                        url = this.gridOption.url.includes('?') ? this.gridOption.url + "&" + queryString : this.gridOption.url + "?" + queryString;
                        return [4 /*yield*/, this.apiService.get(url)];
                    case 2:
                        response = _k.sent();
                        _a = handler.mapResponse(response), items = _a.items, total = _a.total;
                        this.items = items;
                        this.total = total;
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.apiService.post(this.gridOption.url, filter_1)];
                    case 4:
                        response = _k.sent();
                        _b = handler.mapResponse(response), items = _b.items, total = _b.total;
                        this.items = items;
                        this.total = total;
                        _k.label = 5;
                    case 5: return [3 /*break*/, 13];
                    case 6:
                        handler = this.handler;
                        if (!(typeof (this.gridOption.items) === 'function')) return [3 /*break*/, 11];
                        if (!Array.isArray(gridItems)) return [3 /*break*/, 7];
                        this.localItems = gridItems;
                        return [3 /*break*/, 10];
                    case 7:
                        results = this.gridOption.items();
                        if (!(results instanceof Promise)) return [3 /*break*/, 9];
                        _c = this;
                        return [4 /*yield*/, results];
                    case 8:
                        _c.localItems = _k.sent();
                        return [3 /*break*/, 10];
                    case 9:
                        this.localItems = results;
                        _k.label = 10;
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        this.gridOption.items = gridItems || this.gridOption.items;
                        this.localItems = this.gridOption.items;
                        _k.label = 12;
                    case 12:
                        response = handler.filter(this.localItems, {
                            customFilter: this.gridOption.filter.customFilter,
                            rawFilter: this.filter,
                            columns: this.gridOption.columns,
                            rawExternalFilter: this.externalFilter,
                            externalFilters: (_d = this.gridOption.filter) === null || _d === void 0 ? void 0 : _d.externalFilters,
                            orderBy: this.orderBy,
                            orderDirection: this.orderDirection,
                            pageNumber: this.currentPage,
                            pageSize: this.gridOption.paginate.pageSize
                        });
                        this.items = response.items;
                        this.total = response.total;
                        _k.label = 13;
                    case 13:
                        this.items.forEach(function (item) { return item.originItem = __assign({}, item); });
                        return [4 /*yield*/, ((_g = (_e = this.gridOption) === null || _e === void 0 ? void 0 : (_f = _e).onReloadCompleted) === null || _g === void 0 ? void 0 : _g.call(_f, this.items))];
                    case 14:
                        _k.sent();
                        this.generatePaginate();
                        this.generateViewItems();
                        this.generateEditorHandlers();
                        this.generateSumarize();
                        this.isLoading = false;
                        $$1(this.gridBody.nativeElement).scrollTop(0);
                        if (this.currentPage > 1 && !((_h = this.viewItems) === null || _h === void 0 ? void 0 : _h.length)) {
                            if (this.gridOption.type === 'local') {
                                if ((_j = this.localItems) === null || _j === void 0 ? void 0 : _j.length) {
                                    this.selectPage(1);
                                    return [2 /*return*/];
                                }
                            }
                            else {
                                if (this.total > 0) {
                                    this.selectPage(1);
                                    return [2 /*return*/];
                                }
                            }
                        }
                        this.detectChanges();
                        return [3 /*break*/, 16];
                    case 15:
                        error_1 = _k.sent();
                        this.utilityService.handle.error(error_1);
                        this.isLoading = false;
                        return [3 /*break*/, 16];
                    case 16: return [2 /*return*/];
                }
            });
        }); };
        this.onCheck = function (item, isCheckbox) {
            var _a, _b;
            if (!_this.gridOption.checkable) {
                return;
            }
            if (!isCheckbox) {
                item.isChecked = !item.isChecked;
            }
            _this.isCheckedAll = _this.items.length === _this.items.filter(function (e) { return e.isChecked; }).length;
            (_b = (_a = _this.gridOption).onCheck) === null || _b === void 0 ? void 0 : _b.call(_a, _this.items.filter(function (e) { return e.isChecked; }), item);
            _this.setSelectedItems();
        };
        //#endregion
        //#region Sort
        this.sort = function (column) {
            var _a, _b;
            var sortable = (_a = _this.gridOption.sortable, (_a !== null && _a !== void 0 ? _a : true));
            var columnSortable = (_b = column.sortable, (_b !== null && _b !== void 0 ? _b : true));
            if (!sortable || !columnSortable) {
                return;
            }
            if (_this.orderBy === column.field) {
                _this.orderDirection = _this.orderDirection === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                _this.orderBy = column.field;
                _this.orderDirection = 'ASC';
            }
            if (_this.gridOption.type === 'local') {
                _this.reload(_this.localItems);
            }
            else {
                _this.reload();
            }
        };
        this.clearFilter = function () {
            _this.filter = {};
            _this.externalFilter = {};
            _this.initFilter();
            _this.initExternalFilter();
            if (_this.sdGridPopupFilter) {
                _this.sdGridPopupFilter.filter = _this.filter;
                _this.sdGridPopupFilter.externalFilter = _this.externalFilter;
            }
        };
        this.onClearFilter = function () {
            _this.clearFilter();
            _this.reload();
        };
        this.expandOrCollapse = function (gridItem) { return __awaiter(_this, void 0, void 0, function () {
            var temporary, originItem, editorHandler, editingStatus, isChecked, subInformation, item, _a, err_1;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        temporary = gridItem.temporary, originItem = gridItem.originItem, editorHandler = gridItem.editorHandler, editingStatus = gridItem.editingStatus, isChecked = gridItem.isChecked, subInformation = gridItem.subInformation, item = __rest(gridItem, ["temporary", "originItem", "editorHandler", "editingStatus", "isChecked", "subInformation"]);
                        if (!this.gridOption.subInformation) {
                            return [2 /*return*/];
                        }
                        if ((_b = gridItem.subInformation) === null || _b === void 0 ? void 0 : _b.isOpened) {
                            gridItem.subInformation.isOpened = false;
                            return [2 /*return*/];
                        }
                        if (!(this.gridOption.subInformation.lazyLoading && !((_c = gridItem.subInformation) === null || _c === void 0 ? void 0 : _c.isLoaded))) return [3 /*break*/, 5];
                        gridItem.subInformation.isLoading = true;
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 3, , 4]);
                        _a = gridItem.subInformation;
                        return [4 /*yield*/, this.gridOption.subInformation.onLoad(item)];
                    case 2:
                        _a.subItems = _d.sent();
                        if (!Array.isArray(gridItem.subInformation.subItems)) {
                            this.notifyService.alert.warning("Data is not an array");
                            gridItem.subInformation.subItems = [];
                        }
                        gridItem.subInformation.isLoading = false;
                        gridItem.subInformation.isLoaded = true;
                        gridItem.subInformation.isOpened = true;
                        this.ref.detectChanges();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _d.sent();
                        this.utilityService.handle.error(err_1);
                        gridItem.subInformation.isLoading = false;
                        this.ref.detectChanges();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                    case 5:
                        if (this.gridOption.subInformation.lazyLoading === false && !gridItem.subInformation.isLoaded) {
                            gridItem.subInformation.subItems = gridItem[this.gridOption.subInformation.field];
                            if (!Array.isArray(gridItem.subInformation.subItems)) {
                                this.notifyService.alert.warning("Data is not an array");
                                gridItem.subInformation.subItems = [];
                            }
                            gridItem.subInformation.isLoaded = true;
                            gridItem.subInformation.isOpened = true;
                            return [2 /*return*/];
                        }
                        gridItem.subInformation.isOpened = true;
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        }); };
        //#region Editable
        this.onCreate = function () {
            var _a, _b, _c;
            var editor = _this.gridOption.editor;
            if (!editor) {
                return;
            }
            if (!((_a = editor) === null || _a === void 0 ? void 0 : _a.addable)) {
                return;
            }
            var item = {
                editingStatus: 'create',
                blinker: {},
                subInformation: {}
            };
            // Gán giá trị mặc định
            _this.gridOption.columns.forEach(function (column) {
                if (column.type === 'values') {
                    item[column.field] = '';
                }
                else if (column.type === 'bool') {
                    item[column.field] = true;
                }
                else if (column.type === 'number') {
                    item[column.field] = 0;
                }
            });
            (_c = (_b = editor).onAdd) === null || _c === void 0 ? void 0 : _c.call(_b, item);
            // Đưa item lên dòng đầu tiên nếu type khác popup
            if (editor.type !== 'popup') {
                if (_this.gridOption.type === 'local') {
                    _this.items.splice(0, 0, item);
                }
                _this.viewItems.splice(0, 0, item);
            }
            _this.onUpdate(item);
        };
        this.onUpdate = function (item) {
            var editor = _this.gridOption.editor;
            item.editingStatus = item.editingStatus || 'update';
            item.temporary = __assign({}, item);
            _this.generateEditorHanlder(item);
            if (editor.type === 'popup') {
                _this.sdGridPopupEditor.open(item);
            }
        };
        this.onSave = function (item) { return __awaiter(_this, void 0, void 0, function () {
            var editor, result, message, result, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        editor = this.gridOption.editor;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 7, 8, 9]);
                        item.editorHandler.saving = true;
                        if (!editor.validate) return [3 /*break*/, 4];
                        result = editor.validate(item);
                        if (!(result instanceof Promise)) return [3 /*break*/, 3];
                        return [4 /*yield*/, result];
                    case 2:
                        message = _a.sent();
                        if (message) {
                            throw message;
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        if (result) {
                            throw result;
                        }
                        _a.label = 4;
                    case 4:
                        if (!editor.onSave) return [3 /*break*/, 6];
                        result = editor.onSave(item);
                        if (!(result instanceof Promise)) return [3 /*break*/, 6];
                        return [4 /*yield*/, result];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        if (item.editingStatus === 'create' && editor.type === 'popup') {
                            if (this.gridOption.type === 'local') {
                                this.items.splice(0, 0, item);
                            }
                            this.viewItems.splice(0, 0, item);
                        }
                        item.editingStatus = undefined;
                        this.generateEditorHanlder(item);
                        return [3 /*break*/, 9];
                    case 7:
                        err_2 = _a.sent();
                        this.notifyService.notify.warning(err_2);
                        return [3 /*break*/, 9];
                    case 8:
                        item.editorHandler.saving = false;
                        this.ref.detectChanges();
                        return [7 /*endfinally*/];
                    case 9: return [2 /*return*/];
                }
            });
        }); };
        this.onCancel = function (item) {
            var editor = _this.gridOption.editor;
            if (item.editingStatus === 'create') {
                if (editor.type !== 'popup') {
                    if (_this.gridOption.type === 'local') {
                        _this.items.splice(0, 1);
                    }
                    _this.viewItems.splice(0, 1);
                }
            }
            else {
                Object.assign(item, item.temporary);
                item.editingStatus = undefined;
                _this.generateEditorHanlder(item);
                _this.ref.detectChanges();
            }
        };
        this.initExternalFilter = function () {
            var _a, _b;
            if ((_b = (_a = _this.gridOption.filter) === null || _a === void 0 ? void 0 : _a.externalFilters) === null || _b === void 0 ? void 0 : _b.length) {
                _this.gridOption.filter.externalFilters.forEach(function (externalFilter) {
                    var _a, _b, _c, _d, _e, _f, _g, _h;
                    if (externalFilter.type === 'string') {
                        if (externalFilter.default) {
                            _this.externalFilter[externalFilter.field] = (_a = externalFilter.default, (_a !== null && _a !== void 0 ? _a : ''));
                        }
                        return;
                    }
                    if (externalFilter.type === 'number') {
                        if (externalFilter.default) {
                            _this.externalFilter[externalFilter.field] = (_b = externalFilter.default, (_b !== null && _b !== void 0 ? _b : undefined));
                        }
                        return;
                    }
                    if (externalFilter.type === 'daterange') {
                        _this.externalFilter[externalFilter.field] = {
                            from: (_c = externalFilter.defaultFrom, (_c !== null && _c !== void 0 ? _c : undefined)),
                            to: (_d = externalFilter.defaultTo, (_d !== null && _d !== void 0 ? _d : undefined))
                        };
                        return;
                    }
                    if (externalFilter.type === 'numberrange') {
                        _this.externalFilter[externalFilter.field] = {
                            from: (_e = externalFilter.defaultFrom, (_e !== null && _e !== void 0 ? _e : undefined)),
                            to: (_f = externalFilter.defaultTo, (_f !== null && _f !== void 0 ? _f : undefined))
                        };
                        return;
                    }
                    if (externalFilter.type === 'daterangefull') {
                        _this.externalFilter[externalFilter.field] = {
                            from: (_g = externalFilter.defaultFrom, (_g !== null && _g !== void 0 ? _g : undefined)),
                            to: (_h = externalFilter.defaultTo, (_h !== null && _h !== void 0 ? _h : undefined))
                        };
                        return;
                    }
                });
            }
        };
        //#endregion
        this.onSearch = function (searchValue, item, column) {
            item[column.field] = searchValue;
        };
        this.onFilterConfigurationLoaded = function (param) {
            var _a, _b;
            _this.quickFilters = param.quickFilters || [];
            _this.selectedQuickFilter = param.selectedQuickFilter || '';
            if (_this.selectedQuickFilter) {
                var quickFilter = _this.quickFilters.find(function (e) { return e.code === _this.selectedQuickFilter; });
                if (quickFilter) {
                    var f1 = JSON.stringify(quickFilter.filter);
                    var f2 = JSON.stringify(quickFilter.externalFilter);
                    _this.filter = JSON.parse(f1);
                    _this.externalFilter = _this.refreshExternalFilter((_b = (_a = _this.gridOption) === null || _a === void 0 ? void 0 : _a.filter) === null || _b === void 0 ? void 0 : _b.externalFilters, JSON.parse(f2));
                }
            }
            _this.inlineExternal = param.inlineExternal || {};
            _this.inlineColumn = param.inlineColumn || {};
            _this.resize();
        };
        this.onSelectQuickFilter = function (event) {
            var _a, _b, _c, _d, _e;
            var quickFilter = _this.quickFilters.find(function (e) { return e.code === event.value; });
            if ((_a = quickFilter) === null || _a === void 0 ? void 0 : _a.code) {
                var f1 = JSON.stringify(quickFilter.filter);
                var f2 = JSON.stringify(quickFilter.externalFilter);
                _this.selectedQuickFilter = (_b = quickFilter) === null || _b === void 0 ? void 0 : _b.code;
                _this.filter = JSON.parse(f1);
                _this.externalFilter = _this.refreshExternalFilter((_d = (_c = _this.gridOption) === null || _c === void 0 ? void 0 : _c.filter) === null || _d === void 0 ? void 0 : _d.externalFilters, JSON.parse(f2));
                _this.updateFilter();
            }
            else {
                _this.selectedQuickFilter = '';
                _this.onClearFilter();
            }
            (_e = _this.sdGridPopupFilter) === null || _e === void 0 ? void 0 : _e.updateConfiguration(_this.selectedQuickFilter);
        };
        this.getExportItems = function () { return __awaiter(_this, void 0, void 0, function () {
            var pageNumber, pageSize, handler, filter_2, queryString, url, response, response, localItems, handler, results, response, error_2;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.isLoading) {
                            return [2 /*return*/];
                        }
                        pageNumber = 1;
                        pageSize = 10000;
                        this.isLoading = true;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 13, 14, 15]);
                        if (!(this.gridOption.type !== 'local')) return [3 /*break*/, 6];
                        handler = this.handler;
                        filter_2 = handler.mapRequest(this.getFilterInfo(pageNumber, pageSize));
                        if (!(this.gridOption.method === 'GET')) return [3 /*break*/, 3];
                        queryString = Object.keys(filter_2).filter(function (key) { return filter_2[key] !== null && filter_2[key] !== undefined; })
                            .map(function (key) { return key + '=' + filter_2[key]; }).join('&');
                        url = this.gridOption.url.includes('?') ? this.gridOption.url + "&" + queryString : this.gridOption.url + "?" + queryString;
                        return [4 /*yield*/, this.apiService.get(url)];
                    case 2:
                        response = _b.sent();
                        return [2 /*return*/, handler.mapResponse(response).items];
                    case 3: return [4 /*yield*/, this.apiService.post(this.gridOption.url, filter_2)];
                    case 4:
                        response = _b.sent();
                        return [2 /*return*/, handler.mapResponse(response).items];
                    case 5: return [3 /*break*/, 12];
                    case 6:
                        localItems = [];
                        handler = this.handler;
                        if (!(typeof (this.gridOption.items) === 'function')) return [3 /*break*/, 10];
                        results = this.gridOption.items();
                        if (!(results instanceof Promise)) return [3 /*break*/, 8];
                        return [4 /*yield*/, results];
                    case 7:
                        localItems = _b.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        localItems = results;
                        _b.label = 9;
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        localItems = this.gridOption.items;
                        _b.label = 11;
                    case 11:
                        response = handler.filter(localItems, {
                            customFilter: this.gridOption.filter.customFilter,
                            rawFilter: this.filter,
                            columns: this.gridOption.columns,
                            rawExternalFilter: this.externalFilter,
                            externalFilters: (_a = this.gridOption.filter) === null || _a === void 0 ? void 0 : _a.externalFilters,
                            orderBy: this.orderBy,
                            orderDirection: this.orderDirection,
                            pageNumber: pageNumber,
                            pageSize: pageSize
                        });
                        return [2 /*return*/, response.items];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        error_2 = _b.sent();
                        this.utilityService.handle.error(error_2);
                        return [3 /*break*/, 15];
                    case 14:
                        this.isLoading = false;
                        this.ref.detectChanges();
                        return [7 /*endfinally*/];
                    case 15: return [2 /*return*/];
                }
            });
        }); };
        this.getFilterInfo = function (pageNumber, pageSize) {
            var e_1, _a, e_2, _b;
            var _c;
            try {
                for (var _d = __values(Object.keys(_this.filter)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var key = _e.value;
                    if (typeof (_this.filter[key]) === 'string') {
                        _this.filter[key] = _this.filter[key].trim();
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                }
                finally { if (e_1) throw e_1.error; }
            }
            try {
                for (var _f = __values(Object.keys(_this.externalFilter)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var key = _g.value;
                    if (typeof (_this.externalFilter[key]) === 'string') {
                        _this.externalFilter[key] = _this.externalFilter[key].trim();
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return {
                customFilter: _this.gridOption.filter.customFilter,
                rawFilter: _this.filter,
                columns: _this.gridOption.columns,
                rawExternalFilter: _this.externalFilter,
                externalFilters: (_c = _this.gridOption.filter) === null || _c === void 0 ? void 0 : _c.externalFilters,
                orderBy: _this.orderBy,
                orderDirection: _this.orderDirection,
                pageNumber: pageNumber,
                pageSize: pageSize
            };
        };
        this.onExportByTemplate = function (params) { return __awaiter(_this, void 0, void 0, function () {
            var exportItems, results, columns, items;
            var _this = this;
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        this.loadingService.start();
                        exportItems = [];
                        if (!((_a = this.gridOption.export) === null || _a === void 0 ? void 0 : _a.items)) return [3 /*break*/, 2];
                        return [4 /*yield*/, ((_b = this.gridOption.export) === null || _b === void 0 ? void 0 : _b.items(this.getFilterInfo(1, 10000)).finally(this.loadingService.stop))];
                    case 1:
                        exportItems = _e.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.getExportItems().finally(this.loadingService.stop)];
                    case 3:
                        exportItems = _e.sent();
                        _e.label = 4;
                    case 4:
                        if (!((_c = this.gridOption.export) === null || _c === void 0 ? void 0 : _c.mapping)) return [3 /*break*/, 7];
                        results = this.gridOption.export.mapping(exportItems, params.excelConfig.name);
                        if (!(results instanceof Promise)) return [3 /*break*/, 6];
                        return [4 /*yield*/, results];
                    case 5:
                        exportItems = _e.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        exportItems = results;
                        _e.label = 7;
                    case 7:
                        columns = __spread(this.gridOption.columns, (((_d = this.gridOption.export) === null || _d === void 0 ? void 0 : _d.columns) || []));
                        items = exportItems.map(function (item) {
                            var obj = {};
                            var handle = function (column) {
                                if (column.type === 'children') {
                                    column.children.forEach(handle);
                                }
                                else if (column.transform) {
                                    obj[column.field] = column.transform(item[column.field], item);
                                }
                                else if (item[column.field] === undefined || item[column.field] === null || item[column.field] === '') {
                                    obj[column.field] = '';
                                }
                                else if (column.type === 'string' || column.type === 'number' || column.type === 'color') {
                                    // Nếu cell là string hoặc number thì gán bằng chính nó
                                    obj[column.field] = item[column.field];
                                }
                                else if (column.type === 'bool') {
                                    // Nếu là bool thì gán bằng giá trị trueValue và falseValue (nếu có), mặc định là TRUE/FALSE
                                    if (item[column.field]) {
                                        obj[column.field] = column.trueValue || 'True';
                                    }
                                    else {
                                        obj[column.field] = column.falseValue || 'False';
                                    }
                                }
                                else if (column.type === 'date') {
                                    // Nếu là date thì convert theo đúng format
                                    var date = new Date(item[column.field]);
                                    obj[column.field] = _this.datePipe.transform(date, 'dd/MM/yyyy');
                                }
                                else if (column.type === 'datetime') {
                                    // Nếu là datetime thì convert theo đúng format
                                    var date = new Date(item[column.field]);
                                    obj[column.field] = _this.datePipe.transform(date, 'dd/MM/yyyy HH:mm:ss');
                                }
                                else if (column.type === 'time') {
                                    // Nếu là time thì convert theo đúng format
                                    var date = new Date(item[column.field]);
                                    obj[column.field] = _this.datePipe.transform(date, 'HH:mm:ss');
                                }
                                else if (column.type === 'values') {
                                    // Nếu là values thì lấy giá trị của value được chọn
                                    var data = column.values.find(function (e) { return e.value === item[column.field]; });
                                    if (data) {
                                        obj[column.field] = data.text;
                                    }
                                    else {
                                        obj[column.field] = item[column.field];
                                    }
                                }
                                else if (column.type === 'radio') {
                                    var data = column.values.find(function (e) { return e[column.valueField] === item[column.field]; });
                                    if (data) {
                                        obj[column.field] = data[column.displayField];
                                    }
                                    else {
                                        obj[column.field] = item[column.field];
                                    }
                                }
                            };
                            columns.forEach(handle);
                            return obj;
                        });
                        this.excelService.generateExcelDataByTemplate(params.excelConfig.fullPath, params.excelColumns, items, params.excelConfig.name);
                        return [2 /*return*/];
                }
            });
        }); };
        this.onEditorChange = function () {
            _this.ref.detectChanges();
        };
        this.onSelectPageSize = function () {
            _this.reload();
        };
        this.refreshExternalFilter = function (externalFilters, externalFilter) {
            externalFilter = externalFilter || {};
            externalFilters = externalFilters || [];
            externalFilters.forEach(function (e) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
                if (e.type === 'string') {
                    if (e.default) {
                        externalFilter[e.field] = (_a = e.default, (_a !== null && _a !== void 0 ? _a : ''));
                    }
                    return;
                }
                if (e.type === 'number') {
                    externalFilter[e.field] = (_c = (_b = externalFilter[e.field], (_b !== null && _b !== void 0 ? _b : e.default)), (_c !== null && _c !== void 0 ? _c : undefined));
                    return;
                }
                if (e.type === 'daterange') {
                    externalFilter[e.field] = {
                        from: (_f = (_e = (_d = externalFilter[e.field]) === null || _d === void 0 ? void 0 : _d.from, (_e !== null && _e !== void 0 ? _e : e.defaultFrom)), (_f !== null && _f !== void 0 ? _f : undefined)),
                        to: (_j = (_h = (_g = externalFilter[e.field]) === null || _g === void 0 ? void 0 : _g.to, (_h !== null && _h !== void 0 ? _h : e.defaultTo)), (_j !== null && _j !== void 0 ? _j : undefined))
                    };
                    return;
                }
                if (e.type === 'numberrange') {
                    externalFilter[e.field] = {
                        from: (_m = (_l = (_k = externalFilter[e.field]) === null || _k === void 0 ? void 0 : _k.from, (_l !== null && _l !== void 0 ? _l : e.defaultFrom)), (_m !== null && _m !== void 0 ? _m : undefined)),
                        to: (_q = (_p = (_o = externalFilter[e.field]) === null || _o === void 0 ? void 0 : _o.to, (_p !== null && _p !== void 0 ? _p : e.defaultTo)), (_q !== null && _q !== void 0 ? _q : undefined))
                    };
                    return;
                }
                if (e.type === 'daterangefull') {
                    externalFilter[e.field] = {
                        from: (_t = (_s = (_r = externalFilter[e.field]) === null || _r === void 0 ? void 0 : _r.from, (_s !== null && _s !== void 0 ? _s : e.defaultFrom)), (_t !== null && _t !== void 0 ? _t : undefined)),
                        to: (_w = (_v = (_u = externalFilter[e.field]) === null || _u === void 0 ? void 0 : _u.to, (_v !== null && _v !== void 0 ? _v : e.defaultTo)), (_w !== null && _w !== void 0 ? _w : undefined))
                    };
                    return;
                }
            });
            return externalFilter;
        };
        this.onCreateQuickFilter = function (ev) {
            var _a;
            _this.matSelect.close();
            _this.onFilterPopup();
            _this.sdGridPopupFilter.close();
            (_a = _this.sdGridPopupFilter) === null || _a === void 0 ? void 0 : _a.onCreateQuickFilter(ev);
        };
        this.onEditQuickFilter = function (ev, quickFilter) {
            var _a;
            _this.matSelect.close();
            _this.onFilterPopup();
            _this.sdGridPopupFilter.close();
            (_a = _this.sdGridPopupFilter) === null || _a === void 0 ? void 0 : _a.onEditQuickFilter(ev, quickFilter);
        };
        this.onDeleteQuickFilter = function (ev, quickFilter) {
            var _a;
            _this.matSelect.close();
            _this.onFilterPopup();
            _this.sdGridPopupFilter.close();
            (_a = _this.sdGridPopupFilter) === null || _a === void 0 ? void 0 : _a.onDeleteQuickFilter(ev, quickFilter);
        };
        this.noDataImage = (_a = this.configurationService.getGridConfiguration()) === null || _a === void 0 ? void 0 : _a.noDataImage;
        this.isMobileOrTablet = !deviceService.isDesktop();
        // this.ref.detach();
        // setInterval(() => {
        //   this.ref.markForCheck();
        // }, 1000);
        // ref.detach();
    }
    Object.defineProperty(GridControlComponent.prototype, "option", {
        set: function (value) {
            this.setOption(value);
        },
        enumerable: true,
        configurable: true
    });
    GridControlComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.fixedHeadersSubcription = this.fixedHeaders.changes.subscribe(function () {
            var fixedHeaders = _this.fixedHeaders.toArray();
            if (fixedHeaders.length > 0) {
                var left = $$1(fixedHeaders[0].nativeElement).outerWidth(true);
                for (var i = 1; i < fixedHeaders.length; i++) {
                    $$1(fixedHeaders[i].nativeElement).css({ left: left });
                    left += $$1(fixedHeaders[i].nativeElement).outerWidth(true);
                }
            }
        });
        this.fixedBodiesSubcription = this.fixedBodies.changes.subscribe(function () {
            var fixedBodies = _this.fixedBodies.toArray();
            if (fixedBodies.length > 0) {
                var fixedPerRow = _this.fixedBodies.length / _this.viewItems.length;
                var left = $$1(fixedBodies[0].nativeElement).outerWidth(true);
                for (var i = 1; i < fixedBodies.length; i++) {
                    if (i % fixedPerRow === 0) {
                        left = 0;
                    }
                    $$1(fixedBodies[i].nativeElement).css({ left: left });
                    left += $$1(fixedBodies[i].nativeElement).outerWidth(true);
                }
            }
        });
    };
    GridControlComponent.prototype.ngOnDestroy = function () {
        var _a, _b;
        (_a = this.fixedHeadersSubcription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        (_b = this.fixedBodiesSubcription) === null || _b === void 0 ? void 0 : _b.unsubscribe();
    };
    GridControlComponent.prototype.reloadItem = function (data) {
        var _this = this;
        Object.keys(data).forEach(function (id) {
            var item = _this.items.find(function (e) { return !!e.id && e.id === id; });
            if (item) {
                _this.gridOption.columns.forEach(function (column) {
                    if (item[column.field] !== undefined && data[id][column.field] !== undefined && item[column.field] !== data[id][column.field]) {
                        _this.blink(item, column.field);
                    }
                });
                Object.assign(item, data[id]);
                _this.generateEditorHanlder(item);
                _this.stopBlink();
            }
        });
    };
    GridControlComponent.prototype.blink = function (item, field) {
        item.blinker = item.blinker || {};
        item.blinker[field] = true;
    };
    GridControlComponent.prototype.stopBlink = function () {
        var _this = this;
        setTimeout(function () {
            _this.viewItems.forEach(function (item) {
                item.blinker = {};
            });
        }, 1500);
    };
    GridControlComponent.prototype.detectChanges = function () {
        this.ref.detectChanges();
        this.ref.markForCheck();
    };
    GridControlComponent.prototype.generateViewItems = function () {
        var _this = this;
        this.currentPage = this.currentPage || 1;
        delete this.viewItems;
        if (this.gridOption.type === 'local') {
            this.viewItems = this.items.filter(function (item, index) {
                return index >= (_this.currentPage - 1) * _this.gridOption.paginate.pageSize
                    && index < _this.currentPage * _this.gridOption.paginate.pageSize;
            });
        }
        else {
            this.viewItems = this.items;
        }
        this.viewItems.forEach(function (item) {
            item.blinker = item.blinker || {};
            item.subInformation = item.subInformation || {};
        });
    };
    Object.defineProperty(GridControlComponent.prototype, "editedItems", {
        get: function () {
            return this.items.filter(function (item) {
                if (!item.originItem) {
                    return true;
                }
                if (Object.keys(item.originItem).some(function (key) { return item.originItem[key] !== item[key]; })) {
                    return true;
                }
                return false;
            }).map(function (item) {
                var temporary = item.temporary, originItem = item.originItem, editorHandler = item.editorHandler, editingStatus = item.editingStatus, isChecked = item.isChecked, subInformation = item.subInformation, blinker = item.blinker, result = __rest(item, ["temporary", "originItem", "editorHandler", "editingStatus", "isChecked", "subInformation", "blinker"]);
                return result;
            });
        },
        enumerable: true,
        configurable: true
    });
    GridControlComponent.prototype.selectPage = function (selectedPage) {
        if (this.isLoading) {
            return;
        }
        var page = +selectedPage || 1;
        if (this.currentPage !== page && page > 0 && page <= this.totalPage) {
            this.currentPage = page;
            if (this.gridOption.type === 'local') {
                this.reload(this.localItems);
            }
            else {
                this.reload();
            }
        }
    };
    GridControlComponent.prototype.updateFilter = function (param) {
        var _a, _b;
        if ((_a = param) === null || _a === void 0 ? void 0 : _a.filter) {
            this.filter = param.filter;
        }
        if ((_b = param) === null || _b === void 0 ? void 0 : _b.externalFilter) {
            this.externalFilter = param.externalFilter;
        }
        if (this.gridOption.type === 'local') {
            this.reload(this.localItems);
        }
        else {
            this.reload();
        }
    };
    GridControlComponent.prototype.generatePaginate = function () {
        var pageSize = this.gridOption.paginate.pageSize;
        if (this.gridOption.type === 'local') {
            this.total = this.items.length;
        }
        this.pages = [];
        this.totalPage = Math.trunc(this.total / pageSize) + (this.total % pageSize === 0 ? 0 : 1);
        if (this.totalPage <= this.pageCount) {
            for (var i = 1; i <= this.totalPage; i++) {
                this.pages.push(i);
            }
        }
        else {
            if (this.currentPage < 3) {
                this.pages = [1, 2, 3, 4, 5];
            }
            else if (this.currentPage > this.totalPage - 2) {
                this.pages = [this.totalPage - 4, this.totalPage - 3, this.totalPage - 2, this.totalPage - 1, this.totalPage];
            }
            else {
                this.pages = [this.currentPage - 2, this.currentPage - 1, this.currentPage, this.currentPage + 1, this.currentPage + 2];
            }
        }
        this.hiddenPaginate = this.currentPage === 1 && this.total <= pageSize;
    };
    GridControlComponent.prototype.generateSumarize = function () {
        var _a;
        if (((_a = this.items) === null || _a === void 0 ? void 0 : _a.length) > 0) {
            var from = +this.gridOption.paginate.pageSize * (+this.currentPage - 1) + 1;
            var to = from + this.viewItems.length - 1;
            this.sumarize = from + " - " + to + " / " + this.total;
        }
        else {
            this.sumarize = this.translateService.translate('EMPTY');
        }
    };
    GridControlComponent.prototype.getItems = function () {
        return this.items;
    };
    //#region Checkable
    GridControlComponent.prototype.setSelectedItems = function () {
        this.selectedItems = this.items.filter(function (item) { return item.isChecked; })
            .map(function (item) {
            var temporary = item.temporary, originItem = item.originItem, editorHandler = item.editorHandler, editingStatus = item.editingStatus, isChecked = item.isChecked, subInformation = item.subInformation, blinker = item.blinker, result = __rest(item, ["temporary", "originItem", "editorHandler", "editingStatus", "isChecked", "subInformation", "blinker"]);
            return result;
        });
    };
    GridControlComponent.prototype.checkAll = function (isCheckedAll) {
        var _this = this;
        this.isCheckedAll = isCheckedAll;
        this.items.forEach(function (item) { return item.isChecked = _this.isCheckedAll; });
        if (this.gridOption.onCheck) {
            this.gridOption.onCheck(this.items.filter(function (item) { return item.isChecked; }));
        }
        this.setSelectedItems();
    };
    //#endregion
    // #region Resize Grid
    GridControlComponent.prototype.resize = function () {
        var _this = this;
        this.detectChanges();
        if (this.gridOption.height) {
            this.gridBody.nativeElement.style.height = this.gridOption.height;
        }
        else {
            this.gridBody.nativeElement.style.height = window.innerHeight - 300 + "px";
            setTimeout(function () {
                // Lấy offset top để điều chỉnh kích thước Grid vừa với màn hình
                var top = _this.gridBody.nativeElement.getBoundingClientRect().top;
                // const top = $(this.gridBody.nativeElement).offset().top;
                var bottom = _this.gridOption.hideFooter ? 0 : (_this.isMobileOrTablet ? 45 : 55);
                var height = window.innerHeight - top - bottom;
                _this.gridBody.nativeElement.style.height = height + "px";
            }, 0);
            setTimeout(function () {
                // Lấy offset top để điều chỉnh kích thước Grid vừa với màn hình
                var top = _this.gridBody.nativeElement.getBoundingClientRect().top;
                // const top = $(this.gridBody.nativeElement).offset().top;
                var bottom = _this.gridOption.hideFooter ? 0 : (_this.isMobileOrTablet ? 45 : 55);
                var height = window.innerHeight - top - bottom;
                _this.gridBody.nativeElement.style.height = height + "px";
            }, 200);
            setTimeout(function () {
                // Lấy offset top để điều chỉnh kích thước Grid vừa với màn hình
                var top = _this.gridBody.nativeElement.getBoundingClientRect().top;
                // const top = $(this.gridBody.nativeElement).offset().top;
                var bottom = _this.gridOption.hideFooter ? 0 : (_this.isMobileOrTablet ? 45 : 55);
                var height = window.innerHeight - top - bottom;
                _this.gridBody.nativeElement.style.height = height + "px";
            }, 500);
            setTimeout(function () {
                // Lấy offset top để điều chỉnh kích thước Grid vừa với màn hình
                var top = _this.gridBody.nativeElement.getBoundingClientRect().top;
                // const top = $(this.gridBody.nativeElement).offset().top;
                var bottom = _this.gridOption.hideFooter ? 0 : (_this.isMobileOrTablet ? 45 : 55);
                var height = window.innerHeight - top - bottom;
                _this.gridBody.nativeElement.style.height = height + "px";
            }, 1000);
        }
    };
    GridControlComponent.prototype.setHeight = function (height) {
        this.gridOption.height = height;
        this.resize();
    };
    // #endregion
    //#region Import, Export, Config
    GridControlComponent.prototype.loadConfig = function (configResult) {
        this.gridOption.paginate.pageSize = configResult.pageSize;
        this.gridOption.columns = configResult.columns;
        this.fixedColumns = configResult.fixedColumns;
        this.normalColumns = configResult.normalColumns;
        this.columns = __spread(this.fixedColumns, this.normalColumns);
        this.currentPage = 1;
        this.initFilter();
        this.initDictionaryColumnValues();
        this.reload();
    };
    GridControlComponent.prototype.initFilter = function () {
        var _this = this;
        this.gridOption.columns.forEach(function (column) {
            var _a;
            // Gán giá trị filter mặc định cho từng cột
            _this.filter[column.field] = (_a = _this.filter[column.field], (_a !== null && _a !== void 0 ? _a : ''));
        });
    };
    GridControlComponent.prototype.initDictionaryColumnValues = function () {
        this.gridOption.columns.forEach(function (column) {
            if (column.type === 'values') {
                column.dictionary = {};
                if (column.values) {
                    column.values.forEach(function (e) {
                        column.dictionary[e.value.toString()] = {
                            text: e.text,
                            icon: e.icon,
                            color: e.color,
                            backgroundColor: e.backgroundColor
                        };
                    });
                }
            }
            if (column.type === 'children') {
                column.children.forEach(function (childColumn) {
                    if (childColumn.type === 'values') {
                        childColumn.dictionary = {};
                        if (childColumn.values) {
                            childColumn.values.forEach(function (e) {
                                childColumn.dictionary[e.value.toString()] = {
                                    text: e.text,
                                    icon: e.icon,
                                    color: e.color,
                                    backgroundColor: e.backgroundColor
                                };
                            });
                        }
                    }
                });
            }
        });
    };
    //#endregion
    GridControlComponent.prototype.generateEditorHandlers = function () {
        var _this = this;
        this.viewItems.forEach(function (item) {
            _this.generateEditorHanlder(item);
        });
    };
    GridControlComponent.prototype.generateEditorHanlder = function (item) {
        // item.editorHandler = item.editorHandler || {};
        this.editorVisiblePipe.transform(null, item, this.gridOption);
    };
    GridControlComponent.prototype.trackById = function (index, item) {
        return item.id;
    };
    Object.defineProperty(GridControlComponent.prototype, "isFiltering", {
        get: function () {
            return Object.values(this.filter).some(function (value) { return !!value; });
        },
        enumerable: true,
        configurable: true
    });
    GridControlComponent.prototype.onFilterPopup = function () {
        var _a;
        var f1 = JSON.stringify(this.filter);
        var f2 = JSON.stringify(this.externalFilter);
        var filter = JSON.parse(f1);
        var externalFilter = JSON.parse(f2);
        this.sdGridPopupFilter.open(this.fixedColumns, this.normalColumns, filter, externalFilter, (_a = this.gridOption.filter) === null || _a === void 0 ? void 0 : _a.externalFilters);
    };
    Object.defineProperty(GridControlComponent.prototype, "invalidItems", {
        get: function () {
            return this.items.filter(function (e) { var _a; return (_a = e.editorHandler) === null || _a === void 0 ? void 0 : _a.errorMessage; }).map(function (e) {
                var temporary = e.temporary, originItem = e.originItem, editorHandler = e.editorHandler, editingStatus = e.editingStatus, isChecked = e.isChecked, subInformation = e.subInformation, blinker = e.blinker, item = __rest(e, ["temporary", "originItem", "editorHandler", "editingStatus", "isChecked", "subInformation", "blinker"]);
                return {
                    item: item,
                    message: e.editorHandler.errorMessage
                };
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridControlComponent.prototype, "gridItems", {
        get: function () {
            return this.items.map(function (e) {
                var temporary = e.temporary, originItem = e.originItem, editorHandler = e.editorHandler, editingStatus = e.editingStatus, isChecked = e.isChecked, subInformation = e.subInformation, blinker = e.blinker, item = __rest(e, ["temporary", "originItem", "editorHandler", "editingStatus", "isChecked", "subInformation", "blinker"]);
                return item;
            });
        },
        enumerable: true,
        configurable: true
    });
    GridControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DeviceDetectorService },
        { type: HandlerLocal },
        { type: HandlerDotnet },
        { type: UtilityService },
        { type: TranslateService },
        { type: ConfigurationService },
        { type: DatePipe },
        { type: LoadingService },
        { type: ApiService },
        { type: ExcelService },
        { type: NotifyService },
        { type: EditorHandlerPipe }
    ]; };
    __decorate([
        ViewChildren('fixedHeader')
    ], GridControlComponent.prototype, "fixedHeaders", void 0);
    __decorate([
        ViewChildren('fixedBody')
    ], GridControlComponent.prototype, "fixedBodies", void 0);
    __decorate([
        ViewChild('fixedGridContainer')
    ], GridControlComponent.prototype, "fixedGridContainer", void 0);
    __decorate([
        ViewChild('gridFixedBody')
    ], GridControlComponent.prototype, "gridFixedBody", void 0);
    __decorate([
        ViewChild('gridContainer')
    ], GridControlComponent.prototype, "gridContainer", void 0);
    __decorate([
        ViewChild('gridHeader')
    ], GridControlComponent.prototype, "gridHeader", void 0);
    __decorate([
        ViewChild('gridBody')
    ], GridControlComponent.prototype, "gridBody", void 0);
    __decorate([
        ViewChild('sdGridConfig', { static: true })
    ], GridControlComponent.prototype, "sdGridConfig", void 0);
    __decorate([
        ViewChild('sdGridPopupEditor')
    ], GridControlComponent.prototype, "sdGridPopupEditor", void 0);
    __decorate([
        ViewChild('sdGridPopupFilter')
    ], GridControlComponent.prototype, "sdGridPopupFilter", void 0);
    __decorate([
        ViewChild('matSelect')
    ], GridControlComponent.prototype, "matSelect", void 0);
    __decorate([
        ViewChild('sdGridImportExcel')
    ], GridControlComponent.prototype, "sdGridImportExcel", void 0);
    __decorate([
        ViewChild('sdGridPopupExportExcel')
    ], GridControlComponent.prototype, "sdGridPopupExportExcel", void 0);
    __decorate([
        Input()
    ], GridControlComponent.prototype, "option", null);
    GridControlComponent = __decorate([
        Component({
            selector: 'sd-grid-control',
            template: "<div class=\"clearfix\"></div>\r\n<mat-form-field\r\n  *ngIf=\"gridOption?.key && !gridOption?.filter?.disabled && (!gridOption?.filter?.quickFilterVisibility || gridOption?.filter?.quickFilterVisibility === 'inline')\"\r\n  class=\"sd-form\" appearance=\"outline\" style=\"width: 200px;\">\r\n  <mat-label>{{'Quick filters' | sdTranslate}}</mat-label>\r\n  <mat-select [(ngModel)]=\"selectedQuickFilter\" (selectionChange)=\"onSelectQuickFilter($event)\" #matSelect>\r\n    <mat-option value=\"\">{{'Please select' | sdTranslate}}</mat-option>\r\n    <mat-option *ngFor=\"let quickFilter of quickFilters\" [value]=\"quickFilter.code\">\r\n      <div style=\"display:flex; justify-content: space-between\">\r\n        <span>{{quickFilter.code}}</span>\r\n        <div>\r\n          <mat-icon class=\"mr-1 c-fa-icon\" (click)=\"onEditQuickFilter($event, quickFilter)\" fontSet=\"fa\"\r\n            fontIcon=\"fa-pencil\"></mat-icon>\r\n          <mat-icon class=\"mr-0 c-fa-icon\" (click)=\"onDeleteQuickFilter($event, quickFilter)\" fontSet=\"fa\"\r\n            fontIcon=\"fa-trash-o\"></mat-icon>\r\n        </div>\r\n      </div>\r\n    </mat-option>\r\n    <mat-option>\r\n      <div (click)=\"onCreateQuickFilter($event)\">\r\n        <mat-icon class=\"mr-1\" fontSet=\"material-icons-outlined\">add</mat-icon>\r\n        <span>{{'Create quick filter' | sdTranslate}}</span>\r\n      </div>\r\n    </mat-option>\r\n  </mat-select>\r\n</mat-form-field>\r\n<ng-container *ngIf=\"!isMobileOrTablet && !gridOption?.filter?.disabled\">\r\n  <sd-grid-desktop-inline-filter [externalFilters]=\"gridOption?.filter?.externalFilters\" [columns]=\"gridOption?.columns\"\r\n    [filter]=\"filter\" [externalFilter]=\"externalFilter\" [columnInline]=\"gridOption.filter?.columnInline\"\r\n    (sdChange)=\"updateFilter()\" [inlineExternal]=\"inlineExternal\" [inlineColumn]=\"inlineColumn\">\r\n  </sd-grid-desktop-inline-filter>\r\n</ng-container>\r\n<div *ngIf=\"!isMobileOrTablet; else elseMobileOrTablet\" class=\"sd-box sd-box-primary\">\r\n  <div class=\"sd-box-body p-0\">\r\n    <div class=\"row mx-0\">\r\n      <div [ngClass]=\"{'c-loading': isLoading}\" class=\"table-responsive\" #gridBody style=\"position: relative;\">\r\n        <i [ngClass]=\"{'d-none': !isLoading}\" class=\"fa fa-5x fa-spinner fa-pulse c-loading-icon\"></i>\r\n        <table [ngClass]=\"{'c-loading-margin': isLoading}\" *ngIf=\"gridOption\"\r\n          class=\"table table-hover table-striped table-bordered c-table\" style=\"border:0!important;\">\r\n          <thead class=\"thead-light\">\r\n            <tr>\r\n              <th class=\"position-sticky c-sticky-all align-middle p-0\" style=\"width:4px; min-width: 4px;\" #fixedHeader>\r\n              </th>\r\n              <th class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\" #fixedHeader></th>\r\n              <th *ngIf=\"gridOption?.subInformation\" class=\"position-sticky c-sticky-all align-middle text-center p-0\"\r\n                style=\"width:30px;min-width: 30px;line-height: 3rem\" #fixedHeader>\r\n              </th>\r\n              <th *ngIf=\"gridOption?.subInformation\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\"\r\n                #fixedHeader></th>\r\n              <th *ngIf=\"gridOption?.checkable\" class=\"position-sticky c-sticky-all align-middle text-center p-0\"\r\n                style=\"width:50px;min-width:50px;\" #fixedHeader>\r\n                <mat-checkbox class=\"example-margin label-mb-0\" [color]=\"'primary'\" [(ngModel)]=\"isCheckedAll\"\r\n                  (change)=\"checkAll(isCheckedAll)\"></mat-checkbox>\r\n\r\n                <!-- <label class=\"custom-control custom-checkbox\">\r\n                  <input type=\"checkbox\" class=\"custom-control-input\" [(ngModel)]=\"isCheckedAll\"\r\n                    (change)=\"checkAll(isCheckedAll)\">\r\n                  <span class=\"custom-control-label\"></span>\r\n                </label> -->\r\n              </th>\r\n              <th *ngIf=\"gridOption?.checkable\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\"\r\n                #fixedHeader></th>\r\n              <th *ngIf=\"gridOption?.commands?.length\"\r\n                class=\"position-sticky align-middle text-center p-0 c-sticky-all c-w-1\" #fixedHeader>\r\n              </th>\r\n              <th *ngIf=\"gridOption.commands?.length\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\"\r\n                #fixedHeader></th>\r\n              <th *ngIf=\"gridOption.editor?.addable || gridOption.editor?.editable\"\r\n                class=\"position-sticky c-sticky-all align-middle text-center p-0\"\r\n                style=\"width:60px;min-width: 60px;line-height: 1.5\" #fixedHeader>\r\n                <div *ngIf=\"gridOption.editor.addable\" class=\"align-middle text-center\">\r\n                  <button type=\"button\" class=\"c-btn-icon\" (click)=\"onCreate()\">\r\n                    <i class=\"fa fa-plus\"></i>\r\n                  </button>\r\n                </div>\r\n              </th>\r\n              <th *ngIf=\"gridOption.editor\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\"\r\n                #fixedHeader></th>\r\n              <th *ngIf=\"gridOption?.numberable\" class=\"position-sticky c-sticky-all align-middle text-center p-0\"\r\n                style=\"width:50px;min-width:50px;\" #fixedHeader>\r\n                #\r\n              </th>\r\n              <th *ngIf=\"gridOption?.numberable\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\"\r\n                #fixedHeader></th>\r\n              <ng-container *ngFor=\"let column of fixedColumns\">\r\n                <th class=\"position-sticky align-middle cursor-pointer c-cell c-sticky-all\" #fixedHeader\r\n                  [ngStyle]=\"{'width':column.width ? column.width : '','min-width': !column.width || column.width === 'auto' ? '400px' : column.width}\">\r\n                  <span [title]=\"column.title\" class=\"c-header-title\"\r\n                    [ngStyle]=\"{'width':column.width && column.width !== 'auto' ? column.width : '400px'}\"\r\n                    (click)=\"sort(column)\">\r\n                    {{column.title}}\r\n                    <i *ngIf=\"column.type !== 'children' && gridOption.sortable !== false && column.sortable !== false && orderBy !== column.field\"\r\n                      class=\"fa fa-sort fa-fw\"></i>\r\n                    <i *ngIf=\"orderBy == column.field && orderDirection == 'ASC'\" class=\"fa fa-sort-asc fa-fw\"></i>\r\n                    <i *ngIf=\"orderBy == column.field && orderDirection == 'DESC'\" class=\"fa fa-sort-desc fa-fw\"></i>\r\n                  </span>\r\n                  <ng-container\r\n                    *ngIf=\"!gridOption?.filter?.disabled && gridOption?.filter?.columnInline !== 'outside' && !column?.filter?.disabled && (inlineColumn[column.field] || gridOption?.filter?.type === 'inline')\">\r\n                    <input\r\n                      *ngIf=\"column.type === 'string' || column.type === 'number' || column.type === 'color' || column.type === 'children'\"\r\n                      type=\"text\" class=\"form-control form-control-sm\" [(ngModel)]=\"filter[column.field]\"\r\n                      (keyup.enter)=\"updateFilter()\">\r\n                    <select *ngIf=\"column.type === 'bool'\" class=\"form-control form-control-sm\"\r\n                      [(ngModel)]=\"filter[column.field]\" (change)=\"updateFilter()\">\r\n                      <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                      <option value=\"1\">{{column.trueValue || 'True'}}</option>\r\n                      <option value=\"0\">{{column.falseValue || 'False'}}</option>\r\n                    </select>\r\n                    <sd-grid-autocomplete-control *ngIf=\"column.type === 'values' && column?.editor?.autocomplete\"\r\n                      [items]=\"column.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[column.field]\"\r\n                      (sdChange)=\"updateFilter()\">\r\n                    </sd-grid-autocomplete-control>\r\n                    <select class=\"form-control form-control-sm\"\r\n                      *ngIf=\"column.type == 'values' && !column?.editor?.autocomplete\"\r\n                      [(ngModel)]=\"filter[column.field]\" (change)=\"updateFilter()\">\r\n                      <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                      <option *ngFor=\"let data of column.values\" [value]=\"data.value\">{{data.text}}</option>\r\n                    </select>\r\n                    <select class=\"form-control form-control-sm\" *ngIf=\"column.type == 'radio'\"\r\n                      [(ngModel)]=\"filter[column.field]\" (change)=\"updateFilter()\">\r\n                      <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                      <option *ngFor=\"let data of column.values\" [value]=\"data[column.valueField]\">\r\n                        {{data[column.displayField]}}</option>\r\n                    </select>\r\n                    <sd-grid-date-picker-control\r\n                      *ngIf=\"column.type === 'date' || column.type === 'datetime' || column.type === 'time'\"\r\n                      [(model)]=\"filter[column.field]\" (sdChange)=\"updateFilter()\" type=\"date\">\r\n                    </sd-grid-date-picker-control>\r\n                  </ng-container>\r\n                </th>\r\n                <th class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-all\" #fixedHeader></th>\r\n              </ng-container>\r\n              <th *ngFor=\"let column of normalColumns\"\r\n                class=\"position-sticky align-middle cursor-pointer border-top-0 border-bottom-0 c-cell c-sticky-top\"\r\n                [ngStyle]=\"{'width':column.width ? column.width : '','min-width': !column.width || column.width === 'auto' ? '400px' : column.width}\">\r\n                <span [title]=\"column.title\" class=\"c-header-title\"\r\n                  [ngStyle]=\"{'width':column.width && column.width !== 'auto' ? column.width : '400px'}\"\r\n                  (click)=\"sort(column)\">\r\n                  {{column.title}}\r\n                  <i *ngIf=\"column.type !== 'children' && gridOption.sortable !== false && column.sortable !== false && orderBy !== column.field\"\r\n                    class=\"fa fa-sort fa-fw\"></i>\r\n                  <i *ngIf=\"orderBy == column.field && orderDirection == 'ASC'\" class=\"fa fa-sort-asc fa-fw\"></i>\r\n                  <i *ngIf=\"orderBy == column.field && orderDirection == 'DESC'\" class=\"fa fa-sort-desc fa-fw\"></i>\r\n                </span>\r\n                <ng-container\r\n                  *ngIf=\"!gridOption?.filter?.disabled && gridOption?.filter?.columnInline !== 'outside' && !column?.filter?.disabled && (inlineColumn[column.field] || gridOption?.filter?.type === 'inline')\">\r\n                  <input\r\n                    *ngIf=\"column.type === 'string' || column.type === 'number' || column.type === 'color' || column.type === 'children'\"\r\n                    type=\"text\" class=\"form-control form-control-sm\" [(ngModel)]=\"filter[column.field]\"\r\n                    (keyup.enter)=\"updateFilter()\">\r\n                  <select *ngIf=\"column.type === 'bool'\" class=\"form-control form-control-sm\"\r\n                    [(ngModel)]=\"filter[column.field]\" (change)=\"updateFilter()\">\r\n                    <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                    <option value=\"1\">{{column.trueValue || 'TRUE'}}</option>\r\n                    <option value=\"0\">{{column.falseValue || 'FALSE'}}</option>\r\n                  </select>\r\n                  <sd-grid-autocomplete-control *ngIf=\"column.type === 'values' && column?.editor?.autocomplete\"\r\n                    [items]=\"column.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[column.field]\"\r\n                    (sdChange)=\"updateFilter()\">\r\n                  </sd-grid-autocomplete-control>\r\n                  <select class=\"form-control form-control-sm\"\r\n                    *ngIf=\"column.type == 'values' && !column?.editor?.autocomplete\" [(ngModel)]=\"filter[column.field]\"\r\n                    (change)=\"updateFilter()\">\r\n                    <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                    <option *ngFor=\"let data of column.values\" [value]=\"data.value\">{{data.text}}</option>\r\n                  </select>\r\n                  <select class=\"form-control form-control-sm\" *ngIf=\"column.type == 'radio'\"\r\n                    [(ngModel)]=\"filter[column.field]\" (change)=\"updateFilter()\">\r\n                    <option value=\"\">{{'All' | sdTranslate}}</option>\r\n                    <option *ngFor=\"let data of column.values\" [value]=\"data[column.valueField]\">\r\n                      {{data[column.displayField]}}</option>\r\n                  </select>\r\n                  <sd-grid-date-picker-control\r\n                    *ngIf=\"column.type === 'date' || column.type === 'datetime' || column.type === 'time'\"\r\n                    [(model)]=\"filter[column.field]\" (sdChange)=\"updateFilter()\" type=\"date\">\r\n                  </sd-grid-date-picker-control>\r\n                </ng-container>\r\n              </th>\r\n            </tr>\r\n          </thead>\r\n          <tbody>\r\n            <ng-container *ngFor=\"let item of viewItems; index as idx; trackBy: trackById\">\r\n              <tr>\r\n                <td class=\"position-sticky c-sticky-left p-0\"\r\n                  [ngClass]=\"{'c-error': (item.editingStatus && item.editorHandler?.errorMessage), 'c-selected': !(item.editingStatus && item.editorHandler?.errorMessage) && selectedItem === item}\"\r\n                  style=\"width:4px;min-width: 4px;left:0\" matTooltipPosition=\"after\"\r\n                  [matTooltip]=\"item.editingStatus ? item.editorHandler?.errorMessage:''\" #fixedBody>\r\n                </td>\r\n                <td class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\" #fixedBody></td>\r\n                <td *ngIf=\"gridOption.subInformation\" class=\"position-sticky text-center align-middle p-0 c-sticky-left\"\r\n                  style=\"width:30px;min-width: 30px;line-height: 3rem\" #fixedBody>\r\n                  <button *ngIf=\"!item.editingStatus\" (click)=\"expandOrCollapse(item)\" type=\"button\" class=\"c-btn-icon\">\r\n                    <i *ngIf=\"item.subInformation?.isLoading\" class=\"fa fa-spinner fa-spin\"></i>\r\n                    <i *ngIf=\"!item.subInformation?.isLoading\" class=\"fa\"\r\n                      [ngClass]=\"{'fa-caret-right': !item.subInformation?.isOpened, 'fa-caret-down': item.subInformation?.isOpened}\"></i>\r\n                  </button>\r\n                </td>\r\n                <td *ngIf=\"gridOption.subInformation\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\"\r\n                  #fixedBody></td>\r\n                <td *ngIf=\"gridOption.checkable\" class=\"position-sticky c-sticky-left align-middle p-0\" #fixedBody>\r\n                  <div *ngIf=\"!item.editingStatus\" class=\"align-middle text-center\" style=\"width:50px;min-width: 50px;\">\r\n                    <mat-checkbox class=\"example-margin label-mb-0\" [color]=\"'primary'\" [(ngModel)]=\"item.isChecked\"\r\n                      (change)=\"onCheck(item, true)\"></mat-checkbox>\r\n\r\n                    <!-- <label class=\"custom-control custom-checkbox\">\r\n                      <input type=\"checkbox\" class=\"custom-control-input\" [(ngModel)]=\"item.isChecked\"\r\n                        (change)=\"onCheck(item, true)\">\r\n                      <span class=\"custom-control-label\"></span>\r\n                    </label> -->\r\n                  </div>\r\n                </td>\r\n                <td *ngIf=\"gridOption.checkable\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\"\r\n                  #fixedBody></td>\r\n                <td *ngIf=\"gridOption.commands?.length\"\r\n                  class=\"position-sticky align-middle px-2 py-0 c-sticky-left c-w-1\" #fixedBody>\r\n                  <div *ngIf=\"!item.editingStatus\" class=\"d-flex align-middle text-center justify-content-center\">\r\n                    <ng-container\r\n                      *ngIf=\"gridOption.commands | commandFilter:item | async; $implicit as filteredCommands\">\r\n                      <section *ngFor=\"let command of filteredCommands\">\r\n                        <button *ngIf=\"!command.children?.length; else elseCommandChildren\"\r\n                          (click)=\"command.click(item)\" type=\"button\" class=\"c-btn-icon\"\r\n                          [matTooltip]=\"command.title | commandTitle:item\"\r\n                          [disabled]=\"command.disabled | commandDisabled:item\">\r\n                          <i class=\"{{command.icon | commandIcon:item}}\" aria-hidden=\"true\"></i>\r\n                        </button>\r\n                        <ng-template #elseCommandChildren>\r\n                          <button [matMenuTriggerFor]=\"menu\" type=\"button\" class=\"c-btn-icon\"\r\n                            [matTooltip]=\"command.title\" [disabled]=\"command.disabled | commandDisabled:item\">\r\n                            <i class=\"{{command.icon | commandIcon:item}}\" aria-hidden=\"true\"></i>\r\n                          </button>\r\n                          <mat-menu #menu=\"matMenu\">\r\n                            <ng-container *ngFor=\"let childCommand of command.children\">\r\n                              <button *ngIf=\"!(item | commandHidden:childCommand | async)\" mat-menu-item\r\n                                [disabled]=\"childCommand.disabled | commandDisabled:item\"\r\n                                (click)=\"childCommand.click(item)\">\r\n                                <i class=\"{{childCommand.icon | commandIcon:item}}\"></i>\r\n                                <span> {{childCommand.title | commandTitle:item}}</span>\r\n                              </button>\r\n                            </ng-container>\r\n                          </mat-menu>\r\n                        </ng-template>\r\n                      </section>\r\n                    </ng-container>\r\n                  </div>\r\n                </td>\r\n                <td *ngIf=\"gridOption.commands?.length\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\"\r\n                  #fixedBody></td>\r\n                <td *ngIf=\"gridOption.editor?.addable || gridOption.editor?.editable\"\r\n                  class=\"position-sticky c-sticky-left align-middle p-0\" #fixedBody>\r\n                  <div class=\"align-middle text-center\" style=\"width:60px;min-width: 60px;line-height: 1.5\">\r\n                    <button type=\"button\"\r\n                      *ngIf=\"!item.editingStatus && gridOption.editor?.type !== 'inline' && gridOption.editor?.editable\"\r\n                      type=\"button\" class=\"c-btn-icon\" placement=\"top\" matTooltip=\"Edit\" (click)=\"onUpdate(item)\"\r\n                      [disabled]=\"item.editorHandler?.disabled\">\r\n                      <i class=\"fa fa-pencil text-primary\" aria-hidden=\"true\"></i>\r\n                    </button>\r\n                    <button type=\"button\" *ngIf=\"item.editingStatus && gridOption.editor?.type !== 'inline'\"\r\n                      type=\"button\" class=\"c-btn-icon\" placement=\"top\" matTooltip=\"Save\" (click)=\"onSave(item)\"\r\n                      [disabled]=\"item.editorHandler?.errorMessage\">\r\n                      <i class=\"fa fa-fw text-success\"\r\n                        [ngClass]=\"{'fa-floppy-o': !item.editorHandler?.saving, 'fa-spinner': item.editorHandler?.saving, 'fa-spin': item.editorHandler?.saving}\"\r\n                        aria-hidden=\"true\"></i>\r\n                    </button>\r\n                    <button type=\"button\" *ngIf=\"item.editingStatus\" type=\"button\" class=\"c-btn-icon\" placement=\"top\"\r\n                      matTooltip=\"Cancel\" (click)=\"onCancel(item)\">\r\n                      <i class=\"fa fa-fw fa-times text-danger\" aria-hidden=\"true\"></i>\r\n                    </button>\r\n                  </div>\r\n                </td>\r\n                <td *ngIf=\"gridOption.editor\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\"\r\n                  #fixedBody></td>\r\n                <td *ngIf=\"gridOption.numberable\" class=\"position-sticky c-sticky-left align-middle p-0\" #fixedBody>\r\n                  <div *ngIf=\"!item.editingStatus\" class=\"align-middle text-center\" style=\"width:50px;min-width: 50px;\">\r\n                    {{gridOption.paginate?.pageSize * (currentPage - 1) + idx + 1}}\r\n                  </div>\r\n                </td>\r\n                <td *ngIf=\"gridOption.numberable\" class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\"\r\n                  #fixedBody></td>\r\n                <ng-template ngFor let-column [ngForOf]=\"fixedColumns\">\r\n                  <td class=\"position-sticky align-middle c-cell c-sticky-left\"\r\n                    [ngClass]=\"{'text-center': column.type !== 'string' && column.type !== 'number' && column.type !== 'children', 'text-right': column.type === 'number'}\"\r\n                    [ngStyle]=\"{'width':column.width ? column.width : '','min-width': !column.width || column.width === 'auto' ? '400px' : column.width}\"\r\n                    (click)=\"rowHandler.click(item)\" #fixedBody>\r\n                    <ng-container *ngIf=\"column.type !== 'children';else elseColumnChildren\">\r\n                      <div *ngIf=\"item[column.field] | editorHandler:item:gridOption\" class=\"align-middle\"\r\n                        (dblclick)=\"rowHandler.dblClick(item)\">\r\n                        <div\r\n                          *ngIf=\"item.editorHandler[column.field].visible && gridOption.editor?.validate && !(item[column.field] | editorValidate:item:gridOption.editor.validate | async)\">\r\n                        </div>\r\n                        <ng-container *ngIf=\"item.editorHandler[column.field].visible;else columnView\">\r\n                          <sd-grid-desktop-column-edit [column]=\"column\" [item]=\"item\" (sdChange)=\"onEditorChange()\">\r\n                          </sd-grid-desktop-column-edit>\r\n                        </ng-container>\r\n                        <ng-template #columnView>\r\n                          <sd-grid-desktop-column-view [column]=\"column\" [item]=\"item\"></sd-grid-desktop-column-view>\r\n                        </ng-template>\r\n                      </div>\r\n                    </ng-container>\r\n                    <ng-template #elseColumnChildren>\r\n                      <sd-grid-desktop-column-children-view [column]=\"column\" [item]=\"item\">\r\n                      </sd-grid-desktop-column-children-view>\r\n                    </ng-template>\r\n                  </td>\r\n                  <td class=\"position-sticky h-100 p-0 c-sticky-spliter c-sticky-left\" #fixedBody></td>\r\n                </ng-template>\r\n                <td *ngFor=\"let column of normalColumns\" class=\"align-middle c-cell\" (click)=\"rowHandler.click(item)\"\r\n                  [ngClass]=\"{'text-center': column.type !== 'string' && column.type !== 'number' && column.type !== 'children', 'text-right': column.type === 'number'}\"\r\n                  (dblclick)=\"rowHandler.dblClick(item)\"\r\n                  [ngStyle]=\"{'width':column.width ? column.width : '', 'min-width': !column.width || column.width === 'auto' ? '400px' : column.width}\">\r\n                  <ng-container *ngIf=\"column.type !== 'children';else elseColumnChildren\">\r\n                    <div *ngIf=\"item[column.field] | editorHandler:item:gridOption\" class=\"align-middle\"\r\n                      (dblclick)=\"rowHandler.dblClick(item)\">\r\n                      <div\r\n                        *ngIf=\"item.editorHandler[column.field].visible && gridOption.editor?.validate && !(item[column.field] | editorValidate:item:gridOption.editor.validate | async)\">\r\n                      </div>\r\n                      <ng-container *ngIf=\"item.editorHandler[column.field].visible;else columnView\">\r\n                        <sd-grid-desktop-column-edit [column]=\"column\" [item]=\"item\" (sdChange)=\"onEditorChange()\">\r\n                        </sd-grid-desktop-column-edit>\r\n                      </ng-container>\r\n                      <ng-template #columnView>\r\n                        <sd-grid-desktop-column-view [column]=\"column\" [item]=\"item\"></sd-grid-desktop-column-view>\r\n                      </ng-template>\r\n                    </div>\r\n                  </ng-container>\r\n                  <ng-template #elseColumnChildren>\r\n                    <sd-grid-desktop-column-children-view [column]=\"column\" [item]=\"item\">\r\n                    </sd-grid-desktop-column-children-view>\r\n                  </ng-template>\r\n                </td>\r\n              </tr>\r\n              <tr *ngIf=\"gridOption?.subInformation && item?.subInformation?.isOpened\" class=\"c-no-hover\">\r\n                <td class=\"position-sticky c-sticky-left p-0\" style=\"width:4px;min-width: 4px;left:0\">\r\n                </td>\r\n                <td class=\"p-3\" colspan=\"100\">\r\n                  <sd-grid-sub-information [subItems]=\"item?.subInformation?.subItems\"\r\n                    [columns]=\"gridOption?.subInformation?.columns\"></sd-grid-sub-information>\r\n                </td>\r\n              </tr>\r\n            </ng-container>\r\n            <tr *ngIf=\"!viewItems?.length && !isLoading && noDataImage\">\r\n              <td class=\"c-empty\" colspan=\"100\">\r\n                <img [src]=\"noDataImage\">\r\n              </td>\r\n            </tr>\r\n          </tbody>\r\n        </table>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"!gridOption.hideFooter\" class=\"sd-box-footer clearfix\">\r\n    <sd-button *ngIf=\"sdGridPopupFilter\" color=\"gray\" class=\"mr-6\" [title]=\"'Filter' | sdTranslate\" icon=\"filter_list\"\r\n      size=\"sm\" (action)=\"onFilterPopup()\"></sd-button>\r\n    <sd-button *ngIf=\"!gridOption?.hideReload\" color=\"gray\" class=\"mr-6\" [title]=\"'Reload' | sdTranslate\" icon=\"refresh\"\r\n      size=\"sm\" (action)=\"reload()\"></sd-button>\r\n    <sd-button *ngIf=\"gridOption.onImportExcel\" color=\"gray\" class=\"mr-6\" [title]=\"'Import' | sdTranslate\"\r\n      icon=\"publish\" size=\"sm\" (action)=\"sdGridImportExcel.open()\"></sd-button>\r\n    <sd-button *ngIf=\"sdGridPopupExportExcel\" color=\"gray\" class=\"mr-6\" [title]=\"'Export' | sdTranslate\" icon=\"get_app\"\r\n      size=\"sm\" (action)=\"sdGridPopupExportExcel.open()\" [disabled]=\"!viewItems?.length\"></sd-button>\r\n    <sd-button *ngIf=\"gridOption.key\" color=\"gray\" class=\"mr-6\" [title]=\"'Configure' | sdTranslate\" icon=\"settings\"\r\n      size=\"sm\" (action)=\"sdGridConfig.open()\"></sd-button>\r\n    <div class=\"row mr-0 ml-0 text-right pull-right align-items-center\">\r\n      <ul class=\"pagination pagination-primary m-0 d-flex align-items-center\">\r\n        <li class=\"page-item disabled mr-8\">\r\n          <span> {{sumarize}} </span>\r\n        </li>\r\n        <li *ngIf=\"!hiddenPaginate && currentPage > 1\" class=\"page-item\" (click)=\"selectPage(1)\">\r\n          <a class=\"page-link\">\r\n            <!-- {{'First' | sdTranslate | uppercase}} -->\r\n            <mat-icon aria-hidden=\"false\">first_page</mat-icon>\r\n          </a>\r\n        </li>\r\n        <li *ngIf=\"!hiddenPaginate && currentPage > 1\" class=\"page-item\" (click)=\"selectPage(currentPage-1)\">\r\n          <a class=\"page-link\">\r\n            <!-- {{'Previous' | sdTranslate | uppercase}} -->\r\n            <mat-icon aria-hidden=\"false\">chevron_left</mat-icon>\r\n          </a>\r\n        </li>\r\n        <ng-container *ngIf=\"!hiddenPaginate\">\r\n          <li class=\"page-item\" [ngClass]=\"{'active':page === currentPage}\" *ngFor=\"let page of pages\"\r\n            (click)=\"selectPage(page)\">\r\n            <a class=\"page-link\">{{page}}</a>\r\n          </li>\r\n        </ng-container>\r\n        <li *ngIf=\"!hiddenPaginate && currentPage < totalPage\" class=\"page-item\" (click)=\"selectPage(currentPage+1)\">\r\n          <a class=\"page-link\">\r\n            <!-- {{'Next' | sdTranslate | uppercase}} -->\r\n            <mat-icon aria-hidden=\"false\">chevron_right</mat-icon>\r\n          </a>\r\n        </li>\r\n        <li *ngIf=\"!hiddenPaginate && currentPage < totalPage\" class=\"page-item\" (click)=\"selectPage(totalPage)\">\r\n          <a class=\"page-link\">\r\n            <!-- {{'Last' | sdTranslate | uppercase}} -->\r\n            <mat-icon aria-hidden=\"false\">last_page</mat-icon>\r\n          </a>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #elseMobileOrTablet>\r\n  <div class=\"sd-box c-mobile-box\">\r\n    <div class=\"sd-box-body c-mobile-body\" [ngClass]=\"{'c-loading': isLoading}\" #gridBody>\r\n      <i [ngClass]=\"{'d-none': !isLoading}\" class=\"fa fa-4x fa-spinner fa-pulse c-loading-icon\"></i>\r\n      <ng-container *ngFor=\"let item of viewItems\">\r\n        <div class=\"c-mobile-item\" [ngClass]=\"{'c-mobile-item-selected':item.isChecked}\">\r\n          <sd-grid-mobile-item-view [gridOption]=\"gridOption\" [item]=\"item\" (check)=\"onCheck(item)\">\r\n          </sd-grid-mobile-item-view>\r\n          <div class=\"p-2\" *ngIf=\"gridOption?.subInformation && item?.subInformation?.isOpened\">\r\n            <sd-grid-sub-information [subItems]=\"item?.subInformation?.subItems\"\r\n              [columns]=\"gridOption?.subInformation?.columns\"></sd-grid-sub-information>\r\n          </div>\r\n          <div class=\"c-mobile-command\">\r\n            <div>\r\n              <i *ngIf=\"gridOption?.subInformation && item.subInformation?.isLoading\"\r\n                class=\"fa fa-spinner fa-spin ml-1 c-mobile-action\" (click)=\"expandOrCollapse(item)\"></i>\r\n              <i *ngIf=\"gridOption?.subInformation && !item.subInformation?.isLoading\" class=\"fa ml-1 c-mobile-action\"\r\n                [ngClass]=\"{'fa-plus': !item.subInformation?.isOpened, 'fa-minus': item.subInformation?.isOpened}\"\r\n                (click)=\"expandOrCollapse(item)\"></i>\r\n            </div>\r\n            <ng-container *ngIf=\"gridOption.commands | mobileCommandFilter:item | async; $implicit as filteredCommands\">\r\n              <div *ngIf=\"filteredCommands.length\">\r\n                <i [matMenuTriggerFor]=\"menu\" class=\"fa fa-navicon fa-fw c-mobile-action\"></i>\r\n                <mat-menu #menu=\"matMenu\">\r\n                  <button *ngFor=\"let command of filteredCommands\" mat-menu-item (click)=\"command.click(item)\"\r\n                    [disabled]=\"command.disabled | commandDisabled:item\">\r\n                    <i class=\"{{command.icon | commandIcon:item}}\"></i>\r\n                    <span> {{command.title | commandTitle:item}}</span>\r\n                  </button>\r\n                </mat-menu>\r\n              </div>\r\n            </ng-container>\r\n          </div>\r\n        </div>\r\n      </ng-container>\r\n    </div>\r\n    <div *ngIf=\"!gridOption.hideFooter\" class=\"sd-box-footer clearfix\">\r\n      <button *ngIf=\"sdGridPopupFilter\" type=\"button\" class=\"c-btn-icon c-m-3\" (click)=\"onFilterPopup()\">\r\n        <i class=\"fa fa-filter fa-fw sd-text-info c-mobile-action\"></i>\r\n      </button>\r\n      <button *ngIf=\"!gridOption?.hideReload\" type=\"button\" class=\"c-btn-icon c-m-3\" (click)=\"reload()\">\r\n        <i class=\"fa fa-refresh fa-fw sd-text-info c-mobile-action\"></i>\r\n      </button>\r\n      <button *ngIf=\"gridOption.onImportExcel\" type=\"button\" class=\"c-btn-icon c-m-3\"\r\n        (click)=\"sdGridImportExcel.open()\">\r\n        <i class=\"fa fa-upload fa-fw sd-text-success c-mobile-action\"></i>\r\n      </button>\r\n      <button *ngIf=\"sdGridPopupExportExcel\" [disabled]=\"!viewItems?.length\" type=\"button\" class=\"c-btn-icon c-m-3\"\r\n        (click)=\"sdGridPopupExportExcel.open()\">\r\n        <i class=\"fa fa-download fa-fw sd-text-success c-mobile-action\"></i>\r\n      </button>\r\n      <button *ngIf=\"gridOption.key\" type=\"button\" class=\"c-btn-icon c-m-3\" (click)=\"sdGridConfig.open()\">\r\n        <i class=\"fa fa-cogs fa-fw sd-text-primary c-mobile-action\"></i>\r\n      </button>\r\n      <div class=\"row mr-0 ml-0 text-right pull-right\">\r\n        <div class=\"40px\">\r\n          <select class=\"form-control form-control-sm p-0\" [(ngModel)]=\"gridOption.paginate.pageSize\"\r\n            (change)=\"onSelectPageSize()\">\r\n            <option value=\"10\">10</option>\r\n            <option value=\"25\">25</option>\r\n            <option value=\"50\">50</option>\r\n            <option value=\"100\">100</option>\r\n          </select>\r\n        </div>\r\n        <ul class=\"pagination pagination-primary m-0 d-flex align-items-center\">\r\n          <!-- <li class=\"page-item disabled\">\r\n            <span> {{sumarize}} </span>\r\n          </li> -->\r\n          <li class=\"page-item\" [ngClass]=\"{'disabled':currentPage === 1}\" (click)=\"selectPage(currentPage-1)\">\r\n            <a class=\"page-link\">\r\n              <i class=\"fa fa-angle-left\"></i>\r\n            </a>\r\n          </li>\r\n          <li class=\"page-item active\">\r\n            <a class=\"page-link\">{{currentPage}}</a>\r\n          </li>\r\n          <li class=\"page-item\" [ngClass]=\"{'disabled':currentPage === totalPage}\" (click)=\"selectPage(currentPage+1)\">\r\n            <a class=\"page-link\">\r\n              <i class=\"fa fa-angle-right\"></i>\r\n            </a>\r\n          </li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n<!-- Modal Configure Grid -->\r\n<sd-grid-config (sdChange)=\"loadConfig($event)\" #sdGridConfig></sd-grid-config>\r\n<sd-grid-popup-editor (save)=\"onSave($event)\" #sdGridPopupEditor></sd-grid-popup-editor>\r\n<!-- Import Excel -->\r\n<sd-grid-import-excel *ngIf=\"gridOption?.onImportExcel\" [key]=\"gridOption?.key\" [columns]=\"gridOption?.columns\"\r\n  [accept]=\"gridOption?.onImportExcel\" #sdGridImportExcel></sd-grid-import-excel>\r\n<sd-grid-popup-export-excel *ngIf=\"gridOption.exportable\" [key]=\"gridOption?.key\" [columns]=\"gridOption?.columns\"\r\n  [extendColumns]=\"gridOption?.export?.columns\" [fileName]=\"gridOption?.export?.fileName\"\r\n  [exportOption]=\"gridOption?.export\" [validator]=\"gridOption?.export?.validator\"\r\n  (exportByTemplate)=\"onExportByTemplate($event)\" #sdGridPopupExportExcel>\r\n</sd-grid-popup-export-excel>\r\n<sd-grid-popup-filter\r\n  *ngIf=\"!gridOption?.filter?.disabled && (isMobileOrTablet || gridOption?.filter?.type === 'popup' || gridOption?.filter?.externalFilters?.length)\"\r\n  [key]=\"gridOption?.key\" (accept)=\"updateFilter($event)\" [filterType]=\"gridOption?.filter?.type\"\r\n  [quickFilterVisibility]=\"gridOption?.filter?.quickFilterVisibility\" [filterOption]=\"gridOption?.filter\"\r\n  (clear)=\"onClearFilter()\" (loadInlineFilter)=\"onFilterConfigurationLoaded($event)\" #sdGridPopupFilter>\r\n</sd-grid-popup-filter>",
            changeDetection: ChangeDetectionStrategy.OnPush,
            encapsulation: ViewEncapsulation.None,
            styles: ["", ".sd-text-primary{color:#2f6bff!important}.sd-text-secondary{color:#dddfe2!important}.sd-text-info{color:#13c2c2!important}.sd-text-success{color:#00bc3c!important}.sd-text-warning{color:#fa8c16!important}.sd-text-danger{color:#f5222d!important}.sd-t48m{font-size:48px;font-weight:Medium;line-height:56px}.sd-t48r{font-size:48px;font-weight:Regular;line-height:56px}.sd-t32m{font-size:32px;font-weight:Medium;line-height:40px}.sd-t32r{font-size:32px;font-weight:Regular;line-height:40px}.sd-t24m{font-size:24px;font-weight:Medium;line-height:32px}.sd-t24r{font-size:24px;font-weight:Regular;line-height:32px}.sd-t20m{font-size:20px;font-weight:Medium;line-height:28px}.sd-t20r{font-size:20px;font-weight:Regular;line-height:28px}.sd-t16m{font-size:16px;font-weight:Medium;line-height:24px}.sd-t16r{font-size:16px;font-weight:Regular;line-height:24px}.sd-t14m{font-size:14px;font-weight:Medium;line-height:20px}.sd-t14r{font-size:14px;font-weight:Regular;line-height:20px}.sd-t12m{font-size:12px;font-weight:Medium;line-height:16px}.sd-t12r{font-size:12px;font-weight:Regular;line-height:16px}.sd-t10m{font-size:10px;font-weight:Medium;line-height:12px}.sd-t10r{font-size:10px;font-weight:Regular;line-height:12px}", "", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".sd-box{position:relative;border-radius:3px;background:#fff;border-top:3px solid #dddfe2;width:100%;box-shadow:0 1px 1px rgba(0,0,0,.1)}.sd-box.sd-box-primary{border-top-color:#2f6bff!important}.sd-box.sd-box-success{border-top-color:#00bc3c!important}.sd-box.sd-box-info{border-top-color:#13c2c2!important}.sd-box.sd-box-warning{border-top-color:#fa8c16!important}.sd-box.sd-box-danger{border-top-color:#f5222d!important}.sd-box-header{color:#444;display:block;padding:.5rem;position:relative;border-bottom:1px solid #f4f4f4}.sd-box-header .sd-box-title{display:inline-block;font-size:1.2rem;margin:0;line-height:1}.sd-box-body{padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}.sd-box-footer{border-top:1px solid #f4f4f4;padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}", "", "", ".c-btn-icon{background:0 0!important;border:none;opacity:.8;height:20px;display:inline-flex;padding:0 3px}.c-btn-icon:hover{cursor:pointer;opacity:1}.c-btn-icon:disabled{background:0 0!important;border:none;cursor:not-allowed;opacity:.3}", "@charset \"UTF-8\";.c-table.table{margin-bottom:5px}.c-table.table.table-bordered,.c-table.table.table-bordered td,.c-table.table.table-bordered th{border:1px solid #dee2e6!important}.c-table.table.table-bordered td.c-sticky-spliter,.c-table.table.table-bordered th.c-sticky-spliter{background-color:#dee2e6!important;border:none!important}.c-table.table.table-bordered td.c-sticky-left,.c-table.table.table-bordered th.c-sticky-left{border-right:0!important;border-left:0!important}.c-table.table.table-bordered td.c-sticky-all,.c-table.table.table-bordered th.c-sticky-all{border:0!important}.c-table.table.table-bordered td.c-empty,.c-table.table.table-bordered th.c-empty{text-align:center;background-color:#fff;border-bottom:none!important}.c-table.table.table-bordered td.c-empty img,.c-table.table.table-bordered th.c-empty img{margin-top:20px;margin-bottom:20px;opacity:.2}.c-table.table thead.thead-light th{color:#2f3136;background-color:#eceff1;font-size:14px!important;min-width:0;min-height:50px;height:50px;border-top:none!important}.c-table.table thead.thead-light th.c-cell{padding:3px 5px!important}.c-table.table thead.thead-light th .mat-checkbox label{margin-bottom:0}.c-table.table tbody td{font-size:13px!important;min-width:0;min-height:25px}.c-table.table tbody td.c-cell{padding:3px 5px!important}.c-table.table-striped tbody tr:not(.c-no-hover):hover,.c-table.table-striped tbody tr:not(.c-no-hover):hover td.c-sticky-left{background-color:#e3f2fd!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(odd){background-color:#fafafa}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(odd) .c-sticky-left{background-color:#fafafa!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(odd) .c-sticky-left.c-sticky-spliter{background-color:#dee2e6!important;border:none!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(odd) .c-sticky-left.c-selected{background-color:#13c2c2!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(odd) .c-sticky-left.c-error{background-color:#f5222d!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(even){background-color:#fff}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(even) .c-sticky-left{background-color:#fff!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(even) .c-sticky-left.c-sticky-spliter{background-color:#dee2e6!important;border:none!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(even) .c-sticky-left.c-selected{background-color:#13c2c2!important}.c-table.table-striped tbody tr:not(.c-no-hover):nth-of-type(even) .c-sticky-left.c-error{background-color:#f5222d!important}.grid-header{overflow-x:hidden;overflow-y:hidden}.c-cell-padding{padding:3px 5px!important}.c-header-title{text-transform:capitalize;font-weight:500}span.c-header-title{white-space:nowrap;overflow:hidden!important;text-overflow:ellipsis;display:block;padding:0 .3rem}.status{font-weight:500;padding:4px 8px;border-radius:1.5rem;display:inline-block;text-align:center;text-transform:uppercase}.status.c-desktop-status{width:100%}.status.c-align-left{text-align:left!important}.status-success{color:#43a047}.status-danger{color:#f44336}.page-item{cursor:pointer}.sumarize{padding:8px 12px;text-transform:uppercase;font-size:12px;color:#fff;display:inline-block;white-space:normal;font-weight:500;line-height:1;text-align:center;border-radius:10rem;background-color:#00bcd4}.cursor-pointer{cursor:pointer}label.custom-control.custom-checkbox{margin:0}.c-overflow-x-hidden{overflow-x:hidden}.c-overflow-y-hidden{overflow-y:hidden}.c-grid-header{overflow-x:hidden;overflow-y:hidden}.c-input-xs{font-size:13px!important;line-height:1.5!important;padding:3px!important;height:28px!important}.c-sticky-top{z-index:20;top:0!important}.c-sticky-left{z-index:20;left:0}.c-sticky-all{z-index:30;top:0!important;left:0}.c-sticky-spliter{z-index:40!important;background-color:#dee2e6!important;border:none!important;width:1px!important;min-width:1px!important}.c-badge:not(.c-children){display:block!important;border-radius:10rem;padding:.3rem!important;font-weight:500;font-size:12px;max-width:80%;margin:0 auto}.c-badge.c-children{padding:5px!important;font-weight:500;font-size:14px}.blinker{-webkit-animation:.5s linear infinite blinker;animation:.5s linear infinite blinker;color:#1c87c9;font-weight:500}@-webkit-keyframes blinker{50%{opacity:0}}@keyframes blinker{50%{opacity:0}}.c-loading{opacity:.4}.c-loading-icon{position:-webkit-sticky;position:sticky;top:calc(50% - 2.5rem);left:calc(50% - 2.5rem)}.c-loading-margin{margin-top:-5rem}fieldset.c-fieldset-mobile{border-radius:5px;border:1px solid #e0e0e0;padding:3px 5px}legend.c-legend-mobile{width:auto;padding:0 5px;margin:0 10px;border-bottom:none;font-size:16px;font-weight:500}.c-mobile-box{border-top:none!important;box-shadow:0 0 3px 0 rgba(0,0,0,.3)}.c-mobile-body{margin-top:5px;margin-bottom:5px;overflow-x:auto}.c-mobile-item{border:1px solid #fff;border-radius:5px;margin:8px 0;padding:5px;box-shadow:0 0 3px 0 rgba(0,0,0,.3)}.c-mobile-item.c-mobile-item-selected{border:2px solid #13c2c2}.c-mobile-item:nth-of-type(odd){background-color:#fafafa}.c-mobile-item:nth-of-type(even){background-color:#fff}.c-mobile-row{margin-top:0;margin-bottom:3px}.c-desktop-title{font-size:13px;margin-right:3px;font-weight:700;color:#212529;line-height:1.7}.c-mobile-title{font-size:14px;margin-right:3px;font-weight:700;color:#212529}.c-children,.c-mobile-value{font-size:14px;overflow-wrap:break-word;color:#212529}.c-mobile-badge{padding:5px!important;font-weight:500;font-size:14px}.c-mobile-command{padding:5px 3px 0;border-top:1px solid #f4f4f4;display:flex;align-items:center;justify-content:space-between}.c-mobile-action{font-size:18px!important}.c-mobile-checkable{margin:5px 0 5px -5px!important}.c-m-3{margin:3px!important}.c-m-5{margin:5px!important}fieldset.c-fieldset{border-radius:5px;border:1px solid #dddfe2}legend.c-legend{width:auto;padding:0 5px;margin:0 10px;border-bottom:none;font-size:20px}.c-w-1{width:1px}.label-mb-0 label{margin-bottom:0}"]
        })
    ], GridControlComponent);
    return GridControlComponent;
}());

var ModalControl = /** @class */ (function () {
    function ModalControl(dialog, bottomSheet, deviceService) {
        var _this = this;
        this.dialog = dialog;
        this.bottomSheet = bottomSheet;
        this.height = 'auto';
        this.isOpened = false;
        this.isMobileOrTablet = false;
        this.open = function () {
            _this.isOpened = true;
            if (_this.isMobileOrTablet) {
                _this.bottomSheetRef = _this.bottomSheet.open(_this.templateRef);
            }
            else {
                _this.dialogRef = _this.dialog.open(_this.templateRef, {
                    width: _this.width
                });
            }
        };
        this.close = function () {
            var _a, _b;
            if (_this.isMobileOrTablet) {
                (_a = _this.bottomSheetRef) === null || _a === void 0 ? void 0 : _a.dismiss();
            }
            else {
                (_b = _this.dialogRef) === null || _b === void 0 ? void 0 : _b.close();
            }
        };
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    ModalControl.prototype.ngOnInit = function () {
        this.type = this.type || 'primary';
        this.width = this.width || '80vw';
        if (!this.isMobileOrTablet) {
            switch (this.width) {
                case 'lg':
                    this.width = '80vw';
                    break;
                case 'md':
                    this.width = '60vw';
                    break;
                case 'sm':
                    this.width = '40vw';
                    break;
            }
        }
    };
    ModalControl.prototype.ngAfterViewInit = function () {
        // $('body').append(this.modal.nativeElement);
    };
    ModalControl.prototype.ngOnDestroy = function () {
        // $(this.modal.nativeElement).remove();
    };
    ModalControl.index = 0;
    ModalControl.ctorParameters = function () { return [
        { type: MatDialog },
        { type: MatBottomSheet },
        { type: DeviceDetectorService }
    ]; };
    __decorate([
        ViewChild('templateRef')
    ], ModalControl.prototype, "templateRef", void 0);
    __decorate([
        Input()
    ], ModalControl.prototype, "title", void 0);
    __decorate([
        Input()
    ], ModalControl.prototype, "type", void 0);
    __decorate([
        Input()
    ], ModalControl.prototype, "width", void 0);
    __decorate([
        Input()
    ], ModalControl.prototype, "height", void 0);
    __decorate([
        ViewChild('modal')
    ], ModalControl.prototype, "modal", void 0);
    ModalControl = __decorate([
        Component({
            selector: 'sd-modal-control',
            template: "<ng-template #templateRef>\r\n  <ng-container *ngIf=\"isOpened\">\r\n    <sd-modal-header *ngIf=\"title\">\r\n      {{title}}\r\n      <button class=\"float-right\" type=\"button\" (click)=\"close()\" mat-icon-button>\r\n        <mat-icon>close</mat-icon>\r\n      </button>\r\n    </sd-modal-header>\r\n    <div class=\"d-flex flex-column px-12 px-md-24 pb-6 overflow-auto w-100 mh-100\">\r\n      <ng-content></ng-content>\r\n    </div>\r\n  </ng-container>\r\n</ng-template>",
            encapsulation: ViewEncapsulation.None,
            styles: ["::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", "button:focus{outline:0!important}.mat-dialog-container{padding:0!important}.mat-dialog-container .mat-dialog-content{max-height:80vh}.mat-dialog-container .mat-dialog-actions{min-height:auto;margin-bottom:0;padding:0}.mat-bottom-sheet-container{max-height:inherit}sd-modal-header{padding:12px 24px;display:block;width:100%}@media (max-width:640px){sd-modal-header{padding:12px}}.cdk-global-overlay-wrapper .mat-bottom-sheet-container{padding:0;min-width:100vw;box-sizing:border-box;outline:0;max-height:80vh;overflow:hidden;border-top-left-radius:4px;border-top-right-radius:4px;display:flex;flex-direction:column}"]
        })
        // tslint:disable-next-line: component-class-suffix
    ], ModalControl);
    return ModalControl;
}());

var SelectControlComponent = /** @class */ (function () {
    function SelectControlComponent(ref) {
        var _this = this;
        this.ref = ref;
        this.initialized = false;
        this.pItems = [];
        this.flag = false;
        this.name = v4();
        this.multiple = false;
        this.cItems = [];
        this.modelChange = new EventEmitter();
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.onChanges = function () {
            var _a;
            _this.cItems = _this.pItems;
            _this.value = _this.pModel;
            if (_this.flag || (!_this.valueField && !_this.displayField)) {
                _this.cItems = _this.pItems.map(function (e) { return ({
                    code: e
                }); });
                _this.flag = true;
                _this.valueField = 'code';
                _this.displayField = 'code';
            }
            else {
                _this.cItems = _this.pItems;
            }
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
            if (!_this.value && !_this.multiple && _this.required && _this.cItems.length > 0) {
                setTimeout(function () {
                    _this.onChange(_this.cItems[0][_this.valueField]);
                });
            }
        };
        this.onSelectionChange = function (change) {
            var _a;
            var value = ((_a = change) === null || _a === void 0 ? void 0 : _a.value) || '';
            if (_this.multiple) {
                _this.onChange(value || []);
            }
            else {
                _this.onChange(value);
            }
        };
        this.reValidate = function () {
            var _a;
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
        this.onChange = function (value) {
            _this.value = value;
            _this.modelChange.emit(_this.value);
            _this.change.emit(_this.value);
            _this.sdChange.emit(_this.value);
        };
    }
    Object.defineProperty(SelectControlComponent.prototype, "items", {
        set: function (items) {
            if (!Array.isArray(items)) {
                items = [];
            }
            this.pItems = items.filter(function (item) { return !!item; });
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectControlComponent.prototype, "model", {
        set: function (value) {
            this.pModel = value || '';
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    SelectControlComponent.prototype.ngOnInit = function () {
    };
    SelectControlComponent.prototype.ngAfterViewInit = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        this.onChanges();
        this.initialized = true;
        this.ref.detectChanges();
    };
    SelectControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    SelectControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "multiple", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "items", null);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "valueField", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "displayField", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], SelectControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], SelectControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], SelectControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], SelectControlComponent.prototype, "validator", void 0);
    __decorate([
        ViewChild('formModel')
    ], SelectControlComponent.prototype, "formModel", void 0);
    SelectControlComponent = __decorate([
        Component({
            selector: 'sd-select-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <mat-select class=\"sd-select\" #formModel=\"ngModel\" [ngModel]=\"value\" [name]=\"name\" placeholder=\"{{label}}\"\r\n    [required]=\"required\" [disabled]=\"disabled\" [sdCustomValidator]=\"validator\" [multiple]=\"multiple\"\r\n    (selectionChange)=\"onSelectionChange($event)\">\r\n    <mat-option *ngIf=\"!required && !multiple\" value=\"\">{{'Please select' | sdTranslate}}</mat-option>\r\n    <mat-option *ngFor=\"let item of cItems\" [value]=\"item[valueField]\">\r\n      {{item[displayField]}}\r\n    </mat-option>\r\n  </mat-select>\r\n  <mat-error *ngIf=\"formModel.errors?.required\">\r\n    {{'This field is required' | sdTranslate}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.customValidator\">\r\n    {{formModel?.errors?.customValidator}}\r\n  </mat-error>\r\n</mat-form-field>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}"]
        })
    ], SelectControlComponent);
    return SelectControlComponent;
}());

// Document: https://xdsoft.net/jqplugins/datetimepicker/
var DatePickerControlComponent = /** @class */ (function () {
    function DatePickerControlComponent(ref, deviceService) {
        var _this = this;
        this.ref = ref;
        this.isMobileOrTablet = false;
        this.initialized = false;
        this.pMinDate = null;
        this.pMaxDate = null;
        this.name = v4();
        this.type = 'datetime';
        this.disabled = false;
        this.required = false;
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.modelChange = new EventEmitter();
        this.onFocus = function () {
            if (_this.isMobileOrTablet) {
                $$1(_this.control.nativeElement).trigger('blur');
            }
        };
        this.onChanges = function () {
            _this.date = _this.pDate;
        };
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    Object.defineProperty(DatePickerControlComponent.prototype, "minDate", {
        set: function (date) {
            if (!Date.isDate(date)) {
                this.pMinDate = null;
            }
            else {
                this.pMinDate = Date.toFormat(date, 'yyyy/MM/dd HH:mm');
            }
            this.setOption();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePickerControlComponent.prototype, "maxDate", {
        set: function (date) {
            if (!Date.isDate(date)) {
                this.pMaxDate = null;
            }
            else {
                this.pMaxDate = Date.toFormat(date, 'yyyy/MM/dd HH:mm'); // this.datePipe.transform(date, 'yyyy/MM/dd HH:mm');
            }
            this.setOption();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePickerControlComponent.prototype, "model", {
        set: function (val) {
            if (!Date.isDate(val)) {
                this.pDate = null;
            }
            else {
                if (this.type === 'datetime') {
                    this.pDate = Date.toFormat(val, 'dd/MM/yyyy HH:mm');
                }
                else if (this.type === 'date') {
                    this.pDate = Date.toFormat(val, 'dd/MM/yyyy');
                }
                else {
                    this.pDate = Date.toFormat(val, 'HH:mm');
                }
            }
            if (this.initialized) {
                this.onChanges();
            }
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    DatePickerControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    DatePickerControlComponent.prototype.ngAfterViewInit = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        this.onChanges();
        this.initialized = true;
        this.setOption();
        this.ref.detectChanges();
    };
    DatePickerControlComponent.prototype.setOption = function () {
        var _this = this;
        if (this.initialized) {
            $$1(this.control.nativeElement).datetimepicker({
                datepicker: this.type === 'datetime' || this.type === 'date',
                timepicker: this.type === 'datetime' || this.type === 'time',
                format: this.type === 'datetime' ? 'd/m/Y H:i' : (this.type === 'date' ? 'd/m/Y' : 'H:i'),
                step: 15,
                minDate: this.pMinDate || undefined,
                maxDate: this.pMaxDate || undefined,
                scrollMonth: false,
                scrollTime: false,
                scrollInput: false,
                onChangeDateTime: function (date) {
                    if (!date && !_this.date) {
                        return;
                    }
                    if (_this.type === 'datetime') {
                        date = Date.toFormat(date, 'dd/MM/yyyy HH:mm');
                    }
                    else if (_this.type === 'time') {
                        date = Date.toFormat(date, 'HH:mm');
                    }
                    else {
                        date = Date.toFormat(date, 'dd/MM/yyyy');
                    }
                    if (!_this.equal(date, _this.date)) {
                        _this.model = _this.parse(date);
                        _this.modelChange.emit(_this.parse(date));
                        _this.change.emit(_this.parse(date));
                        _this.sdChange.emit(_this.parse(date));
                    }
                    _this.ref.detectChanges();
                }
            });
        }
    };
    DatePickerControlComponent.prototype.parse = function (date) {
        if (this.type === 'date') {
            return Date.parseFrom(date, 'dd/MM/yyyy');
        }
        else if (this.type === 'time') {
            return Date.parseFrom(date, 'HH:mm');
        }
        return Date.parseFrom(date, 'dd/MM/yyyy HH:mm');
    };
    DatePickerControlComponent.prototype.equal = function (date1, date2) {
        return Date.equal(this.parse(date1), this.parse(date2));
    };
    DatePickerControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DeviceDetectorService }
    ]; };
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "type", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "minDate", null);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "maxDate", null);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "validator", void 0);
    __decorate([
        Output()
    ], DatePickerControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], DatePickerControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Input()
    ], DatePickerControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], DatePickerControlComponent.prototype, "modelChange", void 0);
    __decorate([
        ViewChild('control')
    ], DatePickerControlComponent.prototype, "control", void 0);
    __decorate([
        ViewChild('formModel')
    ], DatePickerControlComponent.prototype, "formModel", void 0);
    DatePickerControlComponent = __decorate([
        Component({
            selector: 'sd-date-picker-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <input class=\"sd-input\" #formModel=\"ngModel\" [name]=\"name\" autocomplete=\"false\" #control matInput\r\n    placeholder=\"{{label}}\" [ngModel]=\"date\" (focus)=\"onFocus()\" [required]=\"required\" [disabled]=\"disabled\"\r\n    [sdMinDate]=\"pMinDate\" [sdMaxDate]=\"pMaxDate\" [sdCustomValidator]=\"validator\" autocomplete=\"off\">\r\n  <mat-icon *ngIf=\"type !== 'time'\" matSuffix>date_range</mat-icon>\r\n  <mat-icon *ngIf=\"type === 'time'\" matSuffix>schedule</mat-icon>\r\n  <!-- <i matSuffix class=\"fa\" [ngClass]=\"{'fa-clock-o':type === 'time', 'fa-calendar':type !== 'time'}\"></i> -->\r\n  <mat-error *ngIf=\"formModel?.errors?.required\">\r\n    {{'This field is required' | sdTranslate}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.minDate\">\r\n    {{'Min date' | sdTranslate}}: <strong>{{pMinDate | date:'dd/MM/yyyy HH:mm'}}</strong>\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.maxDate\">\r\n    {{'Max date' | sdTranslate}}: <strong>{{pMaxDate | date:'dd/MM/yyyy HH:mm'}}</strong>\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formModel?.errors?.customValidator\">\r\n    <strong>{{formModel?.errors?.customValidator}}</strong>\r\n  </mat-error>\r\n</mat-form-field>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", ".xdsoft_datetimepicker{z-index:99999}"]
        })
    ], DatePickerControlComponent);
    return DatePickerControlComponent;
}());

var ModalHeaderComponent = /** @class */ (function () {
    function ModalHeaderComponent(deviceService) {
        this.isMobileOrTablet = false;
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    ModalHeaderComponent.prototype.ngOnInit = function () {
    };
    ModalHeaderComponent.ctorParameters = function () { return [
        { type: DeviceDetectorService }
    ]; };
    ModalHeaderComponent = __decorate([
        Component({
            selector: 'sd-modal-header',
            template: "<h3 class=\"mb-0\" mat-dialog-title *ngIf=\"!isMobileOrTablet\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</h3>\r\n<sd-bottom-sheet-header *ngIf=\"isMobileOrTablet\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</sd-bottom-sheet-header>\r\n<ng-template #content>\r\n  <ng-content></ng-content>\r\n</ng-template>",
            encapsulation: ViewEncapsulation.None,
            styles: [".mat-dialog-title{display:flex;justify-content:space-between;align-items:center}button:focus{outline:0!important}"]
        })
    ], ModalHeaderComponent);
    return ModalHeaderComponent;
}());

var ModalBodyComponent = /** @class */ (function () {
    function ModalBodyComponent(deviceService) {
        this.height = 'auto';
        this.isMobileOrTablet = false;
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    ModalBodyComponent.prototype.ngOnInit = function () {
    };
    ModalBodyComponent.ctorParameters = function () { return [
        { type: DeviceDetectorService }
    ]; };
    __decorate([
        Input()
    ], ModalBodyComponent.prototype, "height", void 0);
    ModalBodyComponent = __decorate([
        Component({
            selector: 'sd-modal-body',
            template: "<mat-dialog-content *ngIf=\"!isMobileOrTablet\" [ngStyle]=\"{'height': height}\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</mat-dialog-content>\r\n<sd-bottom-sheet-body *ngIf=\"isMobileOrTablet\" [height]=\"height\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</sd-bottom-sheet-body>\r\n<ng-template #content>\r\n  <ng-content></ng-content>\r\n</ng-template>",
            styles: ["::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ""]
        })
    ], ModalBodyComponent);
    return ModalBodyComponent;
}());

var ModalFooterComponent = /** @class */ (function () {
    function ModalFooterComponent(deviceService) {
        this.isMobileOrTablet = false;
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    ModalFooterComponent.prototype.ngOnInit = function () {
    };
    ModalFooterComponent.ctorParameters = function () { return [
        { type: DeviceDetectorService }
    ]; };
    ModalFooterComponent = __decorate([
        Component({
            selector: 'sd-modal-footer',
            template: "<!-- <div class=\"modal-footer\" style=\"padding:5px\"><ng-content></ng-content></div> -->\r\n<mat-dialog-actions *ngIf=\"!isMobileOrTablet\">\r\n  <div class=\"c-footer\">\r\n    <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n  </div>\r\n</mat-dialog-actions>\r\n<sd-bottom-sheet-footer *ngIf=\"isMobileOrTablet\">\r\n  <ng-container *ngTemplateOutlet=\"content\"></ng-container>\r\n</sd-bottom-sheet-footer>\r\n<ng-template #content>\r\n  <ng-content></ng-content>\r\n</ng-template>",
            encapsulation: ViewEncapsulation.None,
            styles: [".c-footer{flex:auto;display:flex;align-items:center;justify-content:flex-end;padding:8px 0}"]
        })
    ], ModalFooterComponent);
    return ModalFooterComponent;
}());

var UploadExcelControlComponent = /** @class */ (function () {
    function UploadExcelControlComponent(ref, excelService, translateService, notifyService, utilityService, loadingService) {
        var _this = this;
        this.ref = ref;
        this.excelService = excelService;
        this.translateService = translateService;
        this.notifyService = notifyService;
        this.utilityService = utilityService;
        this.loadingService = loadingService;
        this.items = [];
        this.hasDescription = false;
        // Paginate
        this.pages = [1];
        this.pageSize = 50;
        this.currentPage = 1;
        this.pageCount = 5;
        this.totalPage = 1;
        this.showing = 'ALL';
        this.filteredItems = [];
        this.viewItems = [];
        this.numberOfSuccess = 0;
        this.numberOfError = 0;
        this.numberOfWarning = 0;
        this.upload = function () { return __awaiter(_this, void 0, void 0, function () {
            var translate, _a, items, file, offset, _b, _c, _d, idx, item, e_1_1, results, results, err_1;
            var e_1, _e;
            var _this = this;
            var _f, _g;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        _h.trys.push([0, 14, , 15]);
                        translate = this.translateService.translate;
                        return [4 /*yield*/, this.excelService.import()];
                    case 1:
                        _a = _h.sent(), items = _a.items, file = _a.file;
                        if (this.option.columns.some(function (e) { return !!e.description; })) {
                            this.hasDescription = true;
                        }
                        else {
                            this.hasDescription = false;
                        }
                        offset = this.hasDescription ? 2 : 1;
                        items.splice(0, offset);
                        if (items.length === 0) {
                            this.notifyService.notify.warning("" + translate("No data to import"));
                            return [2 /*return*/];
                        }
                        if (items.length > this.option.limit) {
                            this.notifyService.notify.warning(translate("Limit rows") + ": " + this.option.limit);
                            return [2 /*return*/];
                        }
                        this.items = ((_g = (_f = this.option).mappingItems) === null || _g === void 0 ? void 0 : _g.call(_f, items)) || items;
                        this.filteredItems = this.items;
                        this.showing = 'ALL';
                        this.file = file;
                        this.currentPage = 1;
                        this.generatePaginate();
                        _h.label = 2;
                    case 2:
                        _h.trys.push([2, 7, 8, 9]);
                        _b = __values(this.items.entries()), _c = _b.next();
                        _h.label = 3;
                    case 3:
                        if (!!_c.done) return [3 /*break*/, 6];
                        _d = __read(_c.value, 2), idx = _d[0], item = _d[1];
                        item.lineId = v4();
                        item.excelIndex = idx + (this.hasDescription ? 4 : 3);
                        return [4 /*yield*/, this.validate(item)];
                    case 4:
                        _h.sent();
                        _h.label = 5;
                    case 5:
                        _c = _b.next();
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_1_1 = _h.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_c && !_c.done && (_e = _b.return)) _e.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 9:
                        if (!(!this.items.some(function (item) { return !!item.validation.error; }) && this.option.errorValidation)) return [3 /*break*/, 11];
                        this.loadingService.start();
                        return [4 /*yield*/, this.option.errorValidation(this.items)];
                    case 10:
                        results = _h.sent();
                        results.forEach(function (result) { return _this.items[result.idx].validation.error = result.message; });
                        this.loadingService.stop();
                        _h.label = 11;
                    case 11:
                        if (!(!this.items.some(function (item) { return !!item.validation.warning; }) && this.option.warningValidation)) return [3 /*break*/, 13];
                        this.loadingService.start();
                        return [4 /*yield*/, this.option.warningValidation(this.items)];
                    case 12:
                        results = _h.sent();
                        results.forEach(function (result) { return _this.items[result.idx].validation.warning = result.message; });
                        this.loadingService.stop();
                        _h.label = 13;
                    case 13:
                        this.reload();
                        this.ref.detectChanges();
                        return [3 /*break*/, 15];
                    case 14:
                        err_1 = _h.sent();
                        this.utilityService.handle.error(err_1);
                        return [3 /*break*/, 15];
                    case 15: return [2 /*return*/];
                }
            });
        }); };
        this.setValidation = function (validates) {
            if (Array.isArray(validates)) {
                validates.forEach(function (validate) { return _this.items[validate.idx].validation.error = validate.message; });
            }
            _this.reload();
            _this.ref.detectChanges();
        };
        this.view = function (showing) {
            if (showing === void 0) { showing = 'ALL'; }
            _this.showing = showing;
            _this.currentPage = 1;
            _this.reload();
            _this.generatePaginate();
        };
        this.downloadTemplate = function () { return __awaiter(_this, void 0, void 0, function () {
            var excelTemplate, result;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        excelTemplate = {
                            fileName: this.option.fileName || 'Template',
                            columns: this.option.columns.map(function (column) {
                                return {
                                    field: column.field,
                                    title: column.title,
                                    width: column.width,
                                    required: column.required,
                                    description: column.description
                                };
                            }),
                            sheets: this.option.sheets
                        };
                        return [4 /*yield*/, this.excelService.generateExcelTemplate(excelTemplate)];
                    case 1:
                        result = _b.sent();
                        if (!((_a = result) === null || _a === void 0 ? void 0 : _a.filePath)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.excelService.downloadTemplate(result.filePath, excelTemplate.fileName || 'Template.xlsx')];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); };
    }
    UploadExcelControlComponent.prototype.ngOnInit = function () {
        this.uploadExcelConfig.setOption({
            key: this.option.key,
            columns: this.option.columns.filter(function (e) { return !e.hidden; })
        });
    };
    UploadExcelControlComponent.prototype.loadConfig = function (configResult) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.configResult = configResult;
                this.option.columns = configResult.columns;
                return [2 /*return*/];
            });
        });
    };
    UploadExcelControlComponent.prototype.open = function () {
        this.items = [];
        this.numberOfSuccess = 0;
        this.numberOfError = 0;
        this.numberOfWarning = 0;
        this.modal.open();
    };
    UploadExcelControlComponent.prototype.close = function () {
        this.modal.close();
    };
    UploadExcelControlComponent.prototype.reload = function () {
        var _this = this;
        this.currentPage = this.currentPage || 1;
        this.filteredItems = this.items.filter(function (item) {
            if (_this.showing === 'SUCCESS') {
                return !item.validation.error && !item.validation.warning;
            }
            else if (_this.showing === 'WARNING') {
                return !!item.validation.warning && !item.validation.error;
            }
            else if (_this.showing === 'ERROR') {
                return !!item.validation.error;
            }
            return true;
        });
        this.viewItems = this.filteredItems
            .filter(function (item, index) { return index >= (_this.currentPage - 1) * _this.pageSize && index < _this.currentPage * _this.pageSize; });
        this.numberOfSuccess = this.items.filter(function (item) { return !item.validation.error && !item.validation.warning; }).length;
        this.numberOfError = this.items.filter(function (item) { return item.validation.error; }).length;
        this.numberOfWarning = this.items.filter(function (item) { return item.validation.warning && !item.validation.error; }).length;
    };
    UploadExcelControlComponent.prototype.validate = function (item) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var validation, translate, _loop_1, _d, _e, column, e_2_1;
            var e_2, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        validation = {
                            error: '',
                            warning: '',
                            data: {}
                        };
                        translate = this.translateService.translate;
                        _loop_1 = function (column) {
                            var value, value, value, error, warning, ex_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        validation.data[column.field] = {};
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 6, , 7]);
                                        if (column.defaultValue !== undefined) {
                                            item[column.field] = (_a = item[column.field], (_a !== null && _a !== void 0 ? _a : column.defaultValue));
                                        }
                                        else if (column.required && !item[column.field] && item[column.field] !== 0) {
                                            validation.data[column.field].error = "" + translate('required');
                                            validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                            return [2 /*return*/, "continue"];
                                        }
                                        if (column.type === 'string') {
                                            value = (item[column.field] || '').toString();
                                            if (column.minLength !== undefined && value.length < column.minLength) {
                                                validation.data[column.field].error = translate('Min length') + ": " + column.minLength;
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                            if (column.maxLength !== undefined && value.length > column.maxLength) {
                                                validation.data[column.field].error = translate('Max length') + ": " + column.maxLength;
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                        }
                                        else if (column.type === 'number') {
                                            if (item[column.field]) {
                                                value = +item[column.field];
                                                if (Number.isNaN(value)) {
                                                    validation.data[column.field].error = item[column.field] + " " + translate('is not a number');
                                                    validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                    return [2 /*return*/, "continue"];
                                                }
                                                item[column.field] = value;
                                            }
                                            if (!item[column.field] && item[column.field] !== 0) {
                                                item[column.field] = undefined;
                                            }
                                            if (column.minValue !== undefined && item[column.field] < column.minValue) {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Min value') + ": " + column.minValue;
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                            if (column.maxValue !== undefined && item[column.field] > column.maxValue) {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Max value') + ": " + column.maxValue;
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                        }
                                        else if (column.type === 'bool') {
                                            if (item[column.field] === 0 || item[column.field] === false) {
                                                item[column.field] = '0';
                                            }
                                            if (item[column.field] === 1 || item[column.field] === true) {
                                                item[column.field] = '1';
                                            }
                                            if (item[column.field]) {
                                                value = +item[column.field];
                                                if (Number.isNaN(value) || (value !== 0 && value !== 1)) {
                                                    validation.data[column.field].error = "" + translate('Value shoud be 0 or 1');
                                                    validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                }
                                            }
                                        }
                                        else if (column.type === 'values') {
                                            if (typeof (item[column.field]) !== 'number' && typeof (item[column.field]) !== 'string') {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Invalid data type');
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                            if (column.checkValueInArray && item[column.field] && !column.values.some(function (e) { return e.toString() === item[column.field].toString(); })) {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Value not in') + " [" + column.values.join() + "]";
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                        }
                                        else if (column.type === 'radio') {
                                            if (typeof (item[column.field]) !== 'number' && typeof (item[column.field]) !== 'string') {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Invalid data type');
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                            if (column.checkValueInArray && item[column.field] && !column.values.some(function (e) { return e.toString() === item[column.field].toString(); })) {
                                                validation.data[column.field].error = item[column.field] + " " + translate('Value not in') + " [" + column.values.join() + "]";
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                        }
                                        else if (column.type === 'date') {
                                            if (column.format && item[column.field]) {
                                                if (!Date.isDate(Date.parseFrom(item[column.field], column.format))) {
                                                    validation.data[column.field].error = translate('Invalid format') + " " + column.format + ": " + item[column.field];
                                                    validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                }
                                            }
                                            if (item[column.field] && !Date.isDate(item[column.field])) {
                                                validation.data[column.field].error = translate('Invalid date') + ": " + item[column.field];
                                                validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                                return [2 /*return*/, "continue"];
                                            }
                                        }
                                        if (!(!validation.data[column.field].error && column.errorValidation)) return [3 /*break*/, 3];
                                        return [4 /*yield*/, column.errorValidation(item, item[column.field])];
                                    case 2:
                                        error = _a.sent();
                                        if (error) {
                                            validation.data[column.field].error = "" + error;
                                            validation.error += "[" + column.field + "] " + error + "\n";
                                        }
                                        _a.label = 3;
                                    case 3:
                                        if (!(!validation.data[column.field].warning && column.warningValidation)) return [3 /*break*/, 5];
                                        return [4 /*yield*/, column.warningValidation(item, item[column.field])];
                                    case 4:
                                        warning = _a.sent();
                                        if (warning) {
                                            validation.data[column.field].warning = "" + warning;
                                            validation.warning += "[" + column.field + "] " + warning + "\n";
                                        }
                                        _a.label = 5;
                                    case 5: return [3 /*break*/, 7];
                                    case 6:
                                        ex_1 = _a.sent();
                                        validation.data[column.field].error = "" + (((_b = ex_1) === null || _b === void 0 ? void 0 : _b.message) || ((_c = ex_1) === null || _c === void 0 ? void 0 : _c.error) || ex_1 || 'Có lỗi xảy ra');
                                        validation.error += "[" + column.field + "] " + validation.data[column.field].error + "\n";
                                        return [3 /*break*/, 7];
                                    case 7: return [2 /*return*/];
                                }
                            });
                        };
                        _g.label = 1;
                    case 1:
                        _g.trys.push([1, 6, 7, 8]);
                        _d = __values(this.option.columns), _e = _d.next();
                        _g.label = 2;
                    case 2:
                        if (!!_e.done) return [3 /*break*/, 5];
                        column = _e.value;
                        return [5 /*yield**/, _loop_1(column)];
                    case 3:
                        _g.sent();
                        _g.label = 4;
                    case 4:
                        _e = _d.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_2_1 = _g.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        item.validation = validation;
                        return [2 /*return*/];
                }
            });
        });
    };
    UploadExcelControlComponent.prototype.generatePaginate = function () {
        this.pages = [];
        this.totalPage = Math.trunc(this.filteredItems.length / this.pageSize) + (this.filteredItems.length % this.pageSize === 0 ? 0 : 1);
        if (this.currentPage > this.totalPage) {
            this.currentPage = this.totalPage;
        }
        if (this.totalPage <= this.pageCount) {
            for (var i = 1; i <= this.totalPage; i++) {
                this.pages.push(i);
            }
        }
        else {
            if (this.currentPage < 3) {
                this.pages = [1, 2, 3, 4, 5];
            }
            else if (this.currentPage > this.totalPage - 2) {
                this.pages = [this.totalPage - 4, this.totalPage - 3, this.totalPage - 2, this.totalPage - 1, this.totalPage];
            }
            else {
                this.pages = [this.currentPage - 2, this.currentPage - 1, this.currentPage, this.currentPage + 1, this.currentPage + 2];
            }
        }
    };
    UploadExcelControlComponent.prototype.selectPage = function (selectedPage) {
        var page = +selectedPage;
        if (this.currentPage !== page && page > 0 && page <= this.totalPage) {
            this.currentPage = page;
        }
        this.reload();
        this.generatePaginate();
    };
    UploadExcelControlComponent.prototype.accept = function () {
        var _a;
        var successItems = this.items.filter(function (item) { return !item.validation.error && !item.validation.warning; });
        var errorItems = this.items.filter(function (item) { return item.validation.error; });
        var warningItems = this.items.filter(function (item) { return !item.validation.error && item.validation.warning; });
        (_a = this.option) === null || _a === void 0 ? void 0 : _a.onAccept(this.items, successItems, errorItems, warningItems, this.file);
    };
    UploadExcelControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: ExcelService },
        { type: TranslateService },
        { type: NotifyService },
        { type: UtilityService },
        { type: LoadingService }
    ]; };
    __decorate([
        Input()
    ], UploadExcelControlComponent.prototype, "option", void 0);
    __decorate([
        ViewChild('modal')
    ], UploadExcelControlComponent.prototype, "modal", void 0);
    __decorate([
        ViewChild('uploadExcelConfig', { static: true })
    ], UploadExcelControlComponent.prototype, "uploadExcelConfig", void 0);
    UploadExcelControlComponent = __decorate([
        Component({
            selector: 'sd-upload-excel-control',
            template: "<sd-modal-control [title]=\"'Import Excel' | sdTranslate\" #modal>\r\n  <sd-modal-body background=\"#F0F8FF\">\r\n    <div class=\"row mx-0 mb-2\">\r\n      <sd-button *ngIf=\"items?.length\" class=\"mr-5\" (action)=\"view('ALL')\" icon=\"cached\"\r\n        [title]=\"'View all' | sdTranslate\" size=\"sm\"></sd-button>\r\n      <sd-button *ngIf=\"numberOfSuccess\" class=\"mr-5\" (action)=\"view('SUCCESS')\" icon=\"done\" [title]=\"numberOfSuccess\"\r\n        [tooltip]=\"'Number of success rows' | sdTranslate\" size=\"sm\"></sd-button>\r\n      <sd-button *ngIf=\"numberOfWarning\" class=\"mr-5\" (action)=\"view('WARNING')\" icon=\"warning\"\r\n        [title]=\"numberOfWarning\" [tooltip]=\"'Number of warning rows' | sdTranslate\" size=\"sm\"></sd-button>\r\n      <sd-button *ngIf=\"numberOfError\" class=\"mr-5\" (action)=\"view('ERROR')\" icon=\"error\" [title]=\"numberOfError\"\r\n        color=\"accent\" [tooltip]=\"'Number of error rows' | sdTranslate\" size=\"sm\"></sd-button>\r\n    </div>\r\n    <div class=\"sd-box sd-box-primary\">\r\n      <div class=\"sd-box-body p-0\">\r\n        <div class=\"table-responsive\" style=\"position: relative; height:50vh\">\r\n          <table class=\"table table-striped table-sm table-hover table-bordered\">\r\n            <thead class=\"thead-light\">\r\n              <tr>\r\n                <th class=\"text-center position-sticky c-sticky-left\" style=\"width: 50px\">#</th>\r\n                <th *ngFor=\"let column of option.columns\"\r\n                  [ngStyle]=\"{'min-width':column.width ? column.width : '300px'}\">\r\n                  <span class=\"c-ellipsis\"\r\n                    [ngStyle]=\"{'min-width':column.width ? column.width : '300px', 'max-width':column.width ? column.width : '300px'}\">{{column.title}}</span>\r\n                </th>\r\n              </tr>\r\n            </thead>\r\n            <tbody *ngIf=\"items.length\">\r\n              <tr *ngFor=\"let item of viewItems\">\r\n                <td class=\"text-center position-sticky c-sticky-left\" style=\"width: 50px\">\r\n                  <span class=\"badge\"\r\n                    [ngClass]=\"{'badge-success':!item.validation?.warning && !item.validation?.error, 'badge-warning':item.validation?.warning && !item.validation?.error, 'badge-danger':item.validation?.error}\"\r\n                    [matTooltip]=\"item.validation?.error || item.validation?.warning\" matTooltipPosition=\"right\"\r\n                    style=\"width: 100%\" matTooltipClass=\"white-space-pre-line\">{{item.excelIndex}}</span>\r\n                </td>\r\n                <td *ngFor=\"let column of option.columns\" class=\"align-middle\"\r\n                  [ngClass]=\"{'table-warning':item.validation?.data[column.field]?.warning && !item.validation?.data[column.field]?.error, 'table-danger':item.validation?.data[column.field]?.error}\"\r\n                  [matTooltip]=\"item.validation?.data[column.field]?.error || item.validation?.data[column.field]?.warning\"\r\n                  matTooltipPosition=\"above\">\r\n                  <span class=\"c-ellipsis\"\r\n                    [ngStyle]=\"{'min-width':column.width ? column.width : '300px', 'max-width':column.width ? column.width : '300px'}\">\r\n                    <ng-container *ngIf=\"column.type === 'date'\">\r\n                      {{item.validation?.data[column.field]?.error ?  item[column.field] : (item[column.field] | date:'dd/MM/yyyy HH:mm')}}\r\n                    </ng-container>\r\n                    <ng-container *ngIf=\"column.type === 'number'\">\r\n                      {{item.validation?.data[column.field]?.error ?  item[column.field] : (item[column.field] | number : '1.0-2')}}\r\n                    </ng-container>\r\n                    <ng-container *ngIf=\"column.type !== 'date' && column.type !== 'number'\">{{item[column.field]}}\r\n                    </ng-container>\r\n                  </span>\r\n                </td>\r\n              </tr>\r\n            </tbody>\r\n          </table>\r\n        </div>\r\n      </div>\r\n      <div class=\"sd-box-footer clearfix\">\r\n        <div class=\"row mr-0 ml-0 text-right pull-right\">\r\n          <ul class=\"pagination pagination-primary m-0\">\r\n            <li class=\"page-item cursor-pointer\" *ngIf=\"currentPage > 1\" placement=\"top\" ngbTooltip=\"Previous\"\r\n              (click)=\"selectPage(currentPage-1)\">\r\n              <a class=\"page-link\">\r\n                {{'Previous' | sdTranslate | uppercase}}\r\n              </a>\r\n            </li>\r\n            <li class=\"page-item cursor-pointer\" [ngClass]=\"{'active':page === currentPage}\" *ngFor=\"let page of pages\"\r\n              (click)=\"selectPage(page)\">\r\n              <a class=\"page-link\">{{page}}</a>\r\n            </li>\r\n            <li class=\"page-item cursor-pointer\" *ngIf=\"currentPage < totalPage\" placement=\"top\" ngbTooltip=\"Next\"\r\n              (click)=\"selectPage(currentPage+1)\">\r\n              <a class=\"page-link\">\r\n                {{'Next' | sdTranslate | uppercase}}\r\n              </a>\r\n            </li>\r\n          </ul>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </sd-modal-body>\r\n  <sd-modal-footer *sdDesktop>\r\n    <div class=\"mr-auto\">\r\n      <sd-button class=\"mr-1\" (action)=\"upload()\" icon=\"publish\" [title]=\"'Upload' | sdTranslate\" size=\"sm\"></sd-button>\r\n      <sd-button class=\"mr-1\" (action)=\"downloadTemplate()\" icon=\"get_app\" [title]=\"'Download' | sdTranslate\" size=\"sm\">\r\n      </sd-button>\r\n    </div>\r\n    <sd-button (action)=\"accept()\" icon=\"check\" [title]=\"'Accept' | sdTranslate\"\r\n      [disabled]=\"numberOfSuccess === 0 || numberOfError > 0\" color=\"primary\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n  <sd-modal-footer *sdMobileTablet>\r\n    <sd-button style=\"flex: 1; padding-right: 5px;\" (action)=\"upload()\" icon=\"publish\" [title]=\"'Upload' | sdTranslate\"\r\n      width=\"100%\" size=\"sm\"></sd-button>\r\n    <sd-button style=\"flex: 1; padding-left: 5px;\" (action)=\"accept()\" icon=\"check\" [title]=\"'Accept' | sdTranslate\"\r\n      color=\"primary\" width=\"100%\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n</sd-modal-control>\r\n<sd-upload-excel-config (change)=\"loadConfig($event)\" #uploadExcelConfig></sd-upload-excel-config>",
            styles: ["", "", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".sd-box{position:relative;border-radius:3px;background:#fff;border-top:3px solid #dddfe2;width:100%;box-shadow:0 1px 1px rgba(0,0,0,.1)}.sd-box.sd-box-primary{border-top-color:#2f6bff!important}.sd-box.sd-box-success{border-top-color:#00bc3c!important}.sd-box.sd-box-info{border-top-color:#13c2c2!important}.sd-box.sd-box-warning{border-top-color:#fa8c16!important}.sd-box.sd-box-danger{border-top-color:#f5222d!important}.sd-box-header{color:#444;display:block;padding:.5rem;position:relative;border-bottom:1px solid #f4f4f4}.sd-box-header .sd-box-title{display:inline-block;font-size:1.2rem;margin:0;line-height:1}.sd-box-body{padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}.sd-box-footer{border-top:1px solid #f4f4f4;padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}", ".table thead td,.table thead th{padding-top:5px;padding-bottom:5px}.table-striped tbody tr:nth-of-type(even) .c-sticky-left{background-color:#fff}.table-striped tbody tr:nth-of-type(odd) .c-sticky-left{background-color:#f2f2f2}.c-sticky-left{z-index:20;left:0!important;border-left:none!important;border-right:none!important}.c-ellipsis{white-space:nowrap;overflow:hidden!important;text-overflow:ellipsis;display:block;padding:.1rem}"]
        })
    ], UploadExcelControlComponent);
    return UploadExcelControlComponent;
}());

var TextareaControlComponent = /** @class */ (function () {
    function TextareaControlComponent(ref) {
        this.ref = ref;
        this.name = v4();
        this.rows = 5;
        this.modelChange = new EventEmitter();
    }
    Object.defineProperty(TextareaControlComponent.prototype, "model", {
        set: function (value) {
            this.ref.detectChanges();
            // setTimeout(() => {
            //     this._model = value;
            // }, 0);
            this._model = value;
        },
        enumerable: true,
        configurable: true
    });
    TextareaControlComponent.prototype.ngAfterViewInit = function () {
        if (this.form && this.formModel) {
            this.form.addControl(this.formModel);
        }
    };
    TextareaControlComponent.prototype.ngOnDestroy = function () {
        if (this.form && this.formModel) {
            this.form.removeControl(this.formModel);
        }
    };
    TextareaControlComponent.prototype.onChange = function (value) {
        this._model = value;
        this.modelChange.emit(this._model);
    };
    TextareaControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "placeholder", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "rows", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], TextareaControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "maxlength", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "pattern", void 0);
    __decorate([
        Input()
    ], TextareaControlComponent.prototype, "disabled", void 0);
    __decorate([
        ViewChild('formModel')
    ], TextareaControlComponent.prototype, "formModel", void 0);
    TextareaControlComponent = __decorate([
        Component({
            selector: 'sd-textarea-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <textarea class=\"sd-input\" #formModel=\"ngModel\" [name]=\"name\" matInput placeholder=\"{{placeholder || label}}\" [ngModel]=\"_model\"\r\n    (ngModelChange)=\"onChange($event)\" [required]=\"required\" [disabled]=\"disabled\" autocomplete=\"off\" [rows]=\"rows\" [maxlength]=\"maxlength\"></textarea>\r\n  <span *ngIf=\"maxlength\" matSuffix>{{_model?.length || 0}}/{{maxlength}}</span>\r\n  <mat-error *ngIf=\"formModel?.errors?.required\">\r\n    {{'This field is required' | sdTranslate}}\r\n  </mat-error>\r\n</mat-form-field>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", "textarea.mat-input-element{resize:none}"]
        })
    ], TextareaControlComponent);
    return TextareaControlComponent;
}());

var AutocompleteControlComponent = /** @class */ (function () {
    function AutocompleteControlComponent(ref, utilityService) {
        var _this = this;
        this.ref = ref;
        this.utilityService = utilityService;
        this.initialized = false;
        this.pItems = [];
        this.flag = false;
        this.previousResults = [];
        this.delay = 500; // Sau khoảng thời gian delay nếu không có thay đổi thì thì mới bắt đầu thực hiện gọi hàm
        this.isServerFilter = false;
        this.name = v4();
        this.loading = false;
        this.cItems = [];
        this.limit = 100;
        this.modelChange = new EventEmitter();
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.onChanges = function (searchText) { return __awaiter(_this, void 0, void 0, function () {
            var items;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.cModel = this.pModel;
                        items = [];
                        if (!(typeof (this.pItems) === 'function')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.loadItems(searchText, this.pItems)];
                    case 1:
                        items = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        items = this.pItems;
                        _b.label = 3;
                    case 3:
                        if (this.flag || (!this.valueField && !this.displayField)) {
                            this.cItems = items.map(function (e) { return ({
                                code: e
                            }); });
                            this.flag = true;
                            this.valueField = 'code';
                            this.displayField = 'code';
                        }
                        else {
                            this.cItems = items;
                        }
                        (_a = this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        }); };
        this.loadItems = function (searchText, items) { return __awaiter(_this, void 0, void 0, function () {
            var now, dif, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.previous = new Date();
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, _this.delay); })];
                    case 1:
                        _b.sent();
                        now = new Date();
                        dif = now.getTime() - this.previous.getTime();
                        if (dif < this.delay) {
                            return [2 /*return*/, this.previousResults];
                        }
                        this.loading = true;
                        _a = this;
                        return [4 /*yield*/, items(searchText).finally(function () { return _this.loading = false; })];
                    case 2:
                        _a.previousResults = _b.sent();
                        return [2 /*return*/, this.previousResults];
                }
            });
        }); };
        this.onChange = function (item) {
            if (typeof item !== 'string') {
                _this.cModel = item ? item[_this.valueField] : undefined;
                _this.modelChange.emit(_this.cModel);
                _this.change.emit(item);
                _this.sdChange.emit(item);
            }
            else {
                if (!item) {
                    _this.clear();
                }
                _this.onChanges(item);
            }
        };
        this.filter = function (value) {
            var e_1, _a;
            var items = _this.cItems;
            if (!_this.name || _this.isServerFilter) {
                return _this.cItems.filter(function (item, index) { return index < _this.limit; });
            }
            var cItemsDisplayField = [];
            var cItemsValueField = [];
            cItemsDisplayField = _this.cItems.filter(function (item) {
                return _this.utilityService.changeAliasLowerCase(item[_this.displayField])
                    .indexOf(_this.utilityService.changeAliasLowerCase(value)) !== -1;
            }).filter(function (item, index) { return index < _this.limit; });
            cItemsValueField = _this.cItems.filter(function (item) {
                return _this.utilityService.changeAliasLowerCase(item[_this.valueField])
                    .indexOf(_this.utilityService.changeAliasLowerCase(value)) !== -1;
            }).filter(function (item, index) { return index < _this.limit; });
            _this.cItems = __spread(cItemsDisplayField, cItemsValueField);
            var uniqueItems = [];
            var distinctItems = [];
            try {
                for (var _b = __values(_this.cItems), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var cItem = _c.value;
                    if (!uniqueItems[cItem[_this.valueField]]) {
                        distinctItems.push(cItem);
                        uniqueItems[cItem[_this.valueField]] = 1;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return distinctItems;
        };
        this.displayFn = function (value) {
            if (typeof value === 'string') {
                if (!_this.cItems) {
                    return value;
                }
                var selectedItem = _this.cItems.find(function (item) { return item[_this.valueField] === value; });
                if (selectedItem) {
                    return selectedItem[_this.displayField];
                }
                return value;
            }
            else {
                return value ? value[_this.displayField] : undefined;
            }
        };
        this.clear = function ($event) {
            var _a, _b;
            (_a = $event) === null || _a === void 0 ? void 0 : _a.stopPropagation();
            _this.cModel = undefined;
            _this.modelChange.emit(_this.cModel);
            _this.change.emit(_this.cModel);
            _this.sdChange.emit(_this.cModel);
            _this.formModel.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
            if ($event) {
                _this.autocompleteTrigger._onChange('');
                (_b = _this.autocompleteTrigger) === null || _b === void 0 ? void 0 : _b.openPanel();
            }
        };
        this.reValidate = function () {
            var _a;
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
    }
    Object.defineProperty(AutocompleteControlComponent.prototype, "items", {
        set: function (items) {
            var _this = this;
            this.pItems = items || [];
            this.isServerFilter = !Array.isArray(this.pItems);
            if (this.initialized) {
                this.onChanges().then(function () { var _a, _b; return (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.setValue((_b = _this.formModel) === null || _b === void 0 ? void 0 : _b.control.value); });
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AutocompleteControlComponent.prototype, "model", {
        set: function (value) {
            var _this = this;
            this.pModel = value;
            if (this.initialized) {
                this.onChanges(value).then(function () { var _a; return (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.setValue(value); });
            }
        },
        enumerable: true,
        configurable: true
    });
    AutocompleteControlComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.filteredItems = this.formModel.valueChanges.pipe(startWith(''), map(function (item) { return typeof item === 'string' ? item : (item ? item[_this.displayField] : ''); }), map(this.filter));
    };
    AutocompleteControlComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        this.onChanges(this.pModel).then(function () { var _a; return (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.setValue(_this.pModel); });
        this.initialized = true;
        this.ref.detectChanges();
    };
    AutocompleteControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    AutocompleteControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: UtilityService }
    ]; };
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "valueField", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "displayField", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "items", null);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "limit", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], AutocompleteControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], AutocompleteControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], AutocompleteControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], AutocompleteControlComponent.prototype, "disabled", void 0);
    __decorate([
        ViewChild('formModel', { static: true })
    ], AutocompleteControlComponent.prototype, "formModel", void 0);
    __decorate([
        ViewChild(MatAutocompleteTrigger, { read: MatAutocompleteTrigger })
    ], AutocompleteControlComponent.prototype, "autocompleteTrigger", void 0);
    AutocompleteControlComponent = __decorate([
        Component({
            selector: 'sd-autocomplete-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{ label }}</mat-label>\r\n  <input\r\n    class=\"sd-input\"\r\n    #autocompleteTrigger\r\n    #formModel=\"ngModel\"\r\n    [ngModel]=\"cModel\"\r\n    (ngModelChange)=\"onChange($event)\"\r\n    [name]=\"name\"\r\n    placeholder=\"{{ label }}\"\r\n    [matAutocomplete]=\"auto\"\r\n    [required]=\"required\"\r\n    [disabled]=\"disabled\"\r\n    matInput\r\n    autocomplete=\"off\"\r\n  />\r\n  <mat-icon *ngIf=\"!loading && !cModel && !disabled\" matSuffix>search</mat-icon>\r\n  <mat-icon\r\n    *ngIf=\"!loading && cModel && !disabled\"\r\n    class=\"cursor-pointer\"\r\n    (click)=\"clear($event)\"\r\n    matSuffix\r\n    >close</mat-icon\r\n  >\r\n  <!-- <mat-spinner *ngIf=\"loading\" matSuffix></mat-spinner> -->\r\n  <i *ngIf=\"loading\" matSuffix class=\"fa fa-spinner fa-spin\"></i>\r\n  <mat-autocomplete #auto=\"matAutocomplete\" [displayWith]=\"displayFn\">\r\n    <mat-option *ngFor=\"let item of filteredItems | async\" [value]=\"item\">\r\n      {{ item[displayField] }}\r\n    </mat-option>\r\n  </mat-autocomplete>\r\n  <mat-error *ngIf=\"formModel?.errors?.required\">\r\n    {{ \"This field is required\" | sdTranslate }}\r\n  </mat-error>\r\n</mat-form-field>\r\n",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}"]
        })
    ], AutocompleteControlComponent);
    return AutocompleteControlComponent;
}());

var MobileMaxWidth = 767;
var IsMobile = window.innerWidth < MobileMaxWidth;

// Document: https://xdsoft.net/jqplugins/datetimepicker/
var GridDatePickerControlComponent = /** @class */ (function () {
    function GridDatePickerControlComponent(ref, datePipe) {
        var _this = this;
        this.ref = ref;
        this.datePipe = datePipe;
        this.isMobile = window.innerWidth < MobileMaxWidth;
        this.initialized = false;
        this.type = 'datetime';
        this.sdChange = new EventEmitter();
        this.modelChange = new EventEmitter();
        this.onFocus = function () {
            if (_this.isMobile) {
                // tslint:disable-next-line: deprecation
                $$1(_this.control.nativeElement).blur();
            }
        };
        this.onChanges = function () {
            _this.date = _this.pDate;
        };
    }
    Object.defineProperty(GridDatePickerControlComponent.prototype, "model", {
        set: function (val) {
            if (!Date.isDate(val)) {
                this.pDate = null;
            }
            else {
                if (this.type === 'datetime') {
                    this.pDate = this.datePipe.transform(val, 'dd/MM/yyyy HH:mm');
                }
                else if (this.type === 'date') {
                    this.pDate = this.datePipe.transform(val, 'dd/MM/yyyy');
                }
                else {
                    this.pDate = this.datePipe.transform(val, 'HH:mm');
                }
            }
            if (this.initialized) {
                this.onChanges();
            }
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    GridDatePickerControlComponent.prototype.ngOnInit = function () {
    };
    GridDatePickerControlComponent.prototype.ngAfterViewInit = function () {
        this.onChanges();
        this.initialized = true;
        this.setOption();
    };
    GridDatePickerControlComponent.prototype.setOption = function () {
        var _this = this;
        if (this.initialized) {
            $$1(this.control.nativeElement).datetimepicker({
                datepicker: this.type === 'datetime' || this.type === 'date',
                timepicker: this.type === 'datetime' || this.type === 'time',
                format: this.type === 'datetime' ? 'd/m/Y H:i' : (this.type === 'date' ? 'd/m/Y' : 'H:i'),
                step: 15,
                scrollMonth: false,
                scrollTime: false,
                scrollInput: false,
                onChangeDateTime: function (date) {
                    if (!date && !_this.date) {
                        return;
                    }
                    date = Date.toFormat(date, 'dd/MM/yyyy HH:mm');
                    if (!_this.equal(date, _this.date)) {
                        _this.model = _this.parse(date);
                        _this.modelChange.emit(_this.parse(date));
                        _this.sdChange.emit(_this.parse(date));
                        _this.ref.detectChanges();
                    }
                }
            });
        }
    };
    GridDatePickerControlComponent.prototype.parse = function (date) {
        if (this.type === 'date') {
            return Date.parseFrom(date, 'dd/MM/yyyy');
        }
        else if (this.type === 'time') {
            return Date.parseFrom(date, 'HH:mm');
        }
        return Date.parseFrom(date, 'dd/MM/yyyy HH:mm');
    };
    GridDatePickerControlComponent.prototype.equal = function (date1, date2) {
        return Date.equal(this.parse(date1), this.parse(date2));
    };
    GridDatePickerControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DatePipe }
    ]; };
    __decorate([
        Input()
    ], GridDatePickerControlComponent.prototype, "type", void 0);
    __decorate([
        Output()
    ], GridDatePickerControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Input()
    ], GridDatePickerControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], GridDatePickerControlComponent.prototype, "modelChange", void 0);
    __decorate([
        ViewChild('control')
    ], GridDatePickerControlComponent.prototype, "control", void 0);
    GridDatePickerControlComponent = __decorate([
        Component({
            selector: 'sd-grid-date-picker-control',
            template: "<div class=\"w-100 c-container\">\r\n  <input #control class=\"form-control form-control-sm\" [ngModel]=\"date\" (focus)=\"onFocus()\">\r\n  <i class=\"fa c-icon\" [ngClass]=\"{'fa-clock-o':type === 'time', 'fa-calendar':type !== 'time'}\"></i>\r\n</div>",
            styles: [".c-container{position:relative}.c-input-xs{font-size:13px!important;line-height:1.5!important;padding:3px 25px 3px 3px!important;height:28px!important}.c-icon{position:absolute;top:calc(50% - 6px);right:7px;font-size:13px!important}"]
        })
    ], GridDatePickerControlComponent);
    return GridDatePickerControlComponent;
}());

var CheckboxControlComponent = /** @class */ (function () {
    function CheckboxControlComponent(ref) {
        this.ref = ref;
        this.color = 'primary';
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.modelChange = new EventEmitter();
    }
    Object.defineProperty(CheckboxControlComponent.prototype, "model", {
        set: function (value) {
            this.ref.detectChanges();
            this._model = value;
        },
        enumerable: true,
        configurable: true
    });
    CheckboxControlComponent.prototype.onChange = function () {
        this.modelChange.emit(this._model);
        this.change.emit(this._model);
        this.sdChange.emit(this._model);
    };
    CheckboxControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], CheckboxControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], CheckboxControlComponent.prototype, "color", void 0);
    __decorate([
        Input()
    ], CheckboxControlComponent.prototype, "disabled", void 0);
    __decorate([
        Output()
    ], CheckboxControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], CheckboxControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Input()
    ], CheckboxControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], CheckboxControlComponent.prototype, "modelChange", void 0);
    CheckboxControlComponent = __decorate([
        Component({
            selector: 'sd-checkbox-control',
            template: "<mat-checkbox [(ngModel)]=\"_model\" (change)=\"onChange()\" [disabled]=\"disabled\" [color]=\"color\"><span class=\"sd-label\">{{label}}</span></mat-checkbox>",
            styles: [".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}"]
        })
    ], CheckboxControlComponent);
    return CheckboxControlComponent;
}());

var SwitchControlComponent = /** @class */ (function () {
    function SwitchControlComponent(ref) {
        this.ref = ref;
        this.color = 'primary';
        this.modelChange = new EventEmitter();
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
    }
    Object.defineProperty(SwitchControlComponent.prototype, "model", {
        set: function (value) {
            this.ref.detectChanges();
            this.cModel = value;
        },
        enumerable: true,
        configurable: true
    });
    SwitchControlComponent.prototype.ngOnInit = function () {
    };
    SwitchControlComponent.prototype.onChange = function (value) {
        this.cModel = value;
        this.modelChange.emit(this.cModel);
        this.change.emit(this.cModel);
        this.sdChange.emit(this.cModel);
    };
    SwitchControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], SwitchControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], SwitchControlComponent.prototype, "color", void 0);
    __decorate([
        Input()
    ], SwitchControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], SwitchControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], SwitchControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], SwitchControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], SwitchControlComponent.prototype, "sdChange", void 0);
    SwitchControlComponent = __decorate([
        Component({
            selector: 'sd-switch-control',
            template: "<mat-slide-toggle [ngModel]=\"cModel\" (ngModelChange)=\"onChange($event)\" [disabled]=\"disabled\" [color]=\"color\"><span class=\"sd-label\">{{label}}</span></mat-slide-toggle>",
            styles: [".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}"]
        })
    ], SwitchControlComponent);
    return SwitchControlComponent;
}());

var RadioControlComponent = /** @class */ (function () {
    function RadioControlComponent(ref) {
        var _this = this;
        this.ref = ref;
        this.initialized = false;
        this.pItems = [];
        this.name = v4();
        this.valueField = 'value';
        this.displayField = 'display';
        this.display = 'row';
        // tslint:disable-next-line: variable-name
        this._items = [];
        // Optional
        this.required = false;
        this.disabled = false;
        this.modelChange = new EventEmitter();
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.onChanges = function () {
            _this._items = _this.pItems;
            _this._model = _this.pModel;
            if (!_this._model && _this.required && _this._items.length > 0) {
                setTimeout(function () {
                    _this.onChange(_this._items[0][_this.valueField]);
                });
            }
        };
    }
    Object.defineProperty(RadioControlComponent.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (items) {
            if (!Array.isArray(items)) {
                items = [];
            }
            this.pItems = items;
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadioControlComponent.prototype, "model", {
        set: function (value) {
            this.pModel = value || '';
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    // @ViewChild('formModel') formModel: NgModel;
    RadioControlComponent.prototype.ngAfterViewInit = function () {
        this.onChanges();
        this.initialized = true;
        this.ref.detectChanges();
    };
    RadioControlComponent.prototype.onChange = function (value) {
        this._model = value;
        this.modelChange.emit(this._model);
        this.change.emit(this._model);
        this.sdChange.emit(this._model);
    };
    RadioControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "valueField", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "displayField", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "display", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "items", null);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "model", null);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], RadioControlComponent.prototype, "disabled", void 0);
    __decorate([
        Output()
    ], RadioControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], RadioControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], RadioControlComponent.prototype, "sdChange", void 0);
    RadioControlComponent = __decorate([
        Component({
            selector: 'sd-radio-control',
            template: "<section [ngClass]=\"{'c-section': display == 'row'}\">\r\n  <label *ngIf=\"label\" class=\"sd-label d-block mr-2\">{{label}} </label>\r\n  <mat-radio-group [disabled]=\"disabled\" [ngClass]=\"{'c-radio-group-column': display == 'column', 'c-radio-group-row': display == 'row'}\" [ngModel]=\"_model\" (ngModelChange)=\"onChange($event)\" [name]=\"name\">\r\n    <mat-radio-button *ngIf=\"!required\" color=\"warn\" [ngClass]=\"{'m-0': display == 'column', 'mr-4': display == 'row'}\" value=\"\">\r\n      {{'All' | sdTranslate}}\r\n    </mat-radio-button>\r\n    <mat-radio-button color=\"primary\" [ngClass]=\"{'m-0': display == 'column', 'mr-4': display == 'row'}\" *ngFor=\"let item of _items\" [value]=\"item[valueField]\">\r\n      {{item[displayField]}}\r\n    </mat-radio-button>\r\n  </mat-radio-group>\r\n</section>",
            styles: [".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", ".c-section{align-content:center;align-items:center}.c-radio-group-column{display:flex;flex-direction:column}.c-radio-group-row{display:flex;flex-direction:row}"]
        })
    ], RadioControlComponent);
    return RadioControlComponent;
}());

var SettingService = /** @class */ (function () {
    function SettingService(configurationService) {
        var _this = this;
        this.configurationService = configurationService;
        this.cache = {};
        this.getKey = function (key) {
            var _a;
            if (!key) {
                throw new Error("[Setting Service] key is required");
            }
            var hashedKey = typeof (key) === 'string' ? key : hash__default(key);
            if ((_a = _this.configuration) === null || _a === void 0 ? void 0 : _a.convertKey) {
                return _this.configuration.convertKey(hashedKey);
            }
            return hashedKey;
        };
    }
    SettingService.prototype.init = function () {
        this.configuration = this.configurationService.getSettingConfiguration();
    };
    SettingService.prototype.hasKey = function (key) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var hashKey, result, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.init();
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 5, , 6]);
                        hashKey = this.getKey(key);
                        if (!(this.cache[hashKey] === undefined)) return [3 /*break*/, 4];
                        result = localStorage.getItem(hashKey);
                        if (!((_a = this.configuration) === null || _a === void 0 ? void 0 : _a.get)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.configuration.get(hashKey)];
                    case 2:
                        result = _b.sent();
                        _b.label = 3;
                    case 3:
                        if (!result) {
                            this.cache[hashKey] = null;
                        }
                        else {
                            this.cache[hashKey] = JSON.parse(result);
                        }
                        _b.label = 4;
                    case 4: return [2 /*return*/, !!this.cache[hashKey]];
                    case 5:
                        err_1 = _b.sent();
                        console.error("[SETTING HASKEY] " + err_1);
                        return [2 /*return*/, null];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    SettingService.prototype.set = function (key, value, args) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var hashKey;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.init();
                        hashKey = this.getKey(key);
                        if (!hashKey) return [3 /*break*/, 3];
                        localStorage.setItem(hashKey, JSON.stringify(value));
                        if (!((_a = this.configuration) === null || _a === void 0 ? void 0 : _a.set)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.configuration.set(hashKey, value, args)];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2:
                        this.cache[hashKey] = value;
                        _b.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    SettingService.prototype.get = function (key, args) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var hashKey, result, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.init();
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 5, , 6]);
                        hashKey = this.getKey(key);
                        if (!(this.cache[hashKey] === undefined)) return [3 /*break*/, 4];
                        result = localStorage.getItem(hashKey);
                        if (!((_a = this.configuration) === null || _a === void 0 ? void 0 : _a.get)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.configuration.get(hashKey, args)];
                    case 2:
                        result = _b.sent();
                        _b.label = 3;
                    case 3:
                        if (!result) {
                            this.cache[hashKey] = null;
                        }
                        else {
                            this.cache[hashKey] = JSON.parse(result);
                        }
                        _b.label = 4;
                    case 4: return [2 /*return*/, this.cache[hashKey]];
                    case 5:
                        err_2 = _b.sent();
                        console.error("[SETTING GET] " + err_2);
                        return [2 /*return*/, null];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    SettingService.prototype.remove = function (key, args) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var hashKey;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.init();
                        hashKey = typeof (key) === 'string' ? key : hash__default(key);
                        if (!hashKey) return [3 /*break*/, 3];
                        localStorage.removeItem(hashKey);
                        if (!((_a = this.configuration) === null || _a === void 0 ? void 0 : _a.remove)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.configuration.remove(hashKey, args)];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2:
                        this.cache[hashKey] = null;
                        _b.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    SettingService.ctorParameters = function () { return [
        { type: ConfigurationService }
    ]; };
    SettingService = __decorate([
        Injectable()
    ], SettingService);
    return SettingService;
}());

var GridConfigComponent = /** @class */ (function () {
    function GridConfigComponent(ref, notifyService, settingService, translateService) {
        this.ref = ref;
        this.notifyService = notifyService;
        this.settingService = settingService;
        this.translateService = translateService;
        this.isMobileOrTablet = window.innerWidth < MobileMaxWidth;
        this.sdChange = new EventEmitter();
    }
    GridConfigComponent.prototype.ngOnInit = function () {
    };
    GridConfigComponent.prototype.setOption = function (option) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.ref.detectChanges();
                        this.option = option;
                        return [4 /*yield*/, this.init()];
                    case 1:
                        _a.sent();
                        this.emitOnChange();
                        return [2 /*return*/];
                }
            });
        });
    };
    GridConfigComponent.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var storage;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.option.key) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.settingService.get(this.option.key).catch(function () { return undefined; })];
                    case 1:
                        storage = _a.sent();
                        try {
                            if (!storage) {
                                this.settingService.remove(this.option.key).catch(console.error);
                                this.initDefault();
                                return [2 /*return*/];
                            }
                            this.storage = storage;
                            // Loại bỏ những column đã bị xóa khỏi originColumns
                            this.storage.columnConfigs = this.storage.columnConfigs
                                .filter(function (column) { return _this.option.columns.some(function (e) { return e.field === column.originColumn.field; }); });
                            // Thêm những column mới vào storage nếu có
                            this.option.columns.forEach(function (column) {
                                if (!_this.storage.columnConfigs.some(function (e) { return e.originColumn.field === column.field; })) {
                                    _this.storage.columnConfigs.push({
                                        originColumn: {
                                            field: column.field,
                                            title: column.title,
                                            width: column.width,
                                            fixed: column.fixed
                                        },
                                        hidden: false,
                                        fixed: column.fixed
                                    });
                                }
                            });
                            // Cập nhật originColumn
                            this.storage.columnConfigs.forEach(function (column) {
                                var originColumn = _this.option.columns.find(function (e) { return e.field === column.originColumn.field; });
                                if (originColumn) {
                                    Object.assign(column.originColumn, {
                                        title: originColumn.title,
                                        width: originColumn.width,
                                        fixed: originColumn.fixed
                                    });
                                }
                            });
                        }
                        catch (ex) {
                            this.settingService.remove(this.option.key).catch(console.error);
                            this.initDefault();
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        this.initDefault();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    GridConfigComponent.prototype.initDefault = function () {
        var _this = this;
        this.storage = {};
        this.storage.pageSize = this.option.pageSize;
        this.storage.columnConfigs = [];
        this.option.columns.forEach(function (column) {
            _this.storage.columnConfigs.push({
                originColumn: {
                    field: column.field,
                    title: column.title,
                    width: column.width,
                    fixed: column.fixed
                },
                hidden: false,
                fixed: column.fixed
            });
        });
    };
    GridConfigComponent.prototype.open = function () {
        this.modal.open();
    };
    GridConfigComponent.prototype.save = function () {
        if (!Number.isSafeInteger(+this.storage.pageSize)) {
            this.notifyService.notify.warning(this.translateService.translate('Page size must be an integer'));
            return;
        }
        if (this.storage.pageSize > 200) {
            this.notifyService.notify.warning(this.translateService.translate('Page size is too large'));
            return;
        }
        this.settingService.set(this.option.key, this.storage);
        this.emitOnChange();
        this.modal.close();
        this.ref.detectChanges();
    };
    GridConfigComponent.prototype.reset = function () {
        this.settingService.remove(this.option.key);
        this.initDefault();
        // this.reload();
        this.emitOnChange();
        this.modal.close();
        this.ref.detectChanges();
    };
    GridConfigComponent.prototype.moveColumnUp = function (index) {
        var temp = this.storage.columnConfigs[index];
        this.storage.columnConfigs[index] = this.storage.columnConfigs[index - 1];
        this.storage.columnConfigs[index - 1] = temp;
    };
    GridConfigComponent.prototype.moveColumnDown = function (index) {
        var temp = this.storage.columnConfigs[index];
        this.storage.columnConfigs[index] = this.storage.columnConfigs[index + 1];
        this.storage.columnConfigs[index + 1] = temp;
    };
    GridConfigComponent.prototype.emitOnChange = function () {
        var _this = this;
        var pageSize = +this.storage.pageSize || this.option.pageSize;
        var columns = this.option.columns.filter(function (column) {
            // Hidden column theo config
            // Lấy các thuộc tính Title, Width, Fixed từ config
            var columnConfig = _this.storage.columnConfigs.find(function (e) { return e.originColumn.field === column.field; });
            if (columnConfig) {
                column.title = columnConfig.title || column.title;
                column.width = columnConfig.width || column.width;
                column.fixed = columnConfig.fixed;
                return !columnConfig.hidden;
            }
            return true;
        }).sort(function (current, next) {
            // Sắp xếp theo config
            var currentIndex = _this.storage.columnConfigs.findIndex(function (e) { return e.originColumn.field === current.field; });
            var nextIndex = _this.storage.columnConfigs.findIndex(function (e) { return e.originColumn.field === next.field; });
            return currentIndex - nextIndex;
        }).filter(function (column) {
            // Hidden column theo option truyền vào
            if (column.hidden === undefined) {
                return true;
            }
            if (typeof (column.hidden) === 'boolean') {
                return !column.hidden;
            }
            if (typeof (column.hidden) === 'function') {
                return !column.hidden();
            }
            return false;
        });
        var result = {
            pageSize: pageSize,
            columns: columns,
            fixedColumns: columns.filter(function (e) { return e.fixed; }),
            normalColumns: columns.filter(function (e) { return !e.fixed; })
        };
        this.sdChange.emit(result);
    };
    GridConfigComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: NotifyService },
        { type: SettingService },
        { type: TranslateService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], GridConfigComponent.prototype, "modal", void 0);
    __decorate([
        Output()
    ], GridConfigComponent.prototype, "sdChange", void 0);
    GridConfigComponent = __decorate([
        Component({
            selector: 'sd-grid-config',
            template: "<sd-modal-control [title]=\"'Configuration' | sdTranslate\" #modal>\r\n  <sd-modal-body *ngIf=\"storage\">\r\n    <div class=\"row\">\r\n      <div class=\"col-md-3 col-6\">\r\n        <sd-input-control [label]=\"'Page size' | sdTranslate\" [(model)]=\"storage.pageSize\" type=\"number\" step=\"1\">\r\n        </sd-input-control>\r\n      </div>\r\n    </div>\r\n    <div class=\"sd-box sd-box-primary\">\r\n      <div class=\"sd-box-body p-0\">\r\n        <div class=\"table-responsive\">\r\n          <table class=\"table table-striped table-sm table-hover table-bordered c-table\">\r\n            <thead class=\"thead-light\">\r\n              <tr>\r\n                <th class=\"text-center\" style=\"width: 50px\">#</th>\r\n                <th *sdDesktop class=\"text-center\" style=\"width: 80px\"></th>\r\n                <!-- <th class=\"text-uppercase\" style=\"width: 120px\">Field </th> -->\r\n                <th class=\"text-uppercase\">{{'Title' | sdTranslate}}</th>\r\n                <th *sdDesktop class=\"text-uppercase\" style=\"width: 80px\">{{'Width' | sdTranslate}}</th>\r\n                <th class=\"text-uppercase\" style=\"width: 80px\">{{'Hidden' | sdTranslate}}</th>\r\n                <th *sdDesktop class=\"text-uppercase\" style=\"width: 80px\">{{'Freeze' | sdTranslate}}</th>\r\n              </tr>\r\n            </thead>\r\n            <tbody>\r\n              <tr *ngFor=\"let column of storage.columnConfigs; let idx = index\">\r\n                <td class=\"align-middle text-center\">\r\n                  {{idx+1}}\r\n                </td>\r\n                <td *sdDesktop class=\"align-middle text-center\">\r\n                  <button type=\"button\" [disabled]=\"idx==0\" type=\"button\" class=\"c-btn-icon\" placement=\"top\"\r\n                    matTooltip=\"Up\" (click)=\"moveColumnUp(idx)\">\r\n                    <i class=\"fa fa-arrow-up text-primary\" aria-hidden=\"true\"></i>\r\n                  </button>\r\n                  <button type=\"button\" [disabled]=\"idx==storage.columnConfigs.length-1\" type=\"button\"\r\n                    class=\"c-btn-icon\" placement=\"top\" matTooltip=\"Down\" (click)=\"moveColumnDown(idx)\">\r\n                    <i class=\"fa fa-arrow-down text-primary\" aria-hidden=\"true\"></i>\r\n                  </button>\r\n                </td>\r\n                <!-- <td class=\"align-middle\">{{column.originColumn.field}}</td> -->\r\n                <td class=\"align-middle\">\r\n                  <input type=\"text\" placeholder=\"{{column.originColumn.title}}\" [(ngModel)]=\"column.title\"\r\n                    class=\"form-control form-control-sm\">\r\n                </td>\r\n                <td *sdDesktop class=\"align-middle\">\r\n                  <input type=\"text\" placeholder=\"{{column.originColumn.width}}\" [(ngModel)]=\"column.width\"\r\n                    class=\"form-control form-control-sm\">\r\n                </td>\r\n                <td class=\"align-middle text-center\">\r\n                  <mat-slide-toggle [(ngModel)]=\"column.hidden\" color=\"primary\"></mat-slide-toggle>\r\n                </td>\r\n                <td *sdDesktop class=\"align-middle text-center\">\r\n                  <mat-slide-toggle [(ngModel)]=\"column.fixed\" color=\"primary\"></mat-slide-toggle>\r\n                </td>\r\n              </tr>\r\n          </table>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </sd-modal-body>\r\n  <sd-modal-footer *sdDesktop>\r\n    <sd-button class=\"mr-auto\" (action)=\"reset()\" icon=\"refresh\" [title]=\"'Reset' | sdTranslate\" size=\"sm\"></sd-button>\r\n    <sd-button (action)=\"save()\" icon=\"save\" [title]=\"'Save' | sdTranslate\" color=\"primary\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n  <sd-modal-footer *sdMobileTablet>\r\n    <sd-button style=\"flex: 1; padding-right: 5px;\" (action)=\"reset()\" icon=\"refresh\" [title]=\"'Reset' | sdTranslate\"\r\n      width=\"100%\" size=\"sm\"></sd-button>\r\n    <sd-button style=\"flex: 1; padding-left: 5px;\" (action)=\"save()\" icon=\"save\" [title]=\"'Save' | sdTranslate\"\r\n      color=\"primary\" width=\"100%\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n</sd-modal-control>",
            styles: ["", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".sd-box{position:relative;border-radius:3px;background:#fff;border-top:3px solid #dddfe2;width:100%;box-shadow:0 1px 1px rgba(0,0,0,.1)}.sd-box.sd-box-primary{border-top-color:#2f6bff!important}.sd-box.sd-box-success{border-top-color:#00bc3c!important}.sd-box.sd-box-info{border-top-color:#13c2c2!important}.sd-box.sd-box-warning{border-top-color:#fa8c16!important}.sd-box.sd-box-danger{border-top-color:#f5222d!important}.sd-box-header{color:#444;display:block;padding:.5rem;position:relative;border-bottom:1px solid #f4f4f4}.sd-box-header .sd-box-title{display:inline-block;font-size:1.2rem;margin:0;line-height:1}.sd-box-body{padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}.sd-box-footer{border-top:1px solid #f4f4f4;padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}", ".c-btn-icon{background:0 0!important;border:none;opacity:.8}.c-btn-icon:hover{cursor:pointer;opacity:1}.c-btn-icon:disabled{background:0 0!important;border:none;cursor:not-allowed;opacity:.3}.table td,.table th{padding:.2rem!important}.c-table.table{margin-bottom:5px}"]
        })
    ], GridConfigComponent);
    return GridConfigComponent;
}());

var GridImportExcelComponent = /** @class */ (function () {
    function GridImportExcelComponent() {
        var _this = this;
        this.open = function () {
            var _a;
            (_a = _this.control) === null || _a === void 0 ? void 0 : _a.open();
        };
    }
    Object.defineProperty(GridImportExcelComponent.prototype, "columns", {
        set: function (gridColumns) {
            var columns = [];
            gridColumns.forEach(function (column) {
                var _a;
                if (column.ignoreImport) {
                    return;
                }
                if (column.type === 'string' || column.type === 'color') {
                    columns.push({
                        type: 'string',
                        field: column.field,
                        title: column.title,
                        width: column.width
                    });
                }
                else if (column.type === 'number') {
                    columns.push({
                        type: 'number',
                        field: column.field,
                        title: column.title,
                        width: column.width
                    });
                }
                else if (column.type === 'bool') {
                    columns.push({
                        type: 'bool',
                        field: column.field,
                        title: column.title,
                        width: column.width
                    });
                }
                else if (column.type === 'date') {
                    columns.push({
                        type: 'date',
                        field: column.field,
                        title: column.title,
                        width: column.width
                    });
                }
                else if (column.type === 'datetime' || column.type === 'time') {
                    columns.push({
                        type: 'datetime',
                        field: column.field,
                        title: column.title,
                        width: column.width
                    });
                }
                else if (column.type === 'values') {
                    columns.push({
                        type: 'values',
                        field: column.field,
                        title: column.title,
                        width: column.width,
                        values: column.values.map(function (e) { return e.value; }),
                    });
                }
                else if (column.type === 'radio') {
                    columns.push({
                        type: 'radio',
                        field: column.field,
                        title: column.title,
                        width: column.width,
                        values: column.values.map(function (e) { return e[column.valueField]; })
                    });
                }
                if (column.type === 'children' && ((_a = column.children) === null || _a === void 0 ? void 0 : _a.length)) {
                    column.children.forEach(function (childColumn) {
                        if (childColumn.ignoreImport) {
                            return;
                        }
                        if (childColumn.type === 'string' || childColumn.type === 'color') {
                            columns.push({
                                type: 'string',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width
                            });
                        }
                        else if (childColumn.type === 'number') {
                            columns.push({
                                type: 'number',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width
                            });
                        }
                        else if (childColumn.type === 'bool') {
                            columns.push({
                                type: 'bool',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width
                            });
                        }
                        else if (childColumn.type === 'date') {
                            columns.push({
                                type: 'date',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width
                            });
                        }
                        else if (childColumn.type === 'datetime' || childColumn.type === 'time') {
                            columns.push({
                                type: 'datetime',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width
                            });
                        }
                        else if (childColumn.type === 'values') {
                            columns.push({
                                type: 'values',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width,
                                values: childColumn.values.map(function (e) { return e.value; }),
                            });
                        }
                        else if (childColumn.type === 'radio') {
                            columns.push({
                                type: 'radio',
                                field: childColumn.field,
                                title: childColumn.title,
                                width: childColumn.width,
                                values: childColumn.values.map(function (e) { return e[childColumn.valueField]; })
                            });
                        }
                    });
                }
            });
            this.option = {
                key: "GridImport" + this.key,
                columns: columns,
                onAccept: this.accept
            };
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input()
    ], GridImportExcelComponent.prototype, "key", void 0);
    __decorate([
        Input()
    ], GridImportExcelComponent.prototype, "accept", void 0);
    __decorate([
        Input()
    ], GridImportExcelComponent.prototype, "columns", null);
    __decorate([
        ViewChild('control')
    ], GridImportExcelComponent.prototype, "control", void 0);
    GridImportExcelComponent = __decorate([
        Component({
            selector: 'sd-grid-import-excel',
            template: "<sd-upload-excel-control *ngIf=\"option\" [option]=\"option\" #control></sd-upload-excel-control>",
            styles: [""]
        })
    ], GridImportExcelComponent);
    return GridImportExcelComponent;
}());

var CkeditorControlComponent = /** @class */ (function () {
    function CkeditorControlComponent(ref, sanitizer) {
        this.ref = ref;
        this.sanitizer = sanitizer;
        this.disabled = false;
        this.required = false;
        this.modelChange = new EventEmitter();
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.editorUrl = '../../assets/ckeditor/ckeditor.js';
    }
    Object.defineProperty(CkeditorControlComponent.prototype, "model", {
        set: function (value) {
            this.cModel = value;
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CkeditorControlComponent.prototype, "config", {
        set: function (value) {
            this.cConfig = value;
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    CkeditorControlComponent.prototype.ngOnInit = function () {
    };
    CkeditorControlComponent.prototype.onChange = function (value) {
        this.model = value;
        this.modelChange.emit(value);
        this.change.emit(value);
        this.sdChange.emit(value);
    };
    CkeditorControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DomSanitizer }
    ]; };
    __decorate([
        Input()
    ], CkeditorControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], CkeditorControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], CkeditorControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], CkeditorControlComponent.prototype, "model", null);
    __decorate([
        Input()
    ], CkeditorControlComponent.prototype, "config", null);
    __decorate([
        Output()
    ], CkeditorControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], CkeditorControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], CkeditorControlComponent.prototype, "sdChange", void 0);
    CkeditorControlComponent = __decorate([
        Component({
            selector: 'sd-ckeditor-control',
            template: "\r\n<label *ngIf=\"label\" class=\"sd-label d-block\">{{label}} <span *ngIf=\"required\" class=\"text-danger\">*</span></label>\r\n<ckeditor [ngModel]=\"cModel\" (ngModelChange)=\"onChange($event)\" [config]=\"cConfig\" [readOnly]=\"disabled\" [editorUrl]=\"editorUrl\"></ckeditor>",
            styles: [".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", ":host ::ng-deep .ck-editor__editable{min-height:500px}"]
        })
    ], CkeditorControlComponent);
    return CkeditorControlComponent;
}());

var TranslatePipe = /** @class */ (function () {
    function TranslatePipe(translateService) {
        this.translateService = translateService;
    }
    TranslatePipe.prototype.transform = function (value) {
        return this.translateService.translate(value);
    };
    TranslatePipe.ctorParameters = function () { return [
        { type: TranslateService }
    ]; };
    TranslatePipe = __decorate([
        Pipe({
            name: 'sdTranslate'
        })
    ], TranslatePipe);
    return TranslatePipe;
}());

var CacheService = /** @class */ (function () {
    function CacheService() {
        this.cache = {};
    }
    CacheService.prototype.set = function (key, data, group) {
        if (group === void 0) { group = null; }
        var objHash = null;
        var objGroup = null;
        if (typeof (key) === 'object') {
            objHash = __assign({}, key);
            key = hash__default(key);
        }
        if (typeof (group) === 'object') {
            objGroup = __assign({}, group);
            group = hash__default(group);
        }
        if (this.has(key) && typeof (this.cache[key].data) === 'object' && typeof (data) === 'object') {
            Object.assign(this.cache[key].data, data);
        }
        else {
            this.cache[key] = {
                objHash: objHash,
                objGroup: objGroup,
                group: group,
                data: data
            };
        }
    };
    CacheService.prototype.get = function (key) {
        if (typeof (key) === 'object') {
            key = hash__default(key);
        }
        if (!this.has(key)) {
            return null;
        }
        return this.cache[key].data;
    };
    CacheService.prototype.has = function (key) {
        if (typeof (key) === 'object') {
            key = hash__default(key);
        }
        return !!this.cache[key];
    };
    CacheService.prototype.clear = function () {
        this.cache = {};
    };
    CacheService.prototype.allByGroup = function (group) {
        var _this = this;
        if (typeof (group) === 'object') {
            group = hash__default(group);
        }
        var results = [];
        Object.keys(this.cache)
            .filter(function (key) { return _this.cache[key] && _this.cache[key].group === group; })
            .forEach(function (key) { return results.push(_this.cache[key].data); });
        return results;
    };
    CacheService.prototype.clearByGroup = function (group) {
        var _this = this;
        if (typeof (group) === 'object') {
            group = hash__default(group);
        }
        Object.keys(this.cache).forEach(function (key) {
            if (_this.cache[key].group === group) {
                _this.cache[key] = undefined;
            }
        });
    };
    CacheService = __decorate([
        Injectable()
    ], CacheService);
    return CacheService;
}());

var UploadExcelConfigComponent = /** @class */ (function () {
    function UploadExcelConfigComponent(settingService, translateService) {
        this.settingService = settingService;
        this.translateService = translateService;
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
    }
    UploadExcelConfigComponent.prototype.ngOnInit = function () {
    };
    UploadExcelConfigComponent.prototype.setOption = function (option) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.option = option;
                        return [4 /*yield*/, this.init()];
                    case 1:
                        _a.sent();
                        this.emitOnChange();
                        return [2 /*return*/];
                }
            });
        });
    };
    UploadExcelConfigComponent.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(this.option.key && this.settingService.get(this.option.key))) return [3 /*break*/, 5];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        _a = this;
                        return [4 /*yield*/, this.settingService.get(this.option.key)];
                    case 2:
                        _a.storage = _b.sent();
                        if (!this.storage) {
                            // Xóa setting
                            this.settingService.remove(this.option.key);
                            // Lấy setting mặc định
                            this.initDefault();
                            return [2 /*return*/];
                        }
                        // Loại bỏ những column đã bị xóa khỏi originColumns
                        this.storage.columns = this.storage.columns.filter(function (column) { return _this.option.columns.some(function (e) { return e.field === column.originColumn.field; }); });
                        // Thêm những column mới vào storage nếu có
                        this.option.columns.forEach(function (column) {
                            if (!_this.storage.columns.some(function (e) { return e.originColumn.field === column.field; })) {
                                _this.storage.columns.push({
                                    originColumn: {
                                        field: column.field,
                                        title: column.title,
                                        width: column.width,
                                        required: column.required
                                    },
                                    hidden: false
                                });
                            }
                        });
                        // Cập nhật originColumn
                        this.storage.columns.forEach(function (column) {
                            var originColumn = _this.option.columns.find(function (e) { return e.field === column.originColumn.field; });
                            if (originColumn) {
                                Object.assign(column.originColumn, {
                                    title: originColumn.title,
                                    width: originColumn.width
                                });
                            }
                        });
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _b.sent();
                        // Xóa setting
                        this.settingService.remove(this.option.key);
                        // Lấy setting mặc định
                        this.initDefault();
                        return [3 /*break*/, 4];
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        this.initDefault(); // Lấy setting mặc định
                        _b.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    UploadExcelConfigComponent.prototype.initDefault = function () {
        var _this = this;
        this.storage = {};
        this.storage.formatDate = '';
        this.storage.columns = [];
        this.option.columns.forEach(function (column) {
            _this.storage.columns.push({
                originColumn: {
                    field: column.field,
                    title: column.title,
                    width: column.width,
                    required: column.required
                },
                hidden: false
            });
        });
    };
    UploadExcelConfigComponent.prototype.open = function () {
        this.modal.open();
    };
    UploadExcelConfigComponent.prototype.save = function () {
        this.settingService.set(this.option.key, this.storage);
        this.emitOnChange();
        this.modal.close();
    };
    UploadExcelConfigComponent.prototype.reset = function () {
        this.settingService.remove(this.option.key);
        this.initDefault();
        // this.reload();
        this.emitOnChange();
        this.modal.close();
    };
    UploadExcelConfigComponent.prototype.moveColumnUp = function (index) {
        var temp = this.storage.columns[index];
        this.storage.columns[index] = this.storage.columns[index - 1];
        this.storage.columns[index - 1] = temp;
    };
    UploadExcelConfigComponent.prototype.moveColumnDown = function (index) {
        var temp = this.storage.columns[index];
        this.storage.columns[index] = this.storage.columns[index + 1];
        this.storage.columns[index + 1] = temp;
    };
    UploadExcelConfigComponent.prototype.emitOnChange = function () {
        var _this = this;
        var formatDate = this.storage.formatDate || '';
        var columns = this.option.columns.filter(function (column) {
            // Hidden column theo config
            // Lấy các thuộc tính Title, Width từ config
            var columnConfig = _this.storage.columns.find(function (e) { return e.originColumn.field === column.field; });
            if (columnConfig) {
                column.title = columnConfig.title || _this.translateService.translate(columnConfig.originColumn.title);
                column.width = columnConfig.width || columnConfig.originColumn.width;
                return !columnConfig.hidden;
            }
            else {
                return true;
            }
        }).sort(function (current, next) {
            // Sắp xếp theo config
            var currentIndex = _this.storage.columns.findIndex(function (e) { return e.originColumn.field === current.field; });
            var nextIndex = _this.storage.columns.findIndex(function (e) { return e.originColumn.field === next.field; });
            return currentIndex - nextIndex;
        });
        var result = {
            formatDate: '',
            // pageSize: pageSize,
            columns: columns
        };
        this.change.emit(result);
    };
    UploadExcelConfigComponent.ctorParameters = function () { return [
        { type: SettingService },
        { type: TranslateService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], UploadExcelConfigComponent.prototype, "modal", void 0);
    __decorate([
        Output()
    ], UploadExcelConfigComponent.prototype, "change", void 0);
    UploadExcelConfigComponent = __decorate([
        Component({
            selector: 'sd-upload-excel-config',
            template: "<sd-modal-control width=\"sm\" title=\"Configure Upload Excel\" #modal>\r\n  <sd-modal-body *ngIf=\"storage\">\r\n    <div class=\"row\">\r\n      <div class=\"col-md-12 mt-2\">\r\n        <sd-input-control [(model)]=\"storage.formatDate\"></sd-input-control>\r\n      </div>\r\n    </div>\r\n    <div class=\"sd-box sd-box-primary\">\r\n      <div class=\"sd-box-body p-0\">\r\n        <div class=\"table-responsive\" style=\"height: calc(100vh - 20rem)\">\r\n          <table class=\"table table-striped table-sm table-hover table-bordered\">\r\n            <thead class=\"thead-light\">\r\n              <tr>\r\n                <th class=\"text-center\" style=\"width: 50px\">#</th>\r\n                <th class=\"text-center\" style=\"width: 80px\"></th>\r\n                <th class=\"text-uppercase\" style=\"width: 120px\" translate>Field </th>\r\n                <th class=\"text-uppercase\" translate>Title </th>\r\n                <th class=\"text-uppercase\" style=\"width: 80px\" translate>Width </th>\r\n                <th class=\"text-uppercase\" style=\"width: 80px\" translate>Hidden </th>\r\n              </tr>\r\n            </thead>\r\n            <tbody>\r\n              <tr *ngFor=\"let column of storage.columns; let idx = index\">\r\n                <td class=\"align-middle text-center\">\r\n                  {{idx+1}}\r\n                </td>\r\n                <td class=\"align-middle text-center\">\r\n                  <button type=\"button\" [disabled]=\"idx==0\" type=\"button\" class=\"c-btn-icon\" placement=\"top\" matTooltip=\"Up\" (click)=\"moveColumnUp(idx)\">\r\n                    <i class=\"fa fa-arrow-up text-primary\" aria-hidden=\"true\"></i>\r\n                  </button>\r\n                  <button type=\"button\" [disabled]=\"idx==storage.columns.length-1\" type=\"button\" class=\"c-btn-icon\" placement=\"top\" matTooltip=\"Down\" (click)=\"moveColumnDown(idx)\">\r\n                    <i class=\"fa fa-arrow-down text-primary\" aria-hidden=\"true\"></i>\r\n                  </button>\r\n                </td>\r\n                <td class=\"align-middle\">{{column.originColumn.field}}</td>\r\n                <td class=\"align-middle\">\r\n                  <input type=\"text\" placeholder=\"{{column.originColumn.title}}\" [(ngModel)]=\"column.title\" class=\"form-control form-control-sm\">\r\n                </td>\r\n                <td class=\"align-middle\">\r\n                  <input type=\"text\" placeholder=\"{{column.originColumn.width}}\" [(ngModel)]=\"column.width\" class=\"form-control form-control-sm\">\r\n                </td>\r\n                <td class=\"align-middle text-center\">\r\n                  <mat-slide-toggle [(ngModel)]=\"column.hidden\" color=\"primary\" [disabled]=\"column.originColumn.required\"></mat-slide-toggle>\r\n                </td>\r\n              </tr>\r\n          </table>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </sd-modal-body>\r\n  <sd-modal-footer>\r\n    <button type=\"button\" class=\"btn btn-info btn-sm mr-auto\" (click)=\"reset()\">\r\n      <i class=\"fa fa-refresh mr-1\"></i> <span translate>Reset</span></button>\r\n    <button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"save()\">\r\n      <i class=\"fa fa-floppy-o mr-1\"></i> <span translate>Save</span></button>\r\n  </sd-modal-footer>\r\n</sd-modal-control>",
            styles: ["", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".sd-box{position:relative;border-radius:3px;background:#fff;border-top:3px solid #dddfe2;width:100%;box-shadow:0 1px 1px rgba(0,0,0,.1)}.sd-box.sd-box-primary{border-top-color:#2f6bff!important}.sd-box.sd-box-success{border-top-color:#00bc3c!important}.sd-box.sd-box-info{border-top-color:#13c2c2!important}.sd-box.sd-box-warning{border-top-color:#fa8c16!important}.sd-box.sd-box-danger{border-top-color:#f5222d!important}.sd-box-header{color:#444;display:block;padding:.5rem;position:relative;border-bottom:1px solid #f4f4f4}.sd-box-header .sd-box-title{display:inline-block;font-size:1.2rem;margin:0;line-height:1}.sd-box-body{padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}.sd-box-footer{border-top:1px solid #f4f4f4;padding:.5rem;background-color:#fff;border-radius:0 0 3px 3px}", "", ".c-btn-icon{background:0 0!important;border:none;opacity:.8}.c-btn-icon:hover{cursor:pointer;opacity:1}.c-btn-icon:disabled{background:0 0!important;border:none;cursor:not-allowed;opacity:.3}.table td,.table th{padding:.2rem!important}.btn{color:#fff;background-color:#999;border-color:#999;box-shadow:0 2px 2px 0 rgba(153,153,153,.14),0 3px 1px -2px rgba(153,153,153,.2),0 1px 5px 0 rgba(153,153,153,.12)}.btn:hover{color:#fff;background-color:#919191;border-color:#7a7a7a}.btn.btn-sm{font-size:.6875rem}.btn.btn-primary{color:#fff;background-color:#9c27b0;border-color:#9c27b0;box-shadow:0 2px 2px 0 rgba(156,39,176,.14),0 3px 1px -2px rgba(156,39,176,.2),0 1px 5px 0 rgba(156,39,176,.12)}.btn.btn-info{color:#fff;background-color:#00bcd4;border-color:#00bcd4;box-shadow:0 2px 2px 0 rgba(0,188,212,.14),0 3px 1px -2px rgba(0,188,212,.2),0 1px 5px 0 rgba(0,188,212,.12)}.btn.btn-success{color:#fff;background-color:#4caf50;border-color:#4caf50;box-shadow:0 2px 2px 0 rgba(76,175,80,.14),0 3px 1px -2px rgba(76,175,80,.2),0 1px 5px 0 rgba(76,175,80,.12)}.btn.btn-warning{color:#fff;background-color:#ff9800;border-color:#ff9800;box-shadow:0 2px 2px 0 rgba(255,152,0,.14),0 3px 1px -2px rgba(255,152,0,.2),0 1px 5px 0 rgba(255,152,0,.12)}.btn.btn-danger{color:#fff;background-color:#f44336;border-color:#f44336;box-shadow:0 2px 2px 0 rgba(244,67,54,.14),0 3px 1px -2px rgba(244,67,54,.2),0 1px 5px 0 rgba(244,67,54,.12)}"]
        })
    ], UploadExcelConfigComponent);
    return UploadExcelConfigComponent;
}());

var GridAutocompleteControl = /** @class */ (function () {
    function GridAutocompleteControl(ref, utilityService) {
        var _this = this;
        this.ref = ref;
        this.utilityService = utilityService;
        this.initialized = false;
        this.pItems = [];
        this.flag = false;
        this.name = v4();
        this.cItems = [];
        this.limit = 30;
        this.loading = false;
        this.modelChange = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.search = new EventEmitter();
        this.subcription = new Subscription();
        this.visibility = true;
        this.onChanges = function () {
            _this.cModel = _this.pModel;
            if (_this.flag || (!_this.valueField && !_this.displayField)) {
                _this.cItems = _this.pItems.map(function (e) { return ({
                    code: e
                }); });
                _this.flag = true;
                _this.valueField = 'code';
                _this.displayField = 'code';
            }
            else {
                _this.cItems = _this.pItems;
            }
            // this.formModel?.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
        this.reload = function () {
            var _a;
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
        this.filter = function (value) {
            var results = _this.cItems;
            if (value) {
                results = _this.cItems.filter(function (item) {
                    return _this.utilityService.changeAliasLowerCase(item[_this.displayField])
                        .indexOf(_this.utilityService.changeAliasLowerCase(value)) !== -1;
                });
            }
            return results.filter(function (item, index) { return index < _this.limit; });
        };
        this.displayFn = function (value) {
            if (typeof value === 'string') {
                if (!_this.cItems) {
                    return value;
                }
                var selectedItem = _this.cItems.find(function (item) { return item[_this.valueField] === value; });
                if (selectedItem) {
                    return selectedItem[_this.displayField];
                }
                return value;
            }
            else {
                return value ? value[_this.displayField] : undefined;
            }
        };
        this.clear = function ($event) {
            var _a, _b;
            (_a = $event) === null || _a === void 0 ? void 0 : _a.stopPropagation();
            (_b = _this.formModel) === null || _b === void 0 ? void 0 : _b.control.setValue(undefined);
        };
    }
    Object.defineProperty(GridAutocompleteControl.prototype, "items", {
        set: function (items) {
            var _this = this;
            var _a, _b, _c, _d;
            if (!items) {
                items = [];
            }
            if (Array.isArray(items)) {
                this.pItems = items || [];
                if (this.initialized) {
                    this.onChanges();
                    (_a = this.formModel) === null || _a === void 0 ? void 0 : _a.control.setValue((_b = this.formModel) === null || _b === void 0 ? void 0 : _b.control.value);
                    this.reload();
                }
            }
            else if ((_c = items) === null || _c === void 0 ? void 0 : _c.pipe) {
                this.subcription.add((_d = items) === null || _d === void 0 ? void 0 : _d.subscribe(function (values) {
                    var _a, _b;
                    _this.pItems = values || [];
                    if (_this.initialized) {
                        _this.onChanges();
                        (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.setValue((_b = _this.formModel) === null || _b === void 0 ? void 0 : _b.control.value);
                        _this.reload();
                    }
                }));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridAutocompleteControl.prototype, "model", {
        set: function (value) {
            this.pModel = value;
            if (this.initialized) {
                this.onChanges();
                this.reload();
            }
        },
        enumerable: true,
        configurable: true
    });
    GridAutocompleteControl.prototype.ngOnInit = function () {
        var _this = this;
        this.filteredItems = this.formModel.valueChanges.pipe(startWith(''), map(function (item) { return typeof item === 'string' ? item : (item ? item[_this.displayField] : ''); }), map(this.filter));
    };
    GridAutocompleteControl.prototype.ngAfterViewInit = function () {
        this.onChanges();
        this.reload();
        this.initialized = true;
        this.ref.detectChanges();
    };
    GridAutocompleteControl.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.subcription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
    };
    GridAutocompleteControl.prototype.onChange = function (value) {
        var _a;
        if (typeof value !== 'string') {
            this.cModel = value ? value[this.valueField] : undefined;
            this.modelChange.emit(this.cModel);
            this.sdChange.emit(value);
        }
        else {
            if (!value) {
                this.cModel = undefined;
                this.modelChange.emit(this.cModel);
                this.sdChange.emit(this.cModel);
                this.reload();
                (_a = this.autocompleteTrigger) === null || _a === void 0 ? void 0 : _a.openPanel();
                // this.clear();
            }
            this.search.emit(value);
        }
    };
    GridAutocompleteControl.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: UtilityService }
    ]; };
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "loading", void 0);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "valueField", void 0);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "displayField", void 0);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "items", null);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "model", null);
    __decorate([
        Output()
    ], GridAutocompleteControl.prototype, "modelChange", void 0);
    __decorate([
        Output()
    ], GridAutocompleteControl.prototype, "sdChange", void 0);
    __decorate([
        Output()
    ], GridAutocompleteControl.prototype, "search", void 0);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "required", void 0);
    __decorate([
        Input()
    ], GridAutocompleteControl.prototype, "disabled", void 0);
    __decorate([
        ViewChild('formModel', { static: true })
    ], GridAutocompleteControl.prototype, "formModel", void 0);
    __decorate([
        ViewChild(MatAutocompleteTrigger, { read: MatAutocompleteTrigger })
    ], GridAutocompleteControl.prototype, "autocompleteTrigger", void 0);
    GridAutocompleteControl = __decorate([
        Component({
            selector: 'sd-grid-autocomplete-control',
            template: "<div class=\"w-100 c-container\">\r\n  <input #autocompleteTrigger class=\"form-control form-control-sm\" #formModel=\"ngModel\" [ngModel]=\"cModel\" (ngModelChange)=\"onChange($event)\"\r\n    [name]=\"name\" [matAutocomplete]=\"auto\" [required]=\"required\" [disabled]=\"disabled\" autocomplete=\"false\">\r\n  <i *ngIf=\"!cModel; else clearIcon\" class=\"fa fa-search c-icon\"></i>\r\n  <ng-template #clearIcon>\r\n    <i class=\"fa fa-times text-danger c-icon\" (click)=\"clear($event)\" style=\"cursor: pointer;\"></i>\r\n  </ng-template>\r\n</div>\r\n<mat-autocomplete #auto=\"matAutocomplete\" [displayWith]=\"displayFn\" autoActiveFirstOption>\r\n  <mat-option *ngFor=\"let item of filteredItems | async\" [value]=\"item\">\r\n    {{item[displayField]}}\r\n  </mat-option>\r\n</mat-autocomplete>",
            styles: [".c-container{position:relative}.c-input-xs{font-size:13px!important;line-height:1.5!important;padding:3px 25px 3px 3px!important;height:28px!important}.c-icon{position:absolute;top:calc(50% - 6px);right:7px;font-size:13px!important}", ""]
        })
        // tslint:disable-next-line: component-class-suffix
    ], GridAutocompleteControl);
    return GridAutocompleteControl;
}());

var GridPopupEditorComponent = /** @class */ (function () {
    function GridPopupEditorComponent(settingService) {
        this.settingService = settingService;
        this.save = new EventEmitter();
        this.columns = [];
    }
    GridPopupEditorComponent.prototype.ngOnInit = function () {
    };
    GridPopupEditorComponent.prototype.setGridOption = function (gridOption) {
        this.gridOption = gridOption;
    };
    GridPopupEditorComponent.prototype.open = function (item) {
        this.item = item;
        this.columns = this.gridOption.columns.filter(function (column) { return item.editorHandler[column.field].visible; });
    };
    GridPopupEditorComponent.prototype.onCancel = function () {
        this.modal.close();
    };
    GridPopupEditorComponent.prototype.onSave = function () {
        this.modal.close();
        this.save.emit(this.item);
    };
    GridPopupEditorComponent.ctorParameters = function () { return [
        { type: SettingService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], GridPopupEditorComponent.prototype, "modal", void 0);
    __decorate([
        Output()
    ], GridPopupEditorComponent.prototype, "save", void 0);
    GridPopupEditorComponent = __decorate([
        Component({
            selector: 'sd-grid-popup-editor',
            template: "<sd-modal-control title=\"Configuration\" #modal>\r\n  <sd-modal-body *ngIf=\"item && gridOption?.columns\">\r\n    <form #formEditor=\"ngForm\">\r\n      <ng-template ngFor let-column [ngForOf]=\"columns\">\r\n        <div class=\"row\">\r\n          <div class=\"col-md-4\"></div>\r\n          <div class=\"col-md-8\">\r\n            <sd-input-control *ngIf=\"column.type === 'string'\" [(model)]=\"item[column.field]\"></sd-input-control>\r\n            <sd-input-control *ngIf=\"column.type === 'number'\" [(model)]=\"item[column.field]\" type=\"number\">\r\n            </sd-input-control>\r\n            <sd-select-control *ngIf=\"column.type === 'values'\" [(model)]=\"item[column.field]\" [items]=\"column.values\">\r\n            </sd-select-control>\r\n            <sd-switch-control *ngIf=\"column.type === 'boolean'\" [(model)]=\"item[column.field]\">\r\n            </sd-switch-control>\r\n            <sd-radio-control *ngIf=\"column.type === 'radio'\" [(model)]=\"item[column.field]\" [items]=\"column.values\">\r\n            </sd-radio-control>\r\n          </div>\r\n        </div>\r\n      </ng-template>\r\n    </form>\r\n  </sd-modal-body>\r\n  <sd-modal-footer>\r\n    <button type=\"button\" class=\"btn btn-info btn-sm mr-auto\" (click)=\"onCancel()\">\r\n      <i class=\"fa fa-refresh\"></i> {{'Cancel' | sdTranslate }}</button>\r\n    <button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"onSave()\">\r\n      <i class=\"fa fa-floppy-o\"></i> {{'Save' | sdTranslate }}</button>\r\n  </sd-modal-footer>\r\n</sd-modal-control>",
            styles: ["", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}"]
        })
    ], GridPopupEditorComponent);
    return GridPopupEditorComponent;
}());

var FilterMobilePipe = /** @class */ (function () {
    function FilterMobilePipe() {
    }
    FilterMobilePipe.prototype.transform = function (columns, item) {
        // Những giá trị undefined, null và rỗng sẽ bỏ qua khi hiển thị trên mobile
        return columns.filter(function (column) {
            var _a;
            return (item[column.field] !== undefined
                && item[column.field] !== null
                && item[column.field] !== '')
                || column.htmlTemplate
                || column.type === 'children'
                || (column.type === 'string' && ((_a = column.commands) === null || _a === void 0 ? void 0 : _a.length) > 0);
        });
    };
    FilterMobilePipe = __decorate([
        Pipe({
            name: 'filterMobile',
            pure: false
        })
    ], FilterMobilePipe);
    return FilterMobilePipe;
}());

var GridPopupFilterComponent = /** @class */ (function () {
    function GridPopupFilterComponent(ref, deviceService, settingService, notifyService, translateService) {
        var _this = this;
        this.ref = ref;
        this.settingService = settingService;
        this.notifyService = notifyService;
        this.translateService = translateService;
        this.keyPrefix = 'PopupFilter';
        this.displayKey = 'SDCUSTOM';
        this.isMobileOrTablet = false;
        this.filterType = 'inline';
        this.key = '';
        this.accept = new EventEmitter();
        this.clear = new EventEmitter();
        this.loadInlineFilter = new EventEmitter();
        this.newQuickFilter = 'e1ef1d43-d689-424f-959e-e6cd154cfee7';
        this.filter = {};
        this.externalFilter = {};
        this.columns = [];
        this.externalFilters = [];
        this.quickFilters = [];
        this.maxQuickFilters = 5;
        this.inlineExternal = {};
        this.inlineColumn = {};
        this.open = function (fixedColums, normalColumns, filter, externalFilter, externalFilters) {
            _this.init(fixedColums, normalColumns, filter, externalFilter, externalFilters);
            _this.modal.open();
        };
        this.init = function (fixedColums, normalColumns, filter, externalFilter, externalFilters) {
            var e_1, _a, e_2, _b;
            _this.columns = __spread(fixedColums, normalColumns).filter(function (e) { var _a; return !((_a = e.filter) === null || _a === void 0 ? void 0 : _a.disabled); });
            _this.columns.forEach(function (column) {
                if (column.type === 'children') {
                    column.children = column.children.filter(function (e) { var _a; return !((_a = e.filter) === null || _a === void 0 ? void 0 : _a.disabled); });
                }
            });
            if (externalFilters) {
                _this.externalFilters = externalFilters.filter(function (e) { return !e.disabled; });
            }
            else {
                _this.externalFilters = [];
            }
            _this.filter = filter;
            _this.externalFilter = _this.initExternalFilter(externalFilters, externalFilter);
            try {
                for (var _c = __values(_this.externalFilters), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var eFilter = _d.value;
                    if (_this.inlineExternal[eFilter.field] === undefined) {
                        _this.inlineExternal[eFilter.field] = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
            try {
                for (var _e = __values(_this.columns), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var column = _f.value;
                    if (_this.inlineColumn[column.field] === undefined) {
                        _this.inlineColumn[column.field] = true;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        this.close = function () {
            _this.modal.close();
        };
        this.onSelectionChange = function (change) {
            var _a;
            var value = ((_a = change) === null || _a === void 0 ? void 0 : _a.value) || '';
            if (value === _this.newQuickFilter) {
                _this.selectedCode = '';
                _this.onCreateQuickFilter();
                _this.ref.detectChanges();
            }
            else {
                var quickFilter = _this.quickFilters.find(function (e) { return e.code === value; });
                if (quickFilter) {
                    _this.onDetailQuickFilter(quickFilter);
                }
            }
        };
        this.onCreateQuickFilter = function (ev) {
            var _a, _b, _c;
            (_a = ev) === null || _a === void 0 ? void 0 : _a.stopPropagation();
            (_b = ev) === null || _b === void 0 ? void 0 : _b.preventDefault();
            (_c = _this.matSelect) === null || _c === void 0 ? void 0 : _c.close();
            _this.popupQuickFilterDetail.open(_this.columns, _this.externalFilters);
        };
        this.onDetailQuickFilter = function (quickFilter) { return __awaiter(_this, void 0, void 0, function () {
            var f1, f2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!quickFilter) return [3 /*break*/, 2];
                        this.selectedCode = quickFilter.code;
                        f1 = JSON.stringify(quickFilter.filter);
                        f2 = JSON.stringify(quickFilter.externalFilter);
                        this.filter = JSON.parse(f1);
                        this.externalFilter = this.initExternalFilter(this.externalFilters, JSON.parse(f2));
                        return [4 /*yield*/, this.updateConfiguration()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); };
        this.onEditQuickFilter = function (ev, quickFilter) {
            var _a;
            ev.stopPropagation();
            ev.preventDefault();
            (_a = _this.matSelect) === null || _a === void 0 ? void 0 : _a.close();
            if (quickFilter) {
                _this.popupQuickFilterDetail.open(_this.columns, _this.externalFilters, quickFilter.filter, quickFilter.externalFilter, quickFilter.code);
                _this.ref.detectChanges();
            }
        };
        this.onDeleteQuickFilter = function (ev, quickFilter) {
            var _a;
            ev.stopPropagation();
            ev.preventDefault();
            (_a = _this.matSelect) === null || _a === void 0 ? void 0 : _a.close();
            if (quickFilter) {
                _this.notifyService.confirm(_this.translateService.translate('Remove filter')).then(function () { return __awaiter(_this, void 0, void 0, function () {
                    var idx;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (quickFilter.code === this.selectedCode) {
                                    this.selectedCode = '';
                                }
                                idx = this.quickFilters.findIndex(function (e) { return e.code === quickFilter.code; });
                                this.quickFilters.splice(idx, 1);
                                return [4 /*yield*/, this.updateConfiguration()];
                            case 1:
                                _a.sent();
                                this.ref.detectChanges();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
        };
        this.onAcceptQuickFilter = function (args) { return __awaiter(_this, void 0, void 0, function () {
            var quickFilter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        quickFilter = this.quickFilters.find(function (e) { return e.code === args.code; });
                        if (!quickFilter) {
                            this.quickFilters.push({
                                code: args.code,
                                filter: args.filter,
                                externalFilter: this.initExternalFilter(this.externalFilters, args.externalFilter)
                            });
                        }
                        else {
                            quickFilter.filter = args.filter;
                            quickFilter.externalFilter = this.initExternalFilter(this.externalFilters, args.externalFilter);
                        }
                        return [4 /*yield*/, this.updateConfiguration()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.onInlineChange = function () {
            _this.updateConfiguration();
        };
        this.initExternalFilter = function (externalFilters, externalFilter) {
            externalFilter = externalFilter || {};
            externalFilters = externalFilters || [];
            externalFilters.forEach(function (e) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
                if (e.type === 'string') {
                    if (e.default) {
                        externalFilter[e.field] = (_a = e.default, (_a !== null && _a !== void 0 ? _a : ''));
                    }
                    return;
                }
                if (e.type === 'number') {
                    externalFilter[e.field] = (_c = (_b = externalFilter[e.field], (_b !== null && _b !== void 0 ? _b : e.default)), (_c !== null && _c !== void 0 ? _c : undefined));
                    return;
                }
                if (e.type === 'daterange') {
                    externalFilter[e.field] = {
                        from: (_f = (_e = (_d = externalFilter[e.field]) === null || _d === void 0 ? void 0 : _d.from, (_e !== null && _e !== void 0 ? _e : e.defaultFrom)), (_f !== null && _f !== void 0 ? _f : undefined)),
                        to: (_j = (_h = (_g = externalFilter[e.field]) === null || _g === void 0 ? void 0 : _g.to, (_h !== null && _h !== void 0 ? _h : e.defaultTo)), (_j !== null && _j !== void 0 ? _j : undefined))
                    };
                    return;
                }
                if (e.type === 'numberrange') {
                    externalFilter[e.field] = {
                        from: (_m = (_l = (_k = externalFilter[e.field]) === null || _k === void 0 ? void 0 : _k.from, (_l !== null && _l !== void 0 ? _l : e.defaultFrom)), (_m !== null && _m !== void 0 ? _m : undefined)),
                        to: (_q = (_p = (_o = externalFilter[e.field]) === null || _o === void 0 ? void 0 : _o.to, (_p !== null && _p !== void 0 ? _p : e.defaultTo)), (_q !== null && _q !== void 0 ? _q : undefined))
                    };
                    return;
                }
                if (e.type === 'daterangefull') {
                    externalFilter[e.field] = {
                        from: (_t = (_s = (_r = externalFilter[e.field]) === null || _r === void 0 ? void 0 : _r.from, (_s !== null && _s !== void 0 ? _s : e.defaultFrom)), (_t !== null && _t !== void 0 ? _t : undefined)),
                        to: (_w = (_v = (_u = externalFilter[e.field]) === null || _u === void 0 ? void 0 : _u.to, (_v !== null && _v !== void 0 ? _v : e.defaultTo)), (_w !== null && _w !== void 0 ? _w : undefined))
                    };
                    return;
                }
            });
            return externalFilter;
        };
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    GridPopupFilterComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.loadConfiguration().then(function () {
            _this.loadInlineFilter.emit({
                quickFilters: _this.quickFilters || [],
                selectedQuickFilter: _this.selectedCode || '',
                inlineExternal: _this.inlineExternal,
                inlineColumn: _this.inlineColumn
            });
        });
    };
    GridPopupFilterComponent.prototype.ngAfterViewInit = function () {
    };
    GridPopupFilterComponent.prototype.onAccept = function () {
        this.accept.emit({
            filter: this.filter,
            externalFilter: this.externalFilter
        });
        this.modal.close();
    };
    GridPopupFilterComponent.prototype.onClear = function () {
        delete this.selectedCode;
        this.clear.emit();
    };
    GridPopupFilterComponent.prototype.loadConfiguration = function () {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function () {
            var configuration, _e, _f, externalFilter, _g, _h, column;
            var e_3, _j, e_4, _k;
            return __generator(this, function (_l) {
                switch (_l.label) {
                    case 0:
                        this.quickFilters = [];
                        if (!this.key) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.settingService.hasKey(this.keyPrefix + this.key)];
                    case 1:
                        if (!(_l.sent())) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.settingService.get(this.keyPrefix + this.key)];
                    case 2:
                        configuration = _l.sent();
                        if (Array.isArray((_a = configuration) === null || _a === void 0 ? void 0 : _a.quickFilters)) {
                            this.quickFilters = configuration.quickFilters;
                        }
                        this.selectedCode = ((_b = configuration) === null || _b === void 0 ? void 0 : _b.selectedQuickFilter) || '';
                        this.inlineExternal = ((_c = configuration) === null || _c === void 0 ? void 0 : _c.inlineExternal) || {};
                        this.inlineColumn = ((_d = configuration) === null || _d === void 0 ? void 0 : _d.inlineColumn) || {};
                        try {
                            for (_e = __values(this.externalFilters), _f = _e.next(); !_f.done; _f = _e.next()) {
                                externalFilter = _f.value;
                                if (this.inlineExternal[externalFilter.field] === undefined) {
                                    this.inlineExternal[externalFilter.field] = true;
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_f && !_f.done && (_j = _e.return)) _j.call(_e);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        try {
                            for (_g = __values(this.columns), _h = _g.next(); !_h.done; _h = _g.next()) {
                                column = _h.value;
                                if (this.inlineColumn[column.field] === undefined) {
                                    this.inlineColumn[column.field] = true;
                                }
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (_h && !_h.done && (_k = _g.return)) _k.call(_g);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    GridPopupFilterComponent.prototype.updateConfiguration = function (selectedQuickFilterCode) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.key) {
                            return [2 /*return*/];
                        }
                        if (selectedQuickFilterCode !== undefined) {
                            this.selectedCode = selectedQuickFilterCode;
                        }
                        return [4 /*yield*/, this.settingService.set(this.keyPrefix + this.key, {
                                quickFilters: this.quickFilters,
                                selectedQuickFilter: this.selectedCode,
                                inlineExternal: this.inlineExternal,
                                inlineColumn: this.inlineColumn
                            })];
                    case 1:
                        _a.sent();
                        this.loadInlineFilter.emit({
                            quickFilters: this.quickFilters || [],
                            selectedQuickFilter: this.selectedCode || '',
                            inlineExternal: this.inlineExternal,
                            inlineColumn: this.inlineColumn
                        });
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        });
    };
    GridPopupFilterComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DeviceDetectorService },
        { type: SettingService },
        { type: NotifyService },
        { type: TranslateService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], GridPopupFilterComponent.prototype, "modal", void 0);
    __decorate([
        ViewChild('popupQuickFilterDetail')
    ], GridPopupFilterComponent.prototype, "popupQuickFilterDetail", void 0);
    __decorate([
        ViewChild('matSelect')
    ], GridPopupFilterComponent.prototype, "matSelect", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "filterType", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "key", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "quickFilterVisibility", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "filterOption", void 0);
    __decorate([
        Output()
    ], GridPopupFilterComponent.prototype, "accept", void 0);
    __decorate([
        Output()
    ], GridPopupFilterComponent.prototype, "clear", void 0);
    __decorate([
        Output()
    ], GridPopupFilterComponent.prototype, "loadInlineFilter", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "inlineExternal", void 0);
    __decorate([
        Input()
    ], GridPopupFilterComponent.prototype, "inlineColumn", void 0);
    GridPopupFilterComponent = __decorate([
        Component({
            selector: 'sd-grid-popup-filter',
            template: "<sd-modal-control width=\"sm\" [title]=\"'Filter' | sdTranslate\" #modal>\r\n  <sd-modal-body>\r\n    <div\r\n      *ngIf=\"key && (!quickFilterVisibility || quickFilterVisibility === 'popup') && filterOption?.multiple !== false\">\r\n      <mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n        <mat-label>{{'Quick filters' | sdTranslate}}</mat-label>\r\n        <mat-select [(ngModel)]=\"selectedCode\" (selectionChange)=\"onSelectionChange($event)\" #matSelect>\r\n          <mat-option value=\"\">{{'Please select' | sdTranslate}}</mat-option>\r\n          <mat-option *ngFor=\"let quickFilter of quickFilters\" [value]=\"quickFilter.code\">\r\n            <div style=\"display:flex; justify-content: space-between\">\r\n              <span>{{quickFilter.code}}</span>\r\n              <div>\r\n                <mat-icon class=\"mr-1 c-fa-icon\" (click)=\"onEditQuickFilter($event, quickFilter)\" fontSet=\"fa\"\r\n                  fontIcon=\"fa-pencil\"></mat-icon>\r\n                <mat-icon class=\"mr-0 c-fa-icon\" (click)=\"onDeleteQuickFilter($event, quickFilter)\" fontSet=\"fa\"\r\n                  fontIcon=\"fa-trash-o\"></mat-icon>\r\n              </div>\r\n            </div>\r\n          </mat-option>\r\n          <mat-option [value]=\"newQuickFilter\">\r\n            <div (click)=\"onCreateQuickFilter($event)\">\r\n              <mat-icon class=\"mr-1\" fontSet=\"material-icons-outlined\">add</mat-icon>\r\n              <span>{{'Create quick filter' | sdTranslate}}</span>\r\n            </div>\r\n          </mat-option>\r\n        </mat-select>\r\n      </mat-form-field>\r\n    </div>\r\n    <ng-container *ngIf=\"filterOption?.multiple === false\">\r\n      <mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n        <mat-label>{{'Select field' | sdTranslate}}</mat-label>\r\n        <mat-select [(ngModel)]=\"selectedField\">\r\n          <mat-option value=\"\">{{'Please select' | sdTranslate}}</mat-option>\r\n          <mat-option *ngFor=\"let item of externalFilters\" [value]=\"item.field + 'external'\">\r\n            {{item.title}}\r\n          </mat-option>\r\n          <ng-container *ngFor=\"let item of columns\">\r\n            <mat-option *ngIf=\"item.type !== 'children' && item.type !== 'image'\" [value]=\"item.field + 'column'\">\r\n              {{item.title}}\r\n            </mat-option>\r\n            <ng-container *ngIf=\"item.type === 'children' && item.children?.length\">\r\n              <ng-container *ngFor=\"let childColumn of item.children\">\r\n                <mat-option *ngIf=\"childColumn.type !== 'image'\" [value]=\"childColumn.field + 'column'\">\r\n                  {{childColumn.title}}\r\n                </mat-option>\r\n              </ng-container>\r\n            </ng-container>\r\n          </ng-container>\r\n        </mat-select>\r\n      </mat-form-field>\r\n    </ng-container>\r\n    <div *ngFor=\"let item of externalFilters\">\r\n      <ng-container *ngIf=\"filterOption?.multiple !== false || selectedField === item.field + 'external'\">\r\n        <div *sdDesktop class=\"c-checkable\">\r\n          <sd-checkbox-control [(model)]=\"inlineExternal[item.field]\" (sdChange)=\"onInlineChange()\">\r\n          </sd-checkbox-control>\r\n        </div>\r\n        <div class=\"c-filterable\">\r\n          <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'string'\" type=\"text\"\r\n            [(model)]=\"externalFilter[item.field]\">\r\n          </sd-input-control>\r\n          <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'number'\" type=\"number\"\r\n            [(model)]=\"externalFilter[item.field]\">\r\n          </sd-input-control>\r\n          <sd-select-control [label]=\"item.title\" *ngIf=\"item.type === 'bool'\" [items]=\" [{value:'1',display:item.trueValue || 'True' },\r\n              {value:'0',display:item.falseValue || 'False' }]\" valueField=\"value\" displayField=\"display\"\r\n            [(model)]=\"externalFilter[item.field]\">\r\n          </sd-select-control>\r\n          <sd-select-control [label]=\"item.title\" *ngIf=\"item.type === 'radio'\" [items]=\"item.values\"\r\n            [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\">\r\n          </sd-select-control>\r\n          <ng-container *ngIf=\"item.type === 'values'\">\r\n            <sd-select-control *ngIf=\"item.selection === 'MULTIPLE'\" [label]=\"item.title\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\"\r\n              multiple=\"true\">\r\n            </sd-select-control>\r\n            <sd-autocomplete-control *ngIf=\"item.selection === 'AUTOCOMPLETE'\" [label]=\"item.title\"\r\n              [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n              [(model)]=\"externalFilter[item.field]\">\r\n            </sd-autocomplete-control>\r\n            <sd-chip-control *ngIf=\"item.selection === 'MULTIPLEAUTOCOMPLETE'\" [label]=\"item.title\"\r\n              [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n              [(model)]=\"externalFilter[item.field]\">\r\n            </sd-chip-control>\r\n            <sd-select-control *ngIf=\"!item.selection\" [label]=\"item.title\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\">\r\n            </sd-select-control>\r\n          </ng-container>\r\n          <sd-input-control *ngIf=\"item.type === 'custom'\" [label]=\"item.title\"\r\n            [(model)]=\"externalFilter[displayKey + item.field]\"\r\n            (sdFocusForceBlur)=\"item?.onClick(externalFilter, item.field, displayKey + item.field)\">\r\n          </sd-input-control>\r\n          <sd-date-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='date'\"\r\n            [(model)]=\"externalFilter[item.field]\" type=\"date\">\r\n          </sd-date-picker-control>\r\n          <sd-date-range-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='daterangefull'\"\r\n            [(fromDate)]=\"externalFilter[item.field].from\" [(toDate)]=\"externalFilter[item.field].to\"\r\n            [minDate]=\"item.minDate\" [maxDate]=\"item.maxDate\" type=\"date\">\r\n          </sd-date-range-picker-control>\r\n          <ng-container *ngIf=\"item.type ==='daterange'\">\r\n            <div class=\"row\">\r\n              <div class=\"col-6\">\r\n                <sd-date-picker-control [label]=\"item.fromTitle\" [(model)]=\"externalFilter[item.field].from\"\r\n                  [type]=\"item.enableTime ? 'datetime' : 'date'\" [minDate]=\"item.minDate\"\r\n                  [maxDate]=\"externalFilter[item.field].to || item.maxDate\">\r\n                </sd-date-picker-control>\r\n              </div>\r\n              <div class=\"col-6\">\r\n                <sd-date-picker-control [label]=\"item.toTitle\" [(model)]=\"externalFilter[item.field].to\"\r\n                  [type]=\"item.enableTime ? 'datetime' : 'date'\"\r\n                  [minDate]=\"item.minDate || externalFilter[item.field].from\" [maxDate]=\"item.maxDate\">\r\n                </sd-date-picker-control>\r\n              </div>\r\n            </div>\r\n          </ng-container>\r\n          <div class=\"row\" *ngIf=\"item.type ==='numberrange'\">\r\n            <div class=\"col-6\">\r\n              <sd-input-control [label]=\"item.fromTitle\" type=\" number\" [(model)]=\"externalFilter[item.field].from\">\r\n              </sd-input-control>\r\n            </div>\r\n            <div class=\"col-6\">\r\n              <sd-input-control [label]=\"item.toTitle\" type=\" number\" [(model)]=\"externalFilter[item.field].to\">\r\n              </sd-input-control>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </ng-container>\r\n    </div>\r\n    <ng-container *ngFor=\"let column of columns\">\r\n      <ng-container *ngIf=\"column.type !== 'children' && column.type !== 'image'\">\r\n        <ng-container *ngIf=\"filterOption?.multiple !== false || selectedField === column.field + 'column'\">\r\n          <div *sdDesktop class=\"c-checkable\">\r\n            <sd-checkbox-control [(model)]=\"inlineColumn[column.field]\" (sdChange)=\"onInlineChange()\">\r\n            </sd-checkbox-control>\r\n          </div>\r\n          <div class=\"c-filterable\">\r\n            <sd-input-control *ngIf=\"column.type === 'string'\" [label]=\"column.title\" type=\"text\"\r\n              [(model)]=\"filter[column.field]\">\r\n            </sd-input-control>\r\n            <sd-input-control *ngIf=\"column.type === 'number'\" [label]=\"column.title\" type=\" number\"\r\n              [(model)]=\"filter[column.field]\">\r\n            </sd-input-control>\r\n            <sd-radio-control *ngIf=\"column.type === 'bool'\" [label]=\"column.title\" [items]=\"[{value:'1',display:column.trueValue || 'True' },\r\n              {value:'0',display:column.falseValue || 'False' }]\" [(model)]=\"filter[column.field]\">\r\n            </sd-radio-control>\r\n            <sd-select-control *ngIf=\"column.type === 'radio'\" [label]=\"column.title\" [items]=\"column.values\"\r\n              [valueField]=\"column.valueField\" [displayField]=\"column.displayField\" [(model)]=\"filter[column.field]\">\r\n            </sd-select-control>\r\n            <sd-select-control *ngIf=\"column.type === 'values' && !column?.editor?.autocomplete\" [label]=\"column.title\"\r\n              [items]=\"column.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[column.field]\">\r\n            </sd-select-control>\r\n            <sd-autocomplete-control *ngIf=\"column.type === 'values' && column?.editor?.autocomplete\"\r\n              [items]=\"column.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[column.field]\">\r\n            </sd-autocomplete-control>\r\n            <sd-date-picker-control *ngIf=\"column.type ==='date' || column.type==='datetime' ||\r\n              column.type==='time'\" [label]=\"column.title\" [(model)]=\" filter[column.field]\" type=\"date\">\r\n            </sd-date-picker-control>\r\n          </div>\r\n        </ng-container>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"column.type === 'children' && column.children?.length\">\r\n        <ng-template ngFor let-childColumn [ngForOf]=\"column.children\">\r\n          <ng-container\r\n            *ngIf=\"childColumn.type !== 'image' && (filterOption?.multiple !== false || selectedField === childColumn.field + 'column')\">\r\n            <div *sdDesktop class=\"c-checkable\">\r\n              <sd-checkbox-control [(model)]=\"inlineColumn[childColumn.field]\" (sdChange)=\"onInlineChange()\">\r\n              </sd-checkbox-control>\r\n            </div>\r\n            <div class=\"c-filterable\">\r\n              <sd-input-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'string'\" type=\"text\"\r\n                [(model)]=\"filter[childColumn.field]\">\r\n              </sd-input-control>\r\n              <sd-input-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'number'\" type=\" number\"\r\n                [(model)]=\"filter[childColumn.field]\">\r\n              </sd-input-control>\r\n              <sd-radio-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'bool'\" [items]=\"[{value:'1',display:column.trueValue || 'True' },\r\n                {value:'0',display:childColumn.falseValue || 'False' }]\" [(model)]=\"filter[childColumn.field]\">\r\n              </sd-radio-control>\r\n              <sd-radio-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'radio'\"\r\n                [items]=\"childColumn.values\" [valueField]=\"childColumn.valueField\"\r\n                [displayField]=\"childColumn.displayField\" [(model)]=\"filter[childColumn.field]\">\r\n              </sd-radio-control>\r\n              <sd-autocomplete-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'values'\"\r\n                [items]=\"childColumn.values\" valueField=\"value\" displayField=\"text\"\r\n                [(model)]=\"filter[childColumn.field]\">\r\n              </sd-autocomplete-control>\r\n              <sd-date-picker-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type ==='date' || childColumn.type==='datetime' ||\r\n                childColumn.type==='time'\" [(model)]=\" filter[childColumn.field]\" type=\"date\">\r\n              </sd-date-picker-control>\r\n            </div>\r\n          </ng-container>\r\n        </ng-template>\r\n      </ng-container>\r\n    </ng-container>\r\n  </sd-modal-body>\r\n  <sd-modal-footer *sdDesktop>\r\n    <sd-button class=\"mr-auto\" (action)=\"onClear()\" icon=\"clear\" [title]=\"'Clear filter' | sdTranslate\" size=\"sm\">\r\n    </sd-button>\r\n    <sd-button (action)=\"onAccept()\" icon=\"done\" [title]=\"'Accept' | sdTranslate\" color=\"primary\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n  <sd-modal-footer *sdMobileTablet>\r\n    <sd-button style=\"flex: 1; padding-right: 5px;\" (action)=\"onClear()\" icon=\"clear\"\r\n      [title]=\"'Clear filter' | sdTranslate\" width=\"100%\" size=\"sm\"></sd-button>\r\n    <sd-button style=\"flex: 1; padding-left: 5px;\" (action)=\"onAccept()\" icon=\"done\" [title]=\"'Accept' | sdTranslate\"\r\n      color=\"primary\" width=\"100%\" size=\"sm\"></sd-button>\r\n  </sd-modal-footer>\r\n</sd-modal-control>\r\n<sd-grid-popup-quick-filter-detail #popupQuickFilterDetail (accept)=\"onAcceptQuickFilter($event)\">\r\n</sd-grid-popup-quick-filter-detail>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", ".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".cdk-overlay-container{z-index:10000}.c-fa-icon{font-size:20px;color:gray}.c-checkable{width:30px;display:inline-block}.c-filterable{width:calc(100% - 30px);display:inline-block}"]
        })
    ], GridPopupFilterComponent);
    return GridPopupFilterComponent;
}());

var ChartControlComponent = /** @class */ (function () {
    function ChartControlComponent(ref, datePipe) {
        this.ref = ref;
        this.datePipe = datePipe;
        this.initialized = false;
        this.visible = true;
        this.height = '300px';
    }
    Object.defineProperty(ChartControlComponent.prototype, "chartOption", {
        set: function (chartOption) {
            this.pChartOption = chartOption;
            if (this.initialized) {
                this.renderChart();
            }
        },
        enumerable: true,
        configurable: true
    });
    ChartControlComponent.prototype.ngOnInit = function () {
    };
    ChartControlComponent.prototype.ngAfterViewInit = function () {
        this.renderChart(true);
        this.initialized = true;
        this.ref.detectChanges();
    };
    ChartControlComponent.prototype.renderChart = function (firstRender) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.height = ((_a = this.pChartOption) === null || _a === void 0 ? void 0 : _a.height) || '300px';
                        if (!!firstRender) return [3 /*break*/, 2];
                        this.visible = false;
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 500); })];
                    case 1:
                        _b.sent();
                        this.visible = true;
                        _b.label = 2;
                    case 2:
                        setTimeout(function () {
                            var canvas = _this.chartRef.nativeElement;
                            _this.ctx = canvas.getContext('2d');
                            switch (_this.pChartOption.type) {
                                case 'pie':
                                    _this.renderPieChart(_this.pChartOption);
                                    break;
                                case 'bar':
                                    _this.renderBarChart(_this.pChartOption);
                                    break;
                                case 'line':
                                    _this.renderLineChart(_this.pChartOption);
                                    break;
                                case 'barline':
                                    _this.renderBarLineChart(_this.pChartOption);
                                    break;
                                default: break;
                            }
                        }, 500);
                        return [2 /*return*/];
                }
            });
        });
    };
    ChartControlComponent.prototype.renderPieChart = function (option) {
    };
    ChartControlComponent.prototype.renderBarChart = function (option) {
        var _a, _b;
        var labelWidth = (_a = option.labelWidth, (_a !== null && _a !== void 0 ? _a : 50));
        if (option.datasets.length) {
            var newwidth = Math.max(option.labels.length * option.datasets.length * labelWidth, $$1(this.chartWrapperRef.nativeElement).width());
            $$1(this.chartAreaWrapperExtendRef.nativeElement).width(newwidth);
        }
        var configuration = {
            options: {
                responsive: true,
                maintainAspectRatio: false,
                legend: {
                    display: !option.hideLegend
                },
                scales: {
                    xAxes: [{
                            display: true,
                            scaleLabel: {
                                display: !!option.xTitle,
                                labelString: option.xTitle || ''
                            }
                        }],
                    yAxes: [{
                            display: true,
                            ticks: {
                                beginAtZero: (_b = option.beginAtZero, (_b !== null && _b !== void 0 ? _b : true)),
                            },
                            scaleLabel: {
                                display: !!option.yTitle,
                                labelString: option.yTitle || ''
                            }
                        }]
                }
            },
            type: 'bar',
            data: {
                labels: option.labels,
                datasets: option.datasets.map(function (e) {
                    var result = {
                        label: e.label,
                        fill: e.backgroundColor,
                        backgroundColor: e.backgroundColor,
                        data: e.data
                    };
                    return result;
                })
            }
        };
        this.chart = new Chart(this.ctx, configuration);
    };
    ChartControlComponent.prototype.renderLineChart = function (option) {
        var _a, _b;
        var labelWidth = (_a = option.labelWidth, (_a !== null && _a !== void 0 ? _a : 50));
        if (option.datasets.length) {
            var newwidth = Math.max(option.labels.length * labelWidth, $$1(this.chartWrapperRef.nativeElement).width());
            $$1(this.chartAreaWrapperExtendRef.nativeElement).width(newwidth);
        }
        var configuration = {
            options: {
                responsive: true,
                maintainAspectRatio: false,
                legend: {
                    display: !option.hideLegend
                },
                scales: {
                    xAxes: [{
                            display: true,
                            scaleLabel: {
                                display: !!option.xTitle,
                                labelString: option.xTitle || ''
                            }
                        }],
                    yAxes: [{
                            display: true,
                            ticks: {
                                beginAtZero: (_b = option.beginAtZero, (_b !== null && _b !== void 0 ? _b : true))
                            },
                            scaleLabel: {
                                display: !!option.yTitle,
                                labelString: option.yTitle || ''
                            }
                        }]
                }
            },
            type: 'line',
            data: {
                labels: option.labels,
                datasets: option.datasets.map(function (e) {
                    var result = {
                        label: e.label,
                        fill: e.backgroundColor,
                        backgroundColor: e.backgroundColor,
                        borderColor: e.borderColor,
                        data: e.data,
                        lineTension: 0,
                    };
                    return result;
                })
            }
        };
        this.chart = new Chart(this.ctx, configuration);
    };
    ChartControlComponent.prototype.renderBarLineChart = function (option) {
        var _a, _b, _c;
        var labelWidth = (_a = option.labelWidth, (_a !== null && _a !== void 0 ? _a : 50));
        if (option.datasets.length) {
            var numberOfBars = option.datasets.filter(function (e) { return e.type === 'bar'; }).length;
            if (numberOfBars <= 1) {
                var newwidth = Math.max(option.labels.length * labelWidth, $$1(this.chartWrapperRef.nativeElement).width());
                $$1(this.chartAreaWrapperExtendRef.nativeElement).width(newwidth);
            }
            else {
                var newwidth = Math.max(option.labels.length * numberOfBars * labelWidth, $$1(this.chartWrapperRef.nativeElement).width());
                $$1(this.chartAreaWrapperExtendRef.nativeElement).width(newwidth);
            }
        }
        var leftId = "I" + v4();
        var rightId = "I" + v4();
        var yAxes = [{
                type: 'linear',
                display: true,
                position: 'left',
                id: leftId,
                ticks: {
                    beginAtZero: (_b = option.beginAtZero, (_b !== null && _b !== void 0 ? _b : true)),
                    suggestedMin: 0
                },
                scaleLabel: {
                    display: !!option.yTitle,
                    labelString: option.yTitle || ''
                }
            }];
        if (option.datasets.some(function (e) { return e.yAlign === 'right'; })) {
            yAxes.push({
                type: 'linear',
                display: true,
                position: 'right',
                id: rightId,
                ticks: {
                    beginAtZero: (_c = option.beginAtZero, (_c !== null && _c !== void 0 ? _c : true)),
                    suggestedMin: 0
                },
                scaleLabel: {
                    display: !!option.yRightTitle,
                    labelString: option.yRightTitle || ''
                }
            });
        }
        var configuration = {
            options: {
                responsive: true,
                maintainAspectRatio: false,
                legend: {
                    display: !option.hideLegend
                },
                title: {
                    display: true,
                    text: option.title
                },
                scales: {
                    xAxes: [{
                            display: true,
                            scaleLabel: {
                                display: !!option.xTitle,
                                labelString: option.xTitle || ''
                            }
                        }],
                    yAxes: yAxes
                }
            },
            data: {
                labels: option.labels,
                datasets: option.datasets.map(function (e) {
                    var result = {
                        type: e.type,
                        label: e.label,
                        fill: e.backgroundColor,
                        backgroundColor: e.backgroundColor,
                        borderColor: e.borderColor,
                        data: e.data,
                        yAxisID: e.yAlign === 'right' ? rightId : leftId,
                        lineTension: 0
                    };
                    return result;
                })
            }
        };
        this.chart = new Chart(this.ctx, configuration);
    };
    ChartControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: DatePipe }
    ]; };
    __decorate([
        Input()
    ], ChartControlComponent.prototype, "chartOption", null);
    __decorate([
        ViewChild('chart')
    ], ChartControlComponent.prototype, "chartRef", void 0);
    __decorate([
        ViewChild('chartWrapper')
    ], ChartControlComponent.prototype, "chartWrapperRef", void 0);
    __decorate([
        ViewChild('chartAxis')
    ], ChartControlComponent.prototype, "chartAxisRef", void 0);
    __decorate([
        ViewChild('chartAreaWrapperExtend')
    ], ChartControlComponent.prototype, "chartAreaWrapperExtendRef", void 0);
    ChartControlComponent = __decorate([
        Component({
            selector: 'sd-chart-control',
            template: "<div *ngIf=\"visible\" class=\"c-chart-wrapper mt-2\" >\r\n  <div class=\"c-chart-area-wrapper\" #chartWrapper>\r\n    <div class=\"c-chart-area-wrapper-extend\" [ngStyle]=\"{'height':height}\" #chartAreaWrapperExtend>\r\n      <canvas #chart></canvas>\r\n    </div>\r\n  </div>\r\n</div>",
            styles: ["::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".c-container{background:#f5f6f7;border-radius:5px}.c-flex{display:flex;margin:15px;border-radius:8px}.c-chart-container{box-shadow:0 0 13px 0 rgba(82,63,105,.1);border-radius:8px;margin:15px;padding:15px;background:#fff}.c-btn-dashboard{height:60%;align-self:center;vertical-align:middle}.c-chart-wrapper{position:relative}.c-chart-wrapper>canvas{position:absolute;left:0;top:0;pointer-events:none}.c-chart-area-wrapper{overflow-x:scroll;position:relative;width:100%}.c-chart-area-wrapper-extend{position:relative}"]
        })
    ], ChartControlComponent);
    return ChartControlComponent;
}());

var ChipControlComponent = /** @class */ (function () {
    function ChipControlComponent(ref, utilityService, translateService) {
        var _this = this;
        this.ref = ref;
        this.utilityService = utilityService;
        this.translateService = translateService;
        this.initialized = false;
        this.pModel = [];
        this.pItems = [];
        this.name = v4();
        this.separatorKeysCodes = [ENTER, COMMA];
        this.selectable = true;
        this.removable = true;
        // tslint:disable-next-line: variable-name
        this._items = [];
        this.limit = 50;
        this.selectedItems = [];
        // model
        // tslint:disable-next-line: variable-name
        this._model = [];
        this.modelChange = new EventEmitter();
        // tslint:disable-next-line: variable-name
        this._minItem = 0;
        // tslint:disable-next-line: no-output-native
        this.change = new EventEmitter();
        this.sdChange = new EventEmitter();
        this.chipSelected = new EventEmitter();
        this.onChanges = function () {
            var _a;
            _this._model = _this.pModel;
            _this._items = _this.pItems;
            _this.selectedItems = _this._items.filter(function (item) { return _this._model.findIndex(function (value) { var _a; return value === ((_a = item) === null || _a === void 0 ? void 0 : _a[_this.valueField]); }) !== -1; });
            (_a = _this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        };
        this.displayFn = function (value) {
            if (typeof value === 'string') {
                if (!_this.items) {
                    return undefined;
                }
                var selectedItem = _this.items.find(function (item) { return item[_this.valueField] === value; });
                if (selectedItem) {
                    return selectedItem[_this.displayField];
                }
                if (_this.items.some(function (item) { return item[_this.displayField].toLowerCase().indexOf(value.toLowerCase()) !== -1; })) {
                    return value;
                }
                else {
                    return undefined;
                }
            }
            else {
                return value ? value[_this.displayField] : undefined;
            }
        };
        this.validateMinItem = function () {
            if (!_this.chipList) {
                return null;
            }
            if (_this.selectedItems.length < _this._minItem) {
                _this.chipList.errorState = true;
                return _this.translateService.translate('Please select at least') + " " + _this._minItem;
            }
            _this.chipList.errorState = false;
            return null;
        };
        this.clear = function ($event) {
            var _a, _b;
            (_a = $event) === null || _a === void 0 ? void 0 : _a.stopPropagation();
            _this.input.nativeElement.value = '';
            _this.ipt = '';
            _this.formModel.control.setValue(null);
            (_b = _this.autocompleteTrigger) === null || _b === void 0 ? void 0 : _b.openPanel();
            _this.ref.detectChanges();
        };
    }
    Object.defineProperty(ChipControlComponent.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (items) {
            if (!Array.isArray(items)) {
                items = [];
            }
            this.pItems = items;
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChipControlComponent.prototype, "model", {
        set: function (values) {
            if (!Array.isArray(values)) {
                values = [];
            }
            this.pModel = values;
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChipControlComponent.prototype, "minItem", {
        set: function (minItem) {
            var _a;
            minItem = +minItem || 0;
            this._minItem = minItem;
            (_a = this.formModel) === null || _a === void 0 ? void 0 : _a.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    ChipControlComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.filteredItems = this.formModel.valueChanges.pipe(startWith(''), map(function (item) { var _a, _b; return typeof item === 'string' ? item : (_b = (_a = item) === null || _a === void 0 ? void 0 : _a[_this.displayField], (_b !== null && _b !== void 0 ? _b : '')); }), map(function (name) { return _this.filter(name); }));
    };
    ChipControlComponent.prototype.ngAfterViewInit = function () {
        var _a, _b;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        (_b = this.formModel) === null || _b === void 0 ? void 0 : _b.control.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        this.onChanges();
        this.initialized = true;
        this.ref.detectChanges();
    };
    ChipControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    ChipControlComponent.prototype.filter = function (value) {
        var _this = this;
        return this.items
            .filter(function (item) {
            if (_this.selectedItems.some(function (e) { return e[_this.valueField] === item[_this.valueField]; })) {
                return false;
            }
            return !value || _this.utilityService.changeAliasLowerCase(item[_this.displayField])
                .indexOf(_this.utilityService.changeAliasLowerCase(value)) !== -1;
        }).filter(function (item, index) { return index < _this.limit; });
    };
    ChipControlComponent.prototype.add = function (event) {
        var _this = this;
        // Add item only when MatAutocomplete is not open
        // To make sure this does not conflict with OptionSelected Event
        if (!this.matAutocomplete.isOpen) {
            var input = event.input;
            var value_1 = event.value;
            // Add our item
            if ((value_1 || '').trim()) {
                var item = this.items.find(function (e) { return e[_this.displayField]
                    && e[_this.displayField].toString().toLowerCase() === value_1.toString().toLowerCase().trim(); });
                if (item) {
                    this.selectedItems.push(item);
                    this.updateModel();
                }
            }
            // Reset the input value
            if (input) {
                input.value = '';
            }
            this.formModel.control.setValue(null);
        }
    };
    ChipControlComponent.prototype.remove = function (item) {
        var index = this.selectedItems.indexOf(item);
        if (index >= 0) {
            this.selectedItems.splice(index, 1);
            this.updateModel();
            this.formModel.reset();
        }
    };
    ChipControlComponent.prototype.select = function (item) {
        this.chipSelected.emit(item);
    };
    ChipControlComponent.prototype.selected = function (event) {
        var _this = this;
        var value = event.option.viewValue;
        // Add our fruit
        if ((value || '').trim()) {
            var item = this.items.find(function (e) { return e[_this.displayField]
                && e[_this.displayField].toString().toLowerCase() === value.toString().toLowerCase().trim(); });
            this.selectedItems.push(item);
            this.input.nativeElement.value = '';
            this.formModel.control.setValue(null);
            this.updateModel();
            setTimeout(function () {
                var _a;
                (_a = _this.autocompleteTrigger) === null || _a === void 0 ? void 0 : _a.openPanel();
            });
        }
    };
    ChipControlComponent.prototype.updateModel = function () {
        var _this = this;
        this._model = this.selectedItems.map(function (e) { return e[_this.valueField]; });
        this.modelChange.emit(this._model);
        this.change.emit(this.selectedItems);
        this.sdChange.emit(this.selectedItems);
        setTimeout(function () {
            var _a, _b;
            (_b = (_a = _this.form) === null || _a === void 0 ? void 0 : _a.form) === null || _b === void 0 ? void 0 : _b.markAsDirty();
        }, 0);
    };
    ChipControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: UtilityService },
        { type: TranslateService }
    ]; };
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "valueField", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "displayField", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "displayChipField", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "items", null);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "limit", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "model", null);
    __decorate([
        Output()
    ], ChipControlComponent.prototype, "modelChange", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], ChipControlComponent.prototype, "minItem", null);
    __decorate([
        Output()
    ], ChipControlComponent.prototype, "change", void 0);
    __decorate([
        Output()
    ], ChipControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Output()
    ], ChipControlComponent.prototype, "chipSelected", void 0);
    __decorate([
        ViewChild('formModel', { static: true })
    ], ChipControlComponent.prototype, "formModel", void 0);
    __decorate([
        ViewChild('input')
    ], ChipControlComponent.prototype, "input", void 0);
    __decorate([
        ViewChild('auto')
    ], ChipControlComponent.prototype, "matAutocomplete", void 0);
    __decorate([
        ViewChild('chipList', { static: true })
    ], ChipControlComponent.prototype, "chipList", void 0);
    __decorate([
        ViewChild(MatAutocompleteTrigger, { read: MatAutocompleteTrigger })
    ], ChipControlComponent.prototype, "autocompleteTrigger", void 0);
    ChipControlComponent = __decorate([
        Component({
            selector: 'sd-chip-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <mat-chip-list #chipList>\r\n    <ng-container *ngFor=\"let item of selectedItems\">\r\n      <mat-chip *ngIf=\"item\" [selectable]=\"selectable\" [removable]=\"removable\" (removed)=\"remove(item)\" [selected]=\"item.isSelected\"\r\n        (selectionChange)=\"select(item)\" [disabled]=\"disabled\" (click)=\"item.isSelected = !item.isSelected\">\r\n        {{item[displayChipField] || item[displayField]}}\r\n        <mat-icon matChipRemove *ngIf=\"removable\">cancel</mat-icon>\r\n\r\n      </mat-chip>\r\n    </ng-container>\r\n    <input #autocompleteTrigger #formModel=\"ngModel\" [(ngModel)]=\"ipt\" [name]=\"name\" [placeholder]=\"label\"\r\n      [disabled]=\"disabled\" [matAutocomplete]=\"auto\" [matChipInputFor]=\"chipList\"\r\n      [matChipInputSeparatorKeyCodes]=\"separatorKeysCodes\" (matChipInputTokenEnd)=\"add($event)\"\r\n      [sdChipMinItem]=\"validateMinItem\" autocomplete=\"false\" matInput #input>\r\n    <i *ngIf=\"!ipt\" matSuffix class=\"fa fa-search fa-fw\"></i>\r\n    <i *ngIf=\"ipt\" matSuffix class=\"fa fa-times fa-fw text-danger\" (click)=\"clear($event)\" style=\"cursor: pointer;\"></i>\r\n  </mat-chip-list>\r\n  <mat-error *ngIf=\"formModel?.errors?.minItem\">\r\n    {{formModel?.errors?.minItem}}\r\n  </mat-error>\r\n  <mat-autocomplete #auto=\"matAutocomplete\" [displayWith]=\"displayFn\" (optionSelected)=\"selected($event)\">\r\n    <mat-option *ngFor=\"let item of filteredItems | async\" [value]=\"item\">\r\n      {{item[displayField]}}\r\n    </mat-option>\r\n  </mat-autocomplete>\r\n</mat-form-field>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", "sd-chip-control .c-chip-remove:hover{color:#f5222d!important}"]
        })
    ], ChipControlComponent);
    return ChipControlComponent;
}());

var GridSubInformationComponent = /** @class */ (function () {
    function GridSubInformationComponent(ref, settingService, notifyService) {
        var _this = this;
        this.ref = ref;
        this.settingService = settingService;
        this.notifyService = notifyService;
        this.height = 'auto';
        this.columns = [];
        this.commands = [];
        this.subItems = [];
        this.isMobile = window.innerWidth < MobileMaxWidth;
        this.filter = {};
        this.onEditorChange = function (column, item, value) {
            var _a;
            if (column.type !== 'children') {
                (_a = column.editor) === null || _a === void 0 ? void 0 : _a.change(item, value);
                _this.ref.detectChanges();
            }
        };
    }
    GridSubInformationComponent.prototype.ngOnInit = function () {
    };
    GridSubInformationComponent.prototype.ngAfterViewInit = function () {
    };
    GridSubInformationComponent.prototype.updateFilter = function () {
    };
    GridSubInformationComponent.prototype.trackById = function (index, item) {
        return item.id;
    };
    GridSubInformationComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: SettingService },
        { type: NotifyService }
    ]; };
    __decorate([
        Input()
    ], GridSubInformationComponent.prototype, "height", void 0);
    __decorate([
        Input()
    ], GridSubInformationComponent.prototype, "columns", void 0);
    __decorate([
        Input()
    ], GridSubInformationComponent.prototype, "commands", void 0);
    __decorate([
        Input()
    ], GridSubInformationComponent.prototype, "subItems", void 0);
    GridSubInformationComponent = __decorate([
        Component({
            selector: 'sd-grid-sub-information',
            template: "<div class=\"clearfix\"></div>\r\n<div *ngIf=\"!isMobile\" class=\"sd-box sd-box-primary\">\r\n  <div class=\"sd-box-body p-0\">\r\n    <div class=\"row mx-0\">\r\n      <div class=\"table-responsive\" style=\"position: relative;\" [ngStyle]=\"{'height': height}\">\r\n        <table class=\"table table-hover table-striped table-bordered c-table\">\r\n          <thead class=\"thead-light\">\r\n            <tr>\r\n              <th class=\"position-sticky c-sticky-all align-middle p-0\" style=\"width:1px\">\r\n                <div class=\"d-flex h-100\">\r\n                  <div style=\"width:4px; min-width: 4px;\"></div>\r\n                  <div *ngIf=\"commands?.length\" class=\"align-middle text-center\"\r\n                    [ngStyle]=\"{'width':commands.length*35 + 'px', 'min-width': commands.length*35 + 'px'}\">\r\n                  </div>\r\n                  <div *ngIf=\"commands?.length\" class=\"c-sticky-spliter\"></div>\r\n                </div>\r\n              </th>\r\n              <th *ngFor=\"let column of columns\" class=\"position-sticky c-sticky-top\"\r\n                [ngStyle]=\"{'width':column.width ? column.width : '','min-width':column.width ? column.width : '300px'}\">\r\n                <span [title]=\"column.title\" class=\"c-header-title cursor-pointer\"\r\n                  [ngStyle]=\"{'width':column.width ? column.width : ''}\">\r\n                  {{column.title}}\r\n                </span>\r\n              </th>\r\n            </tr>\r\n          </thead>\r\n          <tbody>\r\n            <ng-container *ngFor=\"let item of subItems; trackBy: trackById\">\r\n              <tr>\r\n                <td class=\"position-sticky c-sticky-left p-0\" style=\"width:1px\">\r\n                  <div class=\"d-inline-flex align-middle h-100\">\r\n                    <div class=\"h-100\" style=\"width:4px;min-width: 4px;left:0\" matTooltipPosition=\"after\">\r\n                    </div>\r\n                  </div>\r\n                  <div *ngIf=\"commands?.length\" class=\"d-inline-flex align-middle\">\r\n                    <div class=\"d-flex align-middle text-center justify-content-center\"\r\n                      [ngStyle]=\"{'width':commands.length*35 + 'px', 'min-width': commands.length*35 + 'px'}\">\r\n                      <ng-container *ngIf=\"item.viewCommands?.length\">\r\n                        <section *ngFor=\"let command of item.viewCommands\">\r\n                          <button (click)=\"command.click(item)\" type=\"button\" class=\"c-btn-icon\"\r\n                            [matTooltip]=\"command.title\" [disabled]=\"command.disabled\">\r\n                            <i class=\"{{command.icon}}\" aria-hidden=\"true\"></i>\r\n                          </button>\r\n                        </section>\r\n                      </ng-container>\r\n                    </div>\r\n                  </div>\r\n                  <div *ngIf=\"commands?.length\" class=\"d-inline-flex align-middle h-100\">\r\n                    <div class=\"c-sticky-spliter h-100\"></div>\r\n                  </div>\r\n                </td>\r\n                <td *ngFor=\"let column of columns\" class=\"align-middle\"\r\n                  [ngClass]=\"{'text-center': column.type !== 'string' && column.type !== 'number', 'text-right': column.type === 'number'}\"\r\n                  [ngStyle]=\"{'width':column.width ? column.width : '', 'min-width':column.width ? column.width : '300px'}\">\r\n                  <ng-container *ngIf=\"!column.children?.length\">\r\n                    <ng-container *ngIf=\"item[column.field] | editorSubInformationHandler:item:columns\">\r\n                      <ng-container *ngIf=\"item.editorHandler[column.field].visible;else elseDisableEditor\">\r\n                        <div *ngIf=\"column.type === 'string'\">\r\n                          <input class=\"form-control form-control-sm\"\r\n                            [ngClass]=\"{'border-right-0':column.editor && column.editor.click}\"\r\n                            [(ngModel)]=\"item[column.field]\"\r\n                            (keyup.enter)=\"column.editor?.keyupEnter && column.editor?.keyupEnter(item)\"\r\n                            (change)=\"column.editor?.change && column.editor?.change(item)\">\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'number'\">\r\n                          <input class=\"form-control form-control-sm\" type=\"number\"\r\n                            [ngClass]=\"{'border-right-0':column.editor && column.editor.click}\"\r\n                            [(ngModel)]=\"item[column.field]\"\r\n                            (keyup.enter)=\"column.editor?.keyupEnter && column.editor?.keyupEnter(item)\"\r\n                            (change)=\"column.editor?.change && column.editor?.change(item)\">\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'bool'\">\r\n                          <div class=\"align-middle\">\r\n                            <mat-slide-toggle [(ngModel)]=\"item[column.field]\"\r\n                              (change)=\"onEditorChange(column,item,item[column.field])\" color=\"primary\">\r\n                            </mat-slide-toggle>\r\n                          </div>\r\n                        </div>\r\n                      </ng-container>\r\n                      <ng-template #elseDisableEditor>\r\n                        <div *ngIf=\"column.type === 'string'\">\r\n                          <div class=\"c-ellipsis\">\r\n                            <span [ngClass]=\"{'badge': item.badge && item.badge[column.field], 'c-badge':item.badge && item.badge[column.field], \r\n                            'badge-primary':item.badge && item.badge[column.field] === 'PRIMARY', \r\n                            'badge-secondary':item.badge && item.badge[column.field] === 'SECONDARY', \r\n                            'badge-info':item.badge && item.badge[column.field] === 'INFO', \r\n                            'badge-success':item.badge && item.badge[column.field] === 'SUCCESS', \r\n                            'badge-warning':item.badge && item.badge[column.field] === 'WARNING', \r\n                            'badge-danger':item.badge && item.badge[column.field] === 'DANGER',\r\n                            'badge-light':item.badge && item.badge[column.field] === 'LIGHT',\r\n                            'badge-dark':item.badge && item.badge[column.field] === 'DARK',\r\n                            'blinker': item.blinker && item.blinker[column.field]}\">{{item[column.field]}}</span>\r\n                          </div>\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'color'\">\r\n                          <input [disabled]=\"true\" type=\"color\" class=\"form-control form-control-sm\"\r\n                            [(ngModel)]=\"item[column.field]\">\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'number'\">\r\n                          <div class=\"pull-right\">\r\n                            <span\r\n                              [ngClass]=\"{'badge': item.badge && item.badge[column.field], 'c-badge':item.badge && item.badge[column.field], \r\n                              'badge-primary':item.badge && item.badge[column.field] === 'PRIMARY', \r\n                              'badge-secondary':item.badge && item.badge[column.field] === 'SECONDARY', \r\n                              'badge-info':item.badge && item.badge[column.field] === 'INFO', \r\n                              'badge-success':item.badge && item.badge[column.field] === 'SUCCESS', \r\n                              'badge-warning':item.badge && item.badge[column.field] === 'WARNING', \r\n                              'badge-danger':item.badge && item.badge[column.field] === 'DANGER',\r\n                              'badge-light':item.badge && item.badge[column.field] === 'LIGHT',\r\n                              'badge-dark':item.badge && item.badge[column.field] === 'DARK',\r\n                              'blinker': item.blinker && item.blinker[column.field]}\">{{(item[column.field] | valueTransform:item:column) | number : '1.0-2'}}</span>\r\n                          </div>\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'date'\">\r\n                          {{item[column.field] | date:'dd/MM/yyyy'}}\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'datetime'\">\r\n                          {{item[column.field] | date:'dd/MM/yyyy HH:mm'}}\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'time'\">\r\n                          {{item[column.field] | date:'HH:mm'}}\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'bool'\">\r\n                          <div class=\"align-middle\">\r\n                            <span *ngIf=\"item[column.field]\"\r\n                              class=\"status status-success\">{{column.trueValue || 'True'}}</span>\r\n                            <span *ngIf=\"!item[column.field]\"\r\n                              class=\"status status-danger\">{{column.falseValue || 'False'}}</span>\r\n                          </div>\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'values'\">\r\n                          <div class=\"status c-ellipsis\"\r\n                            [ngStyle]=\"{'color':column?.dictionary[item[column.field]]?.color}\">\r\n                            {{!!column?.dictionary[item[column.field]] ? column?.dictionary[item[column.field]]?.text : item[column.field]}}\r\n                          </div>\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'radio'\">\r\n                          <div class=\"c-ellipsis\">\r\n                            <span>{{item[column.field]}}</span>\r\n                          </div>\r\n                        </div>\r\n                        <div *ngIf=\"column.type === 'image'\">\r\n                          <div class=\"align-middle\">\r\n                            <img [src]=\"item[column.field]\" [width]=\"column.display?.width\"\r\n                              [height]=\"column.display?.height\" style=\"margin: 5px 0\">\r\n                          </div>\r\n                        </div>\r\n                      </ng-template>\r\n                    </ng-container>\r\n                  </ng-container>\r\n                  <div *ngIf=\"column.children?.length\" class=\"row mx-0\">\r\n                    <div *ngFor=\"let childColumn of column.children | filterMobile:item\"\r\n                      [ngClass]=\"{'col-sm-6': childColumn?.colSpan === 1, 'col-sm-12': !childColumn?.colSpan || childColumn?.colSpan === 2}\">\r\n                      <span class=\"c-mobile-title\">\u2022 {{childColumn.title}}:</span>\r\n                      <span *ngIf=\"childColumn.type === 'string'\" class=\"c-mobile-value\" [ngClass]=\"{'badge': item.badge && item.badge[childColumn.field], 'c-mobile-badge':item.badge && item.badge[childColumn.field], \r\n                        'badge-primary':item.badge && item.badge[childColumn.field] === 'PRIMARY', \r\n                        'badge-secondary':item.badge && item.badge[childColumn.field] === 'SECONDARY', \r\n                        'badge-info':item.badge && item.badge[childColumn.field] === 'INFO', \r\n                        'badge-success':item.badge && item.badge[childColumn.field] === 'SUCCESS', \r\n                        'badge-warning':item.badge && item.badge[childColumn.field] === 'WARNING', \r\n                        'badge-danger':item.badge && item.badge[childColumn.field] === 'DANGER',\r\n                        'badge-light':item.badge && item.badge[childColumn.field] === 'LIGHT',\r\n                        'badge-dark':item.badge && item.badge[childColumn.field] === 'DARK',\r\n                        'blinker': item.blinker && item.blinker[childColumn.field]}\">{{item[childColumn.field]}}</span>\r\n                      <span *ngIf=\"childColumn.type === 'number'\" class=\"c-mobile-value\"\r\n                        [ngClass]=\"{'badge': item.badge && item.badge[childColumn.field], 'c-mobile-badge':item.badge && item.badge[childColumn.field], \r\n                        'badge-primary':item.badge && item.badge[childColumn.field] === 'PRIMARY', \r\n                        'badge-secondary':item.badge && item.badge[childColumn.field] === 'SECONDARY', \r\n                        'badge-info':item.badge && item.badge[childColumn.field] === 'INFO', \r\n                        'badge-success':item.badge && item.badge[childColumn.field] === 'SUCCESS', \r\n                        'badge-warning':item.badge && item.badge[childColumn.field] === 'WARNING', \r\n                        'badge-danger':item.badge && item.badge[childColumn.field] === 'DANGER',\r\n                        'badge-light':item.badge && item.badge[childColumn.field] === 'LIGHT',\r\n                        'badge-dark':item.badge && item.badge[childColumn.field] === 'DARK',\r\n                        'blinker': item.blinker && item.blinker[childColumn.field]}\">{{(item[childColumn.field] | valueTransform:item:childColumn) | number : '1.0-2'}}</span>\r\n                      <span *ngIf=\"childColumn.type === 'datetime'\"\r\n                        class=\"c-mobile-value\">{{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}</span>\r\n                      <span *ngIf=\"childColumn.type === 'date'\"\r\n                        class=\"c-mobile-value\">{{item[childColumn.field] | date:'dd/MM/yyyy'}}</span>\r\n                      <span *ngIf=\"childColumn.type === 'time'\"\r\n                        class=\"c-mobile-value\">{{item[childColumn.field] | date:'HH:mm'}}</span>\r\n                      <span *ngIf=\"childColumn.type === 'bool'\" class=\"c-mobile-value\">\r\n                        <span *ngIf=\"item[childColumn.field]\"\r\n                          class=\"status status-success\">{{childColumn.trueValue || 'True'}}</span>\r\n                        <span *ngIf=\"!item[childColumn.field]\"\r\n                          class=\"status status-danger\">{{childColumn.falseValue || 'False'}}</span>\r\n                      </span>\r\n                      <span *ngIf=\"childColumn.type === 'color'\" class=\"c-mobile-value\"><input disabled=\"true\"\r\n                          type=\"color\" class=\"form-control form-control-sm\" [(ngModel)]=\"item[childColumn.field]\"></span>\r\n                      <span *ngIf=\"childColumn.type === 'values'\" class=\"status c-mobile-value\"\r\n                        [ngStyle]=\"{'color':childColumn?.dictionary[item[childColumn.field]]?.color}\">\r\n                        {{!!childColumn?.dictionary[item[childColumn.field]] ? childColumn?.dictionary[item[childColumn.field]]?.text : item[childColumn.field]}}\r\n                      </span>\r\n                      <span *ngIf=\"childColumn.type === 'radio'\"\r\n                        class=\"c-mobile-value\">{{item[childColumn.field]}}</span>\r\n                      <img *ngIf=\"childColumn.type === 'image'\" [src]=\"item[childColumn.field]\"\r\n                        [width]=\"childColumn.display?.width\" [height]=\"childColumn.display?.height\"\r\n                        style=\"margin: 5px 0\">\r\n                    </div>\r\n                  </div>\r\n                </td>\r\n              </tr>\r\n            </ng-container>\r\n          </tbody>\r\n        </table>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<div *ngIf=\"isMobile\" class=\"sd-box c-mobile-box\">\r\n  <div class=\"sd-box-body c-mobile-body\" [ngStyle]=\"{'height': height}\">\r\n    <ng-container *ngFor=\"let item of subItems\">\r\n      <div class=\"c-mobile-item\">\r\n        <ng-container *ngFor=\"let column of columns | filterMobile:item\">\r\n          <div *ngIf=\"item[column.field]\" class=\"c-mobile-row\">\r\n            <span class=\"c-mobile-title\">\u2022 {{column.title}}:</span>\r\n            <span *ngIf=\"column.type === 'string'\" class=\"c-mobile-value\" [ngClass]=\"{'badge': item.badge && item.badge[column.field], 'c-mobile-badge':item.badge && item.badge[column.field], \r\n            'badge-primary':item.badge && item.badge[column.field] === 'PRIMARY', \r\n            'badge-secondary':item.badge && item.badge[column.field] === 'SECONDARY', \r\n            'badge-info':item.badge && item.badge[column.field] === 'INFO', \r\n            'badge-success':item.badge && item.badge[column.field] === 'SUCCESS', \r\n            'badge-warning':item.badge && item.badge[column.field] === 'WARNING', \r\n            'badge-danger':item.badge && item.badge[column.field] === 'DANGER',\r\n            'badge-light':item.badge && item.badge[column.field] === 'LIGHT',\r\n            'badge-dark':item.badge && item.badge[column.field] === 'DARK',\r\n            'blinker': item.blinker && item.blinker[column.field]}\">{{item[column.field]}}</span>\r\n            <span *ngIf=\"column.type === 'number'\" class=\"c-mobile-value\" [ngClass]=\"{'badge': item.badge && item.badge[column.field], 'c-mobile-badge':item.badge && item.badge[column.field], \r\n            'badge-primary':item.badge && item.badge[column.field] === 'PRIMARY', \r\n            'badge-secondary':item.badge && item.badge[column.field] === 'SECONDARY', \r\n            'badge-info':item.badge && item.badge[column.field] === 'INFO', \r\n            'badge-success':item.badge && item.badge[column.field] === 'SUCCESS', \r\n            'badge-warning':item.badge && item.badge[column.field] === 'WARNING', \r\n            'badge-danger':item.badge && item.badge[column.field] === 'DANGER',\r\n            'badge-light':item.badge && item.badge[column.field] === 'LIGHT',\r\n            'badge-dark':item.badge && item.badge[column.field] === 'DARK',\r\n            'blinker': item.blinker && item.blinker[column.field]}\">{{item[column.field] | number : '1.0-2'}}</span>\r\n            <span *ngIf=\"column.type === 'datetime'\"\r\n              class=\"c-mobile-value\">{{item[column.field] | date:'dd/MM/yyyy HH:mm'}}</span>\r\n            <span *ngIf=\"column.type === 'date'\"\r\n              class=\"c-mobile-value\">{{item[column.field] | date:'dd/MM/yyyy'}}</span>\r\n            <span *ngIf=\"column.type === 'time'\" class=\"c-mobile-value\">{{item[column.field] | date:'HH:mm'}}</span>\r\n            <span *ngIf=\"column.type === 'bool'\" class=\"c-mobile-value\">\r\n              <span *ngIf=\"item[column.field]\" class=\"status status-success\">{{column.trueValue || 'True'}}</span>\r\n              <span *ngIf=\"!item[column.field]\" class=\"status status-danger\">{{column.falseValue || 'False'}}</span>\r\n            </span>\r\n            <span *ngIf=\"column.type === 'color'\" class=\"c-mobile-value\"><input disabled=\"true\" type=\"color\"\r\n                class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"></span>\r\n            <span *ngIf=\"column.type === 'values'\" class=\"status c-mobile-value\"\r\n              [ngStyle]=\"{'color':column?.dictionary[item[column.field]]?.color}\">\r\n              {{!!column?.dictionary[item[column.field]] ? column?.dictionary[item[column.field]]?.text : item[column.field]}}\r\n            </span>\r\n            <span *ngIf=\"column.type === 'radio'\" class=\"c-mobile-value\">{{item[column.field]}}</span>\r\n            <img *ngIf=\"column.type === 'image'\" [src]=\"item[column.field]\" [width]=\"column.display?.width\"\r\n              [height]=\"column.display?.height\" style=\"margin: 5px 0\">\r\n          </div>\r\n          <ng-container *ngIf=\"column.children?.length\">\r\n            <div class=\"c-mobile-row\" *ngFor=\"let childColumn of column.children | filterMobile:item\">\r\n              <span class=\"c-mobile-title\">\u2022 {{childColumn.title}}:</span>\r\n              <span *ngIf=\"childColumn.type === 'string'\" class=\"c-mobile-value\" [ngClass]=\"{'badge': item.badge && item.badge[childColumn.field], 'c-mobile-badge':item.badge && item.badge[childColumn.field], \r\n            'badge-primary':item.badge && item.badge[childColumn.field] === 'PRIMARY', \r\n            'badge-secondary':item.badge && item.badge[childColumn.field] === 'SECONDARY', \r\n            'badge-info':item.badge && item.badge[childColumn.field] === 'INFO', \r\n            'badge-success':item.badge && item.badge[childColumn.field] === 'SUCCESS', \r\n            'badge-warning':item.badge && item.badge[childColumn.field] === 'WARNING', \r\n            'badge-danger':item.badge && item.badge[childColumn.field] === 'DANGER',\r\n            'badge-light':item.badge && item.badge[childColumn.field] === 'LIGHT',\r\n            'badge-dark':item.badge && item.badge[childColumn.field] === 'DARK',\r\n            'blinker': item.blinker && item.blinker[childColumn.field]}\">{{item[childColumn.field]}}</span>\r\n              <span *ngIf=\"childColumn.type === 'number'\" class=\"c-mobile-value\"\r\n                [ngClass]=\"{'badge': item.badge && item.badge[childColumn.field], 'c-mobile-badge':item.badge && item.badge[childColumn.field], \r\n            'badge-primary':item.badge && item.badge[childColumn.field] === 'PRIMARY', \r\n            'badge-secondary':item.badge && item.badge[childColumn.field] === 'SECONDARY', \r\n            'badge-info':item.badge && item.badge[childColumn.field] === 'INFO', \r\n            'badge-success':item.badge && item.badge[childColumn.field] === 'SUCCESS', \r\n            'badge-warning':item.badge && item.badge[childColumn.field] === 'WARNING', \r\n            'badge-danger':item.badge && item.badge[childColumn.field] === 'DANGER',\r\n            'badge-light':item.badge && item.badge[childColumn.field] === 'LIGHT',\r\n            'badge-dark':item.badge && item.badge[childColumn.field] === 'DARK',\r\n            'blinker': item.blinker && item.blinker[childColumn.field]}\">{{item[childColumn.field] | number : '1.0-2'}}</span>\r\n              <span *ngIf=\"childColumn.type === 'datetime'\"\r\n                class=\"c-mobile-value\">{{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}</span>\r\n              <span *ngIf=\"childColumn.type === 'date'\"\r\n                class=\"c-mobile-value\">{{item[childColumn.field] | date:'dd/MM/yyyy'}}</span>\r\n              <span *ngIf=\"childColumn.type === 'time'\"\r\n                class=\"c-mobile-value\">{{item[childColumn.field] | date:'HH:mm'}}</span>\r\n              <span *ngIf=\"childColumn.type === 'bool'\" class=\"c-mobile-value\">\r\n                <span *ngIf=\"item[childColumn.field]\"\r\n                  class=\"status status-success\">{{childColumn.trueValue || 'True'}}</span>\r\n                <span *ngIf=\"!item[childColumn.field]\"\r\n                  class=\"status status-danger\">{{childColumn.falseValue || 'False'}}</span>\r\n              </span>\r\n              <span *ngIf=\"childColumn.type === 'color'\" class=\"c-mobile-value\"><input disabled=\"true\" type=\"color\"\r\n                  class=\"form-control form-control-sm\" [(ngModel)]=\"item[childColumn.field]\"></span>\r\n              <span *ngIf=\"childColumn.type === 'values'\" class=\"status c-mobile-value\"\r\n                [ngStyle]=\"{'color':childColumn?.dictionary[item[childColumn.field]]?.color}\">\r\n                {{!!childColumn?.dictionary[item[childColumn.field]] ? childColumn?.dictionary[item[childColumn.field]]?.text : item[childColumn.field]}}\r\n              </span>\r\n              <span *ngIf=\"childColumn.type === 'radio'\" class=\"c-mobile-value\">{{item[childColumn.field]}}</span>\r\n              <img *ngIf=\"childColumn.type === 'image'\" [src]=\"item[childColumn.field]\"\r\n                [width]=\"childColumn.display?.width\" [height]=\"childColumn.display?.height\" style=\"margin: 5px 0\">\r\n            </div>\r\n          </ng-container>\r\n        </ng-container>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</div>",
            styles: ["", ".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", "", "", "@charset \"UTF-8\";.grid-header{overflow-x:hidden;overflow-y:hidden}.c-table.table{margin-bottom:5px}td,th{padding:3px 5px;font-size:13px;min-width:0}.c-cell-padding{padding:3px 5px!important}.c-header-title{text-transform:uppercase;font-weight:500}span.c-header-title{white-space:nowrap;overflow:hidden!important;text-overflow:ellipsis;display:block;padding:0 .3rem}thead th{min-height:50px;height:50px;border-top:none}tbody td{min-height:25px;height:25px}.status{font-weight:500;padding:2px 5px;border-radius:1.5rem;color:#16759b;display:inline-block;text-align:center;text-transform:uppercase}.status-success{color:#43a047}.status-danger{color:#f44336}.sumarize{padding:8px 12px;text-transform:uppercase;font-size:12px;color:#fff;display:inline-block;white-space:normal;font-weight:500;line-height:1;text-align:center;border-radius:10rem;background-color:#00bcd4}.cursor-pointer{cursor:pointer}label.custom-control.custom-checkbox{margin:0}.c-overflow-x-hidden{overflow-x:hidden}.c-overflow-y-hidden{overflow-y:hidden}.c-grid-header{overflow-x:hidden;overflow-y:hidden}.c-th-xs{line-height:1.15;padding:.1rem!important;font-size:.8rem;min-width:0;min-height:49px;height:49px}.c-td-xs{line-height:1.15;padding:.1rem!important;font-size:.8rem;min-width:0;min-height:1.5rem;height:1.5rem}.c-input-xs{font-size:13px!important;line-height:1.5!important;padding:3px!important;height:28px!important}.c-sticky-top{z-index:20;top:0!important}.c-sticky-left{z-index:20;left:0!important;border-left:none!important;border-right:none!important}.c-sticky-all{z-index:30;top:0!important;left:0!important;border-left:none!important;border-right:none!important}.c-sticky-spliter{z-index:40;background-color:#dee2e6;border:none;width:1px;min-width:1px}.table-striped tbody tr:nth-of-type(even) .c-sticky-left{background-color:#fff}.table-striped tbody tr:nth-of-type(odd) .c-sticky-left{background-color:#f2f2f2}.table-responsive>.table-bordered{border:1px solid #dee2e6!important}.c-badge{display:block!important;border-radius:10rem;padding:.3rem!important;font-weight:500;font-size:.8rem}"]
        })
    ], GridSubInformationComponent);
    return GridSubInformationComponent;
}());

var SdMinDateValidator = /** @class */ (function () {
    function SdMinDateValidator() {
    }
    SdMinDateValidator_1 = SdMinDateValidator;
    SdMinDateValidator.prototype.validate = function (c) {
        var date = c.value || null;
        var minDate = this.minDate || null;
        if (!date) {
            return null;
        }
        if (!minDate) {
            return null;
        }
        if (new Date(Date.parseFrom(date, 'dd/MM/yyyy HH:mm')).getTime() < new Date(minDate).getTime()) {
            return {
                minDate: true
            };
        }
        return null;
    };
    var SdMinDateValidator_1;
    __decorate([
        Input('sdMinDate')
    ], SdMinDateValidator.prototype, "minDate", void 0);
    SdMinDateValidator = SdMinDateValidator_1 = __decorate([
        Directive({
            selector: '[sdMinDate]',
            providers: [{ provide: NG_VALIDATORS, useExisting: SdMinDateValidator_1, multi: true }]
        })
    ], SdMinDateValidator);
    return SdMinDateValidator;
}());

var SdMaxDateValidator = /** @class */ (function () {
    function SdMaxDateValidator() {
    }
    SdMaxDateValidator_1 = SdMaxDateValidator;
    SdMaxDateValidator.prototype.validate = function (c) {
        var date = c.value || null;
        var maxDate = this.maxDate || null;
        if (!date) {
            return null;
        }
        if (!maxDate) {
            return null;
        }
        if (new Date(Date.parseFrom(date, 'dd/MM/yyyy HH:mm')).getTime() > new Date(maxDate).getTime()) {
            return {
                maxDate: true
            };
        }
        return null;
    };
    var SdMaxDateValidator_1;
    __decorate([
        Input('sdMaxDate')
    ], SdMaxDateValidator.prototype, "maxDate", void 0);
    SdMaxDateValidator = SdMaxDateValidator_1 = __decorate([
        Directive({
            selector: '[sdMaxDate]',
            providers: [{ provide: NG_VALIDATORS, useExisting: SdMaxDateValidator_1, multi: true }]
        })
    ], SdMaxDateValidator);
    return SdMaxDateValidator;
}());

var SdCustomValidator = /** @class */ (function () {
    function SdCustomValidator() {
    }
    SdCustomValidator_1 = SdCustomValidator;
    SdCustomValidator.prototype.validate = function (c) {
        return __awaiter(this, void 0, void 0, function () {
            var value, result, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        value = c.value || null;
                        if (!(this.func && typeof (this.func) === 'function')) return [3 /*break*/, 3];
                        result = this.func(value);
                        if (!(result instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, result];
                    case 1:
                        message = _a.sent();
                        if (message) {
                            return [2 /*return*/, {
                                    customValidator: message
                                }];
                        }
                        return [2 /*return*/, null];
                    case 2:
                        if (result) {
                            return [2 /*return*/, {
                                    customValidator: result
                                }];
                        }
                        return [2 /*return*/, null];
                    case 3: return [2 /*return*/, null];
                }
            });
        });
    };
    var SdCustomValidator_1;
    __decorate([
        Input('sdCustomValidator')
    ], SdCustomValidator.prototype, "func", void 0);
    SdCustomValidator = SdCustomValidator_1 = __decorate([
        Directive({
            selector: '[sdCustomValidator]',
            providers: [{ provide: NG_ASYNC_VALIDATORS, useExisting: SdCustomValidator_1, multi: true }]
        })
    ], SdCustomValidator);
    return SdCustomValidator;
}());

var CommandIconPipe = /** @class */ (function () {
    function CommandIconPipe() {
    }
    CommandIconPipe.prototype.transform = function (icon, item) {
        if (!icon) {
            return '';
        }
        if (typeof (icon) === 'string') {
            return icon;
        }
        return icon(item);
    };
    CommandIconPipe = __decorate([
        Pipe({
            name: 'commandIcon'
        })
    ], CommandIconPipe);
    return CommandIconPipe;
}());

var CommandTitlePipe = /** @class */ (function () {
    function CommandTitlePipe() {
    }
    CommandTitlePipe.prototype.transform = function (title, item) {
        if (!title) {
            return '';
        }
        if (typeof (title) === 'string') {
            return title;
        }
        return title(item);
    };
    CommandTitlePipe = __decorate([
        Pipe({
            name: 'commandTitle'
        })
    ], CommandTitlePipe);
    return CommandTitlePipe;
}());

var CommandDisabledPipe = /** @class */ (function () {
    function CommandDisabledPipe() {
    }
    CommandDisabledPipe.prototype.transform = function (disabled, item) {
        if (!disabled) {
            return false;
        }
        if (typeof (disabled) === 'boolean') {
            return disabled;
        }
        return disabled(item);
    };
    CommandDisabledPipe = __decorate([
        Pipe({
            name: 'commandDisabled'
        })
    ], CommandDisabledPipe);
    return CommandDisabledPipe;
}());

var CommandHidden = /** @class */ (function () {
    function CommandHidden() {
    }
    CommandHidden.prototype.transform = function (item, command) {
        return __awaiter(this, void 0, void 0, function () {
            var hidden, hiddenByItem, hiddenResult, results, _a, _b, childCommand, childHidden, childHiddenByItem, hiddenResult, e_1_1;
            var e_1, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        hidden = command.hidden, hiddenByItem = command.hiddenByItem;
                        if (hidden) {
                            return [2 /*return*/, true];
                        }
                        if (!hiddenByItem) return [3 /*break*/, 3];
                        hiddenResult = hiddenByItem(item);
                        if (!(hiddenResult instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, hiddenResult];
                    case 1:
                        if (_d.sent()) {
                            return [2 /*return*/, true];
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        if (hiddenResult) {
                            return [2 /*return*/, true];
                        }
                        _d.label = 3;
                    case 3:
                        if (!('children' in command)) return [3 /*break*/, 14];
                        results = [];
                        _d.label = 4;
                    case 4:
                        _d.trys.push([4, 11, 12, 13]);
                        _a = __values(command.children), _b = _a.next();
                        _d.label = 5;
                    case 5:
                        if (!!_b.done) return [3 /*break*/, 10];
                        childCommand = _b.value;
                        childHidden = childCommand.hidden, childHiddenByItem = childCommand.hiddenByItem;
                        if (!(!childHidden && !childHiddenByItem)) return [3 /*break*/, 6];
                        results.push(childCommand);
                        return [3 /*break*/, 9];
                    case 6:
                        if (!childHiddenByItem) return [3 /*break*/, 9];
                        hiddenResult = childHiddenByItem(item);
                        if (!(hiddenResult instanceof Promise)) return [3 /*break*/, 8];
                        return [4 /*yield*/, hiddenResult];
                    case 7:
                        if (!(_d.sent())) {
                            results.push(childCommand);
                        }
                        return [3 /*break*/, 9];
                    case 8:
                        if (!hiddenResult) {
                            results.push(childCommand);
                        }
                        _d.label = 9;
                    case 9:
                        _b = _a.next();
                        return [3 /*break*/, 5];
                    case 10: return [3 /*break*/, 13];
                    case 11:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 13];
                    case 12:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 13:
                        if (results.length === 0) {
                            return [2 /*return*/, true];
                        }
                        _d.label = 14;
                    case 14: return [2 /*return*/, false];
                }
            });
        });
    };
    CommandHidden = __decorate([
        Pipe({
            name: 'commandHidden'
        })
    ], CommandHidden);
    return CommandHidden;
}());

var MobileCommandFilterPipe = /** @class */ (function () {
    function MobileCommandFilterPipe() {
    }
    MobileCommandFilterPipe.prototype.transform = function (commands, item) {
        return __awaiter(this, void 0, void 0, function () {
            var results, commands_1, commands_1_1, command, flag, hiddenByItem, hidden, _a, _b, childCommand, hidden, e_1_1, hiddenByItem, hidden, e_2_1;
            var e_2, _c, e_1, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        results = [];
                        if (!commands) {
                            return [2 /*return*/, results];
                        }
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 22, 23, 24]);
                        commands_1 = __values(commands), commands_1_1 = commands_1.next();
                        _e.label = 2;
                    case 2:
                        if (!!commands_1_1.done) return [3 /*break*/, 21];
                        command = commands_1_1.value;
                        if (!('children' in command)) return [3 /*break*/, 16];
                        flag = true;
                        hiddenByItem = command.hiddenByItem;
                        if (!hiddenByItem) return [3 /*break*/, 5];
                        hidden = hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 4];
                        return [4 /*yield*/, hidden];
                    case 3:
                        if (_e.sent()) {
                            flag = false;
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        if (hidden) {
                            flag = false;
                        }
                        _e.label = 5;
                    case 5:
                        if (!flag) return [3 /*break*/, 15];
                        _e.label = 6;
                    case 6:
                        _e.trys.push([6, 13, 14, 15]);
                        _a = (e_1 = void 0, __values(command.children)), _b = _a.next();
                        _e.label = 7;
                    case 7:
                        if (!!_b.done) return [3 /*break*/, 12];
                        childCommand = _b.value;
                        if (!!childCommand.hiddenByItem) return [3 /*break*/, 8];
                        results.push(childCommand);
                        return [3 /*break*/, 11];
                    case 8:
                        hidden = childCommand.hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 10];
                        return [4 /*yield*/, hidden];
                    case 9:
                        if (!(_e.sent())) {
                            results.push(childCommand);
                        }
                        return [3 /*break*/, 11];
                    case 10:
                        if (!hidden) {
                            results.push(childCommand);
                        }
                        _e.label = 11;
                    case 11:
                        _b = _a.next();
                        return [3 /*break*/, 7];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 15];
                    case 14:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 15: return [3 /*break*/, 20];
                    case 16:
                        hiddenByItem = command.hiddenByItem;
                        if (!!hiddenByItem) return [3 /*break*/, 17];
                        results.push(command);
                        return [3 /*break*/, 20];
                    case 17:
                        hidden = hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 19];
                        return [4 /*yield*/, hidden];
                    case 18:
                        if (!(_e.sent())) {
                            results.push(command);
                        }
                        return [3 /*break*/, 20];
                    case 19:
                        if (!hidden) {
                            results.push(command);
                        }
                        _e.label = 20;
                    case 20:
                        commands_1_1 = commands_1.next();
                        return [3 /*break*/, 2];
                    case 21: return [3 /*break*/, 24];
                    case 22:
                        e_2_1 = _e.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 24];
                    case 23:
                        try {
                            if (commands_1_1 && !commands_1_1.done && (_c = commands_1.return)) _c.call(commands_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 24: return [2 /*return*/, results];
                }
            });
        });
    };
    MobileCommandFilterPipe = __decorate([
        Pipe({
            name: 'mobileCommandFilter'
        })
    ], MobileCommandFilterPipe);
    return MobileCommandFilterPipe;
}());

var ColumnTitlePipe = /** @class */ (function () {
    function ColumnTitlePipe() {
    }
    ColumnTitlePipe.prototype.transform = function (item, title, dynamicTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!title) {
                            return [2 /*return*/, ''];
                        }
                        if (!dynamicTitle) return [3 /*break*/, 3];
                        result = dynamicTitle(item);
                        if (!(result instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, result];
                    case 1: return [2 /*return*/, (_a.sent()) || title];
                    case 2: return [2 /*return*/, result || title];
                    case 3: return [2 /*return*/, title];
                }
            });
        });
    };
    ColumnTitlePipe = __decorate([
        Pipe({
            name: 'columnTitle'
        })
    ], ColumnTitlePipe);
    return ColumnTitlePipe;
}());

var SdChipMinItemValidator = /** @class */ (function () {
    function SdChipMinItemValidator() {
    }
    SdChipMinItemValidator_1 = SdChipMinItemValidator;
    SdChipMinItemValidator.prototype.validate = function (c) {
        if (this.func && typeof (this.func) === 'function') {
            var result = this.func();
            if (result) {
                return {
                    minItem: result
                };
            }
            return null;
        }
        return null;
    };
    var SdChipMinItemValidator_1;
    __decorate([
        Input('sdChipMinItem')
    ], SdChipMinItemValidator.prototype, "func", void 0);
    SdChipMinItemValidator = SdChipMinItemValidator_1 = __decorate([
        Directive({
            selector: '[sdChipMinItem]',
            providers: [{ provide: NG_VALIDATORS, useExisting: SdChipMinItemValidator_1, multi: true }]
        })
    ], SdChipMinItemValidator);
    return SdChipMinItemValidator;
}());

var EditorValidatePipe = /** @class */ (function () {
    function EditorValidatePipe() {
        this.delay = 1000; // Sau khoảng thời gian delay nếu không có thay đổi thì thì mới bắt đầu thực hiện validate
    }
    EditorValidatePipe.prototype.transform = function (value, item, validate) {
        return __awaiter(this, void 0, void 0, function () {
            var now, dif, result, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.previous = new Date();
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, _this.delay); })];
                    case 1:
                        _b.sent();
                        now = new Date();
                        dif = now.getTime() - this.previous.getTime();
                        if (dif < this.delay) {
                            return [2 /*return*/, true];
                        }
                        item.editorHandler = item.editorHandler || {};
                        if (!validate) {
                            item.editorHandler.errorMessage = null;
                            return [2 /*return*/, true];
                        }
                        result = validate(item);
                        if (!(result instanceof Promise)) return [3 /*break*/, 3];
                        _a = item.editorHandler;
                        return [4 /*yield*/, result];
                    case 2:
                        _a.errorMessage = _b.sent();
                        return [2 /*return*/, true];
                    case 3:
                        item.editorHandler.errorMessage = result;
                        return [2 /*return*/, true];
                }
            });
        });
    };
    EditorValidatePipe = __decorate([
        Pipe({
            name: 'editorValidate'
        })
    ], EditorValidatePipe);
    return EditorValidatePipe;
}());

var EditorDynamicItemPipe = /** @class */ (function () {
    function EditorDynamicItemPipe() {
        this.previousResults = [];
        this.delay = 200; // Sau khoảng thời gian delay nếu không có thay đổi thì thì mới bắt đầu thực hiện gọi hàm
    }
    EditorDynamicItemPipe.prototype.transform = function (value, item, editor) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var now, dif, results, _c;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        this.previous = new Date();
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, _this.delay); })];
                    case 1:
                        _d.sent();
                        now = new Date();
                        dif = now.getTime() - this.previous.getTime();
                        if (dif < this.delay) {
                            return [2 /*return*/, this.previousResults];
                        }
                        if (!(editor.type === 'default')) return [3 /*break*/, 2];
                        return [2 /*return*/, editor.items];
                    case 2:
                        if (!(editor.type === 'dependent')) return [3 /*break*/, 5];
                        results = (_b = (_a = editor).items) === null || _b === void 0 ? void 0 : _b.call(_a, item);
                        if (!results) {
                            this.previousResults = [];
                            return [2 /*return*/, this.previousResults];
                        }
                        if (!(results instanceof Promise)) return [3 /*break*/, 4];
                        _c = this;
                        return [4 /*yield*/, results];
                    case 3:
                        _c.previousResults = _d.sent();
                        return [2 /*return*/, this.previousResults];
                    case 4:
                        this.previousResults = results;
                        return [2 /*return*/, results];
                    case 5:
                        this.previousResults = [];
                        return [2 /*return*/, this.previousResults];
                }
            });
        });
    };
    EditorDynamicItemPipe = __decorate([
        Pipe({
            name: 'editorDynamicItem'
        })
    ], EditorDynamicItemPipe);
    return EditorDynamicItemPipe;
}());

var ColumnHtmlTemplatePipe = /** @class */ (function () {
    function ColumnHtmlTemplatePipe(deviceService) {
        this.isMobileOrTablet = false;
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    ColumnHtmlTemplatePipe.prototype.transform = function (value, rowData, htmlTemplate) {
        if (typeof (htmlTemplate) !== 'function') {
            return value;
        }
        return htmlTemplate(value, rowData, this.isMobileOrTablet);
    };
    ColumnHtmlTemplatePipe.ctorParameters = function () { return [
        { type: DeviceDetectorService }
    ]; };
    ColumnHtmlTemplatePipe = __decorate([
        Pipe({
            name: 'columnHtmlTemplate'
        })
    ], ColumnHtmlTemplatePipe);
    return ColumnHtmlTemplatePipe;
}());

var ColumnCommandFilterPipe = /** @class */ (function () {
    function ColumnCommandFilterPipe() {
    }
    ColumnCommandFilterPipe.prototype.transform = function (commands, item) {
        return __awaiter(this, void 0, void 0, function () {
            var results, commands_1, commands_1_1, command, hiddenByItem, hidden, e_1_1;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        results = [];
                        if (!commands) {
                            return [2 /*return*/, results];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 8, 9, 10]);
                        commands_1 = __values(commands), commands_1_1 = commands_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!commands_1_1.done) return [3 /*break*/, 7];
                        command = commands_1_1.value;
                        hiddenByItem = command.hiddenByItem;
                        if (!!hiddenByItem) return [3 /*break*/, 3];
                        results.push(command);
                        return [3 /*break*/, 6];
                    case 3:
                        hidden = hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 5];
                        return [4 /*yield*/, hidden];
                    case 4:
                        if (!(_b.sent())) {
                            results.push(command);
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        if (!hidden) {
                            results.push(command);
                        }
                        _b.label = 6;
                    case 6:
                        commands_1_1 = commands_1.next();
                        return [3 /*break*/, 2];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (commands_1_1 && !commands_1_1.done && (_a = commands_1.return)) _a.call(commands_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 10: return [2 /*return*/, results];
                }
            });
        });
    };
    ColumnCommandFilterPipe = __decorate([
        Pipe({
            name: 'columnCommandFilter'
        })
    ], ColumnCommandFilterPipe);
    return ColumnCommandFilterPipe;
}());

// https://stackoverflow.com/questions/4459379/preview-an-image-before-it-is-uploaded
var UploadFileControlComponent = /** @class */ (function () {
    function UploadFileControlComponent(ref, notifyService, translateService) {
        var _this = this;
        this.ref = ref;
        this.notifyService = notifyService;
        this.translateService = translateService;
        this.id = "I" + v4();
        this.previewFiles = [];
        this.type = 'file';
        this.disabled = false;
        this.extensions = [];
        this.max = 1;
        this.srcs = [];
        this.align = 'center';
        this.sdChange = new EventEmitter();
        this.subscription = new Subscription();
        this.reload = function (previewFiles) {
            if (previewFiles) {
                _this.previewFiles = previewFiles;
                return;
            }
            _this.previewFiles = _this.srcs.map(function (src) { return ({
                file: null,
                previewSrc: null,
                src: src,
                isPreviewImage: _this.type === 'image'
            }); });
        };
        this.validate = function (file) { return __awaiter(_this, void 0, void 0, function () {
            var lastDot, extension_1, message;
            var _this = this;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.type === 'image') {
                            if (file.type.split('/')[0] !== 'image') {
                                return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Uploaded file is not an image')];
                            }
                        }
                        if ((_a = this.extensions) === null || _a === void 0 ? void 0 : _a.length) {
                            lastDot = file.name.lastIndexOf('.');
                            extension_1 = file.name.substring(lastDot + 1);
                            if (!this.extensions.some(function (e) { return e.toUpperCase() === extension_1.toUpperCase(); })) {
                                return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Uploaded file is not match extension') + " " + this.extensions.join(', ')];
                            }
                        }
                        if (this.maxSize) {
                            if (this.maxSize * 1024 * 1024 < file.size) {
                                return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Max file size') + " " + this.maxSize + " Mbs"];
                            }
                        }
                        if (!(this.type === 'image' && (this.maxWidth || this.maxHeight))) return [3 /*break*/, 2];
                        return [4 /*yield*/, new Promise(function (resolve) {
                                var URL = window.URL || window.webkitURL;
                                var img = new Image();
                                img.onload = function () {
                                    if (_this.maxWidth && img.width > _this.maxWidth) {
                                        resolve("[" + file.name + "] " + _this.translateService.translate('Max image width') + " " + _this.maxWidth + "px");
                                    }
                                    if (_this.maxHeight && img.height > _this.maxHeight) {
                                        resolve("[" + file.name + "] " + _this.translateService.translate('Max image height') + " " + _this.maxHeight + "px");
                                    }
                                    resolve();
                                };
                                img.src = URL.createObjectURL(file);
                            })];
                    case 1:
                        message = _b.sent();
                        if (message) {
                            return [2 /*return*/, message];
                        }
                        _b.label = 2;
                    case 2: return [2 /*return*/, null];
                }
            });
        }); };
        this.preview = function () {
            var e_1, _a;
            var _loop_1 = function (previewFile) {
                var reader = new FileReader();
                reader.onload = function (evt) {
                    var _a;
                    previewFile.previewSrc = evt.target.result;
                    previewFile.isPreviewImage = ((_a = previewFile.file) === null || _a === void 0 ? void 0 : _a.type.split('/')[0]) === 'image';
                    _this.ref.detectChanges();
                };
                reader.readAsDataURL(previewFile.file);
            };
            try {
                for (var _b = __values(_this.previewFiles.filter(function (e) { return e.file; })), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var previewFile = _c.value;
                    _loop_1(previewFile);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        this.uploadFile = function (target, previewFile) { return __awaiter(_this, void 0, void 0, function () {
            var files, i, message, i, file, lastDot, extension, idx, file, lastDot, extension;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!target.files.length) {
                            return [2 /*return*/];
                        }
                        files = target.files;
                        if (!!previewFile) return [3 /*break*/, 5];
                        if (files.length + this.previewFiles.length > this.max) {
                            this.notifyService.notify.warning(this.translateService.translate('Max number of files') + " " + this.max);
                            return [2 /*return*/];
                        }
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < files.length)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.validate(files.item(i))];
                    case 2:
                        message = _a.sent();
                        if (message) {
                            this.notifyService.notify.warning(message);
                            return [2 /*return*/];
                        }
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        // tslint:disable-next-line: prefer-for-of
                        for (i = 0; i < files.length; i++) {
                            file = files.item(i);
                            lastDot = file.name.lastIndexOf('.');
                            extension = file.name.substring(lastDot + 1);
                            this.previewFiles.push({
                                file: files.item(i),
                                isPreviewImage: false,
                                previewSrc: null,
                                src: null,
                                fileName: file.name,
                                extension: extension
                            });
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        idx = this.previewFiles.indexOf(previewFile);
                        file = files.item(0);
                        lastDot = file.name.lastIndexOf('.');
                        extension = file.name.substring(lastDot + 1);
                        this.previewFiles[idx] = {
                            file: files.item(0),
                            isPreviewImage: false,
                            previewSrc: null,
                            src: null,
                            fileName: file.name,
                            extension: extension
                        };
                        _a.label = 6;
                    case 6:
                        this.preview();
                        this.sdChange.emit(this.previewFiles);
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        }); };
    }
    UploadFileControlComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.previewFiles = this.srcs.map(function (src) { return ({
            file: null,
            previewSrc: null,
            src: src,
            isPreviewImage: _this.type === 'image'
        }); });
    };
    UploadFileControlComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.dropElements.length > 0) {
            var dropContainer_1 = this.dropElements.first.nativeElement;
            this.currentDropContainer = dropContainer_1;
            dropContainer_1.addEventListener('dragover', function (evt) {
                evt.preventDefault();
                dropContainer_1.style.opacity = 0.9;
                dropContainer_1.style.border = '2px solid grey';
            });
            dropContainer_1.addEventListener('dragenter', function (evt) {
                evt.preventDefault();
            });
            dropContainer_1.addEventListener('dragleave', function (evt) {
                dropContainer_1.style.opacity = 0.6;
                dropContainer_1.style.border = '2px dashed grey';
            });
            dropContainer_1.addEventListener('drop', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            evt.preventDefault();
                            dropContainer_1.style.opacity = 0.6;
                            dropContainer_1.style.border = '2px dashed grey';
                            return [4 /*yield*/, this.uploadFile(evt.dataTransfer)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
        }
        this.subscription.add(this.dropElements.changes.subscribe(function () {
            if (_this.dropElements.length > 0 && _this.currentDropContainer !== _this.dropElements.first.nativeElement) {
                var dropContainer_2 = _this.dropElements.first.nativeElement;
                _this.currentDropContainer = dropContainer_2;
                dropContainer_2.addEventListener('dragover', function (evt) {
                    evt.preventDefault();
                    dropContainer_2.style.opacity = 0.9;
                    dropContainer_2.style.border = '2px solid grey';
                });
                dropContainer_2.addEventListener('dragenter', function (evt) {
                    evt.preventDefault();
                });
                dropContainer_2.addEventListener('dragleave', function (evt) {
                    dropContainer_2.style.opacity = 0.6;
                    dropContainer_2.style.border = '2px dashed grey';
                });
                dropContainer_2.addEventListener('drop', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                evt.preventDefault();
                                dropContainer_2.style.opacity = 0.6;
                                dropContainer_2.style.border = '2px dashed grey';
                                return [4 /*yield*/, this.uploadFile(evt.dataTransfer)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); });
            }
        }));
    };
    UploadFileControlComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    UploadFileControlComponent.prototype.onUpload = function (previewFile) {
        var _this = this;
        if ($$1("#" + this.id).length) {
            $$1('body').children("#" + this.id).remove();
        }
        if (previewFile || this.max === 1) {
            $$1('body').append("<input id=\"" + this.id + "\" style=\"display: none\" type=\"file\" />");
        }
        else {
            $$1('body').append("<input id=\"" + this.id + "\" style=\"display: none\" type=\"file\" multiple />");
        }
        $$1("#" + this.id).on('change', function (evt) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.uploadFile(evt.target, previewFile)];
                    case 1:
                        _a.sent();
                        $$1('body').children("#" + this.id).remove();
                        return [2 /*return*/];
                }
            });
        }); });
        $$1("#" + this.id).trigger('click');
    };
    UploadFileControlComponent.prototype.onRemove = function (previewFile) {
        var idx = this.previewFiles.indexOf(previewFile);
        this.previewFiles.splice(idx, 1);
        this.sdChange.emit(this.previewFiles);
    };
    UploadFileControlComponent.prototype.onDrop = function (event) {
        moveItemInArray(this.previewFiles, event.previousIndex, event.currentIndex);
        this.sdChange.emit(this.previewFiles);
    };
    UploadFileControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: NotifyService },
        { type: TranslateService }
    ]; };
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "type", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "extensions", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "max", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "maxSize", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "maxWidth", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "maxHeight", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "srcs", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "previewWidth", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "previewHeight", void 0);
    __decorate([
        Input()
    ], UploadFileControlComponent.prototype, "align", void 0);
    __decorate([
        Output()
    ], UploadFileControlComponent.prototype, "sdChange", void 0);
    __decorate([
        ViewChildren('dragElement')
    ], UploadFileControlComponent.prototype, "dropElements", void 0);
    UploadFileControlComponent = __decorate([
        Component({
            selector: 'sd-upload-file-control',
            template: "<label *ngIf=\"label\" class=\"sd-label d-block\">{{label}}</label>\r\n<div cdkDropList (cdkDropListDropped)=\"onDrop($event)\" class=\"d-flex c-upload-file-control\"\r\n  cdkDropListOrientation=\"horizontal\"\r\n  [ngClass]=\"{'justify-content-center': align === 'center', 'justify-content-start': align === 'left'}\">\r\n  <div *ngFor=\"let file of previewFiles\" class=\"c-area c-view\"\r\n    [ngStyle]=\"{'width': previewWidth, 'height': previewHeight}\" cdkDrag>\r\n    <div class=\"c-drag-placeholder\" [ngStyle]=\"{'width': previewWidth, 'height': previewHeight}\" *cdkDragPlaceholder>\r\n    </div>\r\n    <div *cdkDragPreview [ngStyle]=\"{'width': previewWidth, 'height': previewHeight}\" style=\"border: 2px dashed grey;\r\n    border-radius: 5px;vertical-align: middle;display: table-cell;\">\r\n      <div style=\"width: 100%;height:100%;padding: 5px 10px 0px 10px;display: table;\">\r\n        <i class=\"fa fa-file-text-o fa-fw\"\r\n          style=\"font-size: 50px;color: grey;vertical-align: middle;display: table-cell;\"></i>\r\n      </div>\r\n    </div>\r\n    <div class=\"c-preview\">\r\n      <div class=\"c-img-container\">\r\n        <ng-container *ngIf=\"file.previewSrc;else elseOrigin\">\r\n          <img *ngIf=\"file.isPreviewImage\" class=\"c-img\" [src]=\"file.previewSrc\" alt=\"Preview\" />\r\n          <i *ngIf=\"!file.isPreviewImage\" class=\"fa fa-file-text-o fa-fw c-icon-file\"></i>\r\n        </ng-container>\r\n        <ng-template #elseOrigin>\r\n          <img *ngIf=\"type === 'image'\" class=\"c-img\" [src]=\"file.src\" alt=\"Preview\" />\r\n          <i *ngIf=\"type !== 'image'\" class=\"fa fa-file-text-o fa-fw c-icon-file\"></i>\r\n        </ng-template>\r\n      </div>\r\n      <div *ngIf=\"!disabled\" class=\"c-action\">\r\n        <i class=\"fa fa-upload c-icon-upload\" (click)=\"onUpload(file)\"></i>\r\n        <i class=\"fa fa-times c-icon-remove\" (click)=\"onRemove(file)\"></i>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"previewFiles?.length < max && !disabled\" class=\"c-area\"\r\n    [ngStyle]=\"{'width': previewWidth, 'height': previewHeight}\" #dragElement>\r\n    <i class=\"fa fa-fw c-icon\" [ngClass]=\"{'fa-upload': type === 'file', 'fa-picture-o': type === 'image'}\"\r\n      (click)=\"onUpload()\"></i>\r\n  </div>\r\n</div>",
            styles: ["::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", ".c-upload-file-control{width:100%;padding:5px 10px;overflow-x:auto}.c-upload-file-control .c-area{border:2px dashed grey;border-radius:5px;display:table;text-align:center;margin:3px;opacity:.6}.c-upload-file-control .c-area.c-view{border:2px solid grey;opacity:.9}.c-upload-file-control .c-area:hover{opacity:.9}.c-upload-file-control .c-area .c-icon{vertical-align:middle;display:table-cell;margin:16px;font-size:50px;color:grey;cursor:pointer}.c-upload-file-control .c-area .c-preview{vertical-align:middle;display:table-cell}.c-upload-file-control .c-area .c-preview .c-img-container{width:100%;padding:5px 10px 0;height:calc(100% - 20px);display:table}.c-upload-file-control .c-area .c-preview .c-img-container .c-img{max-width:calc(100% - 20px);max-height:calc(100% - 5px)}.c-upload-file-control .c-area .c-preview .c-img-container .c-icon-file{font-size:50px;color:grey;vertical-align:middle;display:table-cell}.c-upload-file-control .c-area .c-preview .c-action{padding:0 5px;width:100%;height:20px}.c-upload-file-control .c-area .c-preview .c-action .c-icon-upload{color:grey;float:left;cursor:pointer}.c-upload-file-control .c-area .c-preview .c-action .c-icon-remove{color:red;float:right;cursor:pointer}.c-drag-placeholder{background:#ccc;border:2px dashed grey;display:table-cell;transition:transform 250ms cubic-bezier(0,0,.2,1)}.example-handle{position:absolute;top:10px;right:10px;color:#ccc;cursor:move;width:24px;height:24px}"]
        })
    ], UploadFileControlComponent);
    return UploadFileControlComponent;
}());

Date.equal = function (date1, date2) {
    if (!Date.isDate(date1) && !Date.isDate(date2)) {
        return true;
    }
    if (!Date.isDate(date1) || !Date.isDate(date2)) {
        return false;
    }
    return new Date(date1).getTime() === new Date(date2).getTime();
};
Date.parseFrom = function (value, format) {
    if (!value) {
        return null;
    }
    if (!format) {
        return null;
    }
    value = value.toString();
    var dd = format.indexOf('dd') > -1 ? value.substr(format.indexOf('dd'), 'dd'.length) : '';
    var MM = format.indexOf('MM') > -1 ? value.substr(format.indexOf('MM'), 'MM'.length) : '';
    var yyyy = format.indexOf('yyyy') > -1 ? value.substr(format.indexOf('yyyy'), 'yyyy'.length) : '';
    var HH = format.indexOf('HH') > -1 ? value.substr(format.indexOf('HH'), 'HH'.length) : '00';
    var mm = format.indexOf('mm') > -1 ? value.substr(format.indexOf('mm'), 'mm'.length) : '00';
    var ss = format.indexOf('ss') > -1 ? value.substr(format.indexOf('ss'), 'ss'.length) : '00';
    var today = new Date();
    var strDate = '';
    if (yyyy && MM && dd) {
        strDate += MM + "/" + dd + "/" + yyyy;
    }
    else {
        yyyy = today.getFullYear().toString();
        MM = (today.getMonth() + 1).toString().padStart(2, '0');
        dd = today.getDate().toString().padStart(2, '0');
        strDate += MM + "/" + dd + "/" + yyyy;
    }
    strDate += " " + HH + ":" + mm + ":" + ss;
    return new Date(strDate.trim());
};
Date.isDate = function (value) {
    if (!value) {
        return false;
    }
    var date = new Date(value);
    return !isNaN(date.getTime());
};
Date.toFormat = function (value, format) {
    if (!Date.isDate(value)) {
        return '';
    }
    var date = new Date(value);
    return date.toFormat(format);
};
Date.addMiliseconds = function (value, miliseconds) {
    if (!Date.isDate(value)) {
        return null;
    }
    var date = new Date(value);
    return date.addMiliseconds(miliseconds);
};
Date.addHours = function (value, hours) {
    if (!Date.isDate(value)) {
        return null;
    }
    var date = new Date(value);
    return date.addHours(hours);
};
Date.addDays = function (value, days) {
    if (!Date.isDate(value)) {
        return null;
    }
    var date = new Date(value);
    return date.addDays(days);
};
Date.addMonths = function (value, months) {
    if (!Date.isDate(value)) {
        return null;
    }
    var date = new Date(value);
    return date.addMonths(months);
};
Date.begin = function (value) {
    if (!Date.isDate(value)) {
        return null;
    }
    return new Date(value.toFormat('MM/dd/yyyy'));
};
Date.end = function (value) {
    if (!Date.isDate(value)) {
        return null;
    }
    return new Date(value).addDays(1).begin().addMiliseconds(-1);
};
Date.prototype.begin = function () {
    var date = this;
    return new Date(date.toFormat('MM/dd/yyyy'));
};
Date.prototype.end = function () {
    var date = this;
    return date.addDays(1).begin().addMiliseconds(-1);
};
Date.prototype.addMiliseconds = function (miliseconds) {
    var date = this;
    date.setMilliseconds(date.getMilliseconds() + miliseconds);
    return date;
};
Date.prototype.addHours = function (hours) {
    var date = this;
    date.setHours(date.getHours() + hours);
    return date;
};
Date.prototype.addDays = function (days) {
    var date = this;
    date.setDate(date.getDate() + days);
    return date;
};
Date.prototype.addMonths = function (months) {
    var date = this;
    date.setMonth(date.getMonth() + months);
    return date;
};
Date.prototype.toFormat = function (format) {
    var date = this;
    var result = format;
    result = result.replace('yyyy', date.getFullYear().toString());
    result = result.replace('MM', (date.getMonth() + 1).toString().padStart(2, '0'));
    result = result.replace('dd', date.getDate().toString().padStart(2, '0'));
    result = result.replace('HH', date.getHours().toString().padStart(2, '0'));
    result = result.replace('mm', date.getMinutes().toString().padStart(2, '0'));
    result = result.replace('ss', date.getSeconds().toString().padStart(2, '0'));
    return result;
};

String.isValidEmail = function (value) {
    if (!value) {
        return false;
    }
    var re = /^(([^<>()\[\]\.,;:\s@\"]+(\.[^<>()\[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
    return re.test(value);
};
String.isValidPhone = function (value) {
    if (!value) {
        return false;
    }
    var re = /^[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-\s\./0-9]*$/;
    return re.test(value);
};
String.isValidCode = function (value) {
    if (!value) {
        return false;
    }
    var re = /^[a-zA-Z0-9\@\_\-]{2,20}$/;
    return re.test(value);
};

var GridPopupExportExcelComponent = /** @class */ (function () {
    function GridPopupExportExcelComponent(ref, loadingService, excelService, notifyService, translateService) {
        var _this = this;
        this.ref = ref;
        this.loadingService = loadingService;
        this.excelService = excelService;
        this.notifyService = notifyService;
        this.translateService = translateService;
        this.prefix = 'Popup Export Excel';
        this.newExcelConfig = 'fd8fb5db-a7ad-4398-93ac-cb3350261180';
        this.key = '';
        this.columns = [];
        this.extendColumns = [];
        this.excelConfigs = [];
        this.exportByTemplate = new EventEmitter();
        this.tabIndex = 0;
        this.selectedExcelConfig = {};
        this.exportableColumns = [];
        this.selected = {};
        this.generateExcelColumns = function (columns) {
            var e_1, _a, e_2, _b;
            var excelColumns = [];
            try {
                for (var columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                    var column = columns_1_1.value;
                    if (column.type === 'children') {
                        try {
                            for (var _c = (e_2 = void 0, __values(column.children)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var childColumn = _d.value;
                                if (childColumn.type !== 'image') {
                                    excelColumns.push({
                                        field: childColumn.field,
                                        title: childColumn.title,
                                        description: childColumn.description,
                                        width: childColumn.width
                                    });
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                    }
                    else if (column.type !== 'image') {
                        excelColumns.push({
                            field: column.field,
                            title: column.title,
                            description: column.description,
                            width: column.width
                        });
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (columns_1_1 && !columns_1_1.done && (_a = columns_1.return)) _a.call(columns_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return excelColumns;
        };
        this.initTemplate = function (columns, fileName) { return __awaiter(_this, void 0, void 0, function () {
            var sheets, _a, _b, sheet, _c, _d, _e, e_3_1;
            var e_3, _f;
            var _g;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        columns = columns || [];
                        sheets = [];
                        if (!Array.isArray((_g = this.exportOption) === null || _g === void 0 ? void 0 : _g.sheets)) return [3 /*break*/, 9];
                        _h.label = 1;
                    case 1:
                        _h.trys.push([1, 7, 8, 9]);
                        _a = __values(this.exportOption.sheets), _b = _a.next();
                        _h.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 6];
                        sheet = _b.value;
                        if (!(sheet.name && sheet.items && sheet.fields)) return [3 /*break*/, 5];
                        if (!Array.isArray(sheet.items)) return [3 /*break*/, 3];
                        sheets.push({
                            name: sheet.name,
                            items: sheet.items,
                            fields: sheet.fields
                        });
                        return [3 /*break*/, 5];
                    case 3:
                        _d = (_c = sheets).push;
                        _e = {
                            name: sheet.name
                        };
                        return [4 /*yield*/, sheet.items()];
                    case 4:
                        _d.apply(_c, [(_e.items = _h.sent(),
                                _e.fields = sheet.fields,
                                _e)]);
                        _h.label = 5;
                    case 5:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_3_1 = _h.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
                        }
                        finally { if (e_3) throw e_3.error; }
                        return [7 /*endfinally*/];
                    case 9: return [4 /*yield*/, this.excelService.generateExcelTemplate({
                            fileName: fileName || this.fileName,
                            columns: this.generateExcelColumns(columns),
                            sheets: sheets
                        })];
                    case 10: return [2 /*return*/, _h.sent()];
                }
            });
        }); };
        this.initDefaultTemplate = function () { return __awaiter(_this, void 0, void 0, function () {
            var extendColumns, columns;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        extendColumns = this.extendColumns || [];
                        columns = __spread(this.columns, extendColumns);
                        return [4 /*yield*/, this.initTemplate(columns)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.generateTemplate = function () { return __awaiter(_this, void 0, void 0, function () {
            var result;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.loadingService.start();
                        return [4 /*yield*/, this.initDefaultTemplate().finally(this.loadingService.stop)];
                    case 1:
                        result = _b.sent();
                        if ((_a = result) === null || _a === void 0 ? void 0 : _a.filePath) {
                            this.excelService.downloadTemplate(result.filePath, this.fileName + ".xlsx");
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.generateAndUploadTemplate = function (columns, fileName) { return __awaiter(_this, void 0, void 0, function () {
            var sheets, _a, _b, sheet, _c, _d, _e, e_4_1;
            var e_4, _f;
            var _g;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        sheets = [];
                        if (!Array.isArray((_g = this.exportOption) === null || _g === void 0 ? void 0 : _g.sheets)) return [3 /*break*/, 9];
                        _h.label = 1;
                    case 1:
                        _h.trys.push([1, 7, 8, 9]);
                        _a = __values(this.exportOption.sheets), _b = _a.next();
                        _h.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 6];
                        sheet = _b.value;
                        if (!(sheet.name && sheet.items && sheet.fields)) return [3 /*break*/, 5];
                        if (!Array.isArray(sheet.items)) return [3 /*break*/, 3];
                        sheets.push({
                            name: sheet.name,
                            items: sheet.items,
                            fields: sheet.fields
                        });
                        return [3 /*break*/, 5];
                    case 3:
                        _d = (_c = sheets).push;
                        _e = {
                            name: sheet.name
                        };
                        return [4 /*yield*/, sheet.items()];
                    case 4:
                        _d.apply(_c, [(_e.items = _h.sent(),
                                _e.fields = sheet.fields,
                                _e)]);
                        _h.label = 5;
                    case 5:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_4_1 = _h.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 9: return [4 /*yield*/, this.excelService.generateAndUploadExcelTemplate(this.fullKey, {
                            fileName: fileName || this.fileName,
                            columns: this.generateExcelColumns(columns),
                            sheets: sheets
                        })];
                    case 10: return [2 /*return*/, _h.sent()];
                }
            });
        }); };
        this.onExportByTemplate = function (excelConfig) {
            var extendColumns = _this.extendColumns || [];
            var columns = __spread(_this.columns, extendColumns);
            _this.exportByTemplate.emit({
                excelConfig: excelConfig,
                excelColumns: _this.generateExcelColumns(columns)
            });
            _this.ref.detectChanges();
        };
        this.uploadTemplate = function () { return __awaiter(_this, void 0, void 0, function () {
            var excelConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.excelService.uploadTemplate(this.fullKey, this.validator)];
                    case 1:
                        excelConfig = _a.sent();
                        this.excelConfigs.push({
                            name: excelConfig.name,
                            fullPath: excelConfig.fullPath,
                            removable: true
                        });
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        }); };
        this.downloadTemplate = function (excelConfig) {
            _this.excelService.downloadTemplate(excelConfig.fullPath, excelConfig.name);
        };
        this.removeTemplate = function (excelConfig) {
            _this.notifyService.confirm(_this.translateService.translate('Remove template')).then(function () { return __awaiter(_this, void 0, void 0, function () {
                var idx;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.loadingService.start();
                            return [4 /*yield*/, this.excelService.remove(this.fullKey, excelConfig.name).finally(this.loadingService.stop)];
                        case 1:
                            _a.sent();
                            idx = this.excelConfigs.indexOf(excelConfig);
                            this.excelConfigs.splice(idx, 1);
                            this.ref.detectChanges();
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        this.exportDefault = function () { return __awaiter(_this, void 0, void 0, function () {
            var result, excelColumns, extendColumns, columns, columns_2, columns_2_1, column, _a, _b, childColumn;
            var e_5, _c, e_6, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        this.loadingService.start();
                        return [4 /*yield*/, this.initDefaultTemplate().finally(this.loadingService.stop)];
                    case 1:
                        result = _e.sent();
                        excelColumns = [];
                        extendColumns = this.extendColumns || [];
                        columns = __spread(this.columns, extendColumns);
                        try {
                            for (columns_2 = __values(columns), columns_2_1 = columns_2.next(); !columns_2_1.done; columns_2_1 = columns_2.next()) {
                                column = columns_2_1.value;
                                if (column.type === 'children') {
                                    try {
                                        for (_a = (e_6 = void 0, __values(column.children)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                            childColumn = _b.value;
                                            if (childColumn.type !== 'image') {
                                                excelColumns.push({
                                                    field: childColumn.field,
                                                    title: childColumn.title,
                                                    width: childColumn.width
                                                });
                                            }
                                        }
                                    }
                                    catch (e_6_1) { e_6 = { error: e_6_1 }; }
                                    finally {
                                        try {
                                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                                        }
                                        finally { if (e_6) throw e_6.error; }
                                    }
                                }
                                else if (column.type !== 'image') {
                                    excelColumns.push({
                                        field: column.field,
                                        title: column.title,
                                        width: column.width
                                    });
                                }
                            }
                        }
                        catch (e_5_1) { e_5 = { error: e_5_1 }; }
                        finally {
                            try {
                                if (columns_2_1 && !columns_2_1.done && (_c = columns_2.return)) _c.call(columns_2);
                            }
                            finally { if (e_5) throw e_5.error; }
                        }
                        this.exportByTemplate.emit({
                            excelConfig: {
                                fullPath: result.filePath,
                                name: "[" + this.fullKey + "] Default.xlsx"
                            },
                            excelColumns: excelColumns
                        });
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        }); };
        this.newTemplate = function () {
            _this.notifyService.confirmWithInput(_this.translateService.translate('Enter your template name')).then(function (fileName) { return __awaiter(_this, void 0, void 0, function () {
                var exportableColumns, result, excelConfig;
                var _this = this;
                var _a, _b, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            this.loadingService.start();
                            fileName = fileName + '.xlsx';
                            _d.label = 1;
                        case 1:
                            _d.trys.push([1, , 3, 4]);
                            if ((_b = (_a = this).validator) === null || _b === void 0 ? void 0 : _b.call(_a, fileName)) {
                                this.notifyService.notify.warning(this.validator(fileName));
                                return [2 /*return*/];
                            }
                            exportableColumns = this.exportableColumns.filter(function (column) { return _this.selected[column.field]; });
                            if (!exportableColumns.length) {
                                exportableColumns = this.exportableColumns;
                            }
                            return [4 /*yield*/, this.generateAndUploadTemplate(exportableColumns, fileName)];
                        case 2:
                            result = _d.sent();
                            if ((_c = result) === null || _c === void 0 ? void 0 : _c.filePath) {
                                excelConfig = {
                                    fullPath: result.filePath,
                                    name: result.fileName,
                                    removable: true
                                };
                                this.excelConfigs.push(excelConfig);
                                this.onExportByTemplate(excelConfig);
                            }
                            return [3 /*break*/, 4];
                        case 3:
                            this.loadingService.stop();
                            return [7 /*endfinally*/];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
        };
        this.onChangeRadio = function (matRadioChange) {
            var selectedExcelConfig = _this.excelConfigs.find(function (e) { return e.name === matRadioChange.value; });
            if (!selectedExcelConfig) {
                _this.selectedExcelConfig = {
                    name: _this.newExcelConfig
                };
            }
            else {
                _this.selectedExcelConfig = selectedExcelConfig;
            }
            _this.exportableColumns = __spread(_this.columns, (_this.extendColumns || [])).filter(function (e) { return e.type !== 'image'; });
            _this.selected = {};
        };
    }
    Object.defineProperty(GridPopupExportExcelComponent.prototype, "fullKey", {
        get: function () {
            if (!this.key) {
                return '';
            }
            return hash({
                prefix: this.prefix,
                key: this.key
            });
        },
        enumerable: true,
        configurable: true
    });
    GridPopupExportExcelComponent.prototype.ngOnInit = function () {
    };
    GridPopupExportExcelComponent.prototype.ngAfterViewInit = function () {
    };
    GridPopupExportExcelComponent.prototype.open = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!!this.fullKey) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.exportDefault()];
                    case 1:
                        _c.sent();
                        return [2 /*return*/];
                    case 2: return [4 /*yield*/, this.loadConfiguration()];
                    case 3:
                        _c.sent();
                        this.exportableColumns = __spread(this.columns, (this.extendColumns || [])).filter(function (e) { return e.type !== 'image'; });
                        this.selected = {};
                        if (!((_a = this.selectedExcelConfig) === null || _a === void 0 ? void 0 : _a.name)) {
                            if (((_b = this.excelConfigs) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                                this.selectedExcelConfig = this.excelConfigs[0];
                            }
                            else {
                                this.selectedExcelConfig = {
                                    name: this.newExcelConfig
                                };
                            }
                        }
                        this.modal.open();
                        this.ref.detectChanges();
                        return [2 /*return*/];
                }
            });
        });
    };
    GridPopupExportExcelComponent.prototype.loadConfiguration = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.excelConfigs = [];
                        _a = this;
                        return [4 /*yield*/, this.excelService.getFiles(this.fullKey)];
                    case 1:
                        _a.excelConfigs = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GridPopupExportExcelComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: LoadingService },
        { type: ExcelService },
        { type: NotifyService },
        { type: TranslateService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], GridPopupExportExcelComponent.prototype, "modal", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "key", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "columns", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "extendColumns", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "fileName", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "validator", void 0);
    __decorate([
        Input()
    ], GridPopupExportExcelComponent.prototype, "exportOption", void 0);
    __decorate([
        Output()
    ], GridPopupExportExcelComponent.prototype, "exportByTemplate", void 0);
    GridPopupExportExcelComponent = __decorate([
        Component({
            selector: 'sd-grid-popup-export-excel',
            template: "<sd-modal-control width=\"sm\" [title]=\"'Export excel' | sdTranslate\" #modal>\r\n  <sd-modal-body>\r\n    <mat-radio-group class=\"c-radio-group\" [ngModel]=\"selectedExcelConfig.name\" (change)=\"onChangeRadio($event)\">\r\n      <mat-radio-button class=\"c-radio-button\" *ngFor=\"let excelConfig of excelConfigs\" [value]=\"excelConfig.name\"\r\n        color=\"primary\">\r\n        {{excelConfig.name}}\r\n      </mat-radio-button>\r\n      <mat-radio-button class=\"c-radio-button\" [value]=\"newExcelConfig\" color=\"accent\">\r\n        {{'New template' | sdTranslate}}\r\n      </mat-radio-button>\r\n    </mat-radio-group>\r\n    <div *ngIf=\"selectedExcelConfig.name === newExcelConfig\">\r\n      <mat-chip-list selectable=\"true\" multiple=\"true\">\r\n        <ng-container *ngFor=\"let column of exportableColumns\">\r\n          <mat-chip [selected]=\"selected[column.field]\" (click)=\"selected[column.field] = !selected[column.field]\">\r\n            {{column.title}}\r\n          </mat-chip>\r\n        </ng-container>\r\n      </mat-chip-list>\r\n    </div>\r\n  </sd-modal-body>\r\n  <sd-modal-footer>\r\n    <ng-container *sdDesktop>\r\n      <div class=\"float-right\" *ngIf=\"selectedExcelConfig && selectedExcelConfig.name !== newExcelConfig\">\r\n        <sd-button *ngIf=\"selectedExcelConfig.removable\" class=\"mr-5\" [title]=\"'Delete' | sdTranslate\" icon=\"delete\"\r\n          (action)=\"removeTemplate(selectedExcelConfig)\" size=\"sm\">\r\n        </sd-button>\r\n        <sd-button [title]=\"'Export' | sdTranslate\" icon=\"get_app\" (action)=\"onExportByTemplate(selectedExcelConfig)\"\r\n          size=\"sm\" color=\"primary\">\r\n        </sd-button>\r\n      </div>\r\n      <div class=\"float-right\" *ngIf=\"selectedExcelConfig?.name === newExcelConfig\">\r\n        <sd-button [title]=\"'Add template' | sdTranslate\" icon=\"add\" (action)=\"uploadTemplate()\" size=\"sm\">\r\n        </sd-button>\r\n        <sd-button [title]=\"'Download' | sdTranslate\" icon=\"get_app\" (action)=\"newTemplate()\" size=\"sm\" color=\"primary\">\r\n        </sd-button>\r\n      </div>\r\n    </ng-container>\r\n    <ng-container *sdMobileTablet>\r\n      <ng-container *ngIf=\"selectedExcelConfig && selectedExcelConfig.name !== newExcelConfig\">\r\n        <sd-button *ngIf=\"selectedExcelConfig.removable\" style=\"flex: 1; padding-right: 5px;\"\r\n          [title]=\"'Delete' | sdTranslate\" icon=\"delete\" (action)=\"removeTemplate(selectedExcelConfig)\" size=\"sm\"\r\n          width=\"100%\">\r\n        </sd-button>\r\n        <sd-button style=\"flex: 1;\" [ngClass]=\"{'pl-5':selectedExcelConfig.removable}\" [title]=\"'Export' | sdTranslate\"\r\n          icon=\"get_app\" (action)=\"onExportByTemplate(selectedExcelConfig)\" size=\"sm\" color=\"primary\" width=\"100%\">\r\n        </sd-button>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"selectedExcelConfig?.name === newExcelConfig\">\r\n        <sd-button style=\"flex: 1; padding-right: 5px;\" [title]=\"'Add template' | sdTranslate\" icon=\"add\"\r\n          (action)=\"uploadTemplate()\" size=\"sm\" width=\"100%\">\r\n        </sd-button>\r\n        <sd-button style=\"flex: 1; padding-left: 5px;\" [title]=\"'Download' | sdTranslate\" icon=\"get_app\"\r\n          (action)=\"newTemplate()\" size=\"sm\" color=\"primary\" width=\"100%\">\r\n        </sd-button>\r\n      </ng-container>\r\n    </ng-container>\r\n  </sd-modal-footer>\r\n</sd-modal-control>",
            styles: ["", ".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ".c-radio-group{display:flex;flex-direction:column;margin:15px 0}.c-radio-button{margin:5px}"]
        })
    ], GridPopupExportExcelComponent);
    return GridPopupExportExcelComponent;
}());

var InputTooltipPipe = /** @class */ (function () {
    function InputTooltipPipe() {
    }
    InputTooltipPipe.prototype.transform = function (value, tooltip) {
        if (typeof (tooltip) === 'string') {
            return tooltip;
        }
        return tooltip(value);
    };
    InputTooltipPipe = __decorate([
        Pipe({
            name: 'inputTooltipPipe'
        })
    ], InputTooltipPipe);
    return InputTooltipPipe;
}());

var CellMobileClassNamePipe = /** @class */ (function () {
    function CellMobileClassNamePipe() {
    }
    CellMobileClassNamePipe.prototype.transform = function (value, rowData, column) {
        var classNames = [];
        if (column.click) {
            classNames.push('cursor-pointer');
        }
        if (column.badge) {
            var badge = column.badge(rowData, value);
            if (badge) {
                classNames.push('badge');
                classNames.push('c-badge');
                if (badge === 'PRIMARY') {
                    classNames.push('badge-primary');
                }
                else if (badge === 'SECONDARY') {
                    classNames.push('badge-secondary');
                }
                else if (badge === 'WARNING') {
                    classNames.push('badge-warning');
                }
                else if (badge === 'SUCCESS') {
                    classNames.push('badge-success');
                }
                else if (badge === 'DANGER') {
                    classNames.push('badge-danger');
                }
                else if (badge === 'LIGHT') {
                    classNames.push('badge-light');
                }
                else if (badge === 'DARK') {
                    classNames.push('badge-dark');
                }
            }
        }
        return classNames.join(' ');
    };
    CellMobileClassNamePipe = __decorate([
        Pipe({
            name: 'cellMobileClassName'
        })
    ], CellMobileClassNamePipe);
    return CellMobileClassNamePipe;
}());

var ValueTransformPipe = /** @class */ (function () {
    function ValueTransformPipe() {
    }
    // tslint:disable-next-line: max-line-length
    ValueTransformPipe.prototype.transform = function (value, rowData, column) {
        if (column.transform) {
            return column.transform(value, rowData);
        }
        return value;
    };
    ValueTransformPipe = __decorate([
        Pipe({
            name: 'valueTransform'
        })
    ], ValueTransformPipe);
    return ValueTransformPipe;
}());

var EditorSubInformationHandlerPipe = /** @class */ (function () {
    function EditorSubInformationHandlerPipe() {
    }
    EditorSubInformationHandlerPipe.prototype.transform = function (value, item, columns) {
        var e_1, _a;
        var visible = function (column) {
            if (column.type === 'children') {
                return false;
            }
            var isDisabled = false;
            // Kiểm tra xem có bị disabled hay không?
            if (column.editor) {
                isDisabled = typeof (column.editor.disabled) === 'function' ? column.editor.disabled(item) : column.editor.disabled;
            }
            // Nếu bị disabled return false
            if (isDisabled) {
                return false;
            }
            // Nếu bị disabled return false
            if (isDisabled) {
                return false;
            }
            // Hiển thị editor nếu dòng đó:
            // Đang được edit: editingStatus
            return item.editingStatus
                // Được thiết lập alwayDisplay
                || (column.editor && column.editor.alwayDisplay);
        };
        item.editorHandler = item.editorHandler || {};
        try {
            for (var columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                var column = columns_1_1.value;
                item.editorHandler.disabled = false;
                item.editorHandler[column.field] = {};
                if (item.editorHandler.disabled) {
                    item.editorHandler[column.field].visible = false;
                }
                else {
                    item.editorHandler[column.field].visible = visible(column);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (columns_1_1 && !columns_1_1.done && (_a = columns_1.return)) _a.call(columns_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    EditorSubInformationHandlerPipe = __decorate([
        Pipe({
            name: 'editorSubInformationHandler'
        })
    ], EditorSubInformationHandlerPipe);
    return EditorSubInformationHandlerPipe;
}());

var SafeHtmlPipe = /** @class */ (function () {
    function SafeHtmlPipe(sanitizer) {
        this.sanitizer = sanitizer;
    }
    SafeHtmlPipe.prototype.transform = function (html) {
        return this.sanitizer.bypassSecurityTrustHtml(html);
    };
    SafeHtmlPipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    SafeHtmlPipe = __decorate([
        Pipe({
            name: 'safeHtml',
        })
    ], SafeHtmlPipe);
    return SafeHtmlPipe;
}());

var GridDesktopColumnViewComponent = /** @class */ (function () {
    function GridDesktopColumnViewComponent() {
    }
    __decorate([
        Input()
    ], GridDesktopColumnViewComponent.prototype, "column", void 0);
    __decorate([
        Input()
    ], GridDesktopColumnViewComponent.prototype, "item", void 0);
    GridDesktopColumnViewComponent = __decorate([
        Component({
            selector: 'sd-grid-desktop-column-view',
            template: "<ng-container *ngIf=\"column && item\">\r\n  <ng-container *ngIf=\"column.htmlTemplate;else useDefaultView\">\r\n    <div [innerHTML]=\"(item[column.field] | columnHtmlTemplate:item:column.htmlTemplate) | safeHtml\">\r\n    </div>\r\n  </ng-container>\r\n  <ng-template #useDefaultView>\r\n    <div *ngIf=\"column.type === 'string'\">\r\n      <span [className]=\"item[column.field] | cellDesktopClassName:item:column\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[column.field]}\">\r\n        <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n          (click)=\"column.click(item[column.field], item)\">{{item[column.field]}}</a>\r\n        <ng-container *ngIf=\"!column.click\">{{item[column.field]}}</ng-container>\r\n      </span>\r\n      <ng-container *ngIf=\"column.commands | columnCommandFilter:item | async; $implicit as filteredColumnCommands\">\r\n        <button *ngFor=\"let columnCommand of filteredColumnCommands\" (click)=\"columnCommand.click(item)\" type=\"button\"\r\n          class=\"c-btn-icon\" [matTooltip]=\"columnCommand.title | commandTitle:item\">\r\n          <i class=\"{{columnCommand.icon | commandIcon:item}}\" aria-hidden=\"true\"></i>\r\n        </button>\r\n      </ng-container>\r\n    </div>\r\n    <div *ngIf=\"column.type === 'color'\">\r\n      <input disabled=\"true\" type=\"color\" class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"\r\n        (change)=\"column.editor?.change && column.editor?.change(item)\">\r\n    </div>\r\n    <div *ngIf=\"column.type === 'number'\">\r\n      <span [className]=\"item[column.field] | cellDesktopClassName:item:column\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[column.field]}\">\r\n        <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n          (click)=\"column.click(item[column.field], item)\">{{(item[column.field] | valueTransform:item:column) | number : '1.0-2'}}</a>\r\n        <ng-container *ngIf=\"!column.click\">\r\n          {{(item[column.field] | valueTransform:item:column) | number : '1.0-2'}}</ng-container>\r\n      </span>\r\n    </div>\r\n    <div class=\"text-center\" *ngIf=\"column.type === 'date'\">\r\n      {{item[column.field] | date:'dd/MM/yyyy'}}\r\n    </div>\r\n    <div class=\"text-center\" *ngIf=\"column.type === 'datetime'\">\r\n      {{item[column.field] | date:'dd/MM/yyyy HH:mm'}}\r\n    </div>\r\n    <div class=\"text-center\" *ngIf=\"column.type === 'time'\">\r\n      {{item[column.field] | date:'HH:mm'}}\r\n    </div>\r\n    <div class=\"align-middle text-center\" *ngIf=\"column.type === 'bool'\">\r\n      <span *ngIf=\"!item.editorHandler[column.field].visible && item[column.field]\"\r\n        class=\"status status-success\">{{column.trueValue || 'True'}}</span>\r\n      <span *ngIf=\"!item.editorHandler[column.field].visible && !item[column.field]\"\r\n        class=\"status status-danger\">{{column.falseValue || 'False'}}</span>\r\n    </div>\r\n    <div *ngIf=\"column.type === 'values'\">\r\n      <ng-container *ngIf=\"column?.dictionary[item[column.field]] as dic; else elseNotInDic\">\r\n        <div *ngIf=\"dic.color || dic.backgroundColor; else elseNoStatus\" class=\"status\"\r\n          [ngStyle]=\"{'color':dic.color, 'background-color': dic.backgroundColor}\">\r\n          {{dic.text}}\r\n        </div>\r\n        <ng-template #elseNoStatus>\r\n          <div class=\"text-left\">\r\n            {{dic.text}}\r\n          </div>\r\n        </ng-template>\r\n      </ng-container>\r\n      <ng-template #elseNotInDic>\r\n        <div class=\"text-left\">\r\n          {{item[column.field]}}\r\n        </div>\r\n      </ng-template>\r\n    </div>\r\n    <div *ngIf=\"column.type === 'radio'\">\r\n      {{item[column.field]}}\r\n    </div>\r\n    <div class=\"align-middle text-center\" *ngIf=\"column.type === 'image'\">\r\n      <img *ngIf=\"item[column.field]\" [src]=\"item[column.field]\" [width]=\"column.display?.width\"\r\n        [height]=\"column.display?.height\" style=\"margin: 5px 0\"\r\n        (click)=\"column.click && column.click(item[column.field], item)\" [ngClass]=\"{'c-clickable':column.click}\">\r\n      <i *ngIf=\"!item[column.field]\" class=\"fa fa-picture-o fa-fw c-img\"\r\n        [ngClass]=\"{'c-clickable':column.click}\" (click)=\"column.click && column.click(item[column.field], item)\"></i>\r\n    </div>\r\n  </ng-template>\r\n</ng-container>",
            styles: [".c-badge{display:block!important;border-radius:10rem;padding:.3rem!important;font-weight:500;font-size:12px;max-width:80%;margin:0 auto}.c-badge a{color:#fff}.status{font-weight:500;padding:4px 8px;border-radius:1.5rem;display:inline-block;text-align:center;text-transform:uppercase;width:100%}.status-success{color:#00bc3c}.status-danger{color:#f5222d}.c-btn-icon{background:0 0!important;border:none;opacity:.8;height:20px;display:inline-flex;padding:0 3px}.c-btn-icon:hover{cursor:pointer;opacity:1}.c-btn-icon:disabled{background:0 0!important;border:none;cursor:not-allowed;opacity:.3}.c-clickable{cursor:pointer}.c-img{font-size:50px;opacity:.5}.c-img.c-clickable:hover{opacity:.9}"]
        })
    ], GridDesktopColumnViewComponent);
    return GridDesktopColumnViewComponent;
}());

var GridDesktopColumnEditComponent = /** @class */ (function () {
    function GridDesktopColumnEditComponent(ref) {
        var _this = this;
        this.ref = ref;
        this.sdChange = new EventEmitter();
        this.onEditorChange = function (column, item, value) {
            var _a, _b, _c;
            if (column.type !== 'children') {
                (_c = (_a = column.editor) === null || _a === void 0 ? void 0 : (_b = _a).change) === null || _c === void 0 ? void 0 : _c.call(_b, item, value);
                _this.ref.detectChanges();
                _this.sdChange.emit();
            }
        };
        this.onSearch = function (searchValue, item, column) {
            item[column.field] = searchValue;
        };
    }
    GridDesktopColumnEditComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], GridDesktopColumnEditComponent.prototype, "column", void 0);
    __decorate([
        Input()
    ], GridDesktopColumnEditComponent.prototype, "item", void 0);
    __decorate([
        Output()
    ], GridDesktopColumnEditComponent.prototype, "sdChange", void 0);
    GridDesktopColumnEditComponent = __decorate([
        Component({
            selector: 'sd-grid-desktop-column-edit',
            template: "<ng-container *ngIf=\"column && item\">\r\n  <div *ngIf=\"column.type === 'string'\">\r\n    <div *ngIf=\"column.editor?.item;else elseUseInput\">\r\n      <ng-container *ngIf=\"column.editor.autocomplete; else elseUseSelect\">\r\n        <sd-grid-autocomplete-control *ngIf=\"column.editor.item.type === 'dependent'\"\r\n          [items]=\"item[column.editor.item.dependOnField] | editorDynamicItem:item:column.editor.item | async\"\r\n          [valueField]=\"column.editor.item.value\" [displayField]=\"column.editor.item.display\"\r\n          [(model)]=\"item[column.field]\" (sdChange)=\"onEditorChange(column,item,$event)\"\r\n          (search)=\"onSearch($event, item, column)\">\r\n        </sd-grid-autocomplete-control>\r\n        <sd-grid-autocomplete-control *ngIf=\"column.editor.item.type === 'default'\"\r\n          [items]=\"'' | editorDynamicItem:item:column.editor.item | async\" [valueField]=\"column.editor.item.value\"\r\n          [displayField]=\"column.editor.item.display\" [(model)]=\"item[column.field]\"\r\n          (sdChange)=\"onEditorChange(column,item,$event)\">\r\n        </sd-grid-autocomplete-control>\r\n      </ng-container>\r\n      <ng-template #elseUseSelect>\r\n        <select *ngIf=\"column.editor.item.type === 'dependent'\" class=\"form-control form-control-sm\"\r\n          [(ngModel)]=\"item[column.field]\" (change)=\"onEditorChange(column,item,item[column.field])\">\r\n          <ng-container\r\n            *ngIf=\"item[column.editor.item.dependOnField] | editorDynamicItem:item:column.editor.item | async; let dynamicItems\">\r\n            <ng-container *ngIf=\"dynamicItems?.subscribe;else elseIsArray\">\r\n              <option *ngFor=\"let data of dynamicItems | async\" [value]=\"data[column.editor.item.value]\">\r\n                {{data[column.editor.item.display]}}\r\n              </option>\r\n            </ng-container>\r\n            <ng-template #elseIsArray>\r\n              <option *ngFor=\"let data of (dynamicItems || [])\" [value]=\"data[column.editor.item.value]\">\r\n                {{data[column.editor.item.display]}}\r\n              </option>\r\n            </ng-template>\r\n          </ng-container>\r\n        </select>\r\n        <select *ngIf=\"column.editor.item?.type === 'default'\" class=\"form-control form-control-sm\"\r\n          [(ngModel)]=\"item[column.field]\" (change)=\"onEditorChange(column,item,item[column.field])\">\r\n          <ng-container *ngIf=\"'' | editorDynamicItem:item:column.editor.item | async; let dynamicItems\">\r\n            <option *ngFor=\"let data of dynamicItems\" [value]=\"data[column.editor.item.value]\">\r\n              {{data[column.editor.item.display]}}\r\n            </option>\r\n          </ng-container>\r\n        </select>\r\n      </ng-template>\r\n    </div>\r\n    <ng-template #elseUseInput>\r\n      <div class=\"input-group\">\r\n        <input class=\"form-control form-control-sm\" [ngClass]=\"{'border-right-0':column.editor && column.editor.click}\"\r\n          [(ngModel)]=\"item[column.field]\" (keyup.enter)=\"column.editor?.keyupEnter && column.editor?.keyupEnter(item)\"\r\n          (change)=\"onEditorChange(column,item,item[column.field])\">\r\n        <div *ngIf=\"column.editor?.click\" class=\"input-group-append cursor-pointer\">\r\n          <span class=\"input-group-text border-0 py-0 px-1\" style=\"background:#FFF\" (click)=\"column.editor.click(item)\">\r\n            <i class=\"fa fa-search\"></i>\r\n          </span>\r\n        </div>\r\n      </div>\r\n    </ng-template>\r\n  </div>\r\n  <div *ngIf=\"column.type === 'color'\">\r\n    <input type=\"color\" class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"\r\n      (change)=\"onEditorChange(column,item,item[column.field])\">\r\n  </div>\r\n  <div *ngIf=\"column.type === 'number'\">\r\n    <input type=\"number\" class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"\r\n      (keyup.Enter)=\"column.editor?.keyupEnter && column.editor?.keyupEnter(item)\"\r\n      (change)=\"onEditorChange(column,item,item[column.field])\">\r\n  </div>\r\n  <div *ngIf=\"column.type === 'date'\">\r\n    <sd-grid-date-picker-control [(model)]=\"item[column.field]\" type=\"date\"></sd-grid-date-picker-control>\r\n  </div>\r\n  <div class=\"text-center\" *ngIf=\"column.type === 'datetime'\">\r\n    <sd-grid-date-picker-control [(model)]=\"item[column.field]\" type=\"datetime\"></sd-grid-date-picker-control>\r\n  </div>\r\n  <div class=\"text-center\" *ngIf=\"column.type === 'time'\">\r\n    <sd-grid-date-picker-control [(model)]=\"item[column.field]\" type=\"time\"></sd-grid-date-picker-control>\r\n  </div>\r\n  <div class=\"align-middle text-center\" *ngIf=\"column.type === 'bool'\">\r\n    <sd-switch-control [(model)]=\"item[column.field]\" (sdChange)=\"onEditorChange(column,item,item[column.field])\">\r\n    </sd-switch-control>\r\n    <!-- <mat-slide-toggle [(ngModel)]=\"item[column.field]\"\r\n      (change)=\"onEditorChange(column,item,item[column.field])\" color=\"primary\">\r\n    </mat-slide-toggle> -->\r\n  </div>\r\n  <div *ngIf=\"column.type === 'values'\">\r\n    <ng-container *ngIf=\"column.editor?.autocomplete;else elseUseSelect\">\r\n      <ng-container *ngIf=\"column.editor.item;else elseUseValues\">\r\n        <sd-grid-autocomplete-control *ngIf=\"column.editor.item.type === 'dependent'\"\r\n          [items]=\"item[column.editor.item.dependOnField] | editorDynamicItem:item:column.editor.item | async\"\r\n          [valueField]=\"column.editor.item.value\" [displayField]=\"column.editor.item.display\"\r\n          [(model)]=\"item[column.field]\" (sdChange)=\"onEditorChange(column,item,$event)\"\r\n          (search)=\"onSearch($event, item, column)\">\r\n        </sd-grid-autocomplete-control>\r\n        <sd-grid-autocomplete-control *ngIf=\"column.editor.item.type === 'default'\"\r\n          [items]=\"'' | editorDynamicItem:item:column.editor.item | async\" [valueField]=\"column.editor.item.value\"\r\n          [displayField]=\"column.editor.item.display\" [(model)]=\"item[column.field]\"\r\n          (sdChange)=\"onEditorChange(column,item,$event)\">\r\n        </sd-grid-autocomplete-control>\r\n      </ng-container>\r\n      <ng-template #elseUseValues>\r\n        <sd-grid-autocomplete-control [items]=\"column.values\" valueField=\"value\" displayField=\"text\"\r\n          [(model)]=\"item[column.field]\" (sdChange)=\"onEditorChange(column,item,$event)\">\r\n        </sd-grid-autocomplete-control>\r\n      </ng-template>\r\n    </ng-container>\r\n    <ng-template #elseUseSelect>\r\n      <ng-container *ngIf=\"column.editor?.item;else elseUseValues\">\r\n        <select *ngIf=\"column.editor.item.type === 'dependent'\" class=\"form-control form-control-sm\"\r\n          [(ngModel)]=\"item[column.field]\" (change)=\"onEditorChange(column,item,$event)\">\r\n          <option value=\"\">{{'Please select' | sdTranslate}}</option>\r\n          <ng-container *ngIf=\"item[column.editor.item.dependOnField] | editorDynamicItem:item:column.editor.item\r\n             | async; let dynamicItems\">\r\n            <ng-container *ngIf=\"dynamicItems?.subscribe;else elseIsArray\">\r\n              <option *ngFor=\"let data of dynamicItems | async\" [value]=\"data[column.editor.item.value]\">\r\n                {{data[column.editor.item.display]}}\r\n              </option>\r\n            </ng-container>\r\n            <ng-template #elseIsArray>\r\n              <option *ngFor=\"let data of (dynamicItems || [])\" [value]=\"data[column.editor.item.value]\">\r\n                {{data[column.editor.item.display]}}\r\n              </option>\r\n            </ng-template>\r\n          </ng-container>\r\n        </select>\r\n        <select *ngIf=\"column.editor.item?.type === 'default'\" class=\"form-control form-control-sm\"\r\n          [(ngModel)]=\"item[column.field]\" (change)=\"onEditorChange(column,item,item[column.field])\">\r\n          <ng-container *ngIf=\"'' | editorDynamicItem:item:column.editor.item | async; let dynamicItems\">\r\n            <option *ngFor=\"let data of dynamicItems\" [value]=\"data[column.editor.item.value]\">\r\n              {{data[column.editor.item.display]}}\r\n            </option>\r\n          </ng-container>\r\n        </select>\r\n      </ng-container>\r\n      <ng-template #elseUseValues>\r\n        <select class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"\r\n          (change)=\"column.editor?.change && column.editor.change(item)\">\r\n          <option value=\"\">{{'Please select' | sdTranslate}}</option>\r\n          <option *ngFor=\"let data of column.values\" [value]=\"data.value\">{{data.text}}\r\n          </option>\r\n        </select>\r\n      </ng-template>\r\n    </ng-template>\r\n  </div>\r\n  <div *ngIf=\"column.type === 'radio'\">\r\n    <section class=\"mt-2 ml-3\" style=\"align-content: center; align-items: center;\">\r\n      <mat-radio-group style=\"display: flex\" [(ngModel)]=\"item[column.field]\"\r\n        (change)=\"column.editor?.change && column.editor?.change(item)\">\r\n        <mat-radio-button *ngIf=\"!column.editor?.required\" color=\"warn\" class=\"mr-2\" value=\"\">\r\n          {{'Please select' | sdTranslate}}\r\n        </mat-radio-button>\r\n        <mat-radio-button color=\"primary\" class=\"mr-2\" *ngFor=\"let data of column.values\"\r\n          [value]=\"data[column.valueField]\">\r\n          {{data[column.displayField]}}\r\n        </mat-radio-button>\r\n      </mat-radio-group>\r\n    </section>\r\n  </div>\r\n  <div class=\"align-middle text-center\" *ngIf=\"column.type === 'image'\">\r\n    <img [src]=\"item[column.field]\" [width]=\"column.display?.width\" [height]=\"column.display?.height\"\r\n      style=\"margin: 5px 0\" (click)=\"column.click && column.click(item[column.field], item)\">\r\n  </div>\r\n</ng-container>",
            changeDetection: ChangeDetectionStrategy.OnPush,
            styles: ["", "", ".c-input-xs{font-size:13px!important;line-height:1.5!important;padding:3px!important;height:28px!important}"]
        })
    ], GridDesktopColumnEditComponent);
    return GridDesktopColumnEditComponent;
}());

var GridDesktopInlineFilterComponent = /** @class */ (function () {
    function GridDesktopInlineFilterComponent() {
        var _this = this;
        this.externalFilters = [];
        this.columns = [];
        this.externalFilter = {};
        this.filter = {};
        this.inlineExternal = {};
        this.inlineColumn = {};
        this.sdChange = new EventEmitter();
        this.displayKey = 'SDCUSTOM';
        this.onUpdateFilter = function () {
            _this.sdChange.emit();
        };
    }
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "externalFilters", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "columns", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "externalFilter", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "filter", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "columnInline", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "inlineExternal", void 0);
    __decorate([
        Input()
    ], GridDesktopInlineFilterComponent.prototype, "inlineColumn", void 0);
    __decorate([
        Output()
    ], GridDesktopInlineFilterComponent.prototype, "sdChange", void 0);
    GridDesktopInlineFilterComponent = __decorate([
        Component({
            selector: 'sd-grid-desktop-inline-filter',
            template: "<div class=\"row mx-n8\">\r\n  <ng-container *ngIf=\"externalFilters?.length\">\r\n    <ng-container *ngFor=\"let item of externalFilters\">\r\n      <ng-container *ngIf=\"(inlineExternal[item.field] || inlineExternal[item.field] === undefined) && item.priority !== 'low'\">\r\n        <div *ngIf=\"item.type !=='daterange' && item.type !=='numberrange';else elseFilterRange\"\r\n          class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n          <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'string'\" type=\"text\"\r\n            [(model)]=\"externalFilter[item.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n          </sd-input-control>\r\n          <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'number'\" type=\"number\"\r\n            [(model)]=\"externalFilter[item.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n          </sd-input-control>\r\n          <sd-select-control [label]=\"item.title\" *ngIf=\"item.type === 'bool'\" [items]=\"[{value:'1',display:item.trueValue || 'True' },\r\n          {value:'0',display:item.falseValue || 'False' }]\" valueField=\"value\" displayField=\"display\"\r\n            [(model)]=\"externalFilter[item.field]\" (sdChange)=\"onUpdateFilter()\">\r\n          </sd-select-control>\r\n          <sd-radio-control [label]=\"item.title\" *ngIf=\"item.type === 'radio'\" [items]=\"item.values\"\r\n            [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\"\r\n            (sdChange)=\"onUpdateFilter()\">\r\n          </sd-radio-control>\r\n          <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'custom'\"\r\n            [(model)]=\"externalFilter[displayKey + item.field]\"\r\n            (sdFocusForceBlur)=\"item?.onClick(externalFilter, item.field, displayKey + item.field)\"\r\n            (sdChange)=\"onUpdateFilter()\">\r\n          </sd-input-control>\r\n          <ng-container *ngIf=\"item.type === 'values'\">\r\n            <sd-select-control *ngIf=\"item.selection === 'MULTIPLE'\" [label]=\"item.title\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\"\r\n              (sdChange)=\"onUpdateFilter()\" multiple=\"true\">\r\n            </sd-select-control>\r\n            <sd-autocomplete-control *ngIf=\"item.selection === 'AUTOCOMPLETE'\" [label]=\"item.title\"\r\n              [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n              [(model)]=\"externalFilter[item.field]\" (sdChange)=\"onUpdateFilter()\">\r\n            </sd-autocomplete-control>\r\n            <sd-chip-control *ngIf=\"item.selection === 'MULTIPLEAUTOCOMPLETE'\" [label]=\"item.title\"\r\n              [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n              [(model)]=\"externalFilter[item.field]\" (sdChange)=\"onUpdateFilter()\">\r\n            </sd-chip-control>\r\n            <sd-select-control *ngIf=\"!item.selection\" [label]=\"item.title\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.field]\"\r\n              (sdChange)=\"onUpdateFilter()\">\r\n            </sd-select-control>\r\n          </ng-container>\r\n          <sd-date-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='date'\"\r\n            [(model)]=\"externalFilter[item.field]\" type=\"date\" (sdChange)=\"onUpdateFilter()\">\r\n          </sd-date-picker-control>\r\n          <sd-date-range-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='daterangefull'\"\r\n            [(fromDate)]=\"externalFilter[item.field].from\" [(toDate)]=\"externalFilter[item.field].to\"\r\n            [minDate]=\"item.minDate\" [maxDate]=\"item.maxDate\" type=\"date\" (sdChange)=\"onUpdateFilter()\">\r\n          </sd-date-range-picker-control>\r\n        </div>\r\n        <ng-template #elseFilterRange>\r\n          <ng-container *ngIf=\"item.type ==='daterange' && externalFilter[item.field]\">\r\n            <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n              <sd-date-picker-control [label]=\"item.fromTitle\" [(model)]=\"externalFilter[item.field].from\"\r\n                [type]=\"item.enableTime ? 'datetime' : 'date'\" [minDate]=\"item.minDate\"\r\n                [maxDate]=\"externalFilter[item.field].to || item.maxDate\" (sdChange)=\"onUpdateFilter()\">\r\n              </sd-date-picker-control>\r\n            </div>\r\n            <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n              <sd-date-picker-control [label]=\"item.toTitle\" [(model)]=\"externalFilter[item.field].to\"\r\n                [type]=\"item.enableTime ? 'datetime' : 'date'\"\r\n                [minDate]=\"item.minDate || externalFilter[item.field].from\" [maxDate]=\"item.maxDate\"\r\n                (sdChange)=\"onUpdateFilter()\">\r\n              </sd-date-picker-control>\r\n            </div>\r\n          </ng-container>\r\n          <ng-container *ngIf=\"item.type ==='numberrange' && externalFilter[item.field]\">\r\n            <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n              <sd-input-control [label]=\"item.fromTitle\" type=\" number\" [(model)]=\"externalFilter[item.field].from\"\r\n                (sdChange)=\"onUpdateFilter()\">\r\n              </sd-input-control>\r\n            </div>\r\n            <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n              <sd-input-control [label]=\"item.toTitle\" type=\" number\" [(model)]=\"externalFilter[item.field].to\"\r\n                (sdChange)=\"onUpdateFilter()\">\r\n              </sd-input-control>\r\n            </div>\r\n          </ng-container>\r\n        </ng-template>\r\n      </ng-container>\r\n    </ng-container>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"columns?.length && columnInline === 'outside'\">\r\n    <ng-container *ngFor=\"let item of columns\">\r\n      <ng-container *ngIf=\"item.type !== 'children' && item.type !== 'image' && !item?.filter?.disabled && item.priority !== 'low'\">\r\n        <ng-container *ngIf=\"inlineColumn[item.field] || inlineColumn[item.field] === undefined\">\r\n          <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n            <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'string'\" type=\"text\"\r\n              [(model)]=\"filter[item.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n            </sd-input-control>\r\n            <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'number'\" type=\"number\"\r\n              [(model)]=\"filter[item.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n            </sd-input-control>\r\n            <sd-radio-control [label]=\"item.title\" *ngIf=\"item.type === 'bool'\" [items]=\"[{value:'1',display:item.trueValue || 'True' },\r\n          {value:'0',display:item.falseValue || 'False' }]\" valueField=\"value\" displayField=\"display\"\r\n              [(model)]=\"filter[item.field]\" (sdChange)=\"onUpdateFilter()\">\r\n            </sd-radio-control>\r\n            <sd-select-control [label]=\"item.title\" *ngIf=\"item.type === 'radio'\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"filter[item.field]\"\r\n              (sdChange)=\"onUpdateFilter()\">\r\n            </sd-select-control>\r\n            <sd-select-control *ngIf=\"item.type === 'values' && !item?.editor?.autocomplete\" [label]=\"item.title\"\r\n              [items]=\"item.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[item.field]\"\r\n              (sdChange)=\"onUpdateFilter()\">\r\n            </sd-select-control>\r\n            <sd-autocomplete-control *ngIf=\"item.type === 'values' && item?.editor?.autocomplete\" [items]=\"item.values\"\r\n              valueField=\"value\" displayField=\"text\" [(model)]=\"filter[item.field]\" (sdChange)=\"onUpdateFilter()\">\r\n            </sd-autocomplete-control>\r\n            <sd-date-picker-control *ngIf=\"item.type === 'date' || item.type === 'datetime' || item.type === 'time'\"\r\n              [label]=\"item.title\" [(model)]=\"filter[item.field]\" type=\"date\" (sdChange)=\"onUpdateFilter()\">\r\n            </sd-date-picker-control>\r\n          </div>\r\n        </ng-container>\r\n      </ng-container>\r\n      <ng-container\r\n        *ngIf=\"item.type === 'children' && item.children?.length && !item?.filter?.disabled && item.priority !== 'low'\">\r\n        <ng-container *ngFor=\"let childColumn of item.children\">\r\n          <ng-container *ngIf=\"inlineColumn[childColumn.field] && !childColumn?.filter?.disabled && childColumn.priority !== 'low' && childColumn.type !== 'image'\">\r\n            <div class=\"col-lg-2 col-md-3 col-sm-6 px-8\">\r\n              <sd-input-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'string'\" type=\"text\"\r\n                [(model)]=\"filter[childColumn.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n              </sd-input-control>\r\n              <sd-input-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'number'\" type=\"number\"\r\n                [(model)]=\"filter[childColumn.field]\" (keyupEnter)=\"onUpdateFilter()\">\r\n              </sd-input-control>\r\n              <sd-radio-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'bool'\" [items]=\"[{value:'1',display:childColumn.trueValue || 'True' },\r\n            {value:'0',display:childColumn.falseValue || 'False' }]\" valueField=\"value\" displayField=\"display\"\r\n                [(model)]=\"filter[childColumn.field]\" (sdChange)=\"onUpdateFilter()\">\r\n              </sd-radio-control>\r\n              <sd-select-control [label]=\"childColumn.title\" *ngIf=\"childColumn.type === 'radio'\"\r\n                [items]=\"childColumn.values\" [valueField]=\"childColumn.valueField\"\r\n                [displayField]=\"childColumn.displayField\" [(model)]=\"filter[childColumn.field]\"\r\n                (sdChange)=\"onUpdateFilter()\">\r\n              </sd-select-control>\r\n              <sd-select-control *ngIf=\"childColumn.type === 'values' && !item?.editor?.autocomplete\"\r\n                [label]=\"childColumn.title\" [items]=\"childColumn.values\" valueField=\"value\" displayField=\"text\"\r\n                [(model)]=\"filter[childColumn.field]\" (sdChange)=\"onUpdateFilter()\">\r\n              </sd-select-control>\r\n              <sd-autocomplete-control *ngIf=\"childColumn.type === 'values' && item?.editor?.autocomplete\"\r\n                [items]=\"childColumn.values\" valueField=\"value\" displayField=\"text\"\r\n                [(model)]=\"filter[childColumn.field]\" (sdChange)=\"onUpdateFilter()\">\r\n              </sd-autocomplete-control>\r\n              <sd-date-picker-control\r\n                *ngIf=\"childColumn.type === 'date' || childColumn.type === 'datetime' || childColumn.type === 'time'\"\r\n                [label]=\"childColumn.title\" [(model)]=\"filter[childColumn.field]\" type=\"date\"\r\n                (sdChange)=\"onUpdateFilter()\">\r\n              </sd-date-picker-control>\r\n            </div>\r\n          </ng-container>\r\n        </ng-container>\r\n      </ng-container>\r\n    </ng-container>\r\n  </ng-container>\r\n</div>",
            styles: [""]
        })
    ], GridDesktopInlineFilterComponent);
    return GridDesktopInlineFilterComponent;
}());

var CellDesktopClassNamePipe = /** @class */ (function () {
    function CellDesktopClassNamePipe() {
    }
    CellDesktopClassNamePipe.prototype.transform = function (value, rowData, column, isChildren) {
        var classNames = [];
        if (column.click) {
            classNames.push('cursor-pointer');
        }
        if (isChildren) {
            classNames.push('c-children');
        }
        if (column.badge) {
            var badge = column.badge(rowData, value);
            if (badge) {
                classNames.push('c-badge');
                classNames.push('badge');
                if (badge === 'PRIMARY') {
                    classNames.push('badge-primary');
                }
                else if (badge === 'SECONDARY') {
                    classNames.push('badge-secondary');
                }
                else if (badge === 'WARNING') {
                    classNames.push('badge-warning');
                }
                else if (badge === 'SUCCESS') {
                    classNames.push('badge-success');
                }
                else if (badge === 'DANGER') {
                    classNames.push('badge-danger');
                }
                else if (badge === 'LIGHT') {
                    classNames.push('badge-light');
                }
                else if (badge === 'DARK') {
                    classNames.push('badge-dark');
                }
            }
        }
        return classNames.join(' ');
    };
    CellDesktopClassNamePipe = __decorate([
        Pipe({
            name: 'cellDesktopClassName'
        })
    ], CellDesktopClassNamePipe);
    return CellDesktopClassNamePipe;
}());

var GridDesktopColumnChildrenViewComponent = /** @class */ (function () {
    function GridDesktopColumnChildrenViewComponent() {
    }
    __decorate([
        Input()
    ], GridDesktopColumnChildrenViewComponent.prototype, "column", void 0);
    __decorate([
        Input()
    ], GridDesktopColumnChildrenViewComponent.prototype, "item", void 0);
    GridDesktopColumnChildrenViewComponent = __decorate([
        Component({
            selector: 'sd-grid-desktop-column-children-view',
            template: "<ng-container *ngIf=\"column.children?.length\">\r\n  <div class=\"row mx-n2 c-cell-padding\">\r\n    <div *ngFor=\"let childColumn of column.children | filterMobile:item\" class=\"px-2\"\r\n      [ngClass]=\"{'col-sm-6': childColumn?.colSpan === 1, 'col-sm-12': !childColumn?.colSpan || childColumn?.colSpan === 2}\">\r\n      <span class=\"c-title\">\r\n        {{item | columnTitle:childColumn.title:childColumn.dynamicTitle | async}}:\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'string'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\">\r\n        <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n          (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field]}}</a>\r\n        <ng-container *ngIf=\"!childColumn.click\">\r\n          {{item[childColumn.field]}}</ng-container>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'number'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\">\r\n        <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n          (click)=\"childColumn.click(item[childColumn.field], item)\">{{(item[childColumn.field]  | valueTransform:item:childColumn) | number : '1.0-2'}}</a>\r\n        <ng-container *ngIf=\"!childColumn.click\">\r\n          {{(item[childColumn.field]  | valueTransform:item:childColumn) | number : '1.0-2'}}\r\n        </ng-container>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'datetime'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\">\r\n        <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n          (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}</a>\r\n        <ng-container *ngIf=\"!childColumn.click\">\r\n          {{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}\r\n        </ng-container>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'date'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\">\r\n        <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n          (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'dd/MM/yyyy'}}</a>\r\n        <ng-container *ngIf=\"!childColumn.click\">\r\n          {{item[childColumn.field] | date:'dd/MM/yyyy'}}\r\n        </ng-container>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'time'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\">\r\n        <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n          (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'HH:mm'}}</a>\r\n        <ng-container *ngIf=\"!childColumn.click\">\r\n          {{item[childColumn.field] | date:'HH:mm'}}\r\n        </ng-container>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'bool'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\"\r\n        (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\">\r\n        <span *ngIf=\"item[childColumn.field]\"\r\n          class=\"status status-success\">{{childColumn.trueValue || 'True'}}</span>\r\n        <span *ngIf=\"!item[childColumn.field]\"\r\n          class=\"status status-danger\">{{childColumn.falseValue || 'False'}}</span>\r\n      </span>\r\n      <span *ngIf=\"childColumn.type === 'color'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\"\r\n        (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\"><input\r\n          disabled=\"true\" type=\"color\" class=\"form-control form-control-sm\"\r\n          [(ngModel)]=\"item[childColumn.field]\"></span>\r\n      <ng-container *ngIf=\"childColumn.type === 'values'\">\r\n        <ng-container\r\n          *ngIf=\"childColumn?.dictionary[item[childColumn.field]] as dic; else elseNotInDic\">\r\n          <span *ngIf=\"dic.color || dic.backgroundColor; else elseNoStatus\"\r\n            class=\"status c-children\"\r\n            [ngStyle]=\"{'color':dic.color, 'background-color': dic.backgroundColor}\">\r\n            {{dic.text}}\r\n          </span>\r\n          <ng-template #elseNoStatus>\r\n            <span [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n              [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\"\r\n              (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\">\r\n              {{dic.text}}\r\n            </span>\r\n          </ng-template>\r\n        </ng-container>\r\n        <ng-template #elseNotInDic>\r\n          <span [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n            [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\"\r\n            (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\">\r\n            {{item[childColumn.field]}}\r\n          </span>\r\n        </ng-template>\r\n      </ng-container>\r\n      <span *ngIf=\"childColumn.type === 'radio'\"\r\n        [className]=\"item[childColumn.field] | cellDesktopClassName:item:childColumn:true\"\r\n        [ngClass]=\"{'blinker': item.blinker && item.blinker[childColumn.field]}\"\r\n        (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field]}}</span>\r\n      <img *ngIf=\"childColumn.type === 'image'\" [src]=\"item[childColumn.field]\"\r\n        [width]=\"childColumn.display?.width\" [height]=\"childColumn.display?.height\"\r\n        style=\"margin: 5px 0\" (click)=\"column.click && column.click(item[column.field], item)\">\r\n    </div>\r\n  </div>\r\n</ng-container>",
            styles: [".c-title{font-size:13px;margin-right:3px;font-weight:700;color:#212529;line-height:1.7}.c-badge{display:block!important;border-radius:10rem;font-weight:500;max-width:80%;margin:0 auto;padding:5px!important;font-size:14px;color:#212529}.c-badge a{color:#fff}.c-children{font-size:14px;overflow-wrap:break-word;color:#212529}.status{font-weight:500;padding:4px 8px;border-radius:1.5rem;display:inline-block;text-align:left!important;text-transform:uppercase}.status-success{color:#00bc3c}.status-danger{color:#f5222d}.c-btn-icon{background:0 0!important;border:none;opacity:.8;height:20px;display:inline-flex;padding:0 3px}.c-btn-icon:hover{cursor:pointer;opacity:1}.c-btn-icon:disabled{background:0 0!important;border:none;cursor:not-allowed;opacity:.3}"]
        })
    ], GridDesktopColumnChildrenViewComponent);
    return GridDesktopColumnChildrenViewComponent;
}());

var GridMobileItemViewComponent = /** @class */ (function () {
    function GridMobileItemViewComponent() {
        var _this = this;
        this.check = new EventEmitter();
        this.onCheck = function (item) {
            _this.check.emit(item);
        };
    }
    __decorate([
        Input()
    ], GridMobileItemViewComponent.prototype, "gridOption", void 0);
    __decorate([
        Input()
    ], GridMobileItemViewComponent.prototype, "item", void 0);
    __decorate([
        Output()
    ], GridMobileItemViewComponent.prototype, "check", void 0);
    GridMobileItemViewComponent = __decorate([
        Component({
            selector: 'sd-grid-mobile-item-view',
            template: "<ng-container *ngIf=\"gridOption && item\">\r\n  <ng-container *ngIf=\"gridOption?.mobileOrTablet?.htmlTemplate\">\r\n    <div [innerHTML]=\"(item | mobileViewHtmlTempate:gridOption.columns:gridOption?.mobileOrTablet?.htmlTemplate) | safeHtml\" (click)=\"onCheck(item)\">\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!gridOption?.mobileOrTablet?.htmlTemplate\">\r\n    <ng-container *ngFor=\"let column of gridOption.columns | filterMobile:item\">\r\n      <div *ngIf=\"column.type !== 'children'\" class=\"row c-row\" (click)=\"onCheck(item)\">\r\n        <div class=\"col-5\">\r\n          <span class=\"c-title\">\r\n            {{item | columnTitle:column.title:column.dynamicTitle | async}}:\r\n          </span>\r\n        </div>\r\n        <div class=\"col-7\">\r\n          <ng-container *ngIf=\"column.type === 'string'\">\r\n            <span *ngIf=\"!column.htmlTemplate; else elseUseTemplate\"\r\n              [className]=\"item[column.field] | cellMobileClassName:item:column\">\r\n              <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n                (click)=\"column.click(item[column.field], item)\">{{item[column.field]}}</a>\r\n              <ng-container *ngIf=\"!column.click\">\r\n                {{item[column.field]}}</ng-container>\r\n            </span>\r\n            <ng-template #elseUseTemplate>\r\n              <span class=\"c-value\"\r\n                [innerHTML]=\"(item[column.field] | columnHtmlTemplate:item:column.htmlTemplate) | safeHtml\"></span>\r\n            </ng-template>\r\n            <ng-container\r\n              *ngIf=\"column.commands | columnCommandFilter:item | async; $implicit as filteredColumnCommands\">\r\n              <button *ngFor=\"let columnCommand of filteredColumnCommands\" (click)=\"columnCommand.click(item)\"\r\n                type=\"button\" class=\"c-btn-icon\" [matTooltip]=\"columnCommand.title | commandTitle:item\">\r\n                <i class=\"{{columnCommand.icon | commandIcon:item}}\" aria-hidden=\"true\" style=\"font-size: 14px;\"></i>\r\n              </button>\r\n            </ng-container>\r\n          </ng-container>\r\n          <span *ngIf=\"column.type === 'number'\" [className]=\"item[column.field] | cellMobileClassName:item:column\">\r\n            <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n              (click)=\"column.click(item[column.field], item)\">{{(item[column.field] | valueTransform:item:column) | number : '1.0-2'}}</a>\r\n            <ng-container *ngIf=\"!column.click\">\r\n              {{(item[column.field] | valueTransform:item:column) | number : '1.0-2'}}</ng-container>\r\n          </span>\r\n          <span *ngIf=\"column.type === 'datetime'\" [className]=\"item[column.field] | cellMobileClassName:item:column\">\r\n            <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n              (click)=\"column.click(item[column.field], item)\">{{item[column.field] | date:'dd/MM/yyyy HH:mm'}}</a>\r\n            <ng-container *ngIf=\"!column.click\">\r\n              {{item[column.field] | date:'dd/MM/yyyy HH:mm'}}</ng-container>\r\n          </span>\r\n          <span *ngIf=\"column.type === 'date'\" [className]=\"item[column.field] | cellMobileClassName:item:column\">\r\n            <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n              (click)=\"column.click(item[column.field], item)\">{{item[column.field] | date:'dd/MM/yyyy'}}</a>\r\n            <ng-container *ngIf=\"!column.click\">\r\n              {{item[column.field] | date:'dd/MM/yyyy'}}</ng-container>\r\n          </span>\r\n          <span *ngIf=\"column.type === 'time'\" [className]=\"item[column.field] | cellMobileClassName:item:column\">\r\n            <a *ngIf=\"column.click\" href=\"javascript:;\"\r\n              (click)=\"column.click(item[column.field], item)\">{{item[column.field] | date:'HH:mm'}}</a>\r\n            <ng-container *ngIf=\"!column.click\">\r\n              {{item[column.field] | date:'HH:mm'}}</ng-container>\r\n          </span>\r\n          <span *ngIf=\"column.type === 'bool'\" [className]=\"item[column.field] | cellMobileClassName:item:column\"\r\n            (click)=\"column.click && column.click(item[column.field], item)\">\r\n            <span *ngIf=\"item[column.field]\" class=\"status status-success c-status\">{{column.trueValue || 'True'}}</span>\r\n            <span *ngIf=\"!item[column.field]\" class=\"status status-danger c-status\">{{column.falseValue || 'False'}}</span>\r\n          </span>\r\n          <span *ngIf=\"column.type === 'color'\" class=\"c-value\"><input disabled=\"true\" type=\"color\"\r\n              class=\"form-control form-control-sm\" [(ngModel)]=\"item[column.field]\"></span>\r\n          <ng-container *ngIf=\"column.type === 'values'\">\r\n            <ng-container *ngIf=\"column?.dictionary[item[column.field]] as dic; else elseNotInDic\">\r\n              <span *ngIf=\"dic.color || dic.backgroundColor; else elseNoStatus\" class=\"status c-status\"\r\n                [ngStyle]=\"{'color':dic.color, 'background-color': dic.backgroundColor}\">\r\n                {{dic.text}}\r\n              </span>\r\n              <ng-template #elseNoStatus>\r\n                <span class=\"c-value\">\r\n                  {{dic.text}}\r\n                </span>\r\n              </ng-template>\r\n            </ng-container>\r\n            <ng-template #elseNotInDic>\r\n              <span class=\"c-value\">\r\n                {{item[column.field]}}\r\n              </span>\r\n            </ng-template>\r\n          </ng-container>\r\n          <span *ngIf=\"column.type === 'radio'\" class=\"c-value\">{{item[column.field]}}</span>\r\n          <img *ngIf=\"column.type === 'image'\" [src]=\"item[column.field]\" [width]=\"column.display?.width\"\r\n            [height]=\"column.display?.height\" style=\"margin: 5px 0\"\r\n            (click)=\"column.click && column.click(item[column.field], item)\">\r\n        </div>\r\n      </div>\r\n      <ng-container *ngIf=\"column.type === 'children' && column.children?.length\">\r\n        <div class=\"row c-row\" *ngFor=\"let childColumn of column.children | filterMobile:item\"\r\n          (click)=\"onCheck(item)\">\r\n          <div class=\"col-5\">\r\n            <span class=\"c-title\">\r\n              {{childColumn.title}}:\r\n            </span>\r\n          </div>\r\n          <div class=\"col-7\">\r\n            <ng-container *ngIf=\"childColumn.type === 'string'\">\r\n              <span *ngIf=\"!childColumn.htmlTemplate; else elseUseTemplate\"\r\n                [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\"><a *ngIf=\"childColumn.click\"\r\n                  href=\"javascript:;\"\r\n                  (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field]}}</a>\r\n                <ng-container *ngIf=\"!childColumn.click\">\r\n                  {{item[childColumn.field]}}</ng-container>\r\n              </span>\r\n              <ng-template #elseUseTemplate>\r\n                <span class=\"c-value\"\r\n                  [innerHTML]=\"(item[childColumn.field] | columnHtmlTemplate:item:childColumn.htmlTemplate) | safeHtml\"></span>\r\n              </ng-template>\r\n            </ng-container>\r\n            <span *ngIf=\"childColumn.type === 'number'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\">\r\n              <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n                (click)=\"childColumn.click(item[childColumn.field], item)\">{{(item[childColumn.field] | valueTransform:item:childColumn) | number : '1.0-2'}}</a>\r\n              <ng-container *ngIf=\"!childColumn.click\">\r\n                {{(item[childColumn.field] | valueTransform:item:childColumn) | number : '1.0-2'}}</ng-container>\r\n            </span>\r\n            <span *ngIf=\"childColumn.type === 'datetime'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\">\r\n              <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n                (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}</a>\r\n              <ng-container *ngIf=\"!childColumn.click\">\r\n                {{item[childColumn.field] | date:'dd/MM/yyyy HH:mm'}}</ng-container>\r\n            </span>\r\n            <span *ngIf=\"childColumn.type === 'date'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\">\r\n              <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n                (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'dd/MM/yyyy'}}</a>\r\n              <ng-container *ngIf=\"!childColumn.click\">\r\n                {{item[childColumn.field] | date:'dd/MM/yyyy'}}</ng-container>\r\n            </span>\r\n            <span *ngIf=\"childColumn.type === 'time'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\">\r\n              <a *ngIf=\"childColumn.click\" href=\"javascript:;\"\r\n                (click)=\"childColumn.click(item[childColumn.field], item)\">{{item[childColumn.field] | date:'HH:mm'}}</a>\r\n              <ng-container *ngIf=\"!childColumn.click\">\r\n                {{item[childColumn.field] | date:'HH:mm'}}</ng-container>\r\n            </span>\r\n            <span *ngIf=\"childColumn.type === 'bool'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\"\r\n              (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\">\r\n              <span *ngIf=\"item[childColumn.field]\"\r\n                class=\"status status-success c-status\">{{childColumn.trueValue || 'True'}}</span>\r\n              <span *ngIf=\"!item[childColumn.field]\"\r\n                class=\"status status-danger c-status\">{{childColumn.falseValue || 'False'}}</span>\r\n            </span>\r\n            <span *ngIf=\"childColumn.type === 'color'\"\r\n              [className]=\"item[childColumn.field] | cellMobileClassName:item:childColumn\"\r\n              (click)=\"childColumn.click && childColumn.click(item[childColumn.field], item)\"><input disabled=\"true\"\r\n                type=\"color\" class=\"form-control form-control-sm\" [(ngModel)]=\"item[childColumn.field]\"></span>\r\n            <ng-container *ngIf=\"childColumn.type === 'values'\">\r\n              <ng-container *ngIf=\"childColumn?.dictionary[item[childColumn.field]] as dic; else elseNotInDic\">\r\n                <span *ngIf=\"dic.color || dic.backgroundColor; else elseNoStatus\" class=\"status c-status\"\r\n                  [ngStyle]=\"{'color':dic.color, 'background-color': dic.backgroundColor}\">\r\n                  {{dic.text}}\r\n                </span>\r\n                <ng-template #elseNoStatus>\r\n                  <span class=\"c-value\">\r\n                    {{dic.text}}\r\n                  </span>\r\n                </ng-template>\r\n              </ng-container>\r\n              <ng-template #elseNotInDic>\r\n                <span class=\"c-value\">\r\n                  {{item[childColumn.field]}}\r\n                </span>\r\n              </ng-template>\r\n            </ng-container>\r\n            <span *ngIf=\"childColumn.type === 'radio'\" class=\"c-value\">{{item[childColumn.field]}}</span>\r\n            <img *ngIf=\"childColumn.type === 'image'\" [src]=\"item[childColumn.field]\"\r\n              [width]=\"childColumn.display?.width\" [height]=\"childColumn.display?.height\" style=\"margin: 5px 0\"\r\n              (click)=\"column.click && column.click(item[column.field], item)\">\r\n          </div>\r\n        </div>\r\n      </ng-container>\r\n    </ng-container>\r\n  </ng-container>\r\n</ng-container>",
            styles: [".c-status.status{font-weight:500;padding:4px 8px;border-radius:1.5rem;display:inline-block;text-align:center;text-transform:uppercase}.c-row{margin:0 -8px 3px}.c-title{font-size:14px;margin-right:3px;font-weight:700;color:#212529}.c-value{font-size:14px;overflow-wrap:break-word;color:#212529}.c-badge{padding:5px!important;font-weight:500;font-size:14px}"]
        })
    ], GridMobileItemViewComponent);
    return GridMobileItemViewComponent;
}());

// Document: http://www.daterangepicker.com/
var DateRangePickerControlComponent = /** @class */ (function () {
    function DateRangePickerControlComponent(ref, translateService) {
        var _this = this;
        this.ref = ref;
        this.translateService = translateService;
        this.initialized = false;
        this.pMinDate = null;
        this.pMaxDate = null;
        this.jsFormat = 'MM/dd/yyyy HH:mm';
        this.momentFormat = 'MM/DD/YYYY hh:mm';
        this.name = v4();
        this.model = '';
        this.type = 'datetime';
        this.disabled = false;
        this.required = false;
        this.sdChange = new EventEmitter();
        this.fromDateChange = new EventEmitter();
        this.toDateChange = new EventEmitter();
        this.onFocus = function () {
            $$1(_this.control.nativeElement).trigger('blur');
        };
        this.onChanges = function () {
        };
        this.clear = function () {
            // ($(this.control.nativeElement) as any).val('');
            _this.model = '';
            var fromDate = null;
            var toDate = null;
            _this.pFromDate = fromDate;
            _this.pToDate = toDate;
            _this.fromDateChange.emit(_this.pFromDate);
            _this.toDateChange.emit(_this.pToDate);
            _this.sdChange.emit({ fromDate: fromDate, toDate: toDate });
            _this.ref.detectChanges();
        };
        this.reload = function (startDate, endDate) {
            if (!startDate || !endDate) {
                _this.model = '';
            }
            else {
                _this.model = startDate + ' - ' + endDate;
            }
            _this.ref.detectChanges();
        };
    }
    Object.defineProperty(DateRangePickerControlComponent.prototype, "viewFormat", {
        get: function () {
            var format = 'DD/MM/YYYY';
            if (this.type === 'datetime') {
                format = 'DD/MM/YYYY hh:mm';
            }
            else if (this.type === 'time') {
                format = 'hh:mm';
            }
            return format;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePickerControlComponent.prototype, "format", {
        get: function () {
            var format = 'MM/DD/YYYY';
            if (this.type === 'datetime') {
                format = 'MM/DD/YYYY hh:mm';
            }
            else if (this.type === 'time') {
                format = 'MM/DD/YYYY hh:mm';
            }
            return format;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePickerControlComponent.prototype, "minDate", {
        set: function (val) {
            if (!Date.isDate(val)) {
                val = null;
            }
            else {
                val = Date.toFormat(val, this.jsFormat);
            }
            this.pMinDate = val;
            if (this.initialized) {
                this.setOption();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePickerControlComponent.prototype, "maxDate", {
        set: function (val) {
            if (!Date.isDate(val)) {
                val = null;
            }
            else {
                val = Date.toFormat(val, this.jsFormat);
            }
            this.pMaxDate = val;
            if (this.initialized) {
                this.setOption();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePickerControlComponent.prototype, "fromDate", {
        set: function (val) {
            if (!Date.isDate(val)) {
                val = null;
            }
            else {
                val = Date.toFormat(val, this.jsFormat);
            }
            if (this.initialized) {
                if (this.pFromDate !== val) {
                    $$1(this.control.nativeElement)
                        .data('daterangepicker').setStartDate(val ? moment(val, this.momentFormat) : moment());
                }
                var startDate = val ? moment(val, this.momentFormat).format(this.viewFormat) : '';
                var toDate = this.pToDate ? moment(this.pToDate, this.momentFormat).format(this.viewFormat) : '';
                this.reload(startDate, toDate);
            }
            this.pFromDate = val;
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePickerControlComponent.prototype, "toDate", {
        set: function (val) {
            if (!Date.isDate(val)) {
                val = null;
            }
            else {
                val = Date.toFormat(val, this.jsFormat);
            }
            if (this.initialized) {
                if (this.pToDate !== val) {
                    $$1(this.control.nativeElement)
                        .data('daterangepicker').setEndDate(val ? moment(val, this.momentFormat) : moment());
                }
                var startDate = this.pFromDate ? moment(this.pFromDate, this.momentFormat).format(this.viewFormat) : '';
                var toDate = val ? moment(val, this.momentFormat).format(this.viewFormat) : '';
                this.reload(startDate, toDate);
            }
            this.pToDate = val;
            this.ref.detectChanges();
        },
        enumerable: true,
        configurable: true
    });
    DateRangePickerControlComponent.prototype.ngOnDestroy = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.removeControl(this.formModel);
    };
    DateRangePickerControlComponent.prototype.ngAfterViewInit = function () {
        var _a;
        (_a = this.form) === null || _a === void 0 ? void 0 : _a.addControl(this.formModel);
        this.onChanges();
        this.initialized = true;
        this.setOption();
        var startDate = this.pFromDate ? moment(this.pFromDate, this.momentFormat).format(this.viewFormat) : '';
        var toDate = this.pToDate ? moment(this.pToDate, this.momentFormat).format(this.viewFormat) : '';
        this.reload(startDate, toDate);
        this.ref.detectChanges();
    };
    DateRangePickerControlComponent.prototype.setOption = function () {
        var _this = this;
        if (this.initialized) {
            $$1(this.control.nativeElement).daterangepicker({
                autoUpdateInput: false,
                timePicker: this.type === 'datetime' || this.type === 'time',
                timePicker24Hour: true,
                locale: {
                    // format: this.format,
                    // separator: ' - ',
                    applyLabel: this.translateService.translate('Apply'),
                    cancelLabel: this.translateService.translate('Clear'),
                    fromLabel: this.translateService.translate('From'),
                    toLabel: this.translateService.translate('To'),
                    customRangeLabel: this.translateService.translate('Custom'),
                    weekLabel: 'W',
                    daysOfWeek: [
                        this.translateService.translate('Su'),
                        this.translateService.translate('Mo'),
                        this.translateService.translate('Tu'),
                        this.translateService.translate('We'),
                        this.translateService.translate('Th'),
                        this.translateService.translate('Fr'),
                        this.translateService.translate('Sa')
                    ],
                    monthNames: [
                        this.translateService.translate('January'),
                        this.translateService.translate('February'),
                        this.translateService.translate('March'),
                        this.translateService.translate('April'),
                        this.translateService.translate('May'),
                        this.translateService.translate('June'),
                        this.translateService.translate('July'),
                        this.translateService.translate('August'),
                        this.translateService.translate('September'),
                        this.translateService.translate('October'),
                        this.translateService.translate('November'),
                        this.translateService.translate('December')
                    ],
                    firstDay: 1
                },
                startDate: Date.isDate(this.pFromDate) ? moment(this.pFromDate, this.momentFormat) : undefined,
                endDate: Date.isDate(this.pToDate) ? moment(this.pToDate, this.momentFormat) : undefined,
                minDate: Date.isDate(this.pMinDate) ? moment(this.pMinDate, this.momentFormat) : undefined,
                maxDate: Date.isDate(this.pMaxDate) ? moment(this.pMaxDate, this.momentFormat) : undefined,
            }, function (fDate, tDate, label) {
                var fromDate = fDate.format(_this.format);
                var toDate = tDate.format(_this.format);
                _this.pFromDate = fromDate;
                _this.pToDate = toDate;
                _this.fromDateChange.emit(_this.pFromDate);
                _this.toDateChange.emit(_this.pToDate);
                _this.sdChange.emit({ fromDate: fromDate, toDate: toDate });
                _this.ref.detectChanges();
            });
            $$1(this.control.nativeElement).on('apply.daterangepicker', function (ev, picker) {
                var _a, _b;
                var startDate = (_a = picker.startDate) === null || _a === void 0 ? void 0 : _a.format(_this.viewFormat);
                var endDate = (_b = picker.endDate) === null || _b === void 0 ? void 0 : _b.format(_this.viewFormat);
                _this.reload(startDate, endDate);
            });
            $$1(this.control.nativeElement).on('cancel.daterangepicker', this.clear);
        }
    };
    DateRangePickerControlComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: TranslateService }
    ]; };
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "form", void 0);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "type", void 0);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "disabled", void 0);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "required", void 0);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "minDate", null);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "maxDate", null);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "fromDate", null);
    __decorate([
        Input()
    ], DateRangePickerControlComponent.prototype, "toDate", null);
    __decorate([
        Output()
    ], DateRangePickerControlComponent.prototype, "sdChange", void 0);
    __decorate([
        Output()
    ], DateRangePickerControlComponent.prototype, "fromDateChange", void 0);
    __decorate([
        Output()
    ], DateRangePickerControlComponent.prototype, "toDateChange", void 0);
    __decorate([
        ViewChild('control')
    ], DateRangePickerControlComponent.prototype, "control", void 0);
    __decorate([
        ViewChild('formModel')
    ], DateRangePickerControlComponent.prototype, "formModel", void 0);
    DateRangePickerControlComponent = __decorate([
        Component({
            selector: 'sd-date-range-picker-control',
            template: "<mat-form-field class=\"sd-form\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <input #formModel=\"ngModel\" [ngModel]=\"model\" class=\"sd-input\" [name]=\"name\" autocomplete=\"false\" #control matInput\r\n    placeholder=\"{{label}}\" (focus)=\"onFocus()\" [required]=\"required\" [disabled]=\"disabled\" autocomplete=\"off\">\r\n  <mat-icon *ngIf=\"type !== 'time'\" matSuffix>date_range</mat-icon>\r\n  <mat-icon *ngIf=\"type === 'time'\" matSuffix>schedule</mat-icon>\r\n</mat-form-field>",
            encapsulation: ViewEncapsulation.None,
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", ".daterangepicker td.end-date,.daterangepicker td.start-date{background-color:#5d78ff!important}.daterangepicker td.in-range{background-color:#d0effd!important}.daterangepicker td.in-range.end-date,.daterangepicker td.in-range.start-date{background-color:#5d78ff!important}"]
        })
    ], DateRangePickerControlComponent);
    return DateRangePickerControlComponent;
}());

var BottomSheetComponent = /** @class */ (function () {
    function BottomSheetComponent(bottomSheet) {
        var _this = this;
        this.bottomSheet = bottomSheet;
        this.isOpened = false;
        this.open = function () {
            _this.isOpened = true;
            _this.bottomSheet.open(_this.templateRef);
        };
        this.close = function () {
            _this.bottomSheet.dismiss();
        };
    }
    BottomSheetComponent.ctorParameters = function () { return [
        { type: MatBottomSheet }
    ]; };
    __decorate([
        ViewChild('templateRef')
    ], BottomSheetComponent.prototype, "templateRef", void 0);
    __decorate([
        Input()
    ], BottomSheetComponent.prototype, "title", void 0);
    BottomSheetComponent = __decorate([
        Component({
            selector: 'sd-bottom-sheet',
            template: "<ng-template #templateRef>\r\n  <ng-container *ngIf=\"isOpened\">\r\n    <sd-bottom-sheet-header *ngIf=\"title\">{{title}}</sd-bottom-sheet-header>\r\n    <ng-content></ng-content>\r\n  </ng-container>\r\n</ng-template>"
        })
    ], BottomSheetComponent);
    return BottomSheetComponent;
}());

var BottomSheetBodyComponent = /** @class */ (function () {
    function BottomSheetBodyComponent() {
        this.height = 'auto';
    }
    BottomSheetBodyComponent.prototype.ngOnInit = function () {
    };
    __decorate([
        Input()
    ], BottomSheetBodyComponent.prototype, "height", void 0);
    BottomSheetBodyComponent = __decorate([
        Component({
            selector: 'sd-bottom-sheet-body',
            template: "<div class=\"c-body\" [ngStyle]=\"{'height': height}\">\r\n  <ng-content></ng-content>\r\n<div>",
            styles: ["::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ""]
        })
    ], BottomSheetBodyComponent);
    return BottomSheetBodyComponent;
}());

var BottomSheetFooterComponent = /** @class */ (function () {
    function BottomSheetFooterComponent() {
    }
    BottomSheetFooterComponent.prototype.ngOnInit = function () {
    };
    BottomSheetFooterComponent = __decorate([
        Component({
            selector: 'sd-bottom-sheet-footer',
            template: "<!-- <div class=\"modal-footer\" style=\"padding:5px\"><ng-content></ng-content></div> -->\r\n<div class=\"c-footer\">\r\n  <ng-content></ng-content>\r\n</div>",
            styles: [".c-footer{padding-top:5px;padding-bottom:5px;flex:auto;display:flex;align-items:center;justify-content:flex-end}"]
        })
    ], BottomSheetFooterComponent);
    return BottomSheetFooterComponent;
}());

var BottomSheetHeaderComponent = /** @class */ (function () {
    function BottomSheetHeaderComponent() {
    }
    BottomSheetHeaderComponent.prototype.ngOnInit = function () {
    };
    BottomSheetHeaderComponent = __decorate([
        Component({
            selector: 'sd-bottom-sheet-header',
            template: "<h3 class=\"mb-0\" mat-dialog-title><ng-content></ng-content></h3>"
        })
    ], BottomSheetHeaderComponent);
    return BottomSheetHeaderComponent;
}());

var ButtonComponent = /** @class */ (function () {
    function ButtonComponent(ref) {
        var _this = this;
        this.ref = ref;
        this.pDisabled = false;
        this.initialized = false;
        this.isDisabled = false;
        this.color = undefined;
        this.iconSuffix = false;
        this.fontSet = 'material-icons';
        this.loading = false;
        this.action = new EventEmitter();
        this.onClick = function ($event) {
            if (_this.loading) {
                return;
            }
            _this.action.emit($event);
        };
    }
    Object.defineProperty(ButtonComponent.prototype, "disabled", {
        set: function (value) {
            this.pDisabled = value || false;
            if (this.initialized) {
                this.onChanges();
            }
        },
        enumerable: true,
        configurable: true
    });
    ButtonComponent.prototype.ngOnInit = function () {
    };
    ButtonComponent.prototype.ngAfterViewInit = function () {
        this.onChanges();
        this.initialized = true;
    };
    ButtonComponent.prototype.onChanges = function () {
        this.isDisabled = this.pDisabled;
        this.ref.detectChanges();
    };
    ButtonComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    __decorate([
        Input()
    ], ButtonComponent.prototype, "color", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "title", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "icon", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "width", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "size", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "tooltip", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "iconSuffix", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "fontSet", void 0);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "disabled", null);
    __decorate([
        Input()
    ], ButtonComponent.prototype, "loading", void 0);
    __decorate([
        Output()
    ], ButtonComponent.prototype, "action", void 0);
    ButtonComponent = __decorate([
        Component({
            selector: 'sd-button',
            template: "<button *ngIf=\"title\" [ngStyle]=\"{'width':width}\" class=\"c-button\" [ngClass]=\"{'c-sm': size === 'sm', 'c-lg': size === 'lg'}\" type=\"button\" \r\n  (click)=\"onClick($event)\" [color]=\"color\" [disabled]=\"isDisabled\" matTooltipPosition=\"above\"\r\n  [matTooltip]=\"tooltip\" mat-raised-button>\r\n  <mat-icon [fontSet]=\"fontSet\">{{icon}}</mat-icon>\r\n  <span class=\"d-none d-sm-inline c-title\">{{title}}</span>\r\n</button>\r\n<button *ngIf=\"!title\" [ngStyle]=\"{'width':width}\" class=\"c-button\" [ngClass]=\"{'c-sm': size === 'sm', 'c-lg': size === 'lg'}\" type=\"button\" \r\n  (click)=\"onClick($event)\" [color]=\"color\" [disabled]=\"isDisabled\" matTooltipPosition=\"above\"\r\n  [matTooltip]=\"tooltip\" mat-icon-button>\r\n  <mat-icon [fontSet]=\"fontSet\">{{icon}}</mat-icon>\r\n</button>",
            styles: ["button.c-button{font-size:16px;height:38px;line-height:24px;padding:6px 16px!important}button.c-button.c-sm{font-size:14px!important;line-height:20px!important;padding:6px 12px!important;height:30px;font-weight:400}button.c-button.c-sm mat-icon{height:20px!important;width:20px!important;font-size:20px!important}button.c-button.c-lg{font-size:16px!important;line-height:24px!important;padding:6px 16px!important;height:48px}button.c-button.c-lg mat-icon{height:16px!important;width:16px!important;font-size:16px!important}button.c-button:focus{outline:0}button:focus{outline:0!important}.c-title{margin-left:3px;margin-right:3px}.mat-raised-button[disabled][disabled]{background-color:rgba(0,0,0,.12)!important;color:rgba(0,0,0,.26)!important}.mat-button.mat-gray,.mat-stroked-button.mat-gray{color:#eceff1}.mat-button.mat-gray:hover,.mat-stroked-button.mat-gray:hover{background-color:#495057}.mat-fab.mat-gray,.mat-flat-button.mat-gray,.mat-mini-fab.mat-gray,.mat-raised-button.mat-gray{color:#495057;background-color:#eceff1}.mat-icon-button.mat-gray{color:#eceff1}.mat-button.mat-secondary,.mat-stroked-button.mat-secondary{color:#ebeef5}.mat-button.mat-secondary:hover,.mat-stroked-button.mat-secondary:hover{background-color:#2f6bff}.mat-fab.mat-secondary,.mat-flat-button.mat-secondary,.mat-mini-fab.mat-secondary,.mat-raised-button.mat-secondary{color:#2f6bff;background-color:#ebeef5}.mat-button.mat-tertiary,.mat-icon-button.mat-secondary,.mat-stroked-button.mat-tertiary{color:#ebeef5}.mat-button.mat-tertiary:hover,.mat-stroked-button.mat-tertiary:hover{background-color:#2f3136}.mat-fab.mat-tertiary,.mat-flat-button.mat-tertiary,.mat-mini-fab.mat-tertiary,.mat-raised-button.mat-tertiary{color:#2f3136;background-color:#ebeef5}.mat-icon-button.mat-tertiary{color:#ebeef5}.mat-button.mat-positive,.mat-stroked-button.mat-positive{color:#00bc3c}.mat-button.mat-positive:hover,.mat-stroked-button.mat-positive:hover{background-color:#fff}.mat-fab.mat-positive,.mat-flat-button.mat-positive,.mat-mini-fab.mat-positive,.mat-raised-button.mat-positive{color:#fff;background-color:#00bc3c}.mat-icon-button.mat-positive{color:#00bc3c}.mat-button.mat-negative,.mat-stroked-button.mat-negative{color:#fceaeb}.mat-button.mat-negative:hover,.mat-stroked-button.mat-negative:hover{background-color:#f5222d}.mat-fab.mat-negative,.mat-flat-button.mat-negative,.mat-mini-fab.mat-negative,.mat-raised-button.mat-negative{color:#f5222d;background-color:#fceaeb}.mat-icon-button.mat-negative{color:#fceaeb}"]
        })
    ], ButtonComponent);
    return ButtonComponent;
}());

var DesktopDirective = /** @class */ (function () {
    function DesktopDirective(templateRef, viewContainerRef, deviceService) {
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        if (deviceService.isDesktop()) {
            this.viewContainerRef.createEmbeddedView(this.templateRef);
        }
    }
    DesktopDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: DeviceDetectorService }
    ]; };
    DesktopDirective = __decorate([
        Directive({
            selector: '[sdDesktop]'
        })
    ], DesktopDirective);
    return DesktopDirective;
}());

var MobileDirective = /** @class */ (function () {
    function MobileDirective(templateRef, viewContainerRef, deviceService) {
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        if (deviceService.isMobile()) {
            this.viewContainerRef.createEmbeddedView(this.templateRef);
        }
    }
    MobileDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: DeviceDetectorService }
    ]; };
    MobileDirective = __decorate([
        Directive({
            selector: '[sdMobile]'
        })
    ], MobileDirective);
    return MobileDirective;
}());

var TabletDirective = /** @class */ (function () {
    function TabletDirective(templateRef, viewContainerRef, deviceService) {
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        if (deviceService.isTablet()) {
            this.viewContainerRef.createEmbeddedView(this.templateRef);
        }
    }
    TabletDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: DeviceDetectorService }
    ]; };
    TabletDirective = __decorate([
        Directive({
            selector: '[sdTablet]'
        })
    ], TabletDirective);
    return TabletDirective;
}());

var MobileTabletDirective = /** @class */ (function () {
    function MobileTabletDirective(templateRef, viewContainerRef, deviceService) {
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        if (deviceService.isMobile() || deviceService.isTablet()) {
            this.viewContainerRef.createEmbeddedView(this.templateRef);
        }
    }
    MobileTabletDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: DeviceDetectorService }
    ]; };
    MobileTabletDirective = __decorate([
        Directive({
            selector: '[sdMobileTablet]'
        })
    ], MobileTabletDirective);
    return MobileTabletDirective;
}());

var GridPopupQuickFilterDetailComponent = /** @class */ (function () {
    function GridPopupQuickFilterDetailComponent(deviceService, notifyService, translateService) {
        var _this = this;
        this.notifyService = notifyService;
        this.translateService = translateService;
        this.displayKey = 'SDCUSTOM';
        this.isMobileOrTablet = false;
        this.accept = new EventEmitter();
        this.fields = [];
        this.selectableFields = [];
        this.columns = [];
        this.externalFilters = [];
        this.filter = {};
        this.externalFilter = {};
        this.selectedField = {};
        this.page = 1;
        this.onAccept = function () {
            var execute = function () {
                var filter = {};
                var externalFilter = {};
                Object.keys(_this.filter).forEach(function (key) {
                    if (_this.filter[key] === undefined || _this.filter[key] === null || _this.filter[key] === '') {
                        return;
                    }
                    if (!_this.fields.some(function (e) { return e.group === 'column' && e.code === key; })) {
                        return;
                    }
                    filter[key] = _this.filter[key];
                });
                Object.keys(_this.externalFilter).forEach(function (key) {
                    if (_this.externalFilter[key] === undefined || _this.externalFilter[key] === null || _this.externalFilter[key] === '') {
                        return;
                    }
                    externalFilter[key] = _this.externalFilter[key];
                });
                _this.accept.emit({
                    code: _this.code,
                    filter: filter,
                    externalFilter: externalFilter
                });
                _this.modal.close();
            };
            if (!_this.code) {
                _this.notifyService.confirmWithInput('Enter your quick filter name').then(function (value) {
                    var _a;
                    if (value) {
                        if ((_a = _this.quickFilters) === null || _a === void 0 ? void 0 : _a.some(function (e) { return e.code === value; })) {
                            _this.notifyService.notify.warning(_this.translateService.translate('Code is existed'));
                            return;
                        }
                        _this.code = value;
                        execute();
                    }
                });
            }
            else {
                execute();
            }
        };
        this.onCancel = function () {
            _this.modal.close();
        };
        this.onSelectField = function (values) {
            var e_1, _a;
            _this.fields = _this.selectableFields.filter(function (e) { return values.some(function (v) { return e.code === v; }); });
            try {
                for (var _b = __values(_this.fields), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var field = _c.value;
                    if (field.group === 'external' && field.type.includes('range')) {
                        _this.externalFilter[field.code] = _this.externalFilter[field.code] || {};
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        this.onSelectFields = function () {
            var e_2, _a;
            _this.fields = _this.selectableFields.filter(function (e) { return _this.selectedField[e.id]; });
            try {
                for (var _b = __values(_this.fields), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var field = _c.value;
                    if (field.group === 'external' && field.type.includes('range')) {
                        _this.externalFilter[field.code] = _this.externalFilter[field.code] || {};
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        this.isMobileOrTablet = !deviceService.isDesktop();
    }
    GridPopupQuickFilterDetailComponent.prototype.ngOnInit = function () {
    };
    GridPopupQuickFilterDetailComponent.prototype.ngAfterViewInit = function () {
    };
    GridPopupQuickFilterDetailComponent.prototype.open = function (columns, externalFilters, filter, externalFilter, code) {
        var _this = this;
        var _a, _b;
        this.fields = [];
        this.filter = {};
        this.externalFilter = {};
        this.columns = columns;
        this.externalFilters = externalFilters;
        this.code = code;
        if (filter) {
            Object.keys(filter).forEach(function (key) {
                if (filter[key] === undefined || filter[key] === null || filter[key] === '') {
                    return;
                }
                var column = columns.find(function (e) { return e.field === key; });
                if (!column) {
                    return;
                }
                _this.filter[key] = filter[key];
                _this.fields.push(__assign(__assign({}, column), { id: 'column' + column.field, group: 'column', type: column.type, code: column.field, title: column.title }));
            });
        }
        if (externalFilter) {
            Object.keys(externalFilter).forEach(function (key) {
                var _a, _b, _c, _d;
                if (externalFilter[key] === undefined || externalFilter[key] === null || externalFilter[key] === '') {
                    return;
                }
                if (key.startsWith(_this.displayKey)) {
                    _this.externalFilter[key] = externalFilter[key];
                    return;
                }
                var item = externalFilters.find(function (e) { return e.field === key; });
                if (!item) {
                    return;
                }
                if (item.type === 'daterange' || item.type === 'numberrange') {
                    _this.externalFilter[key] = __assign({}, externalFilter[key]);
                    if (!((_a = externalFilter[key]) === null || _a === void 0 ? void 0 : _a.from) && !((_b = externalFilter[key]) === null || _b === void 0 ? void 0 : _b.to)) {
                        return;
                    }
                    _this.fields.push(__assign(__assign({}, item), { id: 'external' + item.field, group: 'external', type: item.type, code: item.field, title: item.title, fromTitle: item.fromTitle, toTitle: item.toTitle }));
                }
                else if (item.type === 'daterangefull') {
                    _this.externalFilter[key] = __assign({}, externalFilter[key]);
                    if (!((_c = externalFilter[key]) === null || _c === void 0 ? void 0 : _c.from) && !((_d = externalFilter[key]) === null || _d === void 0 ? void 0 : _d.to)) {
                        return;
                    }
                    _this.fields.push(__assign(__assign({}, item), { id: 'external' + item.field, group: 'external', type: item.type, code: item.field, title: item.title }));
                }
                else {
                    _this.externalFilter[key] = externalFilter[key];
                    _this.fields.push(__assign(__assign({}, item), { id: 'external' + item.field, group: 'external', type: item.type, code: item.field, title: item.title }));
                }
            });
        }
        var externalFields = ((_a = externalFilters) === null || _a === void 0 ? void 0 : _a.map(function (e) { return (__assign(__assign({}, e), { id: 'external' + e.field, group: 'external', code: e.field, type: e.type, title: e.title })); })) || [];
        var columnFields = [];
        (_b = columns) === null || _b === void 0 ? void 0 : _b.filter(function (e) { return e.type !== 'image'; }).forEach(function (column) {
            var _a;
            if ('children' in column) {
                (_a = column.children) === null || _a === void 0 ? void 0 : _a.filter(function (e) { return e.type !== 'image'; }).forEach(function (e) {
                    columnFields.push(__assign(__assign({}, e), { id: 'column' + e.field, group: 'column', code: e.field, type: e.type, title: e.title }));
                });
            }
            else {
                columnFields.push(__assign(__assign({}, column), { id: 'column' + column.field, group: 'column', code: column.field, type: column.type, title: column.title }));
            }
        });
        this.selectableFields = __spread(externalFields, columnFields);
        this.selectedField = {};
        this.fields.forEach(function (e) { return _this.selectedField[e.id] = true; });
        this.page = this.fields.length > 0 ? 2 : 1;
        this.modal.open();
    };
    GridPopupQuickFilterDetailComponent.ctorParameters = function () { return [
        { type: DeviceDetectorService },
        { type: NotifyService },
        { type: TranslateService }
    ]; };
    __decorate([
        ViewChild('modal')
    ], GridPopupQuickFilterDetailComponent.prototype, "modal", void 0);
    __decorate([
        Input()
    ], GridPopupQuickFilterDetailComponent.prototype, "quickFilters", void 0);
    __decorate([
        Output()
    ], GridPopupQuickFilterDetailComponent.prototype, "accept", void 0);
    GridPopupQuickFilterDetailComponent = __decorate([
        Component({
            selector: 'sd-grid-popup-quick-filter-detail',
            template: "<sd-modal-control width=\"sm\" [title]=\"(page === 1 ? 'Select filtered fields':'Input filtered fields') | sdTranslate\"\r\n  #modal>\r\n  <sd-modal-body>\r\n    <div class=\"row\">\r\n      <ng-container *ngIf=\"page === 1\">\r\n        <div *ngFor=\"let field of selectableFields\" class=\"col-12\">\r\n          <sd-checkbox-control [(model)]=\"selectedField[field.id]\" [label]=\"field.title\" (sdChange)=\"onSelectFields()\">\r\n          </sd-checkbox-control>\r\n        </div>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"page === 2\">\r\n        <div class=\"col-12\" *ngFor=\"let item of fields\">\r\n          <ng-container *ngIf=\"item.group === 'external'\">\r\n            <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'string'\" type=\"text\"\r\n              [(model)]=\"externalFilter[item.code]\">\r\n            </sd-input-control>\r\n            <sd-input-control [label]=\"item.title\" *ngIf=\"item.type === 'number'\" type=\"number\"\r\n              [(model)]=\"externalFilter[item.code]\">\r\n            </sd-input-control>\r\n            <sd-select-control [label]=\"item.title\" *ngIf=\"item.type === 'bool'\" [items]=\" [{value:'1',display:item.trueValue || 'True' },\r\n              {value:'0',display:item.falseValue || 'False' }]\" valueField=\"value\" displayField=\"display\"\r\n              [(model)]=\"externalFilter[item.code]\">\r\n            </sd-select-control>\r\n            <sd-radio-control [label]=\"item.title\" *ngIf=\"item.type === 'radio'\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.code]\">\r\n            </sd-radio-control>\r\n            <ng-container *ngIf=\"item.type === 'values'\">\r\n              <sd-select-control *ngIf=\"item.selection === 'MULTIPLE'\" [label]=\"item.title\" [items]=\"item.values\"\r\n                [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.code]\"\r\n                multiple=\"true\">\r\n              </sd-select-control>\r\n              <sd-autocomplete-control *ngIf=\"item.selection === 'AUTOCOMPLETE'\" [label]=\"item.title\"\r\n                [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n                [(model)]=\"externalFilter[item.code]\">\r\n              </sd-autocomplete-control>\r\n              <sd-chip-control *ngIf=\"item.selection === 'MULTIPLEAUTOCOMPLETE'\" [label]=\"item.title\"\r\n                [items]=\"item.values\" [valueField]=\"item.valueField\" [displayField]=\"item.displayField\"\r\n                [(model)]=\"externalFilter[item.code]\">\r\n              </sd-chip-control>\r\n              <sd-select-control *ngIf=\"!item.selection\" [label]=\"item.title\" [items]=\"item.values\"\r\n                [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"externalFilter[item.code]\">\r\n              </sd-select-control>\r\n            </ng-container>\r\n            <sd-input-control *ngIf=\"item.type === 'custom'\" [label]=\"item.title\"\r\n              [(model)]=\"externalFilter[displayKey + item.code]\"\r\n              (sdFocusForceBlur)=\"item?.onClick(externalFilter, item.code, displayKey + item.code)\">\r\n            </sd-input-control>\r\n            <sd-date-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='date'\"\r\n              [(model)]=\"externalFilter[item.code]\" type=\"date\">\r\n            </sd-date-picker-control>\r\n            <sd-date-range-picker-control [label]=\"item.title\" *ngIf=\"item.type ==='daterangefull'\"\r\n              [(fromDate)]=\"externalFilter[item.code].from\" [(toDate)]=\"externalFilter[item.code].to\"\r\n              [minDate]=\"item.minDate\" [maxDate]=\"item.maxDate\" type=\"date\">\r\n            </sd-date-range-picker-control>\r\n            <ng-container *ngIf=\"item.type ==='daterange'\">\r\n              <div class=\"row\">\r\n                <div class=\"col-6\">\r\n                  <sd-date-picker-control [label]=\"item.fromTitle\" [(model)]=\"externalFilter[item.code].from\"\r\n                    [type]=\"item.enableTime ? 'datetime' : 'date'\" [minDate]=\"item.minDate\"\r\n                    [maxDate]=\"externalFilter[item.code].to || item.maxDate\">\r\n                  </sd-date-picker-control>\r\n                </div>\r\n                <div class=\"col-6\">\r\n                  <sd-date-picker-control [label]=\"item.toTitle\" [(model)]=\"externalFilter[item.code].to\"\r\n                    [type]=\"item.enableTime ? 'datetime' : 'date'\"\r\n                    [minDate]=\"item.minDate || externalFilter[item.code].from\" [maxDate]=\"item.maxDate\">\r\n                  </sd-date-picker-control>\r\n                </div>\r\n              </div>\r\n            </ng-container>\r\n            <div class=\"row\" *ngIf=\"item.type ==='numberrange'\">\r\n              <div class=\"col-6\">\r\n                <sd-input-control [label]=\"item.fromTitle\" type=\" number\" [(model)]=\"externalFilter[item.code].from\">\r\n                </sd-input-control>\r\n              </div>\r\n              <div class=\"col-6\">\r\n                <sd-input-control [label]=\"item.toTitle\" type=\" number\" [(model)]=\"externalFilter[item.code].to\">\r\n                </sd-input-control>\r\n              </div>\r\n            </div>\r\n          </ng-container>\r\n          <ng-container *ngIf=\"item.group === 'column'\">\r\n            <sd-input-control *ngIf=\"item.type === 'string'\" [label]=\"item.title\" type=\"text\"\r\n              [(model)]=\"filter[item.code]\">\r\n            </sd-input-control>\r\n            <sd-input-control *ngIf=\"item.type === 'number'\" [label]=\"item.title\" type=\" number\"\r\n              [(model)]=\"filter[item.code]\">\r\n            </sd-input-control>\r\n            <sd-radio-control *ngIf=\"item.type === 'bool'\" [label]=\"item.title\" [items]=\"[{value:'1',display:item.trueValue || 'True' },\r\n            {value:'0',display:item.falseValue || 'False' }]\" [(model)]=\"filter[item.code]\">\r\n            </sd-radio-control>\r\n            <sd-radio-control *ngIf=\"item.type === 'radio'\" [label]=\"item.title\" [items]=\"item.values\"\r\n              [valueField]=\"item.valueField\" [displayField]=\"item.displayField\" [(model)]=\"filter[item.code]\">\r\n            </sd-radio-control>\r\n            <sd-autocomplete-control *ngIf=\"item.type === 'values' && item.editor?.autocomplete\" [label]=\"item.title\"\r\n              [items]=\"item.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[item.code]\">\r\n            </sd-autocomplete-control>\r\n            <sd-select-control *ngIf=\"item.type === 'values' && !item.editor?.autocomplete\" [label]=\"item.title\"\r\n              [items]=\"item.values\" valueField=\"value\" displayField=\"text\" [(model)]=\"filter[item.code]\">\r\n            </sd-select-control>\r\n            <sd-date-picker-control *ngIf=\"item.type ==='date' || item.type==='datetime' ||\r\n            item.type==='time'\" [label]=\"item.title\" [(model)]=\" filter[item.code]\" type=\"date\">\r\n            </sd-date-picker-control>\r\n          </ng-container>\r\n        </div>\r\n      </ng-container>\r\n    </div>\r\n  </sd-modal-body>\r\n  <ng-container *ngIf=\"page === 1\">\r\n    <sd-modal-footer *sdDesktop>\r\n      <sd-button class=\"mr-auto\" (action)=\"onCancel()\" icon=\"clear\" [title]=\"'Cancel' | sdTranslate\" size=\"sm\">\r\n      </sd-button>\r\n      <sd-button (action)=\"page = 2\" icon=\"arrow_forward\" [title]=\"'Next' | sdTranslate\" color=\"primary\"\r\n        iconSuffix=\"true\" [disabled]=\"!fields.length\" size=\"sm\"></sd-button>\r\n    </sd-modal-footer>\r\n    <sd-modal-footer *sdMobileTablet>\r\n      <sd-button style=\"flex: 1; padding-right: 5px;\" (action)=\"onCancel()\" icon=\"clear\"\r\n        [title]=\"'Cancel' | sdTranslate\" width=\"100%\" size=\"sm\"></sd-button>\r\n      <sd-button style=\"flex: 1; padding-left: 5px;\" (action)=\"page = 2\" icon=\"arrow_forward\"\r\n        [title]=\"'Next' | sdTranslate\" color=\"primary\" width=\"100%\" iconSuffix=\"true\" [disabled]=\"!fields.length\"\r\n        size=\"sm\">\r\n      </sd-button>\r\n    </sd-modal-footer>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"page === 2\">\r\n    <sd-modal-footer *sdDesktop>\r\n      <sd-button class=\"mr-auto\" (action)=\"page = 1\" icon=\"arrow_back\" [title]=\"'Back' | sdTranslate\" size=\"sm\">\r\n      </sd-button>\r\n      <sd-button (action)=\"onAccept()\" icon=\"done\" [title]=\"'Accept' | sdTranslate\" color=\"primary\" size=\"sm\">\r\n      </sd-button>\r\n    </sd-modal-footer>\r\n    <sd-modal-footer *sdMobileTablet>\r\n      <sd-button style=\"flex: 1; padding-right: 5px;\" (action)=\"page = 1\" icon=\"arrow_back\"\r\n        [title]=\"'Back' | sdTranslate\" width=\"100%\" size=\"sm\"></sd-button>\r\n      <sd-button style=\"flex: 1; padding-left: 5px;\" (action)=\"onAccept()\" icon=\"done\" [title]=\"'Accept' | sdTranslate\"\r\n        color=\"primary\" width=\"100%\" size=\"sm\"></sd-button>\r\n    </sd-modal-footer>\r\n  </ng-container>\r\n</sd-modal-control>",
            styles: [".sd-form{width:100%;font-size:14px}.sd-form.sd-form-with-information{width:calc(100% - 30px)}.sd-information{display:inline-block;text-align:center;margin:auto;width:30px}.cdk-overlay-container .mat-option{font-size:12px}.swal2-popup .swal2-content .swal2-html-container{line-height:1.7;color:#7c7c7e}.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_other_month{opacity:1;cursor:pointer}.daterangepicker{z-index:99999}", ".sd-label.sd-label-primary{color:#2f6bff!important}.sd-label.sd-label-success{color:#00bc3c!important}.sd-label.sd-label-info{color:#13c2c2!important}.sd-label.sd-label-warning{color:#fa8c16!important}.sd-label.sd-label-danger{color:#f5222d!important}", "::-webkit-scrollbar{width:7px;height:7px}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888;border-radius:50px}::-webkit-scrollbar-thumb:hover{background:#555}", ""]
        })
    ], GridPopupQuickFilterDetailComponent);
    return GridPopupQuickFilterDetailComponent;
}());

var CommandFilterPipe = /** @class */ (function () {
    function CommandFilterPipe() {
    }
    CommandFilterPipe.prototype.transform = function (commands, item) {
        return __awaiter(this, void 0, void 0, function () {
            var results, commands_1, commands_1_1, command, flag, hiddenByItem, hidden, children, _a, _b, childCommand, hidden, e_1_1, hiddenByItem, hidden, e_2_1;
            var e_2, _c, e_1, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        results = [];
                        if (!commands) {
                            return [2 /*return*/, results];
                        }
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 23, 24, 25]);
                        commands_1 = __values(commands), commands_1_1 = commands_1.next();
                        _e.label = 2;
                    case 2:
                        if (!!commands_1_1.done) return [3 /*break*/, 22];
                        command = commands_1_1.value;
                        if (!('children' in command)) return [3 /*break*/, 17];
                        flag = true;
                        hiddenByItem = command.hiddenByItem;
                        if (!hiddenByItem) return [3 /*break*/, 5];
                        hidden = hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 4];
                        return [4 /*yield*/, hidden];
                    case 3:
                        if (_e.sent()) {
                            flag = false;
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        if (hidden) {
                            flag = false;
                        }
                        _e.label = 5;
                    case 5:
                        if (!flag) return [3 /*break*/, 16];
                        children = [];
                        _e.label = 6;
                    case 6:
                        _e.trys.push([6, 13, 14, 15]);
                        _a = (e_1 = void 0, __values(command.children)), _b = _a.next();
                        _e.label = 7;
                    case 7:
                        if (!!_b.done) return [3 /*break*/, 12];
                        childCommand = _b.value;
                        if (!!childCommand.hiddenByItem) return [3 /*break*/, 8];
                        children.push(childCommand);
                        return [3 /*break*/, 11];
                    case 8:
                        hidden = childCommand.hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 10];
                        return [4 /*yield*/, hidden];
                    case 9:
                        if (!(_e.sent())) {
                            children.push(childCommand);
                        }
                        return [3 /*break*/, 11];
                    case 10:
                        if (!hidden) {
                            children.push(childCommand);
                        }
                        _e.label = 11;
                    case 11:
                        _b = _a.next();
                        return [3 /*break*/, 7];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 15];
                    case 14:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 15:
                        if (children.length) {
                            results.push(__assign(__assign({}, command), { children: children }));
                        }
                        _e.label = 16;
                    case 16: return [3 /*break*/, 21];
                    case 17:
                        hiddenByItem = command.hiddenByItem;
                        if (!!hiddenByItem) return [3 /*break*/, 18];
                        results.push(command);
                        return [3 /*break*/, 21];
                    case 18:
                        hidden = hiddenByItem(item);
                        if (!(hidden instanceof Promise)) return [3 /*break*/, 20];
                        return [4 /*yield*/, hidden];
                    case 19:
                        if (!(_e.sent())) {
                            results.push(command);
                        }
                        return [3 /*break*/, 21];
                    case 20:
                        if (!hidden) {
                            results.push(command);
                        }
                        _e.label = 21;
                    case 21:
                        commands_1_1 = commands_1.next();
                        return [3 /*break*/, 2];
                    case 22: return [3 /*break*/, 25];
                    case 23:
                        e_2_1 = _e.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 25];
                    case 24:
                        try {
                            if (commands_1_1 && !commands_1_1.done && (_c = commands_1.return)) _c.call(commands_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 25: return [2 /*return*/, results];
                }
            });
        });
    };
    CommandFilterPipe = __decorate([
        Pipe({
            name: 'commandFilter'
        })
    ], CommandFilterPipe);
    return CommandFilterPipe;
}());

var MobileViewHtmlTemplatePipe = /** @class */ (function () {
    function MobileViewHtmlTemplatePipe() {
    }
    MobileViewHtmlTemplatePipe.prototype.transform = function (rowData, columns, htmlTemplate) {
        return htmlTemplate(rowData, columns);
    };
    MobileViewHtmlTemplatePipe = __decorate([
        Pipe({
            name: 'mobileViewHtmlTempate'
        })
    ], MobileViewHtmlTemplatePipe);
    return MobileViewHtmlTemplatePipe;
}());

var SdCurrencyPipe = /** @class */ (function () {
    function SdCurrencyPipe(sanitizer) {
        this.sanitizer = sanitizer;
    }
    SdCurrencyPipe.prototype.transform = function (value) {
        var val = +value;
        if (!Number.isNaN(val)) {
            return val.toLocaleString();
        }
        return '';
    };
    SdCurrencyPipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    SdCurrencyPipe = __decorate([
        Pipe({
            name: 'sdCurrency',
        })
    ], SdCurrencyPipe);
    return SdCurrencyPipe;
}());

var LabelComponent = /** @class */ (function () {
    function LabelComponent() {
    }
    LabelComponent.prototype.ngOnInit = function () {
    };
    LabelComponent.prototype.ngAfterViewInit = function () {
    };
    __decorate([
        Input()
    ], LabelComponent.prototype, "label", void 0);
    LabelComponent = __decorate([
        Component({
            selector: 'sd-label',
            template: "<span class=\"mr-2\">{{label}}:</span>\r\n<strong><ng-content></ng-content></strong>"
        })
    ], LabelComponent);
    return LabelComponent;
}());

var SuperdevAngularCoreModule = /** @class */ (function () {
    function SuperdevAngularCoreModule() {
    }
    SuperdevAngularCoreModule_1 = SuperdevAngularCoreModule;
    SuperdevAngularCoreModule.forRoot = function () {
        return {
            ngModule: SuperdevAngularCoreModule_1,
            providers: [
                DatePipe,
                HandlerLocal,
                HandlerDotnet,
                ApiService,
                ConfigurationService,
                NotifyService,
                UtilityService,
                EditorHandlerPipe,
                TranslateService,
                CacheService,
                ExcelService,
                LoadingService,
                SettingService
            ]
        };
    };
    SuperdevAngularCoreModule.forChild = function () {
        return {
            ngModule: SuperdevAngularCoreModule_1,
            providers: []
        };
    };
    var SuperdevAngularCoreModule_1;
    SuperdevAngularCoreModule = SuperdevAngularCoreModule_1 = __decorate([
        NgModule({
            imports: [
                CommonModule,
                FormsModule,
                ReactiveFormsModule,
                HttpClientModule,
                MaterialModule,
                CKEditorModule,
                DeviceDetectorModule.forRoot()
            ],
            declarations: [
                GridControlComponent,
                GridConfigComponent,
                GridPopupExportExcelComponent,
                GridImportExcelComponent,
                GridPopupEditorComponent,
                GridSubInformationComponent,
                GridDesktopColumnViewComponent,
                GridDesktopColumnEditComponent,
                GridDesktopColumnChildrenViewComponent,
                GridDesktopInlineFilterComponent,
                GridMobileItemViewComponent,
                UploadExcelConfigComponent,
                UploadExcelControlComponent,
                InputControlComponent,
                SelectControlComponent,
                ModalControl,
                DatePickerControlComponent,
                DateRangePickerControlComponent,
                ModalHeaderComponent,
                ModalBodyComponent,
                ModalFooterComponent,
                TextareaControlComponent,
                AutocompleteControlComponent,
                GridDatePickerControlComponent,
                GridAutocompleteControl,
                GridPopupFilterComponent,
                GridPopupQuickFilterDetailComponent,
                DesktopDirective,
                MobileDirective,
                TabletDirective,
                MobileTabletDirective,
                CheckboxControlComponent,
                SwitchControlComponent,
                RadioControlComponent,
                CkeditorControlComponent,
                ChartControlComponent,
                ChipControlComponent,
                UploadFileControlComponent,
                BottomSheetComponent,
                BottomSheetBodyComponent,
                BottomSheetFooterComponent,
                BottomSheetHeaderComponent,
                ButtonComponent,
                LabelComponent,
                // Pipes
                TranslatePipe,
                EditorHandlerPipe,
                EditorValidatePipe,
                EditorDynamicItemPipe,
                FilterMobilePipe,
                MobileCommandFilterPipe,
                ColumnHtmlTemplatePipe,
                ColumnTitlePipe,
                CommandIconPipe,
                CommandTitlePipe,
                CommandDisabledPipe,
                CommandHidden,
                CommandFilterPipe,
                ColumnCommandFilterPipe,
                CellMobileClassNamePipe,
                CellDesktopClassNamePipe,
                MobileViewHtmlTemplatePipe,
                InputTooltipPipe,
                ValueTransformPipe,
                EditorSubInformationHandlerPipe,
                SafeHtmlPipe,
                SdCurrencyPipe,
                // Validators
                SdMinDateValidator,
                SdMaxDateValidator,
                SdCustomValidator,
                SdChipMinItemValidator,
                // Components,
                DialogConfirmComponent
            ],
            exports: [
                MaterialModule,
                // Controls
                InputControlComponent,
                SelectControlComponent,
                DatePickerControlComponent,
                DateRangePickerControlComponent,
                GridControlComponent,
                UploadExcelControlComponent,
                TextareaControlComponent,
                AutocompleteControlComponent,
                ModalControl,
                ModalHeaderComponent,
                ModalBodyComponent,
                ModalFooterComponent,
                CheckboxControlComponent,
                SwitchControlComponent,
                RadioControlComponent,
                CkeditorControlComponent,
                ChartControlComponent,
                ChipControlComponent,
                UploadFileControlComponent,
                BottomSheetComponent,
                BottomSheetBodyComponent,
                BottomSheetFooterComponent,
                BottomSheetHeaderComponent,
                ButtonComponent,
                LabelComponent,
                // Directives
                DesktopDirective,
                MobileDirective,
                TabletDirective,
                MobileTabletDirective,
                // Pipes
                TranslatePipe,
            ]
        })
    ], SuperdevAngularCoreModule);
    return SuperdevAngularCoreModule;
}());

/*
 * Public API Surface of superdev-angular-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ApiService, AutocompleteControlComponent, BottomSheetBodyComponent, BottomSheetComponent, BottomSheetFooterComponent, BottomSheetHeaderComponent, ButtonComponent, CacheService, ChartControlComponent, CheckboxControlComponent, CkeditorControlComponent, ConfigurationService, DatePickerControlComponent, DateRangePickerControlComponent, DesktopDirective, ExcelService, GridControlComponent, HandlerDotnet, HandlerLocal, InputControlComponent, LabelComponent, LoadingService, MobileDirective, MobileTabletDirective, ModalBodyComponent, ModalControl, ModalFooterComponent, ModalHeaderComponent, NotifyService, RadioControlComponent, SelectControlComponent, SettingService, SuperdevAngularCoreModule, SwitchControlComponent, TabletDirective, TextareaControlComponent, TranslatePipe, TranslateService, UploadExcelControlComponent, UploadFileControlComponent, UtilityService, defaultGridOption, MaterialModule as ɵa, GridControlComponent as ɵb, SelectControlComponent as ɵba, ModalControl as ɵbb, DatePickerControlComponent as ɵbc, DateRangePickerControlComponent as ɵbd, ModalHeaderComponent as ɵbe, ModalBodyComponent as ɵbf, ModalFooterComponent as ɵbg, TextareaControlComponent as ɵbh, AutocompleteControlComponent as ɵbi, GridDatePickerControlComponent as ɵbj, GridAutocompleteControl as ɵbk, GridPopupFilterComponent as ɵbl, GridPopupQuickFilterDetailComponent as ɵbm, DesktopDirective as ɵbn, MobileDirective as ɵbo, TabletDirective as ɵbp, MobileTabletDirective as ɵbq, CheckboxControlComponent as ɵbr, SwitchControlComponent as ɵbs, RadioControlComponent as ɵbt, CkeditorControlComponent as ɵbu, ChartControlComponent as ɵbv, ChipControlComponent as ɵbw, UploadFileControlComponent as ɵbx, BottomSheetComponent as ɵby, BottomSheetBodyComponent as ɵbz, HandlerLocal as ɵc, BottomSheetFooterComponent as ɵca, BottomSheetHeaderComponent as ɵcb, ButtonComponent as ɵcc, LabelComponent as ɵcd, TranslatePipe as ɵce, EditorValidatePipe as ɵcf, EditorDynamicItemPipe as ɵcg, FilterMobilePipe as ɵch, MobileCommandFilterPipe as ɵci, ColumnHtmlTemplatePipe as ɵcj, ColumnTitlePipe as ɵck, CommandIconPipe as ɵcl, CommandTitlePipe as ɵcm, CommandDisabledPipe as ɵcn, CommandHidden as ɵco, CommandFilterPipe as ɵcp, ColumnCommandFilterPipe as ɵcq, CellMobileClassNamePipe as ɵcr, CellDesktopClassNamePipe as ɵcs, MobileViewHtmlTemplatePipe as ɵct, InputTooltipPipe as ɵcu, ValueTransformPipe as ɵcv, EditorSubInformationHandlerPipe as ɵcw, SafeHtmlPipe as ɵcx, SdCurrencyPipe as ɵcy, SdMinDateValidator as ɵcz, HandlerDotnet as ɵd, SdMaxDateValidator as ɵda, SdCustomValidator as ɵdb, SdChipMinItemValidator as ɵdc, DialogConfirmComponent as ɵdd, CacheService as ɵde, UtilityService as ɵe, NotifyService as ɵf, TranslateService as ɵg, ConfigurationService as ɵh, LoadingService as ɵi, ApiService as ɵj, ExcelService as ɵk, EditorHandlerPipe as ɵl, GridConfigComponent as ɵm, SettingService as ɵn, GridPopupExportExcelComponent as ɵo, GridImportExcelComponent as ɵp, GridPopupEditorComponent as ɵq, GridSubInformationComponent as ɵr, GridDesktopColumnViewComponent as ɵs, GridDesktopColumnEditComponent as ɵt, GridDesktopColumnChildrenViewComponent as ɵu, GridDesktopInlineFilterComponent as ɵv, GridMobileItemViewComponent as ɵw, UploadExcelConfigComponent as ɵx, UploadExcelControlComponent as ɵy, InputControlComponent as ɵz };
//# sourceMappingURL=superdev-angular-core.js.map
